/******************************************************************************
 * EZ_XRSRC.C   d'apres XRSRC 
 *              modifie pour EZ_GEM par Roland Sevin
 *
 *........................ Original d'apres ...................................
 *            Extended Resource-Manager. RSC-Files can now have up to
 *            4294967295 bytes length.
 *            You can modify this source to handle more than one RSC-File
 *            by calling the MLOCAL-Functions
 *
 *                rs_load(pglobal,  re_lpfname);
 *                rs_gaddr(pglobal, re_gtype, re_gindex, re_gaddr);
 *                rs_sadd(pglobal,  re_stype, re_sindex, re_saddr);
 *
 *            with an integer-pointer to a 15 INT16 array which will be
 *            handled as single global-arrays for each RSC-File.
 *
 *            This Source is copyrighted material by
 *                    Oliver Groeger
 *                    Graf-Konrad-Str.25
 *                    8000 Munich 40
 *                    Germany
 *
 * Version  :  1.00
 * Date     :  Aug 15th 1991
 * Author   :  Oliver Groeger
 *
 * Version  :  1.10
 * Datum    :  27 Sept. 1992
 * Autor    :  Olaf Meisiek
 * Modifs   :  - utilisation sur tous les TOS des icnes couleur
 *.................... modifie pour EZ_GEM ...........................
 * Version  :  1.11
 * Datum    :  18 Dec. 1996
 * Autor    :  Sevin Roland
 * Modifs   :  - xrsrc_construct permet de convertir une ressource deja
 *                               chargee en memoire par l'utilisateur
 *                               permet chargement dynamique de plusieurs
 *                               fichier de ressource.
 *             - xrsrc_destruct  libere tous ce que xrsrc_construct a pu
 *                               modifier comme memoire et autre...
 *                               appel obligatoire en fin de programme ou
 *                               apres effacement definitif de la ressource
 *.................... modifie pour EZ_GEM ...........................
 * Version  :  1.12
 * Datum    :  01 Mars 1999
 * Autor    :  Sevin Roland
 * Modifs   :  - DrawCicon permet de dessiner une icone ou l'on veut avec
 *                                juste des fonctions VDI.
 *              -DataCiconToMFDB permet de recuperer un MFDB pret a l'emploi
 *                               pour dessiner une icone.
 *
  *.................... modifie pour EZ_GEM ...........................
 * Version  :  1.13
 * Datum    :  03 Avril 2001
 * Autor    :  Sevin Roland
 * Modifs   :  -Supression de toutes les fonctions inutiles
 *             -Adoption des fonctions:
 *                                       malloc_ID()     
 *                                       realloc_ID()    
 *                                       calloc_ID()     
 *                                       FreeAll_ID()    
 *              car la reservation et liberation memoire d'origine
 *              etait assez bugge. Maintenant All Is Ok
 *             -adoption du handle VDI: d'EAZY_GEM: VDIhandle
 ******************************************************************************/

#include "EAZY_GEM.H"

/* end of include......................................................... */

/****** Compilerswitches ******************************************************/

#ifdef __TURBOC__
#pragma warn -sig           /* Warnung "Conversion may loose significant digits" ausschalten */
#endif

/****** TYPES ****************************************************************/
typedef struct
  {USERBLK    ublk;
   unsigned INT16 old_type;
  } OBBLK;

/****** VARIABLES ************************************************************/
/*............. variables globales devant etre initialiee ........................*/
/*              avant appel de tout autre fonction de cette bibliotheque          */
/*              le mieux etant de les initialiser apres chargement en memoire     */

 INT16   *rs_global;
 RSXHDR  *rs_hdr;
 RSXHDR  *hdr_buf;
 INT16    xgl_wbox, xgl_hbox;
 GRECT    xdesk;

/*............... autre globales ne devant pas etre initialisees .................*/
 INT16           farbtbl[256][32];
 unsigned long   farbtbl2[32];
 INT16           is_palette = 0;
 INT16           rgb_palette[256][4];
 INT16           xpixelbytes;
 INT16           xscrn_planes;

/****** FUNCTIONS PUBLIQUES EXPORTEES ********************************************************/
 INT16    xrsrc_construct  (void *adr, long size_fic, INT16 scale_flag);
 INT16    xrsrc_destruct   (INT16 *pglobal);
 INT16    xrsrc_gaddr      (INT16 re_gtype, INT16 re_gindex, void *re_gaddr, INT16 *pglobal);
 INT16    xrsrc_saddr      (INT16 re_stype, INT16 re_sindex, void *re_saddr, INT16 *pglobal);
 INT16    DrawCicon        (INT16 handle, OBJECT *object, INT16 ind_ob, INT16 ob_x, INT16 ob_y);
 MFDB    *CiconToMFDB      (OBJECT *object, INT16 ind_ob, MFDB *mfdb, INT16 state);
/****** FUNCTIONS PRIVEE INTERNES ************************************************************/
 void   rs_obfix      (OBJECT *rs_otree, INT16 rs_oobject, INT16 scale_flag);
 void   rs_sglobal    (INT16 *base);
 INT16  rs_gaddr      (INT16 *base, INT16 re_gtype, INT16 re_gindex, OBJECT **re_gaddr);
 INT16  rs_sadd       (INT16 *base, INT16 rs_stype, INT16 rs_sindex, OBJECT *re_saddr);
 void  *get_address   (INT16 type, INT16 index);
 void  *get_sub       (INT16 index, long offset, INT16 size);
 void   rs_fixindex   (INT16 *global, INT16 scale_flag);
 void   do_rsfix      (unsigned long rs_size);
 void   fix_treeindex (void);
 void   fix_object    (INT16 scale_flag);
 void   fix_tedinfo   (void);
 void   fix_nptr      (long index, INT16 ob_type);
 INT16  fix_ptr       (INT16 type, long index);
 INT16  fix_long      (long *lptr);
 void   fix_chp       (INT16 *pcoord, INT16 flag);
 
 INT16  DrawMonIcon       (INT16 handle, OBJECT *object, INT16 ind_ob, INT16 ob_x, INT16 ob_y);
 INT16  DrawColIcon       (INT16 handle, OBJECT *object, INT16 ind_ob, INT16 ob_x, INT16 ob_y);
 MFDB  *MonGiconToMFDB    (OBJECT *object, INT16 ind_ob, MFDB *mfdb, INT16 state);
 MFDB  *ColGiconToMFDB    (OBJECT *object, INT16 ind_ob, MFDB *mfdb, INT16 state);
 void   do_ciconfix       (unsigned long header, RSXHDR *rsxhdr, long rs_len);
 INT16  xadd_cicon        (CICONBLK *cicnblk, OBJECT *obj, INT16 nub);
 void   draw_bitblk       (INT16 handle, INT16 *p, INT16 x, INT16 y, INT16 w, INT16 h, INT16 num_planes, INT16 mode, INT16 *index);
 void   xfix_cicon        (unsigned INT16 *col_data, long len, INT16 old_planes, INT16 new_planes, XMFDB *s);
 void   std_to_byte       (unsigned INT16 *col_data, long len, INT16 old_planes, unsigned long *farbtbl2, XMFDB *s);
 void   xrect2array       (const GRECT *rect, INT16 *array);
 INT16  test_rez          (void);
 void   xfill_farbtbl     (void);
 INT16  fill_cicon_liste  (long *cicon_liste, unsigned long header, RSXHDR *rsxhdr);
 INT16  cdecl xdraw_cicon (PARMBLK *pb);
 MFDB  *DataCiconToMFDB   (INT16 *p,INT16 w, INT16 h, INT16 num_planes,MFDB *s);


/*--------------------------- xrsrc_construct -------------------------------*/
/* ACTION: converti et reloge une ressource chargee en memoire               */
/* ENTREE: adr pointe sur le debut de la zone memoire ou est la ressource    */
/*         a cette adresse on doit trouver:                                  */
/*                                   rs_global[], (taille du tableau global) */
/*                                   RSXHDR hdr_buf,                         */
/*                                   ressource (avec son header  RSHDR)      */

 INT16 xrsrc_construct(void *adr, long size_fic, INT16 scale_flag)
{INT16 dumy;
 long i;
 long nb_ob;
 unsigned long len;
 OBJECT *object;
 INT16 ob_xtype,ob_type;
 ICONBLK *iconblk;
 BITBLK   *bitblk;
 /*......... initialiser variables globales de la ressource ................*/
 
 graf_handle(&xgl_wbox, &xgl_hbox, &dumy, &dumy) ;
 wind_get(0,WF_WORKXYWH, &xdesk.g_x, &xdesk.g_y, &xdesk.g_w, &xdesk.g_h) ;
 
/*............. initialiser rs_global avec adresse de chargement............*/ 
/* ...............INT16 global[16].....RSXHDR.......RSHDR data ressource......*/ 
 len                     = sizeof (RSXHDR);
 rs_global               = (INT16*) adr;
 *(long*) &rs_global[12] = (long)size_fic;
 hdr_buf                 = (RSXHDR*)( (char*)adr + sizeof(INT16)*16 ); /* RSXHDR est apres global  */
 (long)rs_hdr            = ( (long)hdr_buf + len);
 /*........ selon Numero version ressource initialiser structure RSXHDR.......*/
 if (((RSHDR *)rs_hdr)->rsh_vrsn == 3)
    {memcpy (hdr_buf, rs_hdr, len);
    }
 else
    {for (i = 0; i < len / sizeof (long); i++)
         {((unsigned long *)hdr_buf)[i] = ((unsigned INT16 *)rs_hdr)[i];
         }
    }
 
 if (scale_flag>=0) 
    {do_rsfix (hdr_buf->rsh_rssize);
    }
 else
    {scale_flag = abs(scale_flag+1);  
    }
 
 /*............... convertir icones couleurs ...............................*/
 if (size_fic > hdr_buf->rsh_rssize + 72L)  /* icnes couleur dans le RSC ? */
    {do_ciconfix ((unsigned long)rs_hdr, hdr_buf, size_fic);
    }
 /*..............mode caractere en mode points ecran .......................*/
 rs_fixindex ((INT16*)adr, scale_flag);
 
 /*..............hauteur icone = hauteur pixel .............................*/
 nb_ob = hdr_buf->rsh_nobs;
 xrsrc_gaddr (R_TREE, 0, &object, adr);   
 for (i=0; i<nb_ob; i++)
     {ob_xtype = (object[i].ob_type>>8) & 0x00FF;
      ob_type  =  object[i].ob_type & 0x00FF;
      if (ob_type == G_USERDEF && ob_xtype == G_CICON)
         {iconblk = (ICONBLK *)(object[i].ob_spec.userblk->ub_parm);
          object[i].ob_width  = iconblk->ib_wicon;
          object[i].ob_height = iconblk->ib_hicon;
         } 
      if (ob_type == G_ICON )
         {iconblk = (ICONBLK *)(object[i].ob_spec.iconblk);
          object[i].ob_width  = iconblk->ib_wicon;
          object[i].ob_height = iconblk->ib_hicon;
         }    
      if (ob_type == G_IMAGE)
         {bitblk = object[i].ob_spec.bitblk;
          object[i].ob_width  = bitblk->bi_wb<<3;
          object[i].ob_height = bitblk->bi_hl;
         }    
     }
 return 1;
}

/*-------------------------- xrsrc_destruct ---------------------------------*/
/* ACTION: libere la memoire additionnele que la fonction d'initialisation   */
/*         a reservee pour notamment convertir les icones couleurs           */
INT16 xrsrc_destruct(INT16 *base)
{FreeAll_ID((long)base);
 return (TRUE);
}

/*--------------------------- DrawCicon --------------------------------*/
/* ACTION: dessine une icone couleur,  l'emplacement ob_x & ob_y de    */
/*         votre choix, en utilisant que des fonctions VDI. Cette       */
/*         fonction peut etre utilisee dans les USERDEF et autres       */
/*         fonctions type LISTBOX et SCROLBOX.                          */
/* NOTE:   les icones doivent etre des CICON prealablement Chargees par */
/*         les fonctions EAZY_GEM qui adaptent les couleurs aux         */
/*         resolutions ecran en cours.                                  */
/* ENTREE: INT16 handle: handle VDI de la station de travail.             */
/*         OBJECT *object: adresse de l'objet racine de l'arbre ou se   */
/*                         trouve l'icone a dessiner.                   */
/*         INT16 ind_ob: indice dans l'arbre, de l'objet CICON a dessiner */
/*         INT16 ob_x, INT16 ob_y: coordonnees d'affichage desirees de      */
/*                            l'angle superieur gauche de l'icone.      */
/* RETOUR: l'etat de l'icone dessine (selectionne ou pas)               */

INT16 DrawCicon (INT16 handle, OBJECT *object, INT16 ind_ob, INT16 ob_x, INT16 ob_y)
{INT16 ob_xtype = GET_XOBTYPE(object,ind_ob);
 INT16 ob_type  =  object[ind_ob].ob_type & 0x00FF;
 INT16 ret      = 0;
 if (ob_xtype == G_CICON)     ret = DrawColIcon(handle, object, ind_ob, ob_x, ob_y);
 else if (ob_type == G_ICON)  ret = DrawMonIcon(handle, object, ind_ob, ob_x, ob_y);
 return ret;
}

/*--------------------------- DrawMonIcon -----------------------------*/
INT16 DrawMonIcon (INT16 handle, OBJECT *object, INT16 ind_ob, INT16 ob_x, INT16 ob_y)
{INT16   x, y, dummy, pxy[4], m_mode, i_mode, mskcol, icncol;
 ICONBLK *iconblk;
 INT16     *mask, *data = NULL;
 char    letter[2];
 INT16    selected, mindex[2], iindex[2], buf;
 INT16 invert = FALSE;
 
 /*............ recuperer specification objet ................... */
 selected = object[ind_ob].ob_state & SELECTED;
 iconblk  = object[ind_ob].ob_spec.iconblk; 
 m_mode   = MD_TRANS;
 /*.......................... SELECTIONNE ..........................*/
 mask                 = iconblk->ib_pmask;
 data                 = iconblk->ib_pdata;
 if (selected) invert = TRUE;   
 i_mode               = MD_TRANS; 
 /*.................... dessiner les images .......................*/
 mindex [0] = ((iconblk->ib_char & 0x0f00) != 0x0100) ? (iconblk->ib_char & 0x0f00) >> 8 : WHITE;
 mindex [1] = WHITE;
 iindex[0]  = (INT16)(((unsigned INT16)iconblk->ib_char & 0xf000U) >> 12U);
 iindex[1]  = WHITE;
 icncol     = iindex[0];
 mskcol     = (iconblk->ib_char & 0x0f00) >> 8;

 x = ob_x + iconblk->ib_xicon;
 y = ob_y + iconblk->ib_yicon;

 if (invert)
    {buf       = iindex[0];
     iindex[0] = mindex[0];
     mindex[0] = buf;
     i_mode    = MD_TRANS;
    }
 if (selected)
    {buf    = icncol;
     icncol = mskcol;
     mskcol = buf;
    }
 
 draw_bitblk (handle, mask, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, m_mode, mindex);
 draw_bitblk (handle, data, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, i_mode, iindex);

 /*.................... dessiner la boite de texte ...............*/
 if (iconblk->ib_ptext[0])
    {x = ob_x + iconblk->ib_xtext;
     y = ob_y + iconblk->ib_ytext;
  
     pxy[0] = x;
     pxy[1] = y;
     pxy[2] = x + iconblk->ib_wtext - 1;
     pxy[3] = y + iconblk->ib_htext - 1;
  
     vswr_mode     (handle, MD_REPLACE);  /* dessiner la boite texte (TextBox) */
     vsf_color     (handle, mskcol);
     vsf_interior  (handle, FIS_SOLID);
     vsf_perimeter (handle, FALSE);
     v_bar         (handle, pxy);
    }
 /*...................... dessiner le texte ......................*/
 vswr_mode     (handle, MD_TRANS);
 vst_font      (handle, 1); /* Systemfont */
 vst_height    (handle, 4, &dummy, &dummy, &dummy, &dummy);
 vst_color     (handle, icncol);
 vst_effects   (handle, TXT_NORMAL);
 vst_alignment (handle, ALI_LEFT, ALI_TOP, &dummy, &dummy);
 vst_rotation  (handle, 0);
 
 if (iconblk->ib_ptext[0])
    {x += (iconblk->ib_wtext - (INT16)strlen ((char*)iconblk->ib_ptext) * 6) >> 1;
     y += (iconblk->ib_htext - 6) >>1; 
     v_gtext (handle, x, y, iconblk->ib_ptext);
    }
 /*.................... dessiner la lettre ......................*/
 letter[0] = iconblk->ib_char & 0xff;
 if (letter[0])
    {letter[1] = '\0';
     x = ob_x + iconblk->ib_xicon + iconblk->ib_xchar;
     y = ob_y + iconblk->ib_yicon + iconblk->ib_ychar;
     v_gtext (handle, x, y, letter);
    }
 return (selected);
} 

/*--------------------------- DrawColIcon -----------------------------*/
INT16 DrawColIcon (INT16 handle, OBJECT *object, INT16 ind_ob, INT16 ob_x, INT16 ob_y)
{INT16   x, y, dummy, pxy[4], m_mode, i_mode, mskcol, icncol;
 ICONBLK *iconblk;
 CICON   *cicn;
 INT16    *mask, *data, *dark = NULL;
 char    letter[2];
 INT16    selected, mindex[2], iindex[2], buf;
 INT16 invert = FALSE;
  
 /*............ recuperer specification objet ................... */
 selected = object[ind_ob].ob_state & SELECTED;
 iconblk  = (ICONBLK *) (object[ind_ob].ob_spec.userblk->ub_parm);
 cicn     = ((CICONBLK *)iconblk)->mainlist;
 m_mode   = MD_TRANS;
 /*.......................... SELECTIONNE ..........................*/
 if (selected) 
    {if (cicn->sel_data != NULL)  /*..... SI ICONE SELECT EXISTE    */
        {mask = cicn->sel_mask;
         data = cicn->sel_data;
         if (cicn->num_planes > 1)
            {if (cicn->num_planes > 8) /* TrueColor, carte couleur en mode RVB? */
                 i_mode = S_AND_D;
             else
                 i_mode = S_OR_D;
            }
         else
            {i_mode = MD_TRANS;
            }
        }
     else                        /*..... SI ICONE SELECT EXISTE PAS */
        {mask = cicn->col_mask;
         data = cicn->col_data;
         if (cicn->num_planes > 1)
            {if (cicn->num_planes > 8)
                 i_mode = S_AND_D;
             else
                 i_mode = S_OR_D;
             dark = cicn->sel_mask;
           }
         else
           {invert = TRUE;
           }
        } /*  endifelse icone select existe pas  */
    }  /*  endif (selected) */
 /*.......................... NON SELECTIONNE ......................*/
 else    
    {mask = cicn->col_mask;
     data = cicn->col_data;
     if (cicn->num_planes > 1)
        {if (cicn->num_planes > 8)
             i_mode = S_AND_D;
         else
             i_mode = S_OR_D;
       }
     else
       {i_mode = MD_TRANS;
       }
    } /* endifelse (selected) */
 /*.................... dessiner les images .......................*/
 mindex [0] = ((iconblk->ib_char & 0x0f00) != 0x0100) ? (iconblk->ib_char & 0x0f00) >> 8 : WHITE;
 mindex [1] = WHITE;
 iindex[0]  = (INT16)(((unsigned INT16)iconblk->ib_char & 0xf000U) >> 12U);
 icncol     = iindex[0];
 iindex[1]  = WHITE;
 mskcol     = (iconblk->ib_char & 0x0f00) >> 8;

 x = ob_x + iconblk->ib_xicon;
 y = ob_y + iconblk->ib_yicon;

 if (invert)
    {buf       = iindex[0];
     iindex[0] = mindex[0];
     mindex[0] = buf;
     i_mode    = MD_TRANS;
    }
 if (selected)
    {buf    = icncol;
     icncol = mskcol;
     mskcol = buf;
    }
 
 draw_bitblk (handle, mask, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, m_mode, mindex);
 draw_bitblk (handle, data, x, y, iconblk->ib_wicon, iconblk->ib_hicon, cicn->num_planes, i_mode, iindex);
 
 if (dark)
    {mindex [0] = BLACK;
     mindex [1] = WHITE;
     draw_bitblk (handle, dark, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, MD_TRANS, mindex);
    }
 /*.................... dessiner la boite de texte ...............*/
 if (iconblk->ib_ptext[0])
    {x = ob_x + iconblk->ib_xtext;
     y = ob_y + iconblk->ib_ytext;
  
     pxy[0] = x;
     pxy[1] = y;
     pxy[2] = x + iconblk->ib_wtext - 1;
     pxy[3] = y + iconblk->ib_htext - 1;
  
     vswr_mode     (handle, MD_REPLACE);  /* dessiner la boite texte (TextBox) */
     vsf_color     (handle, mskcol);
     vsf_interior  (handle, FIS_SOLID);
     vsf_perimeter (handle, FALSE);
     v_bar         (handle, pxy);
    }
 /*...................... dessiner le texte ......................*/
 vswr_mode     (handle, MD_TRANS);
 vst_font      (handle, 1); /* Systemfont */
 vst_height    (handle, 4, &dummy, &dummy, &dummy, &dummy);
 vst_color     (handle, icncol);
 vst_effects   (handle, TXT_NORMAL);
 vst_alignment (handle, ALI_LEFT, ALI_TOP, &dummy, &dummy);
 vst_rotation  (handle, 0);
 
 if (iconblk->ib_ptext[0])
    {x += (iconblk->ib_wtext - (INT16)strlen ((char*)iconblk->ib_ptext) * 6) >> 1;
     y += (iconblk->ib_htext - 6) >>1; 
     v_gtext (handle, x, y, iconblk->ib_ptext);
    }
 /*.................... dessiner la lettre ......................*/
 letter[0] = iconblk->ib_char & 0xff;
 if (letter[0])
    {letter[1] = '\0';
     x = ob_x + iconblk->ib_xicon + iconblk->ib_xchar;
     y = ob_y + iconblk->ib_yicon + iconblk->ib_ychar;
     v_gtext (handle, x, y, letter);
    }
 return (selected);
} 


/*--------------------------- CiconToMFDB ------------------------------*/
/* ACTION: retourne un MFDB pret  l'emploi pour affichage  partir     */
/*         d'une icone couleur. Archi utile pour creer des fonds de     */
/*         fenetre cette fonction peut etre utilisee dans les USERDEF   */
/*         et autres fonctions type LISTBOX et SCROLBOX.                */
/* NOTE:   les icones doivent etre des CICON prealablement Chargees par */
/*         les fonctions EAZY_GEM qui adaptent les couleurs aux         */
/*         resolutions ecran en cours.                                  */
/* ENTREE: OBJECT *object: adresse de l'objet racine de l'arbre ou se   */
/*                         trouve l'icone a dessiner.                   */
/*         INT16 ind_ob: indice dans l'arbre, de l'objet CICON a dessiner */
/*         MFDB *mfdb: adresse du MFDB a initialiser avec l'icone.      */
/*         INT16 state:  etat de l'icone que l'on souhaite recuperer.     */
/*                    BIT 0 Icone Selectionne       /1   (place)        */
/*                          Icone Normale           /0   (non place)    */
/*                    BIT 1 le Masque est retourne  /1   (place)        */  
/*                          l'image est retournee   /0   (non place)    */
/* RETOUR: MFDB *: pointe sur le MFDB initialise.                       */

MFDB *CiconToMFDB (OBJECT *object, INT16 ind_ob, MFDB *mfdb, INT16 state)
{INT16 ob_xtype = GET_XOBTYPE(object,ind_ob);
 INT16 ob_type  =  object[ind_ob].ob_type & 0x00FF;
 MFDB *ret    = 0;
 if      (ob_xtype == G_CICON) ret = ColGiconToMFDB (object, ind_ob, mfdb, state);
 else if (ob_type  == G_ICON)  ret = MonGiconToMFDB (object, ind_ob, mfdb, state);
 return ret;
}

MFDB *MonGiconToMFDB (OBJECT *object, INT16 ind_ob, MFDB *mfdb, INT16 state)
{ICONBLK *iconblk;
 INT16    *data; 
 /*............ recuperer specification objet ................... */
 iconblk            = object[ind_ob].ob_spec.iconblk; 
 if (state&2) data  = iconblk->ib_pmask;
 else         data  = iconblk->ib_pdata;
 return DataCiconToMFDB(data, iconblk->ib_wicon, iconblk->ib_hicon, 1, mfdb);    
} 


MFDB *ColGiconToMFDB (OBJECT *object, INT16 ind_ob, MFDB *mfdb, INT16 state)
{ICONBLK *iconblk;
 CICON   *cicn;
 INT16    *mask, *data;
  
 /*............ recuperer specification objet ................... */
 iconblk  = (ICONBLK *)(object[ind_ob].ob_spec.userblk->ub_parm);
 cicn     = ((CICONBLK *)iconblk)->mainlist;
 /*.......................... SELECTIONNE ..........................*/
 if (state&1) 
    {if (cicn->sel_data != NULL)  /*..... SI ICONE SELECT EXISTE    */
        {mask = cicn->sel_mask;
         data = cicn->sel_data;
        }
     else                        /*..... SI ICONE SELECT EXISTE PAS */
        {mask = cicn->col_mask;
         data = cicn->col_data;
        } /*  endifelse icone select existe pas  */
    }  /*  endif (selected) */
 /*.......................... NON SELECTIONNE ......................*/   
 else    
    {mask = cicn->col_mask;
     data = cicn->col_data;
    } /* endifelse (selected) */
 
 /*........ si on demande le masque en retour ................*/
 if (state&2)
    {return DataCiconToMFDB(mask, iconblk->ib_wicon, iconblk->ib_hicon, 1, mfdb);
    }
 /*........ si on demande l'image en retour ..................*/
 else
    {return DataCiconToMFDB(data, iconblk->ib_wicon, iconblk->ib_hicon, cicn->num_planes, mfdb);
    }
} 

MFDB *DataCiconToMFDB(INT16 *p,INT16 w, INT16 h, INT16 num_planes,MFDB *s)
{s->fd_addr    = (void *)p;
 s->fd_w       = w;
 s->fd_h       = h;
 s->fd_wdwidth = w >> 4;
 s->fd_stand   = FALSE;
 s->fd_nplanes = num_planes;
 return s;
}

/*---------------------------- xrsrc_gaddr --------------------------------*/
INT16 xrsrc_gaddr (INT16 re_gtype, INT16 re_gindex, void *re_gaddr, INT16 *pglobal)
{return (rs_gaddr (pglobal, re_gtype, re_gindex, re_gaddr));
}

/*---------------------------- xrsrc_saddr --------------------------------*/
INT16 xrsrc_saddr (INT16 re_stype, INT16 re_sindex, void *re_saddr, INT16 *pglobal)
{return (rs_sadd (pglobal, re_stype, re_sindex, re_saddr));
}


/*---------------------------- rs_obfix --------------------------------*/
/* ACTION: convertit coord objet en mode caractere en points ecrans     */

void rs_obfix (OBJECT *rs_otree, INT16 rs_oobject, INT16 scale_flag)
{
  INT16 *coord;
  INT16 tmp = FALSE;
  INT16 count = 0;
  INT16 ob_type,ob_xtype;
  INT16 mode_flag=0;
  
  if (rs_otree[rs_oobject].ob_flags & 0x8000) 
     {mode_flag = 0x0002;
     }
  ob_xtype = (rs_otree[rs_oobject].ob_type>>8) & 0x00FF;
  ob_type  =  rs_otree[rs_oobject].ob_type & 0x00FF;
  coord    = &rs_otree[rs_oobject].ob_x;
  
     while (count++ < 4)
        {if (ob_type  == G_ICON  ||
             ob_type  == G_CICON ||
             ob_type  == G_IMAGE ||
             ob_xtype == G_CICON
            )
            {
             fix_chp (coord++, FALSE);
             if (scale_flag) fix_chp (coord++, TRUE);
             else            fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE);
             count += 4;
            } 
         else if (scale_flag)
            {fix_chp (coord++, tmp);         
             tmp = tmp ? FALSE : TRUE;
            }  
         else if (mode_flag !=2)
            {fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE);
             count += 4;
            }     
         else 
            {fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE);
             fix_chp (coord++, FALSE|mode_flag);
             count += 4;
            }    
        }
  return;
}
/*--------------------------------- fix_chp ---------------------------------*/
/* ACTION: Adapte la coordonne passee en caractere en point ecrans          */
/* ENTREE: *pcoord pointe sur la coordonnee                                  */
/*         flag FALSE->coord X TRUE->coord Y                                 */
/*                  2->coord X    3->coord Y (mode 16 pixels obligatoire)    */
/*                                           ce mode sert pour obliger un    */
/*                                           objet  scaler sa hauteur comme */
/*                                           une icone (utile si il en       */
/*                                           contient!! )                    */
                 
void fix_chp (INT16 *pcoord, INT16 flag)
{INT16 ncoord = *pcoord & 0xff;    /* purifier coord mode caractere          */
 if (!flag && ncoord == 0x50)      /* si = 80 caracteres                     */
        ncoord = xdesk.g_w;        /* xdesk.w = largeur de l'cran en points */
 else if (flag==0)  ncoord *=  xgl_wbox;          
 else if (flag==1)  ncoord *=  xgl_hbox;         
 else if (flag|2)   ncoord *=  16;        
 if (((*pcoord >> 8) & 0xff) > 0x80)
     ncoord += (((*pcoord >> 8) & 0xff) | 0xff00);
 else
     ncoord += ((*pcoord >> 8) & 0xff);

 *pcoord = ncoord;
}

/*------------------------------ rs_sglobal----------------------------------*/
/* ACTION: initialise les variables globales rs_globale, hdr_buf, rs_hdr     */
/*          partir de l'adresse base (celle de chargement de la ressource)  */
void rs_sglobal (INT16 *base)
{rs_global    = base;
 hdr_buf      = (RSXHDR *)*(long *)&rs_global[7];
 (long)rs_hdr = (long)hdr_buf + sizeof (RSXHDR);
 return;
}

/*------------------------------ rs_gaddr----------------------------------*/

INT16 rs_gaddr (INT16 *base, INT16 re_gtype, INT16 re_gindex, OBJECT **re_gaddr)
{ rs_sglobal (base);
  *re_gaddr = get_address (re_gtype, re_gindex);
  if (*re_gaddr == (OBJECT *)NULL)  return (FALSE);
  return (TRUE);
}

/*------------------------------ rs_sadd ----------------------------------*/

INT16 rs_sadd (INT16 *base, INT16 rs_stype, INT16 rs_sindex, OBJECT *re_saddr)
{ OBJECT *old_addr;
  rs_sglobal (base);
  old_addr = get_address (rs_stype, rs_sindex);
  if (old_addr == (OBJECT *)NULL)    return (FALSE);
  *old_addr = *re_saddr;
  return (TRUE);
}

/*------------------------------ get_address ----------------------------------*/
void *get_address (INT16 type, INT16 index)
{
    void *the_addr = (void *)NULL;
    union
    {
        void        *dummy;
        char        *string;
        OBJECT    **dpobject;
        OBJECT    *object;
        TEDINFO    *tedinfo;
        ICONBLK    *iconblk;
        BITBLK    *bitblk;
    } all_ptr;

    switch (type)
    {
        case R_TREE:
            all_ptr.dpobject = (OBJECT **)(*(long **)&rs_global[5]);
            the_addr = all_ptr.dpobject[index];
            break;

        case R_OBJECT:
            the_addr = get_sub (index, hdr_buf->rsh_object, sizeof(OBJECT));
            break;

        case R_TEDINFO:
        case R_TEPTEXT:
            the_addr = get_sub (index, hdr_buf->rsh_tedinfo, sizeof(TEDINFO));
            break;

        case R_ICONBLK:
        case R_IBPMASK:
            the_addr = get_sub (index, hdr_buf->rsh_iconblk, sizeof(ICONBLK));
            break;

        case R_BITBLK:
        case R_BIPDATA:
            the_addr = get_sub (index, hdr_buf->rsh_bitblk, sizeof(BITBLK));
            break;

        case R_OBSPEC:
            all_ptr.object = get_address(R_OBJECT, index);
            the_addr = &all_ptr.object->ob_spec.index;
            break;

        case R_TEPVALID:
        case R_TEPTMPLT:
            all_ptr.tedinfo = get_address(R_TEDINFO, index);
            if (type == R_TEPVALID)
                the_addr = &all_ptr.tedinfo->te_pvalid;
            else
                the_addr = &all_ptr.tedinfo->te_ptmplt;
            break;

        case R_IBPDATA:
        case R_IBPTEXT:
            all_ptr.iconblk = get_address(R_ICONBLK, index);
            if (type == R_IBPDATA)
                the_addr = &all_ptr.iconblk->ib_pdata;
            else
                the_addr = &all_ptr.iconblk->ib_ptext;
            break;

        case R_STRING:
            the_addr = get_sub (index, hdr_buf->rsh_frstr, sizeof (char *));
            the_addr = (void *)*(char *)the_addr;
            break;

        case R_IMAGEDATA:
            the_addr = get_sub (index, hdr_buf->rsh_imdata, sizeof (char *));
            the_addr = (void *)*(char *)the_addr;
            break;

        case R_FRIMG:
            the_addr = get_sub (index, hdr_buf->rsh_frimg, sizeof (char *));
            the_addr = (void *)*(char *)the_addr;
            break;

        case R_FRSTR:
            the_addr = get_sub (index, hdr_buf->rsh_frstr, sizeof (char *));
            break;
    }

    return (the_addr);
}

/*------------------------------ get_sub ----------------------------------*/
void *get_sub (INT16 index, long offset, INT16 size)
{unsigned char *ptr = (unsigned char *)rs_hdr;

 ptr += offset;
 ptr += (index * size);
 return ((void *)ptr);
}


/*------------------------------ rs_fixindex ----------------------------------*/

 void rs_fixindex (INT16 *global, INT16 scale_flag)
{ rs_sglobal (global);
  fix_object (scale_flag);
}

/*------------------------------ do_rsfix ----------------------------------*/

 void do_rsfix (unsigned long size)
{
    rs_global[7] = ((long)hdr_buf >> 16) & 0xFFFF;
    rs_global[8] = (long)hdr_buf & 0xFFFF;
    rs_global[9] = (unsigned INT16)size;

    fix_treeindex ();
    fix_tedinfo ();

    fix_nptr (hdr_buf->rsh_nib - 1, R_IBPMASK);
    fix_nptr (hdr_buf->rsh_nib - 1, R_IBPDATA);
    fix_nptr (hdr_buf->rsh_nib - 1, R_IBPTEXT);

    fix_nptr (hdr_buf->rsh_nbb - 1, R_BIPDATA);
    fix_nptr (hdr_buf->rsh_nstring - 1, R_FRSTR);
    fix_nptr (hdr_buf->rsh_nimages - 1, R_FRIMG);
}

/*------------------------------ fix_treeindex ------------------------------*/
/* ACTION: additionne l'ofset de chargement de la ressource au tableau de    */
/*         pointeurs d'arbre                                                 */
 void fix_treeindex (void)
{OBJECT **adr  = get_sub (0, hdr_buf->rsh_trindex, sizeof (OBJECT *));
 long   count  = hdr_buf->rsh_ntree - 1L;;

 rs_global[5] = ((long)adr >> 16) & 0xFFFF;
 rs_global[6] = (long)adr & 0xFFFF;
 while (count >= 0)
    {fix_long ((long *)(count * sizeof (OBJECT *) + (long)adr));
     count--;
    }
}

/*------------------------------ fix_object ----------------------------------*/
void fix_object (INT16 scale_flag)
{INT16      i = 0;
 INT16 count  = hdr_buf->rsh_nobs;
 INT16 s_flag = scale_flag;
 OBJECT *obj;

 while (i < count)
    {obj = get_address (R_OBJECT, i);
     
     if ((obj->ob_type & 0xff) != G_BOX && (obj->ob_type & 0xff) != G_IBOX && (obj->ob_type & 0xff) != G_BOXCHAR)
          fix_long ((long *)&obj->ob_spec.index);
     
     /*........... si objet racine type GBOX et lettre significative ............*/
     /*            alors c'est la lettre qui determine l'echelle                 */
     
     if (obj->ob_next == -1)                /* SI OBJET RACINE    */
        {INT16  ob_type = obj->ob_type & 0xff;
         INT16 xob_type = GET_XOBTYPE(obj,0);
         s_flag = scale_flag;
         if (ob_type == G_BOX || ob_type == G_IBOX || ob_type == G_BOXCHAR)
            {char c  = obj->ob_spec.obspec.character;
             if      (c=='') s_flag = NO_SCALE;
             else if (c=='') s_flag = SCALE;
             if (c==''||c=='') obj->ob_spec.obspec.character=0;
            }        
         if (ob_type == G_BUTTON  || ob_type == G_TEXT   ||
             ob_type == G_BOXTEXT || ob_type == G_FTEXT  ||
             ob_type == G_FBOXTEXT
            )
            {char *c = ObjcGetTxt(obj,0);
             if      (*c=='') s_flag = NO_SCALE;
             else if (*c=='') s_flag = SCALE;
             if (xob_type==0)  *c=0;
            }            
         if (s_flag) obj->ob_state |= 0x2000;    
        } 
     rs_obfix (obj, 0, s_flag);
     i++;
    } /* endwhile (i < count) */
}

/*------------------------------ fix_tedinfo ----------------------------------*/
void fix_tedinfo()
{long        count  = hdr_buf->rsh_nted - 1;
 TEDINFO    *tedinfo;

 while (count >= 0)
   {tedinfo = get_address (R_TEDINFO, count);
    if (fix_ptr (R_TEPTEXT, count))
       {tedinfo->te_txtlen = 0;
        if (tedinfo->te_ptext>0)
            tedinfo->te_txtlen = strlen ((char*)tedinfo->te_ptext) + 1;
       }
    if (fix_ptr (R_TEPTMPLT, count))
       {tedinfo->te_tmplen = 0;
        if (tedinfo->te_ptmplt>0)
            tedinfo->te_tmplen = strlen ((char*)tedinfo->te_ptmplt) + 1;
       }
    fix_ptr (R_TEPVALID, count);
    count--;
   }
 return;
}

/*------------------------------ fix_nptr ----------------------------------*/
void fix_nptr (long index, INT16 ob_type)
{while (index >= 0)
        fix_long (get_address(ob_type, index--));
}

/*------------------------------ fix_ptr ----------------------------------*/
INT16 fix_ptr (INT16 type, long index)
{return (fix_long (get_address (type, index)));
}

/*------------------------------ fix_long -----------------------------------*/
/* ACTION: l'ofset de chargement de la ressource est ajoutee au mot long     */
/*         point par lptr                                                   */
INT16 fix_long (long *lptr)
{long base;
 base = *lptr;
 if (base == 0L) return (FALSE);
 base += (long)rs_hdr;
 *lptr = base;
 return (TRUE);
}

/*------------------------------ do_ciconfix ----------------------------------*/
/* initialiser les icnes couleur pour la rsolution actuelle                */

void do_ciconfix (unsigned long header, RSXHDR *rsxhdr, long rs_len)
{long   *cicon_liste;
 INT16   i;
 INT16 nub = 0, work_out [57], *palette;
 OBJECT *obj;
    
 /* cicon_liste = (long *)(*(long *)(rsxhdr->rsh_rssize + (rsxhdr->rsh_rssize & 1L) + header + sizeof (long)) + header); */
 
 /*..............................reperer la liste d'icones couleurs ...............................*/
 cicon_liste =                                                         /* ->le long situ :       */
 (long *)(*(long *) (rsxhdr->rsh_rssize + (rsxhdr->rsh_rssize & 1L) +  /*   (longueur ressource  + */
                     header +                                          /*    adresse header      + */
                     sizeof (long)                                     /*    taille d'un long)     */
                    )                                                  /*                          */
          +                                                            /*  +                       */
          header                                                       /* ->adresse ressource      */
         );
 /*...................... si cette liste existe ainsi que les icones ..............................*/ 
 if ((long)cicon_liste - header > rsxhdr->rsh_rssize && 
     (long)cicon_liste - header < rs_len)
    {/*  INT16 fill_cicon_liste  (long *cicon_liste, unsigned long header, RSXHDR *rsxhdr); */
     if (fill_cicon_liste (cicon_liste, header,rsxhdr) != -1    )
        {
         
         if (*(long *)rs_global && *(long *)&rs_global[2])
            {vq_extnd (VDIhandle, TRUE, work_out);    /* Nombre de plans */
             xscrn_planes = work_out[4];

             xpixelbytes = test_rez ();
             palette = (INT16 *)*(long *)(rsxhdr->rsh_rssize + (rsxhdr->rsh_rssize & 1L) + header + 2 * sizeof (long));
             if (palette != NULL)
                {(long)palette += header;
                 memcpy (rgb_palette, palette, sizeof (rgb_palette));
                 is_palette = TRUE;
                }
             else
                 is_palette = FALSE;
                
             xfill_farbtbl ();
            
             for (i = 0; i < rsxhdr->rsh_nobs; i++)
                {obj = &((OBJECT *)(rsxhdr->rsh_object + header))[i];
                 if ((obj->ob_type & 0xff) == G_CICON)
                    {if ( xadd_cicon ( (CICONBLK *)obj->ob_spec.index, obj, nub++) == 0)
                        {memset (&((CICON *)*(long *)&rs_global[2])[nub-1], 0, sizeof (CICON));
                         obj->ob_type = (obj->ob_type & 0xff00) | G_ICON;
                        }
                     obj->ob_spec.index -= header;
                    }
                }
            }
         else
/* #endif */
            {for (i = 0; i < rsxhdr->rsh_nobs; i++)
                 {obj = &((OBJECT *)(rsxhdr->rsh_object + header))[i];
                  if ((obj->ob_type & 0xff) == G_CICON)
                     {obj->ob_type = (obj->ob_type & 0xff00) | G_ICON;
                      obj->ob_spec.index -= header;
                     }
                 } /*endfor (i = 0; i < rsxhdr->rsh_nobs; i++) */
            }
        }
    }
}

/*------------------------------ fill_cicon_liste ----------------------------------*/
/* initialisation du pointeur pour les icnes couleurs dans le RSC                  */

INT16 fill_cicon_liste (long *cicon_liste, unsigned long header, RSXHDR *rsxhdr)

{   INT16     i, i2, num = 0;
    char     *p;
    long     iclen, num_cicon, ob, p2;
    CICONBLK *cblk;
    CICON    *cicon, *cold;
    OBJECT   *pobject;
    /*.............................. compter nbr d'icones ................*/
    while (!cicon_liste[num])
            num++;    
    if (cicon_liste[num] != -1L)
        return (-1);
    /*............... pointer sur les CICONBLK proprement dits ...........*/
    /*                et reloger toutes les adresses                      */
    cblk = (CICONBLK *)&cicon_liste[num+1];
    /*.............. pour toutes les CICONBLK reloger adresses ...........*/
    /* typedef struct cicon_blk                                           */
    /*    {                                                               */
    /*     ICONBLK monoblk;            default monochrome icon block      */
    /*     CICON   *mainlist;          -> linked list for resolutions     */
    /*    } CICONBLK;                                                     */
    /*                                                                    */
    /* la structure est immediatement suivie des blocs de donnes:        */
    /*                 ib_data, ib_mask, 12 caracteres de masque          */
    /*                 puis (si elle existe) liste des CICON de cette     */
    /*                 CICONBLK (peut y en avoir plusieurs selon          */
    /*                 resolutions comme zero)                            */
    /*                 noter que:                                         */
    /*                 CICON   *mainlist; contient le nombre de CICON     */
    /*                  reloger, qui suivent et qu'il convient de placer */
    /*                         avoir recupere cette valeur, l'adresse de  */
    /*                         la liste                                   */
    /* typedef struct cicon_data                                          */
    /*    {                                                               */
    /*     INT16              num_planes;   number of color bit planes    */
    /*     INT16              *col_data;    -> color image for unselected */
    /*     INT16              *col_mask;    -> bit mask for unselected    */
    /*     INT16              *sel_data;    -> color image for selected   */
    /*     INT16              *sel_mask;    -> bit mask for selected      */
    /*     struct cicon_data  *next_res;    NULL for last resolution      */
    /*    } CICON;                                                        */


    for (i = 0; i < num; i++)
       {/*......... placer adresse reelle dans la liste ..................*/
        cicon_liste[i] = (long)cblk;  /* mettre adresse premier icone ds liste */
        /*......... reloger lesdonnes monochromes .......................*/
        p = (char *)&cblk[1];         /* relever adresse                       */
        cblk->monoblk.ib_pdata = (INT16 *)p; /* la mettre en data                */
        iclen = cblk->monoblk.ib_wicon / 8 * cblk->monoblk.ib_hicon;
        p += iclen;
        cblk->monoblk.ib_pmask = (INT16 *)p;
        p += iclen;
        p2 = (long)cblk->monoblk.ib_ptext;
        if (!p2 || header + p2 == (long)p || p2 < rsxhdr->rsh_string || p2 > rsxhdr->rsh_rssize)
            cblk->monoblk.ib_ptext = (char *)p;
        else
            (long)cblk->monoblk.ib_ptext = header + (long)cblk->monoblk.ib_ptext;
        
        cicon = (CICON *)&p[12];
        p    += 12L;
        cold  = cicon;
        /*.......... si liste de CICON  couleurs pour .........*/
        /*      (peut y en avoir plusieurs selon resolution)   */
        /*           pour cette CICONBLK: les reloger          */
        if ((num_cicon = (long)cblk->mainlist) > 0)
           {
            cblk->mainlist = cicon;             /* placer adresse liste CICON */
            for (i2 = 0; i2 < num_cicon; i2++)  /* reloger les data           */
                {p = (char *)&cicon[1];
                 cicon->col_data = (INT16 *)p;
                 p += iclen * cicon->num_planes;
                 cicon->col_mask = (INT16 *)p;
                 p += iclen;
                 if (cicon->sel_data != NULL)
                    {cicon->sel_data = (INT16 *)p;
                     p += iclen * cicon->num_planes;
                     cicon->sel_mask = (INT16 *)p;
                     p += iclen;
                   }
                 cicon->next_res = (CICON *)p;
                 cold = cicon;
                 cicon = (CICON *)p;
                } /* endfor (i2 = 0; i2 < num_cicon; i2++) */
            cold->next_res = NULL;             /* y en a plus                  */
           } /* endif ((num_cicon = (long)cblk->mainlist) > 0) */
        cblk = (CICONBLK *)p;
       } /*endfor (i = 0; i < num; i++) */
    
    /*.................. petits reajustages divers ............................*/
    if (num != -1)
       {/*....... adresse des premiers objets .................................*/
        pobject = (OBJECT *)(header + rsxhdr->rsh_object);
        /*.................. placer les adresse reelles des icones dans ...........*/
        /*                   leur:  pobject[ob].ob_spec.index                      */
        for (ob = 0; ob < rsxhdr->rsh_nobs; ob++)
            {if ((pobject[ob].ob_type & 0xff) == G_CICON)
                      pobject[ob].ob_spec.index = cicon_liste[pobject[ob].ob_spec.index];
            }
        /*.................... reserver memoire pour les OBBLK et CICON ...........*/
        /* typedef struct                                                          */
        /*   {                                                                     */
        /*    USERBLK    ublk;                                                     */
        /*    unsigned INT16 old_type;                                             */
        /*   } OBBLK;                                                              */
        
        if ((*(long *)rs_global = (long)calloc_ID (num * sizeof (OBBLK), 1, (long)rs_global)) != 0L)
            memset ((void *)*(long *)rs_global, 0, num * sizeof (OBBLK));
        if ((*(long *)&rs_global[2] = (long)calloc_ID (num * sizeof (CICON), 1, (long)rs_global)) != 0L)
            memset ((void *)*(long *)&rs_global[2], 0, num * sizeof (CICON));
        rs_global[4] = num;
       }
/*pat*/    
    else
        rs_global[4] = 0;
 return (num);
}


/*------------------------------ xadd_cicon ----------------------------------*/
/* changer le format de l'icne et l'adapter aux autres rsolutions.          */

INT16 xadd_cicon (CICONBLK *cicnblk, OBJECT *obj, INT16 nub)
{INT16     x, y, line, xmax, best_planes, find_planes;
 CICON    *cicn, *color_icn, *best_icn = NULL;
 long     len, *next;
 XMFDB     d;
 OBBLK    *ub;
 CICON    *max_icn = NULL;
 /*................ calcul nbr octets d'un plan ..................*/
 len = cicnblk->monoblk.ib_wicon / 8 * cicnblk->monoblk.ib_hicon;
 /*................ adresse de l'icone couleur ...................*/
 color_icn = &((CICON *)*(long *)&rs_global[2])[nub];
 
 best_planes = 1;
 /*................. 8 plans maxi (256 couleurs) .................*/
 if (xscrn_planes > 8)     /* ERS  14/10/2000   */
     find_planes = 8;
 else
     find_planes = xscrn_planes;
 /*................ adresse liste de cette icone .................*/
 cicn = cicnblk->mainlist;
 next = (long *)&cicnblk->mainlist;
 /*................ chercher ds liste si existe ..................*/
 /*            une icone correspondant au nbr de plans            */
 while (cicn != NULL)
   {*next = (long)cicn;
     next = (long *)&cicn->next_res;

     /*......... relever icone ayant nbr de plans .................*/
     /*          sup  celui de l'ecran                            */
     /*     (alors c'est max_icn car on devra rester dessous)      */
     if (cicn->num_planes > xscrn_planes)
         max_icn = cicn;
     /*..... meilleure = le plus grand nbr de plans (au moins 1)........*/
     /*                  inferieure ou egale au nbr plans max possible  */
     if (cicn->num_planes >= best_planes && cicn->num_planes <= find_planes)
        {best_planes = cicn->num_planes;
         best_icn    = cicn;
        }
     cicn = cicn->next_res;
   } /*end while (cicn != NULL)*/
    /*.................... si rien trouve ds liste CASSOS ................*/
 if (best_icn == NULL)           /* aucune icne couleur trouve          */
     return (FALSE);
 else
     *color_icn = *best_icn;
 /*............ Si il existe une icone couleur de plus de 1 plan ......*/
 /*             mettre son nbr de plans  celui de l'ecran             */
 /*             sinon elle est de 1 plan monochrome                    */
 if (best_planes > 1)
     color_icn->num_planes = xscrn_planes;
 else
     color_icn->num_planes = 1;
    
 /*............... Allouer la place pour le format universel .........*/
 /*               CAD taille d'un plan: len * nbr de plans            */
 if ((color_icn->col_data = calloc_ID (len * color_icn->num_planes, 1, (long)rs_global)) == NULL)
     return (FALSE);
 /*............... pareil pour l'icone selectionne ..................*/
 if (color_icn->sel_data)
    {if ((color_icn->sel_data = calloc_ID (len * color_icn->num_planes, 1, (long)rs_global)) == NULL)
        {free (color_icn->col_data);
         return (FALSE);
        }
    }
 /*........ si pas d'icone selectionne dans l'icone la meilleure ....*/
 /*         preparer un masque de selection en reservant sa place     */
 if (best_planes > 1)
    {if (best_icn->sel_data == NULL)
        {/*....... Prparer le masque slectionn ....................*/
         if ((color_icn->sel_mask = calloc_ID (len, 1, (long)rs_global)) == NULL)
            {free (color_icn->col_data);
             if (color_icn->sel_data)
                 free (color_icn->sel_data);
             return (FALSE);
            }
         xmax = cicnblk->monoblk.ib_wicon / 16; /* nbr de short de la largeur */
         /*........ pour toutes les lignes de cette icone............*/
         for (y = 0; y < cicnblk->monoblk.ib_hicon; y++)
             {line = y * xmax;
              for (x = 0; x < xmax; x++)
                  {if (y & 1)
                       color_icn->sel_mask[line + x] = best_icn->col_mask[line + x] & 0xaaaa;
                   else
                       color_icn->sel_mask[line + x] = best_icn->col_mask[line + x] & 0x5555;
                  }
             }
        } /*endif if (best_icn->sel_data == NULL)   */
     /*.......... initialiser MFDB icone couleur .....................*/
     d.mp  = color_icn->col_data;
     d.fwp = cicnblk->monoblk.ib_wicon;
     d.fh  = cicnblk->monoblk.ib_hicon;
     d.fww = d.fwp >> 4;
     d.ff  = TRUE;
     d.np  = xscrn_planes;
     /*...............................................................*/
     xfix_cicon ((unsigned INT16 *)best_icn->col_data, len, best_planes, xscrn_planes, &d);
     if (best_icn->sel_data)
        {d.mp = color_icn->sel_data;
         xfix_cicon ((unsigned INT16 *)best_icn->sel_data, len, best_planes, xscrn_planes, &d);
        }
    }
 else
    {memcpy (color_icn->col_data, best_icn->col_data, len);
     memcpy (color_icn->sel_data, best_icn->sel_data, len);
    }

 if (best_icn->num_planes < color_icn->num_planes && max_icn != NULL)
    {if (best_icn->sel_data == NULL || max_icn->sel_data != NULL)
        {best_icn->col_data = max_icn->col_data;
         best_icn->sel_data = max_icn->sel_data;
         best_icn->num_planes = xscrn_planes;
        }
    }
    
 if (best_icn->num_planes == color_icn->num_planes)
    {memcpy (best_icn->col_data, color_icn->col_data, len * color_icn->num_planes);
     free (color_icn->col_data);
     color_icn->col_data = NULL;
     if (best_icn->sel_data != NULL)
        {memcpy (best_icn->sel_data, color_icn->sel_data, len * color_icn->num_planes);
         free (color_icn->sel_data);
         color_icn->sel_data = NULL;
        }
     else
        {memcpy (cicnblk->monoblk.ib_pmask, color_icn->sel_mask, len);
         best_icn->sel_mask = cicnblk->monoblk.ib_pmask;
         free (color_icn->sel_mask);
         color_icn->sel_mask = NULL;
        }
    }
 else
    {if (best_icn->sel_data == NULL)
        {memcpy (cicnblk->monoblk.ib_pmask, color_icn->sel_mask, len);
         if (color_icn->sel_mask) free (color_icn->sel_mask);
         color_icn->sel_mask  = NULL;
         best_icn->col_data   = color_icn->col_data;
         best_icn->sel_mask   = cicnblk->monoblk.ib_pmask;
         best_icn->num_planes = color_icn->num_planes;
        }
     else
        *best_icn = *color_icn;
    }
 cicnblk->mainlist = best_icn;
/*
#else
    color_icn->next_res = cicnblk->mainlist;
    cicnblk->mainlist   = color_icn;
#endif
*/

/* if(Sversion()<0x3000)     */
 {ub = (OBBLK *)*(long *)rs_global;
  ub[nub].old_type = G_CICON;
  ub[nub].ublk.ub_parm = obj->ob_spec.index;
  (long)ub[nub].ublk.ub_code = (long)xdraw_cicon;
  obj->ob_spec.index = (long)&ub[nub].ublk;
  obj->ob_type  = (G_CICON<<8) | G_USERDEF;        
 }/*if*/
    
 return (TRUE);
}

/*------------------------------ test_rez ----------------------------------*/
/* combiens de bytes par pixels seront changs au format                   */
/*
typedef struct 
{
  void *mp;  adresse data
  INT16 fwp;   largeur (arondie au mot sup)
  INT16 fh;    hauteur
  INT16 fww;   nbr mot de la largeur
  INT16 ff;    format standard 1/ non standard 0
  INT16 np;    nbr de plan
  INT16 r1;    reserves
  INT16 r2;
  INT16 r3;
} MFDB;
*/

INT16 test_rez ()
{INT16             i, np, color, pxy[8], rgb[3], bpp = 0;
 unsigned INT16    backup[32], test[32];
 INT16             black[3] = {0, 0, 0};
 INT16             white[3] = {1000, 1000, 1000};
 XMFDB             pixel    = {NULL, 16, 1, 1, 0, 1, 0, 0, 0};
 XMFDB             stdfm    = {NULL, 16, 1, 1, 1, 1, 0, 0, 0};
 XMFDB             screen;

 if (xscrn_planes >= 8)
    {stdfm.np = pixel.np = xscrn_planes;
     if (xscrn_planes == 8)
        {color = 0xff;
         memset (test, 0, xscrn_planes * sizeof (INT16));
         for (np = 0; np < xscrn_planes; np++)
              test[np] = (color & (1 << np)) << (15 - np);
         
         pixel.mp = stdfm.mp = test;
         vr_trnfm (VDIhandle,(MFDB*) &stdfm,(MFDB*) &pixel);
         
         for (i = 1; i < xscrn_planes; i++)
              if (test[i])    break;
         
         if (i >= xscrn_planes && !(test[0] & 0x00ff))    bpp = 1;
        }
     else
        {xrect2array (&xdesk, pxy); /*printf("%c",7);*/
         vs_clip (VDIhandle, TRUE, pxy); /*FALSE*/
         screen.mp = NULL;
         
         memset (backup, 0, sizeof (backup));
         
         vswr_mode (VDIhandle, MD_REPLACE);
         vsl_ends  (VDIhandle, 0, 0);
         vsl_type  (VDIhandle, 1);
         vsl_width (VDIhandle, 1);
         /*.............. zone de 1 pixel .........*/
         memset (pxy, 0, sizeof (pxy));            
         graf_mouse (M_OFF, NULL);
         
         pixel.mp = backup;    
         vro_cpyfm (VDIhandle, S_ONLY, pxy, (MFDB*)&screen,(MFDB*) &pixel);
         
         /*.......... sauver l'ancienne couleur........... */
         vq_color (VDIhandle, 15, 1, rgb);
         
         /*.......... tester le format universel ..........*/
         /*                    >> on trace un point blanc  */
         vsl_color (VDIhandle, 15);
         vs_color  (VDIhandle, 15, white);
         v_pline   (VDIhandle, 2, pxy);
         
         /*.....creer un bit map plein de zero ................*/
         memset (test, 0, xscrn_planes * sizeof (INT16));
         pixel.mp = test; /*   >> on sauve le point ds test */ 
         vro_cpyfm (VDIhandle, S_ONLY, pxy,(MFDB*) &screen,(MFDB*) &pixel);
         
         /*..... quel est le plan chang ......................*/
         for (i = (xscrn_planes + 15) / 16 * 2; i < xscrn_planes; i++)
              if (test[i])    break;
         
         if (i >= xscrn_planes)
            {vs_color (VDIhandle, 15, black);
             v_pline (VDIhandle, 2, pxy);
             
             memset (test, 0, xscrn_planes * sizeof (INT16));
             vro_cpyfm (VDIhandle, S_ONLY, pxy,(MFDB*) &screen, (MFDB*)&pixel);
             
             for (i = (xscrn_planes + 15) / 16 * 2; i < xscrn_planes; i++)
                  if (test[i])    break;
             
             if (i >= xscrn_planes) bpp = (xscrn_planes + 7) / 8;
            }
         
         /*.......... restaurer l'ancienne couleur et point............ */
         vs_color (VDIhandle, 15, rgb);    
         pixel.mp = backup;    /* restaurer le point */
         vro_cpyfm (VDIhandle, S_ONLY, pxy, (MFDB*)&pixel, (MFDB*)&screen);        
         graf_mouse (M_ON, NULL);
         
         xrect2array (&xdesk, pxy);
         vs_clip (VDIhandle, FALSE, pxy); /*TRUE*/
        } /* endelseif if (xscrn_planes == 8) */
    }   /* endif if (xscrn_planes >= 8)  */
 return (bpp);
}

/*------------------------------ xfill_farbtbl ------------------------------*/
/* En mode True-Color, passer la valeur de point en palette RVB              */
/*****************************************************************************/

 void xfill_farbtbl ()
{INT16 np, color, pxy[8], backup[32], rgb[3];
 XMFDB screen;
 XMFDB pixel      = {NULL, 16, 1, 1, 0, 1, 0, 0, 0};
 XMFDB stdfm      = {NULL, 16, 1, 1, 1, 1, 0, 0, 0};
 INT16 pixtbl[16] = {0, 2, 3, 6, 4, 7, 5, 8, 9, 10, 11, 14, 12, 15, 13, 16};
    
 if (xscrn_planes >= 8)
    {if (xscrn_planes > 8)
        {if (is_palette == FALSE)    /* pas de palette dans le Ressource */
            {for (color = 0; color < 255; color++)
                 {if (color < 16)
                     {vq_color (VDIhandle, pixtbl[color], 1, rgb_palette[color]);
                      rgb_palette[color][3] = pixtbl[color];
                     }
                  else
                     {vq_color (VDIhandle, color - 1, 1, rgb_palette[color]);
                      rgb_palette[color][3] = color - 1;
                     }
                 }
             vq_color (VDIhandle, 1, 1, rgb_palette[255]);
             rgb_palette[255][3] = 1;
             is_palette = TRUE;
            }
            
         /*printf("%c",7);*/
         vs_clip (VDIhandle, 0, pxy); /*FALSE*/
         graf_mouse (M_OFF, NULL);
         memset (backup, 0, sizeof (backup));
         memset (farbtbl, 0, 32 * 256 * sizeof (INT16));
         screen.mp = NULL;
         stdfm.np  = pixel.np = xscrn_planes;
         
         vswr_mode (VDIhandle, MD_REPLACE);
         vsl_ends  (VDIhandle, 0, 0);
         vsl_type  (VDIhandle, 1);
         vsl_width (VDIhandle, 1);
         memset    (pxy, 0, sizeof (pxy));
         /*....................sauver le point.............................*/
         pixel.mp = backup;    
         vro_cpyfm (VDIhandle, S_ONLY, pxy, (MFDB*)&screen, (MFDB*)&pixel);
         
         /*...............calculer l'ancienne couleur......................*/
         vq_color (VDIhandle, 15, 1, rgb);
         
         for (color = 0; color < 256; color++)
             {/*......... pour chaque couleur de la pallette tracer un point .....*/
              vs_color  (VDIhandle, 15, rgb_palette[color]);
              vsl_color (VDIhandle, 15);
              v_pline   (VDIhandle, 2, pxy);
              
              stdfm.mp = pixel.mp = farbtbl[color];
              
              /* vro_cpyfm,  car v_get_pixel ne fonctionne pas en TrueColor (>=24 Plans) */
              vro_cpyfm (VDIhandle, S_ONLY, pxy, (MFDB*)&screen, (MFDB*)&pixel);
              if (farbtbl2 != NULL && xpixelbytes)
                 {farbtbl2[color] = 0L;
                  memcpy (&farbtbl2[color], pixel.mp, xpixelbytes);
                 }
              
              vr_trnfm (VDIhandle, (MFDB*)&pixel, (MFDB*)&stdfm);
              for (np = 0; np < xscrn_planes; np++)
                   if (farbtbl[color][np])    farbtbl[color][np] = 0xffff;
             }
         
         /*................ restaurer l'ancien point................. */
         vs_color (VDIhandle, 15, rgb);
         pixel.mp = backup;    /* restaurer le point */
         vro_cpyfm (VDIhandle, S_ONLY, pxy, (MFDB*)&pixel, (MFDB*)&screen);        
         graf_mouse (M_ON, NULL);
         vs_clip (VDIhandle, FALSE, pxy); 
        }  /* endif if (xscrn_planes > 8  */
    } /* endif if xscrn_planes >= 8   */
}

/*------------------------------ xfix_cicon ---------------------------------*/
/* adapter l'icne  la rsolution graphique actuelle                        */
/* (par exemple : une icne de 4 Plans vers 24 Plans TrueColor)              */

void xfix_cicon (unsigned INT16 *col_data, long len, INT16 old_planes, INT16 new_planes, XMFDB *s)
{long  x, i, old_len, rest_len, mul[32], pos;
 unsigned INT16 np, *new_data, mask, pixel, bit, color, back[32], old_col[32], maxcol;
 INT16  got_mem = FALSE;
 XMFDB  d;
    
 len >>= 1;

 if (old_planes == new_planes)
    {if (s != NULL)
        {if (new_planes == xscrn_planes)
            {d     = *s;
             d.ff  = FALSE;
             s->mp = col_data;
             if (d.mp == s->mp)
                {if ((d.mp = calloc_ID (len * 2 * new_planes, 1, (long)rs_global)) == NULL)
                     d.mp = s->mp;
                 else
                     got_mem = TRUE;
                }
                
             vr_trnfm (VDIhandle, (MFDB*)s, (MFDB*)&d);
             if (d.mp != s->mp && got_mem == TRUE)
                {
                 memcpy (s->mp, d.mp, len * 2 * new_planes);
                 free (d.mp);
                }
            } /* endif (new_planes == xscrn_planes) */
         else
            {memcpy (s->mp, col_data, len * 2 * new_planes);
            }
        }
     return;
    } /*endif (old_planes == new_planes) */
    
 if (new_planes <= 8)
    {old_len  = old_planes * len;
     rest_len = new_planes * len - old_len;

     if (s != NULL)
        {new_data = &((unsigned INT16 *)s->mp)[old_len];
         memset (new_data, 0, rest_len * 2);
         memcpy (s->mp, col_data, old_len * 2);
         col_data = s->mp;
        }
     else
        {new_data = (unsigned INT16 *)&col_data[old_len];
        }
     for (x = 0; x < len; x++)
         {mask = 0xffff;
          
          for (i = 0; i < old_len; i += len)
               mask &= (unsigned INT16)col_data[x+i];
            
          if (mask)
               for (i = 0; i < rest_len; i += len)
                    new_data[x+i] |= mask;
         } /*endfor (x = 0; x < len; x++) */

     if (s != NULL)    /* convertir au format universel */
        {d    = *s;
         d.ff = 0;
         if ((d.mp = calloc_ID (len * 2 * new_planes, 1, (long)rs_global)) == NULL)
              d.mp = s->mp;
            
         vr_trnfm (VDIhandle, (MFDB*)s,(MFDB*) &d);
         if (d.mp != s->mp)
            {memcpy (s->mp, d.mp, len * 2 * new_planes);
             free (d.mp);
            }
        } /* endif (s != NULL) */
    } /*endif (new_planes <= 8) */
 else    /* TrueColor, valeur de points en RVB */
    {if (!xpixelbytes || s == NULL)
        {for (i = 0; i < new_planes; i++)  mul[i] = i * len;
            
         if (old_planes < 8)
            {maxcol = (1 << old_planes) - 1;
             memcpy (old_col, farbtbl[maxcol], new_planes * sizeof (INT16));
             memset (farbtbl[maxcol], 0, new_planes * sizeof (INT16));
            }
         
         if (s != NULL)
            {new_data = &((unsigned INT16 *)s->mp)[old_len];
             memset (new_data, 0, rest_len * 2);
             memcpy (s->mp, col_data, old_len * 2);
             col_data = s->mp;
            }
             
         for (x = 0; x < len; x++)
             {bit = 1;
              for (np = 0; np < old_planes; np++) back[np] = col_data[mul[np] + x];
                
              for (pixel = 0; pixel < 16; pixel++)
                  {color = 0;
                   for (np = 0; np < old_planes; np++)
                       {color += ((back[np] & 1) << np);
                        back[np] >>= 1;
                       }
                    
                   for (np = 0; np < new_planes; np++)
                       {pos = mul[np] + x;
                        col_data[pos] = (col_data[pos] & ~bit) | 
                                        (farbtbl[color][np] & bit);
                       }
                   bit <<= 1;
                  } /* endfor (pixel = 0; pixel < 16; pixel++) */
             } /*endfor (x = 0; x < len; x++) */
         if (old_planes < 8)
             memcpy (farbtbl[maxcol], old_col, new_planes * sizeof (INT16));

         if (s != NULL)    /* convertir au format universel */
            {d    = *s;
             d.ff = 0;
             if ((d.mp = calloc_ID (len * 2 * new_planes, 1, (long)rs_global)) == NULL) 
                  d.mp = s->mp;
                                  
             vr_trnfm (VDIhandle, (MFDB*)s, (MFDB*)&d);
                      
             if (d.mp != s->mp)
                {memcpy (s->mp, d.mp, len * 2 * new_planes);
                 free (d.mp);
                }
            } /*endif (s != NULL) */
        } /* endif (!xpixelbytes || s == NULL) */
     else
        {std_to_byte (col_data, len, old_planes, farbtbl2, s);
        }
    } /* end else if (new_planes <= 8) */
}

/*------------------------------ std_to_byte ----------------------------------*/
/* std_to_byte transforme un dessin du format standard au format             */
/* universel (pour les rsolutions >= 16 Plans)                              */

void std_to_byte (unsigned INT16 *col_data, long len, INT16 old_planes,
                  unsigned long *farbtbl2, XMFDB  *s)
{long  x, i, mul[32], pos;
 unsigned INT16 np, *new_data, pixel, color, back[32];
 INT16  memflag = FALSE;
 unsigned char *p1, *p2;
 unsigned long  colback;

 if (s->mp == col_data)
    {if ((col_data = calloc_ID (len * 2 * s->np, 1, (long)rs_global)) == NULL)
        return;
     memcpy (col_data, s->mp, len * 2 * s->np);
     memflag = TRUE;
    }
 new_data = (unsigned INT16 *)s->mp;
 p1       = (unsigned char *)new_data;

 if (old_planes < 8)
    {colback = farbtbl2[(1 << old_planes) - 1];
     farbtbl2[(1 << old_planes) - 1] = farbtbl2[255];
    }
        
 for (i = 0; i < old_planes; i++) mul[i] = i * len;
    
 pos = 0;
 
 for (x = 0; x < len; x++)
     {for (np = 0; np < old_planes; np++)
           back[np] = col_data[mul[np] + x];
        
      for (pixel = 0; pixel < 16; pixel++)
          {color = 0;
           for (np = 0; np < old_planes; np++)
               {color     |= ((back[np] & 0x8000) >> (15 - np));
                back[np] <<= 1;
               }
           if ( (!is_palette) && (old_planes==8) && (color>=16)) color--;   /* ERS    15/10/2000 */
           switch (xpixelbytes)
             {case 2:
                   new_data[pos++] = *(unsigned INT16 *)&farbtbl2[color];
                   break;

              case 3:
                   p2      = (unsigned char *)&farbtbl2[color];
                   *(p1++) = *(p2++);
                   *(p1++) = *(p2++);
                   *(p1++) = *(p2++);
                   break;

              case 4:
                   ((unsigned long *)new_data)[pos++] = farbtbl2[color];
                   break;
             }
          } /* next pixel  */
     }  /* next x      */

 if (old_planes < 8) farbtbl2[(1 << old_planes) - 1] = colback;
 if (memflag) free (col_data);
}

/*------------------------------ xdraw_cicon ----------------------------------*/
/* dessine l'icne couleur                                                     */
INT16 cdecl xdraw_cicon (PARMBLK *pb)
{INT16    ob_x, ob_y, x, y, dummy, pxy[4], m_mode, i_mode, mskcol, icncol;
 long     ob_spec;
 ICONBLK *iconblk;
 CICON   *cicn;
 INT16   *mask, *data, *dark = NULL;
 char     letter[2];
 INT16    selected, mindex[2], iindex[2], buf, xy[4];
 INT16    invert = FALSE;
 
 selected = pb->pb_currstate & SELECTED;
 
 xrect2array ((GRECT *)&pb->pb_xc, xy);
 vs_clip (VDIhandle, TRUE, xy);   /* dfinit la zone rectangulaire */
 
 ob_spec    = pb->pb_parm;
 ob_x       = pb->pb_x;
 ob_y       = pb->pb_y;
 iconblk    = (ICONBLK *)ob_spec;
 cicn       = ((CICONBLK *)ob_spec)->mainlist;
 m_mode     = MD_TRANS;

 if (selected) /* it was an objc_change */
    {if (cicn->sel_data != NULL)
        {mask = cicn->sel_mask;
         data = cicn->sel_data;
         if (cicn->num_planes > 1)
            {if (cicn->num_planes > 8)    /* TrueColor, carte couleur en mode RVB? */
                 i_mode = S_AND_D;
             else
                i_mode = S_OR_D;
            }
         else
            i_mode = MD_TRANS;
        }
     else
        {mask = cicn->col_mask;
         data = cicn->col_data;
         if (cicn->num_planes > 1)
            {if (cicn->num_planes > 8)
                 i_mode = S_AND_D;
             else
                 i_mode = S_OR_D;
             dark = cicn->sel_mask;
            }
         else
             invert = TRUE;
        }
    }
 else
    {mask = cicn->col_mask;
     data = cicn->col_data;
    
     if (cicn->num_planes > 1)
        {if (cicn->num_planes > 8)
             i_mode = S_AND_D;
         else
             i_mode = S_OR_D;
        }
     else
         i_mode = MD_TRANS;
    }
    
 mindex [0] = ((iconblk->ib_char & 0x0f00) != 0x0100) ? (iconblk->ib_char & 0x0f00) >> 8 : WHITE;
 mindex [1] = WHITE;
    
 icncol = iindex[0] = (INT16)(((unsigned INT16)iconblk->ib_char & 0xf000U) >> 12U);
 iindex[1] = WHITE;

 mskcol = (iconblk->ib_char & 0x0f00) >> 8;

 x = ob_x + iconblk->ib_xicon;
 y = ob_y + iconblk->ib_yicon;

 if (invert)
    {buf       = iindex[0];
     iindex[0] = mindex[0];
     mindex[0] = buf;
     i_mode    = MD_TRANS;
    }
 if (selected)
    {buf    = icncol;
     icncol = mskcol;
     mskcol = buf;
    }
    
 draw_bitblk (VDIhandle, mask, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, m_mode, mindex);
 draw_bitblk (VDIhandle, data, x, y, iconblk->ib_wicon, iconblk->ib_hicon, cicn->num_planes, i_mode, iindex);
    
 if (dark)
    {mindex [0] = BLACK;
     mindex [1] = WHITE;
     draw_bitblk (VDIhandle, dark, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, MD_TRANS, mindex);
    }

 if (iconblk->ib_ptext[0])
    {x = ob_x + iconblk->ib_xtext;
     y = ob_y + iconblk->ib_ytext;
     
     pxy[0] = x;
     pxy[1] = y;
     pxy[2] = x + iconblk->ib_wtext - 1;
     pxy[3] = y + iconblk->ib_htext - 1;
     
     vswr_mode     (VDIhandle, MD_REPLACE);        /* dessiner la boite texte (TextBox) */
     vsf_color     (VDIhandle, mskcol);
     vsf_interior  (VDIhandle, FIS_SOLID);
     vsf_perimeter (VDIhandle, FALSE);
     v_bar         (VDIhandle, pxy);
    }

 vswr_mode     (VDIhandle, MD_TRANS);
 vst_font      (VDIhandle, 1);    /* Systemfont */
 vst_height    (VDIhandle, 4, &dummy, &dummy, &dummy, &dummy);
 vst_color     (VDIhandle, icncol);
 vst_effects   (VDIhandle, TXT_NORMAL);
 vst_alignment (VDIhandle, ALI_LEFT, ALI_TOP, &dummy, &dummy);
 vst_rotation  (VDIhandle, 0);
    
 if (iconblk->ib_ptext[0])
    {x += (iconblk->ib_wtext - strlen ((char*)iconblk->ib_ptext) * 6) >> 1;
     y += (iconblk->ib_htext - 6) >>1;
     v_gtext (VDIhandle, x, y, iconblk->ib_ptext);
    }

 letter[0] = iconblk->ib_char & 0xff;
 if (letter[0])
    {letter[1] = '\0';
     x = ob_x + iconblk->ib_xicon + iconblk->ib_xchar;
     y = ob_y + iconblk->ib_yicon + iconblk->ib_ychar;
     v_gtext (VDIhandle, x, y, letter);
    }
    
    
/* QUEL BANDE DE CON, ILS ONT OUBLIER DE FERMER LE CLIP !!!!!!! Patrice je presume */
/* mais quand meme quel boulot !!!! (Roland)                                       */
 
 xrect2array ((GRECT *)&pb->pb_xc, xy);
 vs_clip (VDIhandle, FALSE, xy); 
 
 return (pb->pb_currstate & ~ SELECTED);
} /* draw_userdef */


/*------------------------------ draw_bitblk ----------------------------------*/
void draw_bitblk (INT16 handle, INT16 *p, INT16 x, INT16 y, INT16 w, INT16 h, INT16 num_planes, INT16 mode, INT16 *index)
{INT16         pxy[8];
 XMFDB         s, d;

 d.mp    = NULL; /* screen */
 s.mp    = (void *)p;
 s.fwp   = w;
 s.fh    = h;
 s.fww   = w >> 4;
 s.ff    = FALSE;
 s.np    = num_planes;
 
 pxy[0] = 0;
 pxy[1] = 0;
 pxy[2] = s.fwp - 1;
 pxy[3] = s.fh - 1;
 
 pxy[4] = x;
 pxy[5] = y;
 pxy[6] = pxy[4] + pxy [2];
 pxy[7] = pxy[5] + pxy [3];
 
 if (num_planes > 1)
     vro_cpyfm (handle, mode, pxy, (MFDB*)&s, (MFDB*)&d);
 else
     vrt_cpyfm (handle, mode, pxy, (MFDB*)&s, (MFDB*)&d, index);     /* copy it */
}

/*------------------------------ xrect2array ----------------------------------*/
void xrect2array (const GRECT *rect, INT16 *array)
{ *array++ = rect->g_x;
  *array++ = rect->g_y;
  *array++ = rect->g_x + rect->g_w - 1;
  *array   = rect->g_y + rect->g_h - 1;
} /* xrect2array */



