/* ------------------------------------------------------------------------- */
/* ----- fsel_inp.h ------------------------ (c) 1992 by Oliver Scheel ----- */
/* ------------------------------------------------------------------------- */
/* end of include...................................................... */

#ifndef __FSELLIB__
#define __FSELLIB__

#include <tos.h>

#define CMD_FILES_OUT	0x01		/* return filelist */
#define CFG_ONESTRING	0x02		/* return list in one string */
#define CFG_FIRSTNEXT	0x08

/* ------------------------------------------------------------------------- */
/* ----- Selectric Structure ----------------------------------------------- */
/* ------------------------------------------------------------------------- */

typedef struct
{
	unsigned long	id;		/* Selectric ID (SLCT)		*/
	unsigned INT16	version;	/* version (BCD-Format)		*/
	struct
	{
                unsigned           : 7;    /* reserved                     */
                unsigned todaytime : 1;
                unsigned pthsav    : 1;    /* save GEMDOS paths            */
                unsigned stdest    : 1;    /* stay in destination path     */
                unsigned           : 1;    /* reserved                     */
                unsigned numsrt    : 1;    /* numsort                      */
                unsigned lower     : 1;    /* use lowercase letters        */
                unsigned dclick    : 1;    /* open folder on dclick        */
                unsigned hidden    : 1;    /* show hidden files            */
                unsigned bypass    : 1;    /* Selectric ON/OFF             */
	} config;
	INT16	sort;			     /* sort-mode (neg. = rev.)	*/
	INT16	num_ext;		   /* number of extensions		  */
	char	*(*ext)[];	 /* preset extensions		     */
	INT16	num_paths;		 /* number of paths	       	*/
	char	*(*paths)[];/* preset paths		         	*/
	INT16	comm;			     /* communication word		    */
	INT16	in_count;	  	/* input counter		         */
	void	*in_ptr;	   /* input pointer		         */
	INT16	out_count;		 /* output counter	        	*/
	void	*out_ptr;	  /* output pointer		        */
	INT16	cdecl	(*get_first)(DTA *dta, INT16 attrib);
	INT16	cdecl 	(*get_next)(DTA *dta);
	INT16	cdecl	(*release_dir)(void);

} SLCT_STR;

/* ------------------------------------------------------------------------- */
#endif
