#ifndef __EAZY_GEM__
#define __EAZY_GEM__
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include <limits.h>
#include <tos.h>
/*.............. si on doit compiler avec PCGEMLIB.LIB de PureC .......*/
#ifndef __GEM_LIB__ /* defini par l'option de compilation -D du projet */
 #include <aes.h>
 #include <vdi.h>
#endif

#include <stdio.h>
#include <portab.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <ext.h>
#include <math.h>
#include <ctype.h>
/*.............. si on doit compiler avec MGEMLIB.LIB des copains .....*/
#ifdef __GEM_LIB__  /* defini par l'option de compilation -D du projet */
 #include <MGEM.h>
 #include <mgemx.h>
#endif

#ifdef _GEMLIB_H_
  extern  int          _app;
  #define ED_STR          4
  #define ED_ERASE        5
  #define ED_BLKAFF       6
  
  #define BORDER          0x2000
#endif
  #define ED_ALL_REDRAW   7
  
/* end of include...................................................... */
#ifndef _GEMLIB_H_
 typedef int INT16; 
#endif

#define MAX_PATH 256


/*......................... gestion de la memoire .........................*/
/*                 les fonctions suivantes sont celles                     */
/*                 qui vont remplacer les fonctions standard               */
/*                 de gestion de la memoire. vous n'avez pas              */
/*                 y faire appel directement.                              */

extern void* MyMalloc( size_t size , long lign, char *file, long Id);
extern void* MyRealloc( void *ptr, size_t size, long lign , char *file, long Id);
extern void* MyCalloc( size_t num_elems, size_t elem_size , long lign, char *name, long Id);
extern void  MyFree( void *ptr , long lign , char *file);

/*................ pour les quatres fonctions suivantes il ................*/
/*                 vaut mieux appeler leurs equivalentes                   */
/*                 representes par les macro qui vous                     */
/*                 dispensent d'ajouter __LINE__ et __FILE__               */
/*                 lors de l'appel. (la macro le fait pour vous)           */


/*...... APPEL EQUIVALENT: VerifyBlk(void *test_blk, INT16 mode) ..........*/
/*                         definie plus loin par une macro                 */
extern INT16   BlkCheck( void *test_blk, INT16 mode, long lign, char *name);

/*...... APPEL EQUIVALENT: VerifyAllBlk(INT16 mode) .......................*/
/*                         definie plus loin par une macro                 */
extern void  MemoryCheck(INT16 mode, long lign, char *name);

/*...... APPEL EQUIVALENT: FreeAllMemory() ................................*/
/*                         definie plus loin par une macro                 */
extern void  ExitMemMngr(long lign, char *name);

/*...... APPEL EQUIVALENT: FreeAll_ID() ...................................*/
/*                         definie plus loin par une macro                 */
extern long  FreeMem_ID(long lign, char *name, long iD);

/*.................... modes d'affichage des erreurs ........................*/
#define ERR_ERASE   1             /* parametre:  fichier erreur effac       */
#define ERR_APPEND  0             /* parametre:  fichier erreur non effac   */

#define TO_FILE    1       /* parametre:  sortie erreur sur fichier         */
#define TO_SCREEN  2       /* parametre:  sortie erreur sur ecran           */
#define TO_EZ_EDIT 4       /* parametre:  sortie erreur dans EZ_EDIT        */

/*----------------------------- InitMemMngr ---------------------------------*/
/* ACTION: fonction d'initialisation generale permettant d'initialiser       */
/*         les pointeurs du premier bloc de base. Cette fonction est        */
/*         appeler en premier dans main().                                   */
/* ENTREE: int mode: mode de sortie par defaut des erreurs.                  */
/*                   TO_FILE  l'erreur est reporte dans le fichier d'erreur */
/*                   TO_SCREEN l'erreur est affiche  l'ecran               */
/*                   TO_EZ_EDIT l'erreur est envoye  EZ_EDIT               */
/*       ces trois modes peuvent etre combins (TO_FILE|TO_SCREEN|TO_EZ_EDIT)*/
/*       et modifis par la fonction: int SetMode(int mode)                  */
/* SORTIE: neant                                                             */

extern void  InitMemMngr(INT16 mode);

/*-------------------------- SetMemMngrMode ---------------------------------*/
/* ACTION: met en place le mode par defaut de sortie des erreurs.            */
/* ENTREE: int mode: TO_FILE  l'erreur est reporte dans le fichier d'erreur */
/*                   TO_SCREEN l'erreur est affiche  l'ecran               */
/*                   TO_EZ_EDIT l'erreur est envoye  EZ_EDIT               */
/*       ces trois modes peuvent etre combins (TO_FILE|TO_SCREEN|TO_EZ_EDIT)*/
/* SORTIE: INT16: qui est l'ancien mode                                      */

extern INT16   SetMemMngrMode(INT16 mode);

/*---------------------- SetErreurName ----------------------------*/
/* ACTION: permet de donner le chemin et le nom du fichier         */
/*         d'erreurs par defaut.                                   */
/* ENTREE: char *path, char *nom: pointe sur le chemin et le nom   */
/*                                du fichier d'erreurs. Si nom = 0 */
/*                                alors path doit etre complet     */
/*                                sinon nom est concatene  path   */
/*         INT16 mode: 1/ si il existe un fichier d'erreur portant */
/*                      le nom de celui donn en entre alors il   */
/*                      est effac.                                */
/*                     0/ si il existe un fichier d'erreur portant */
/*                      le nom de celui donn en entre alors il   */
/*                      n'est pas effac.                          */
/* SORTIE: neant.                                                  */

extern void  SetErreurName(char *path, char *nom, INT16 mode);

/*-------------------------------- OutErreur --------------------------------*/
/* ACTION: ajoute la chaine: char *err dans le fichier d'erreurs             */
/*         par defaut et ou l'affiche selon mode de sortie par defaut        */
/* ENTREE: char *err: pointe sur la chaine  rajouter au fichier             */
/*         d'erreurs par defaut et ou  afficher.                            */
/*         long lign: ligne du source ou est appele la fonction (mettre     */
/*                    __LINE__   )                                           */
/*         char *name: nom du source ou est appele la fonction. (mettre     */
/*                    __FILE__                                               */
/* SORTIE: neant.                                                            */
/* NOTE:   La chaine:  char *err est ajoute dans le fichier d'erreurs et ou */
/*         affiche  l'ecran selon le mode mis en place par la fonction:    */
/*                       void InitMemMngr(INT16 mode)  o   INT16 mode       */
/*      = TO_FILE  l'erreur est reporte dans le fichier d'erreur            */
/*      = TO_SCREEN l'erreur est affiche  l'ecran                          */
/*      = TO_EZ_EDIT l'erreur est affiche dans la fenetre LOGOUT d'EZ_EDIT  */
/*                                                                           */
/*      ces trois modes peuvent etre combins (TO_FILE|TO_SCREEN|TO_EZ_EDIT) */
/*      et modifis par la fonction: INT16 SetMode(INT16 mode)               */

extern void OutErreur(char *err, long lign, char *name);

/*------------------------------- WriteMessage -----------------------------*/
/* ACTION: sort un message d'erreur ou d'autre nature:                       */
/*              => dans la fenetre Logout d'EZ_GEM: where = TO_EZ_EDIT,      */
/*              => dans le fichier d'erreurs:       where = TO_FILE          */
/*              =>  l'ecran:                       where = TO_SCREEN        */
/*               sachant que les trois modes peuvent etre combines  l'aide  */
/*               de l'operateur ou | exple: TO_SCREEN | TO_EZ_EDIT | TO_FILE */
/* ENTREE: long where: flag determinant ou doit se faire la sortie           */
/*                     (voir explication ci dessus)                          */
/*         long lign: ligne du source ou est appele la fonction (mettre     */
/*                    __LINE__   )                                           */
/*         char *name: nom du source ou est appele la fonction. (mettre     */
/*                    __FILE__                                               */
/*              si zero alors le message ne sera pas localis et precede de  */
/*              la mention exple: "Logout C:\CHEMIN\SOURCE.C  4092           */
/*              permettant  un editeur de texte sachant gerer ces infos de  */
/*              retrouver la ligne dans le code source ou le message a ete   */
/*              genere.                                                      */
/*         const char *format: chaine decrivant le format de la liste        */
/*                             d'arguments qui va suivre (meme syntaxe que   */
/*                             printf() )                                    */
/*         ... : liste d'arguments comme celle de printf()                   */
/* SORTIE: neant.                                                            */
/* NOTE:   la chaine generee ne devra pas depasser 16000 octets.             */

void WriteMessage(long where, long lign, char *name, const char *format, ...);

/*-------------------------------- OutMessage -------------------------------*/
/* ACTION: ajoute la chaine: char *err dans le fichier d'erreurs             */
/*         par defaut et ou l'affiche selon mode de sortie par defaut        */
/*         cette fonction permet d'ajouter au fichier d'erreur un message    */
/*         de son choix. cela peut etre utile par exemple si l'on veut faire */
/*         un fichier .LOG ou journal etc....                                */
/* ENTREE: char *err: pointe sur la chaine  rajouter au fichier             */
/*         d'erreurs par defaut et ou  afficher.                            */
/* SORTIE: neant.                                                            */
/* NOTE:   La chaine:  char *err est ajoute dans le fichier d'erreurs et ou */
/*         affiche  l'ecran selon le mode mis en place par la fonction:    */
/*                       void InitMemMngr(INT16 mode)  o   INT16 mode       */
/* NOTE:   La chaine:  char *err est ajoute dans le fichier d'erreurs et ou */
/*         affiche  l'ecran selon le mode mis en place par la fonction:    */
/*                       void InitMemMngr(INT16 mode)  o   INT16 mode       */
/*      = TO_FILE  l'erreur est reporte dans le fichier d'erreur            */
/*      = TO_SCREEN l'erreur est affiche  l'ecran                          */
/*      = TO_EZ_EDIT l'erreur est affiche dans la fenetre LOGOUT d'EZ_EDIT  */
/*                                                                           */
/*      ces trois modes peuvent etre combins (TO_FILE|TO_SCREEN|TO_EZ_EDIT) */
/*      et modifis par la fonction: INT16 SetMode(INT16 mode)               */
/*                                                                           */
/* PROTO: void OutMessage(char *err)     defini par la macro suivante:       */

#define OutMessage(a)      OutErreur((a), __LINE__, __FILE__)

/*----------------------- VerifyBlk -----------------------------------------*/
/* ACTION: verifie si l'adresse memoire donne en entree est corrompue.      */
/*         cette fonction est utile afin de savoir si apres appel  une      */
/*         fonction, celle ci abime une zone memoire sur laquelle elle       */
/*         doit travailler.                                                  */
/* ENTREE: void *test_ptr: pointeur initialise par une des fonctions         */
/*                         malloc, calloc, realloc, dont il faut verifier    */
/*                         l'integrite de la zone memoire pointe.           */
/*         INT16 mode: TO_FILE  l'erreur est reporte dans le fichier erreur */
/*                   TO_SCREEN l'erreur est affiche  l'ecran               */
/*                   ces deux modes peuvent etre combins (TO_FILE|TO_SCREEN)*/
/*                                                                           */
/* PROTO:  INT16 VerifyBlk(void *test_ptr, INT16 mode);                      */
/*                                             defini par la macro suivante: */

#define VerifyBlk(a,b)     BlkCheck((a), (b) , __LINE__, __FILE__)

/*-------------------- VerifyAllBlk -----------------------------------------*/
/* ACTION: scanne tous les blocs allous au moment de l'appel et verifie si  */
/*         ils sont corrompus et ecrit dans le fichier d'erreur si c'est le  */
/*         cas.                                                              */
/* ENTREE: INT16 mode: TO_FILE  l'erreur est reporte dans le fichier erreur */
/*                   TO_SCREEN l'erreur est affiche  l'ecran               */
/*                   ces deux modes peuvent etre combins (TO_FILE|TO_SCREEN)*/
/*                                                                           */
/* PROTO: void VerifyAllBlk(INT16 mode);  defini par la macro suivante:      */

#define VerifyAllBlk(a)    MemoryCheck((a), __LINE__, __FILE__)


/*-------------------- FreeAllMemory ----------------------------------------*/
/* ACTION: libere tous les blocs alloues de la liste chaine. Cette fonction */
/*          appeler en fin de programme permet d'etre certain que toute la  */
/*         memoire sera libre en fin de programme. Normalement il ne       */
/*         devrait  pas y avoir de bloc restant  desallouer...              */
/* ENTREE: neant.                                                            */
/* SORTIE: Neant.                                                            */
/*                                                                           */
/* NOTE:   si des erreurs sont trouves lors de la desallocation, elles sont */
/*         reportes dans le fichier d'erreurs et ou affiches  l'ecran     */
/*         selon le mode mis en place par la fonction:                       */
/*                       void InitMemMngr(INT16 mode)  o   INT16 mode       */
/*          = TO_FILE  l'erreur est reporte dans le fichier d'erreur        */
/*          = TO_SCREEN l'erreur est affiche  l'ecran                      */
/*            ces deux modes peuvent etre combins (TO_FILE|TO_SCREEN)       */
/*            et modifis par la fonction: INT16 SetMode(INT16 mode)         */
/*                                                                           */
/* PROTO: void FreeAllMemory();  defini par la macro suivante:               */

#define FreeAllMemory()    ExitMemMngr(__LINE__, __FILE__)

/*-------------- malloc_ID ---- calloc_ID ------- realloc_ID ----------------*/
/*ACTION: comme malloc, calloc, realloc  sauf que vous specifiez en plus un  */
/*        parametre d'identificateur de votre choix, permettant lorsque      */
/*        vous appelerez par la suite la  fonction:                          */
/*                free_all_ID() de ne liberer que les blocs possedant cet    */
/*                              identificateur.                              */
/*ENTREE: size_t size: taille du bloc  reserver.                            */
/*        long Id:     identificateur de ce bloc. (selon votre imagination)  */
/*        size_t n_memb: nombre de bloc  reserver (pour calloc_ID)          */
/*        sortie void *: pointeur sur la zone reserve ou zero si echec.     */
/*                                                                           */
/* PROTO: void* malloc_ID(size_t size, long iD);                             */
/* PROTO: void* realloc_ID(size_t size, long iD);                            */
/* PROTO: void* calloc_ID(size_t n_memb, size_t size, long iD);              */

#define  malloc_ID(a,b)      MyMalloc((a), __LINE__, __FILE__ , (b))
#define  realloc_ID(a,b,c)   MyRealloc((a),(b), __LINE__, __FILE__ , (c))
#define  calloc_ID(a,b,c)    MyCalloc((a),(b), __LINE__, __FILE__ , (c))

/*-------------------- FreeAll_ID -------------------------------------------*/
/* ACTION: libere tous les blocs alloues de la liste chaine, dont l'identi- */
/*         est commun.                                                       */
/*         long Id: identificateur des blocs  liberer.                      */
/* SORTIE: long: nombre de blocs liberes.                                    */
/*                                                                           */
/* NOTE:   si des erreurs sont trouves lors de la desallocation, elles sont */
/*         reportes dans le fichier d'erreurs et ou affiches  l'ecran     */
/*         selon le mode mis en place par la fonction:                       */
/*                       void InitMemMngr(int mode)  o   int mode           */
/*          = TO_FILE  l'erreur est reporte dans le fichier d'erreur        */
/*          = TO_SCREEN l'erreur est affiche  l'ecran                      */
/*            ces deux modes peuvent etre combins (TO_FILE|TO_SCREEN)       */
/*            et modifis par la fonction: int SetMode(int mode)             */
/* PROTO: long  FreeAll_ID(long iD);                                         */

#define FreeAll_ID(a)    FreeMem_ID(__LINE__, __FILE__, (a))


/*...................... detournement des fonctions standard ................*/
/*                       de gestion de la memoire                            */
#ifndef __EZMEM_INIT__ /* ce flag n'est defini que dans: MemMngr.C ou bien   */
                       /* sur il ne faut surtout pas redefinir les fonctions */
                       /* de gestion de la memoire !!!                       */
  #undef  malloc(a)
  #define malloc(a)          MyMalloc((a), __LINE__, __FILE__ , 0L)

  #undef  calloc(a,b)
  #define calloc(a,b)        MyCalloc((a),(b), __LINE__, __FILE__ , 0L)

  #undef  free(a)
  #define free(a)            MyFree((a), __LINE__, __FILE__)

  #undef  realloc(a,b)
  #define realloc(a,b)       MyRealloc((a),(b), __LINE__, __FILE__ , 0L)
#endif                 /* __EZMEM_INIT__ */

/*..........................................................................*/

#define VDI_CNTRLMAX   15
#define VDI_INTINMAX   1024
#define VDI_INTOUTMAX  256
#define VDI_PTSINMAX   256
#define VDI_PTSOUTMAX  256

#pragma warn -ucp
#define Min(a, b)             ((a) < (b) ? (a) : (b))
#define Max(a, b)             ((a) > (b) ? (a) : (b))
#define OB_ROOT      -1

#undef  NULL
#define NULL                  0L
#define ZERO                  0


#define MESS_ENDPRG      0
#define MESS_TTONOFF     1

typedef struct
{
  unsigned INT16   rsh_vrsn;            /* should be 3                                                             */
  unsigned INT16   rsh_extvrsn;        /* not used, initialised to 'IN' for Interface */
  unsigned long    rsh_object;
  unsigned long    rsh_tedinfo;
  unsigned long    rsh_iconblk;         /* list of ICONBLKS                                   */
  unsigned long    rsh_bitblk;
  unsigned long    rsh_frstr;
  unsigned long    rsh_string;
  unsigned long    rsh_imdata;            /* image data                                          */
  unsigned long    rsh_frimg;
  unsigned long    rsh_trindex;
  unsigned long    rsh_nobs;             /* counts of various structs                     */
  unsigned long    rsh_ntree;
  unsigned long    rsh_nted;
  unsigned long    rsh_nib;
  unsigned long    rsh_nbb;
  unsigned long    rsh_nstring;
  unsigned long    rsh_nimages;
  unsigned long    rsh_rssize;            /* total bytes in resource   */
} RSXHDR;

typedef INT16 CALLBACK ;
/*......................... AES ETENDU ............................*/

typedef struct                    /* Box Spec or Color Spec        */
 {unsigned framecol    :  4;      /* border color                  */
  unsigned textcol     :  4;      /* text color                    */
  unsigned textmode    :  1;      /* 0=transparent, 1=opaque       */
  unsigned fillpattern :  3;      /* 0=no fill, ... 7=solid fill   */
  unsigned interiorcol :  4;      /* fill color using fill pattern */
 } BFTEDCOLOR;

/*........................... VA_START Definitions ................*/
# define  VA_START   0x4711
# define  VA_AKCNW   0x4738
# undef   TRUE
# undef   FALSE
# define  TRUE   1
# define  FALSE  0
# define  K_LRSHIFT          0x0003
# define  K_ALT_SHIFT        0x000B
# define  K_CTRL_SHIFT       0x0007
# define  K_ALT_CTRL         0x000C
# define  K_ALT_SHIFT_CTRL   0x000F

/*........................ GEMSRIPT definitions ...................*/
#define GS_REQUEST  0x1350
#define GS_REPLY    0x1351
#define GS_COMMAND  0x1352
#define GS_ACK      0x1353
#define GS_QUIT     0x1354

#define GSLIB_EVENT  0x134F
/*........................... Drag and Drop Definitions ...........*/
#define DD_OK             0
#define DD_NAK            1
#define DD_EXT            2
#define DD_LEN            3
#define DD_TRASH          4
#define DD_PRINTER        5
#define DD_CLIPBOARD      6

/* Timeout en Millisecondes (4 secondes.) */
#define DD_TIMEOUT        4000

/* Anzahl der Extensionen/Bytes der "bevorzugten Extensionen" */
#define DD_NUMEXTS        8
#define DD_EXTSIZE        32L

/* longueur max des noms de fichiers Drag&Drop */
#define DD_NAMEMAX        128

/* longueur max et min des Header Drag&Drop  */
#define DD_HDRMAX        (8+DD_NAMEMAX+DD_NAMEMAX)
#define DD_HDRMIN         9                    /* Minimum length of Drag&Drop header */

/*........................... Resource definitions ..................................*/
                                /* data structure types */
#define R_TREE           0
#define R_OBJECT         1
#define R_TEDINFO        2
#define R_ICONBLK        3
#define R_BITBLK         4
#define R_STRING         5              /* gets pointer to free strings */
#define R_IMAGEDATA      6              /* gets pointer to free images */
#define R_OBSPEC         7
#define R_TEPTEXT        8              /* sub ptrs in TEDINFO */
#define R_TEPTMPLT       9
#define R_TEPVALID      10
#define R_IBPMASK       11              /* sub ptrs in ICONBLK */
#define R_IBPDATA       12
#define R_IBPTEXT       13
#define R_BIPDATA       14              /* sub ptrs in BITBLK */
#define R_FRSTR         15              /* gets addr of ptr to free strings */
#define R_FRIMG         16              /* gets addr of ptr to free images  */

#define ALL_OBJECT      -1

#define TXT_NORMAL       0x0000 /* text effects */
#define TXT_THICKENED    0x0001
#define TXT_LIGHT        0x0002
#define TXT_SKEWED       0x0004
#define TXT_UNDERLINED   0x0008
#define TXT_OUTLINED     0x0010
#define TXT_SHADOWED     0x0020

#define ALI_LEFT         0 /* horizontal text alignment */
#define ALI_CENTER       1
#define ALI_RIGHT        2

#define ALI_BASE         0 /* vertical text alignment */
#define ALI_HALF         1
#define ALI_ASCENT       2
#define ALI_BOTTOM       3
#define ALI_DESCENT      4
#define ALI_TOP          5

typedef struct
{ void    *mp;
  INT16   fwp;
  INT16   fh;
  INT16   fww;
  INT16   ff;
  INT16   np;
  INT16   r1;
  INT16   r2;
  INT16   r3;
} XMFDB;

/*.............................. EZ_GEM ...........................*/

#define XSIZER  0x00010000L          /* bordure agrandissable      */
#define XMODAL  0x00020000L          /* fenetre modale (bloquante) */
#define XBORDER 0x00040000L          /* bordure fenetre EZ_GEM     */
#define XFRAME  0x00040000L          /* bordure fenetre EZ_GEM     */
#define XMOVER  0x00080000L          /* bordure deplaable         */

#define IDC_ARROW         0
#define IDC_SIZEWE        8
#define IDC_SIZENS        9
#define IDC_SIZEALL       10
#define IDC_SIZENWSE      11
#define IDC_SIZENESW      12
#define IDC_NO            13
#define IDC_UPARROW       14
#define IDC_INFO          15
#define IDC_INTERO        16
#define IDC_LISTBOX       17
/*.............. type de parametres SCROLL_BOX .....................*/
#define SCROLL_TXT    1
/*...................... type d'objets etendus .....................*/
#define GROUP_LITLE   100     /* cadre d'entourement (ou de groupe) fin          */
#define GROUP_LARGE   101     /* cadre d'entourement (ou de groupe) epais        */
#define NEW_BUTTON    102     /* bouton EAZY GEM (s'adapte  l'echelle 9pts)     */
#define RADIO_BUTTON  103     /* boite radio button new look EAZY GEM            */
#define COCHE_BUTTON  104     /* boite a cocher new look EAZY GEM                */
#define TT_STATE_BOX  105     /* boite de type indicateur  d'etat bulle d'aide   */
#define LISTBOX       106     /* boite de type liste deroulante avec ascensseurs */
#define WINDMENU      107     /* boite devant recevoir un  menu en fenetre fils  */
#define ONGLET_MASTER 108     /* boite devant recevoir les dialogues fils        */
#define CADRE_VIDE    109     /* cadre invisible universel                       */
#define SCROLL_GROUP0 110     /* cadre invisible type scroll structure           */
#define SCROLL_BOX    111     /* boite de scroll contenant les info  afficher   */
#define SCROLL_EDIT   112     /* boite d'edition de texte                        */
#define USER_SV_UP    113     /* objet de type scrolling haut    (fils d'une Scroll structure) */
#define USER_SV_DW    114     /* objet de type scrolling bas     (fils d'une Scroll structure) */
#define USER_SV_AS    115     /* objet de type ascenseur vertic. (fils d'une Scroll structure) */
#define USER_SV_BAR   116     /* objet de type barre verticale   (fils d'une Scroll structure) */
#define USER_SH_LF    117     /* objet de type scrolling gauche  (fils d'une Scroll structure) */
#define USER_SH_RG    118     /* objet de type scrolling droit   (fils d'une Scroll structure) */
#define USER_SH_AS    119     /* objet de type ascenseur horiz.  (fils d'une Scroll structure) */
#define USER_SH_BAR   120     /* objet de type barre horizontale (fils d'une Scroll structure) */
#define USER_BMPBOX   121     /* objet de type boite BitMap      (boite avec motif bit map)    */

#define ONGLET_SLAVE  200     /* boite o se trouvent les dialogues fils avant       */
#define MULTI_DIAL    201     /* arbre de type dialogues multiples                   */
#define TOP_DIAL      202     /* dialogue (fils d'un multiple) du sommet de fenetre  */
#define RIGHT_DIAL    203     /* dialogue (fils d'un multiple) du bord droit fenetre */
#define BOTTOM_DIAL   204     /* dialogue (fils d'un multiple) du bas de la fenetre  */
#define LEFT_DIAL     205     /* dialogue (fils d'un multiple) bord gauche fenetre   */

#define SCROLL_GROUP  206     /* cadre pere type scroll structure                              */
#define SCROLLV_UP    207     /* objet de type scrolling haut    (fils d'une Scroll structure) */
#define SCROLLV_DW    208     /* objet de type scrolling bas     (fils d'une Scroll structure) */
#define SCROLLV_AS    209     /* objet de type ascenseur vertic. (fils d'une Scroll structure) */
#define SCROLLV_BAR   210     /* objet de type barre verticale   (fils d'une Scroll structure) */
#define SCROLLH_LF    211     /* objet de type scrolling gauche  (fils d'une Scroll structure) */
#define SCROLLH_RG    212     /* objet de type scrolling droit   (fils d'une Scroll structure) */
#define SCROLLH_AS    213     /* objet de type ascenseur horiz.  (fils d'une Scroll structure) */
#define SCROLLH_BAR   214     /* objet de type barre horizontale (fils d'une Scroll structure) */

#define PAINT_BOX     215     /* objet envoyant un WM_PAINTBOX lors du redraw                  */
#define ICON_WIND     216     /* objet type ressource d'iconification  fenetre                 */
#define ICON_APPL     217     /* objet type ressource d'iconification  application             */



#define SCRIPT_LINK   250     /* objet dont le texte sert de lien pour une boite de string     */
#define SCRIPT_TARGET 251     /* objet type boite de definitions de fichier/formulaire         */
#define TAB_LINK_CONT 252

#define RSC_PLUS 6    /* debord pour effet relief */
#define RSC_DIAL 1    /* fenetre type dialogue    */
#define TOOL_BAR 2    /* fenetre type tool_bar    */
#define NO_SCALE 0
#define SCALE    1
#define NORELOG_NO_SCALE -1
#define NORELOG_SCALE    -2

#define DEF_BOX_WIND 1
#define DELT_LEFT    0
#define DELT_TOP     1
#define DELT_RIGHT   2
#define DELT_BOTTOM  3

#define CTRL_LEFT_TOP       1
#define CTRL_TOP            2
#define CTRL_RIGHT_TOP      3
#define CTRL_RIGHT          4
#define CTRL_RIGHT_BOTTOM   5
#define CTRL_BOTTOM         6
#define CTRL_LEFT_BOTTOM    7
#define CTRL_LEFT           8

#define VRLEFT      0
#define VRTOP       1
#define VRRIGHT     2
#define VRBOTTOM    3

#define MULTI_LINE  -2
/*.................. define lis aux tool tips ...................*/
#define TT_OBJECT     1
#define TT_GRECT      2
#define TT_RECT       3
#define TT_RSXHDR     4
#define TT_RSHDR      5
#define TT_UPSMEN     6
#define TT_UPSTOOL    7   /* type tool barre upsis                      */
#define TT_XRSC       8   /* adresse ressource                          */

/*.................. define lis aux nouveaux messages .................*/
#define MU_MOVE        64
#define MU_UPL         128
#define MU_DWL         256
#define MU_UPR         512
#define MU_DWR         1024

#define WM_MOUSEWHEEL    0x0930

#define WM_CONSTRUCT     0x100
#define WM_DESTRUCT      0x101
#define WM_ABORT         0x102
#define WM_TT_GET_TXT    0x103
#define WM_PAINT         0x104
#define WM_UNTOP         0x105
#define WM_ISTOP         0x106
#define WM_POPUP_CHANGE  0x107
#define WM_TT_ON_OFF     0x108
#define WM_STANDBY       0x109
#define WM_WND_MENU      0x10A
#define WM_EXEFUNC       0x10B
#define WM_ONGLET_CHG    0x10C
#define WM_PAINTBOX      0x10D
#define WM_ACTIVEWIND    0x10E
#define WM_MODAL_END     0x10F
#define WM_PAINT_ICON    0x110
#define WM_PARAM_SEND    0x111
#define WM_EDIT_OPEN     0x112
#define WM_EDIT_CLOSE    0x113
#define WM_EDIT_UPDATE   0x114
#define WM_SCROLL_DO     0x115
#define WM_LIST_DO       0x116
#define WM_EDIT_ON       0x117


/*................. message d'ordre pour l'editeur de texte ............*/
#define EXE_ED_COPY           0x118
#define EXE_ED_COPY_ADD       0x119
#define EXE_ED_CUT            0x11A
#define EXE_ED_DEL            0x11B
#define EXE_ED_SCRAP_PASTE    0x11C
#define EXE_ED_MEMORY_PASTE   0x11D
#define EXE_ED_FILE_PASTE     0x11E
#define EXE_ED_SET_CURS_POS   0x11F
#define EXE_ED_SET_SEL_DEB    0x120
#define EXE_ED_SET_SEL_END    0x121
#define EXE_ED_CLEAR_SEL      0x122

#define AID_REQUEST      1502
#define AID_SEND         1500

#define WM_USER          10000
/*......................... define de flag ........................*/
#define W_IS_OPEN 0x0001    /* fenetre ouverte                     */
#define W_IS_ICON 0x0002    /* fenetre iconifiee                   */
#define W_IS_ALLICON 0x0004 /* fenetre iconifiee                   */


#define END_QUEUE          -1
#define END_KEYBD          END_QUEUE-1

#define MESG     0
#define APPL     1
#define SUPL     2
#define WHND     3
#define X_G      4
#define Y_G      5
#define W_G      6
#define H_G      7
#define X_B      8
#define Y_B      9
#define W_B      10
#define H_B      11
#define S_0      12
#define S_1      13
#define S_2      14

#define HORIZONTAL 1
#define VERTICAL   2

/*................... Oula les Macros sont l .....................*/
#define SWAPW(a,b)   {INT16 SwapVar=(b);\
                      (b)=(a);\
                      (a)=SwapVar;\
                     }
#define SWAPL(a,b)   {long SwapVar=(b);\
                      (b)=(a);\
                      (a)=SwapVar;\
                     }                        
#define MAKELPAIR(a)   (((a)+1)&0xFFFFFFF0L)
#define MAKEWPAIR(a)   (((a)+1)&0xFFF0)
#define MAKELONG(h,l)  (   ( ( (h) << 16 ) + (l) )   )
#define HIWORD(hl)   ((INT16) ( ( (long)(hl) & 0xFFFF0000L ) >> 16) )
#define LOWORD(hl)   ((INT16) ( ( (long)(hl) & 0x0000FFFFL )      ) )
#define MAKEINT16(h,l)  (((h)<<8+(l)))
#define XTENDED_TYPE(a,b) ((a)[(b)].ob_type>>8)
#define GETWINDTREE(a) Windtab[(a)].DlgVar.tree
#define GETGEMHAND(a) Windtab[(a)].w_h
#define GETWINDIDENT(a) Windtab[(a)].ident
#define GETWINDRSC(a)  Windtab[(a)].DlgVar.AdrRsc
#define GETOBJCEDIT(a)  Windtab[(a)].DlgVar.ObjEdit
#define GET_OBTYPE(a,b) ((a)[(b)].ob_type&0x00FF)
#define GET_XOBTYPE(a,b) (((a)[(b)].ob_type>>8)&0x00FF)
#define GET_FONTNAME(a) FontName + (a)*36
#define GETWIND_EZB(a) Windtab[(a)].EZB_struct
#define GL2GI(a) NormaliseGraphCoordLongToInt((a))
#define EZ_ED_GETCURLIG(a)  (a)->TabLgnCtx[(a)->LigPt].ptTxt
#define EZ_ED_GETTXT(a,l,c) (a)->TabLgnCtx[(l)].ptTxt+c
#define EZ_ED_GETPOS(a,l,c) (a)->TabLgnCtx[(l)].ptTxt+c-(a)->ptTxt
#define EZ_ED_GETCURTXT(a)  (a)->TabLgnCtx[(a)->LigPt].ptTxt+(a)->CarPt
#define EZ_ED_GETCURPOS(a)  (a)->TabLgnCtx[(a)->LigPt].ptTxt+(a)->CarPt-(a)->ptTxt

#define LST_MAJUS       1  /* le texte converti en majuscules     */
#define LST_C_MODE      2  /* la fin d'une ligne est un zero      */
#define LST_REVERSE     4  /* ligne selectionne en video inverse */
#define LST_AFFPOS      8  /* affichage de la position ascenseur  */
#define LST_RLLF        16 /* la fin d'une ligne est return ou lf */

#define LST_UP               0
#define LST_DOWN             1
#define LST_LEFT             2
#define LST_RIGHT            3
#define LST_DRAW             4
#define LST_CLICK            5
#define LST_SCROLL           6
#define LST_USER             7
#define LST_GRECT_ITEM_INQ   8
#define LST_GRECT_CLIENT_INQ 9
#define LST_NODRAW      -1

#define LSTBOXOPEN      1
#define LSTBOXCLICK     2
#define LSTBOXDOWN      4
#define LSTBOXUPP       8
#define LSTBOXLIST     16
#define LSTBOXEDIT     32
#define LSTBOXCLOSE    64
#define LSTBOXSTAY     128

#define LST_FNTSEL     'FntS'
#define LST_FNTPTS     'FntP'
#define LST_PATERN     'Pate'
#define LST_LGNTYP     'LgnT'
#define LST_TXTEFF     'TxtE'
#define LST_COLOR      'Colo'

#define POPUP_CHANGE   32000
#define ALERT_MODAL     2468
#define W_ALERT         2468
#define W_MODAL         2469
/*................ structure pour enregistrer evenements .................*/

extern INT16 Mo_ID;
typedef struct
{ INT16  evnt;
  INT16  x;
  INT16  y;
  INT16  k;
  INT16  ksp;
  long  time;
} MO_STACK;
/*................ structure collectant les info sur la machine ..........*/
typedef struct
{long machine;
 long cpu;
 long fpu;
 long video;
 long sound;
 long mult_os;
}MACHINE_INFO;

/*...................... Structure des Cookies ...........................*/
typedef struct
   {long ident;
    union {long l;
           INT16 i[2];
           char c[4];
           }U_typ;
   } COOKIE;
/*........... LIST_GET_TXT ...............................................*/
typedef struct
 {INT16 lign;
  INT16 preml;
  INT16 pointl;
  INT16 h_lign;
  GRECT grect;
  GRECT clipgrect;
  void *LstBoxParam;
  long Lparam;
 }LIST_GET_TXT;

/*............................. DID_HELP ..............................*/
/* definition de la structure permettant de communiquer avec l'aide    */
/* de DIDEROT. Les parametres de cette structure determinent, avec     */
/* quel fichier d'aide et quelle reference de ce fichier la fenetre de */
/* DIDEROT doit s'afficher.                                            */

 typedef struct
   {
    char Aid_file[MAX_PATH]; /*recevra le chemin complet du fichier d'aide */
                        /* d'aide que l'on veut associer a notre       */
                        /* programme.                                  */
    long Ref;           /*Numro de la reference que l'on veut voir   */
                        /* dans ce fichier.                            */
    INT16  x_win;       /*position X de la fenetre d'aide             */
    INT16  y_win;       /*position Y de la fenetre d'aide             */
    INT16  w_win;       /*largeur de la fenetre d'aide                */
    INT16  h_win;       /*hauteur de la fenetre d'aide                */
                        /* Si il est fourni -1 comme parametre, la     */
                        /* fenetre de DIDEROT s'ouvrira avec des       */
                        /* dimensions par defaut.                      */
                        /* Ce sont les dimensions exterieures de la    */
                        /* fenetre que ces parametres decrivent.       */
    INT16  w_h;         /*handle de la fenetre demandeuse, DIDEROT a  */
                        /* besoin de la connaitre pour la remettre au  */
                        /* dessus des autres(l'activer), apres s'etre  */
                        /* ouvert !!!. Ce n'est utile que lors des     */
                        /* AES < 3.99.                                 */
                        /* Si l'on fourni -1 pour w_h, la fenetre      */
                        /* demandeuse ne sera pas remise au TOP.       */

   }DID_HELP;

/*................ SCROLLBOX_GET_AFFI .................................*/
typedef struct
 {INT16   LgnH;            /* H ligne en pixels           */
  INT16   ClnW;            /* L colonne en pixels         */
  long  FstLgn;            /* premiere ligne en haut      */
  long  FstCln;            /* premiere colonne a gauche   */
  long  LgnAff;            /* ligne a afficher            */
  long  ClnAff;            /* colonne a afficher          */
  long  LgnSel;            /* ligne selectionnee          */
  long  ClnSel;            /* colonne selectionnee        */
  GRECT Grect;             /* dimensions de fenetre affi  */
  GRECT GrectX;            /* dimensions non ajustes     */
  GRECT ClipGrect;         /* rectangle de cliping        */
  void *ScrollBoxParam;    /* parametre de transmission   */
  INT16 Do;                /* type d'action demandee      */
  OBJECT *object;          /* adresse objet racine        */
  INT16 ind_ob;            /* indice objet en cours       */
  INT16 Back;              /* fond pour le redessin       */
  INT16 VDIFntID;
  INT16 Pts;
  INT16 Col;
  INT16 P4;
 }SCROLLBOX_GET_AFFI;


/*................ USERBLK special pour les scrollbox ..................*/
/*                         et G_BOXTEXT avec Xtype  20                 */
typedef struct
{
        INT16 cdecl (*ub_code)(PARMBLK *parmblock);
                                   /* Zeiger auf eine Funktion */
        long     ub_parm;          /* optionaler Parameter     */
        TEDINFO *tedinfo;
        INT16    LgnH;
        INT16    ClnW;
        INT16    (*ScrollBoxGetAffiFunc)(SCROLLBOX_GET_AFFI *ptSCRLDRAWSTRUCT);
        long     NbLgn;
        long     NbCln;
        long     FstLgn;
        long     FstCln;
        long     LgnSlct;
        long     ClnSlct;
        INT16    Do;
        long     NScrol;
        void    *ScrollBoxParam;
        INT16    VDIFntID;
        INT16    Pts;
        INT16    Col;
} XSCROLLBLK;
/*........................ Structure pour SCROLL_TXT ..........................*/
typedef struct
{       INT16  Type;
        char  *txt;
        char **PtLgnTab;
        INT16  Pts;
        INT16  Color;
        long   FontId;
} SCROLL_TXT_PRM;
/*........................ USERBLK special pour les editables .................*/
/*                         et G_BOXTEXT avec Xtype  20                        */
typedef struct
{
        INT16 cdecl (*ub_code)(PARMBLK *parmblock);
                                   /* Zeiger auf eine Funktion */
        long    ub_parm;              /* optionaler Parameter     */
        TEDINFO *tedinfo;
        INT16   BlkDeb;
        INT16   BlkEnd;
        INT16   (*LstBoxGetLigneFunc)(LIST_GET_TXT *ptLISTGETTXT);
        INT16   LstBoxState;
        GRECT   LstBoxGrect;
        INT16   LstBoxHlign;
        INT16   LstBoxNbItem;
        INT16   LstBoxSel;
        void   *LstBoxParam;
        INT16   P1;
        INT16   P2;
        INT16   P3;
        INT16   P4;
        INT16   P6;
        INT16   P7;
        INT16   P8;
        INT16   P9;
        INT16   P10;
        long    P11;
        long    P12;
} XUSERBLK;
/*........................ USERBLK special pour les editables .................*/
typedef struct
{
        INT16 cdecl (*ub_code)(PARMBLK *parmblock);
                                   /* Zeiger auf eine Funktion */
        long    ub_parm;           /* optionaler Parameter     */
        TEDINFO *tedinfo;
        INT16   BlkDeb;
        INT16   BlkEnd;
        INT16   (*LstBoxGetLigneFunc)(LIST_GET_TXT *ptLISTGETTXT);
        long    LenNewTxtAlloc;
        char*   Old_te_ptext;
        char*   Old_te_ptmplt;
        char*   Old_te_pvalid;
        INT16   Old_txtlen;
        INT16   LeftOfset;
        INT16   width_txt;
        INT16   height_txt;
} NEW_EDIT;

/*........................ USERBLK special pour les gadgets ................*/
/* #define USER_SV_UP    113      objet de type scrolling haut    (fils d'une Scroll structure) */
/* #define USER_SV_DW    114      objet de type scrolling bas     (fils d'une Scroll structure) */
/* #define USER_SV_AS    115      objet de type ascenseur vertic. (fils d'une Scroll structure) */
/* #define USER_SV_BAR   116      objet de type barre verticale   (fils d'une Scroll structure) */
/* #define USER_SH_LF    117      objet de type scrolling gauche  (fils d'une Scroll structure) */
/* #define USER_SH_RG    118      objet de type scrolling droit   (fils d'une Scroll structure) */
/* #define USER_SH_AS    119      objet de type ascenseur horiz.  (fils d'une Scroll structure) */
/* #define USER_SH_BAR   120      objet de type barre horizontale (fils d'une Scroll structure) */
/* #define USER_BMPBOX   121      objet de type boite BitMap      (boite avec motif bit map)    */

#define NO_REDRAW      1
#define BMP_UP_DW      2
#define BMP_TRANS      4
#define NOBMP_BACKDRAW 8
#define NOBMP_DRAW    16
/*........................ USERBLK special pour les gadgets.................*/
/*                         de scrolling et Boite Bit_Map                    */
typedef struct
{
        INT16 cdecl (*ub_code)(PARMBLK *parmblock);
                                     /* Zeiger auf eine Funktion */
        long     ub_parm;            /* optionaler Parameter     */
        TEDINFO *tedinfo;
        MFDB     StdMfdb;
        MFDB     SelMfdb;
        INT16      Type;
        INT16      W0;
        INT16      H0;
        INT16      W1;
        INT16      H1;
        INT16      Min;
        INT16   IsIcon;
} XSCRGADGET;

/*........................ USERBLK special pour les onglets ...................*/
/*                         et G_BOXTEXT avec Xtype  108                       */
typedef struct
{
        INT16 cdecl (*ub_code)(PARMBLK *parmblock);
                                   /* Zeiger auf eine Funktion */
        long ub_parm;              /* optionaler Parameter     */
        TEDINFO *tedinfo;
        INT16 nb_dial;               /* nombre d'onglets         */
        INT16 nb_lign;               /* nombre de ligne d'onglet */
        INT16 h_onglt;               /* hauteur d'un onglet      */
        INT16 (*OngletDrawFunc)(void *ptOngletParam);
} ONGLETUSERBLK;

/*........................ ONG_DRAW_PARAM structure passee ....................*/
/*                         a la routine de redessin d'un onglet                */
typedef struct
{
        OBJECT *object;    /* Racine objet en coours     */
        INT16   ind_ob;    /* indice de l'objet en cours */
        char   *txt;       /* texte de l'onglet en cours */
        GRECT  *grect;     /* rectangle de l'onglet      */
        GRECT  *clip_rect; /* rectangle de cliping.      */
} ONG_DRAW_PARAM;


/*........................ USERBLK special pour les menus en fenetre ..........*/
/*                         et G_BOXTEXT avec Xtype  107                       */
typedef struct
{
        INT16 cdecl (*ub_code)(PARMBLK *parmblock);
                                   /* Zeiger auf eine Funktion */
        long ub_parm;              /* optionaler Parameter     */
        TEDINFO *tedinfo;
        OBJECT  *MenTree;
        INT16  Tree_ind;
        INT16 res2;
        INT16 res3;
        GRECT MenBoxGrect;
        INT16 res4;
        INT16 res5;
        INT16 res6;
} MENUSERBLK;

/*.............. Structure de flux evenementiel de sortie .....................*/
typedef struct
 {INT16 evnt;
  INT16 pipe[24];
  INT16 x;
  INT16 y;
  INT16 k;
  INT16 ksp;
  INT16 key;
  INT16 click;
 }EVNT_O;

/*.............. Structure de flux evenementiel d'entree .....................*/
typedef struct
 {INT16 evnt_type;
  INT16 Bclick;
  INT16 Bmask;
  INT16 Bstate;
  INT16  FlagBox_1;
  GRECT Box_1;
  INT16  FlagBox_2;
  GRECT Box_2;
  INT16 lotimer;
  INT16 hitimer;
 }EVNT_I;

/*...................... Structures de bulle d'aide ..........................*/
typedef struct
{INT16 w_h;      /* handle fenetre concernee                                      */
 INT16 type;     /* type du pointeur suivant (RSXHDR, OBJECT, liste de GRECT ...) */
 INT16 nbr;      /* si OBJECT, GRECT, donne le nbr d'objets  valuer             */
 void *ptr;      /* pointe sur la structure dfinie plus haut                     */
}TOOL_TIPS;

/*...................... Structures de gestion de base de donnee .........*/
 typedef struct
    {INT16 PremChp;    /* indice premier champ dans CHPSTRUCT[PremChp].   */
     INT16 LastChp;    /* indice dernier champ dans CHPSTRUCT[LastChp].   */
     char *RecBuff;    /* buffer contenant l'enregistrement CurRec        */
     char Path[MAX_PATH];   /* path du fichier                                 */
     char FicName[64]; /* nom du fichier                                  */
     FILE *Fstream;    /* structure alouee lors ouverture                 */
     long LenRec;      /* longueur d'un enregistrement                    */
    }FICSTRUCT;

 typedef struct
    {INT16  IndFic;  /* indice de la structure de fichier FICSTRUCT[IndFic] */
     INT16  ObChp;   /* indice OBJET champ de saisie                        */
     long DebChp;    /* indice du premier octet du champ                    */
     long LenChp;    /* longueur du champ                                   */
    }CHPSTRUCT;

 typedef struct
    {OBJECT *ObScript;        /* container de script                      */
     long CurRec;             /* enregistrement courant                   */
     long NbFic;              /* nombre de fichiers concernes et ouverts  */
     long NbChp;              /* nombre de structures de champs           */
     FICSTRUCT *ptFicStruct;  /* pointeur sur zone structure de fichiers  */
     CHPSTRUCT *ptChpStruct;  /* pointeur sur zone structure de champs    */
     char *PtRecBuff;         /* pointeur sur zone buffer enregistrements */
    }EZB_FIC_STRUCT;

/*.................. structure de dialogue en fenetre ................*/
typedef struct
 {INT16   type;         /* structure type ressource en fenetre          */
  void  *AdrRsc;        /* adresse ressource                            */
  INT16    NumTree;     /* numero arbre de cette ressource              */
  INT16    NbrTree;     /* nombre d'arbre de cette ressource            */
  OBJECT *tree;         /* adresse arbre de la resource de  fenetre     */
  INT16 ObjEdit;        /* stocke numero objet en edition               */
  INT16 PosCursX;       /* position du curseur dans le champ editable   */
  INT16 CurState;       /* etat allume/1 ou eteint/0 du curseur         */
  INT16 CurTim;         /* compteur de temps pour clignotage curseur    */
  INT16 MoForm;         /* forme de la souris                           */
  INT16 BlkDef;         /* bloc en mode edition/1  ou non edition/0     */
  void *LstAdr;         /* adr d'une listbox si il y a en a une ouverte */

 }DLG_VAR;

/*................... Structures de fenetres .........................*/
typedef struct
{INT16 ident;                                   /* Identificateur prive de la fenetre    */
 CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt); /* procedure de gestion de fenetre       */
 long w_attr;                                   /* attributs de la fenetre               */
 INT16 w_h;                                     /* handle de la fenetre                  */
 INT16 w_flag;                                  /* flags                                 */
 EVNT_I w_evnt_i;                             /* structure evenementielle              */
 GRECT ExtGrectUse;                           /* rectangle exterieur lorsque non full  */
 GRECT GemWorkGrect;                          /* espace de travail GEM de la fenetre   */
 DLG_VAR DlgVar;                              /* structure pour ressources en fenetre  */
 char titre[256];                             /* titre de la fenetre                   */
 EZB_FIC_STRUCT *EZB_struct;                  /* pt sur structure gestion de fichiers  */
 void *UserPtr;                               /* Pointeur sur zone utilisateur         */
 char  MemSup[256];                           /* 256 octets par fenetre pour variables */
 OBJECT *ObIcn;                               /* objet d'iconification                 */
}WINDTAB;


typedef struct
    {INT16 first_ob;
     INT16 nb_ob;
    } ONG_LST;
/*.................... Structure de case de popup .....................*/
typedef struct
  {short x0;
   short y0;
   short x1;
   short y1;
   short numfnc;
   short numicn;
   char  racc1;
   char  racc2;
   short numhlp;
  }MEN_CASE;
/*...................... Structures vqt_extent ....................*/
typedef struct
    {INT16 XinfG;
     INT16 YinfG;
     INT16 XinfD;
     INT16 YinfD;
     INT16 XsupG;
     INT16 YsupG;
     INT16 XsupD;
     INT16 YsupD;
    }EXTND_DIM;
/*...................... Structures vqt_fontinfo .................*/
typedef struct
    {INT16 bot2bas;
     INT16 des2bas;
     INT16 hlf2bas;
     INT16 asc2bas;
     INT16 top2bas;
    }FNT_INF;
/*...................... Structures rectangles ....................*/
typedef struct
    {INT16 left;
     INT16 top;
     INT16 right;
     INT16 bottom;
    }VRECT;

typedef struct
    {INT16 left;
     INT16 top;
     INT16 right;
     INT16 bottom;
    } RECT;

typedef struct
    {INT16 x;
     INT16 y;
    } POINT;

typedef struct
    {long x;
     long y;
    } POINTL;

/*............ header for rectangle buffers (invisible to global functions)...................*/
typedef struct 
 {
  long   magic;
  INT16	 vdihandle;
  INT16	 pxy[8];
  MFDB   mfdb,scr;
  char   data[1];
 } FLYBUFF;

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\            UN_STACK.C          \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ D E F I N E S et T Y P E D E F \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#ifndef __UN_STACK__
#define __UN_STACK__
# define AUTO_ALLOC   1  /* flag d'allocation automatique de donnes   */
/*........................ Parametre d'une action UNDO ................*/
typedef union UD { long Dlong;
                   INT16  Dint[2];
                   char Dchar[4];
                   char *Dszstr;
                 }UData;
/*........................ UNDO_REC ...................................*/
/*             structure definissant une action UNDO                   */
/*             il y en a autant que de UNDO empils                    */

typedef struct{char    Token[10]; /* nom de cette action UNDO            */
               INT16   Type;      /* type du premier paramtre Data1     */
                                  /* si AUTO_ALLOC, la memoire  pointee  */
                                  /* par Data1 sera automatiquement      */
                                  /* liberee lors destruction de cette   */
                                  /* action UNDO, lorsque la pile n'a    */
                                  /* plus de place et detruit les        */
                                  /* premiers UNDO empiles.              */
                                  /* Automatiquement liberee aussi lors  */
                                  /* destruction de la pile.             */
               UData Data1;       /* 1er parametre de cette action UNDO  */
               UData Data2;       /* 2eme parametre de cette action UNDO */
               UData Data3;       /* 3eme parametre de cette action UNDO */
              } UNDO_REC;
/*........................ UNDO_STACK ................................*/
/*              structure definissant une pile UNDO                   */
/*              pointeurs et curseurs sur l'action UNDO en cours      */
/*              et zonne memoire de stockage des actions UNDO         */
typedef struct{UNDO_REC *Pt_deb;  /* premier enregistrement UNDO      */
               UNDO_REC *Pt_end;  /* fin des enregistrements UNDO     */
               long Rec_cur;      /* pointe sur UNDO en cours         */
               long Rec_nbr;      /* nombre de UNDO total possibles   */
              } UNDO_STACK;
#endif

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\            TXT_PROC.C          \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ D E F I N E S et T Y P E D E F \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#ifndef __TXT_PROC__
#define __TXT_PROC__

/*................ attributs de style de la syntaxe ...................*/
#define ATT_TXT_NORMAL     0  /*  texte normal       */
#define ATT_TXT_NUM_LGN    1  /*  Numero de ligne    */
#define ATT_TXT_EOL        2  /*  fin de ligne       */

/*........ type de parametres de la fonction EZ_ED_GetLigCol() ........*/
#define BLK_DEB        1
#define BLK_END        2
#define CURS_POS       4
#define BLK_DEBXY      8
#define BLK_ENDXY      16
#define CURS_POSXY     32
#define BLK_TXT_MARK   64
#define XY_TO_LIGPT    128


/*............ taille du bloc memoire realouee ........................*/
/*             lorsque l'editeur ne trouve plus de place               */
#define SIZE_MEM_ALLOC  32768L

/*............. types de selection lors double clic ...................*/
#define WORD_SIMPLE    1
#define WORD_VAR       2

/*............... types de reraw pour le curseur texte ................*/
#define CURS_ERASE     0         /* efface le curseur                  */
#define CURS_DRAW      1         /* dessine le curseur                 */
#define CURS_FLASH     2         /* fait clignoter le curseur          */

/*......... flag de mise a jour lors calcul coordonnees curseur .......*/
/*          si non positionne la mise a jour des coordonnees du        */
/*          curseur ne se fait pas et seul le calcul est fait          */
#define CURS_UPDATE    1

/*......... Type de dessins possibles du bloc de selection ...........................*/
#define BLK_ALL_DRAW   1  /* tout le bloc (non possible en mode Superviseur)          */
#define BLK_LINE_DRAW  2  /* seul celui de la ligne concernee(Ok pour superviseur)    */
#define BLK_UPDATE     4  /* ce qui est nouveau lors tracage du bloc a la souris      */

/*.......... Flag d'etat de l'editeur de texte ............................................*/
#define EDIT_ACTIV                    1      /* specifie que  le texte est edite           */
#define MO_TRACK_ON                   2      /* specifie que  souris est  pistee           */
#define EDIT_CHG                      4      /* specifie que le texte est chang           */
#define EDIT_HIDE                     8      /* specifie que le texte est invisible        */
#define EDIT_TAB                     16      /* specifie que TAB est active                */
#define EDIT_TAB_VISIBLE             32      /* specifie que TAB est visible               */
#define EDIT_BLK_NOT_AFTER_PASTE     64      /* specifie que l'ajout est non marque        */
#define EDIT_SCRLV_NOT_AFTER_PASTE  128      /* specifie ecran non auto centre apres paste */
#define EDIT_SCRLH_NOT_AFTER_PASTE  256      /* specifie ecran non auto centre apres paste */
#define EDIT_MOFORM_POINT_HAND      512      /* specifie souris doigt lors survol fenetre  */
#define EDIT_MOFORM_ARROW          1024      /* specifie souris fleche lors survol fenetre */
/*........... Position retournee par fonction CheckForScroll() .......................*/
#define SCROLL_LEFT    1
#define SCROLL_RIGHT   2
#define SCROLL_TOP     4
#define SCROLL_BOTTOM  8

/*........... Position retournee apres fonction IsCursInBloc() .......................*/
#define BLK_DEFINED        1
#define BLK_AFTER_CURS     2
#define BLK_NEAR_CURS      4
#define BLK_INVERSED       8
#define BLK_CURS_NOT_IN    16

/*........ Types de notification envoyees avec le message: WM_EDIT_UPDATE ............*/
#define ED_NBR_LIG_CHG  1   /* notifie un changement du nbr de ligne     */
#define ED_FST_LIG_CHG  2   /* notifie un changement de la prem ligne    */
#define ED_FST_CLN_CHG  3   /* notifie un changement de la prem colonne  */
#define ED_POS_CURS_CHG 4   /* notifie un changement position curseur    */
#define ED_CLICK_OUT    5   /* notifie un click en dehors du texte       */
#define ED_LOSE_FOCUS   6   /* notifie la perte du focus                 */
#define ED_CLICK_IN     7   /* notifie un clic dans la fenetre texte     */
#define ED_SET_FOCUS    8   /* notifie que le texte recupere le focus    */
#define ED_KEYB_CNTRL   9   /* notifie que la touche CONTROL appuyee     */
#define ED_KEYB_ALT     10  /* notifie que la touche ALTERNATE appuyee   */
#define ED_KEYB_DWN     11  /* notifie une touche clavier appuyee        */
#define ED_TXT_CHG      12  /* notifie que le texte a ete modifie.       */
#define ED_SIZE_CHG     13  /* notifie que la taille du texte a chang   */
#define ED_RETURN_DWN   14  /* notifie que ENTER ou RETURN on ete appyes */
#define ED_RETURN_CHG   15  /* notifie modification du buffer d'edition  */

/*.............. Flag d'entree de la fonction EZ_ED_SaveTxt() .........*/
#define  TXT_SAVE       1
#define  BLK_SAVE       2

/*.............. Flag d'entree de la fonction SizeOf_EOF() ............*/
#define AFTER_EOL       1        /* on pointe apres la fin de ligne    */
#define BEFORE_EOL      2        /* on pointe avant la fin de ligne    */


/*\\\\\\\\\\\\\\\\\\\ T Y P E D E F    S T R U C T \\\\\\\\\\\\\\\\\\\\*/
/*.............. structure definissant les attributs graphiques .......*/
/*               du texte                                              */
typedef struct
{INT16  CarCol;         /* Couleur caractre           */
 INT16  CarEff;         /* effet  appliquer           */
 INT16  CarPts;         /* taille caractre en Points  */
 INT16  FntID;          /* Indice VDI de la fonte      */
 char FntName[36];      /* nom de la police  employer */
} CAR_ATTR;

/*............ structure descripteur de ligne .........................*/
/*             chaque editeur de texte possede un tableau              */
/*             de cette structure: LGN_CTX *TabLgnCtx                  */
typedef struct
{char *ptTxt;         /* texte pointe.                                 */
 /* INT16  NCom;  */          /* nombre de commentaire avant (si zero on est pas dans un commentaire)  */
 /* INT16  Npar;  */          /* nombre de parenthses avant (si zero on est pas dans une parenthese)  */
 /* INT16  NAco;  */          /* nombre d'accolades avant    (si zero on est pas dans une accolade)    */
}LGN_CTX;

/*..................... Structure de definition d'un texte edite ...................*/
/*                    contient toutes les informations necessaires                  */
/*                    au fonctionnement de l'editeur pour un texte donne            */
typedef struct TXT_VAR
{INT16     IntLg;            /* interligne en pixel                                   */
 INT16     BaseAjust;        /* ajustage vertical de la fonte                         */
 INT16     MargLeft;         /* Marge gauche en pixels                                */
 INT16     MargRight;        /* Marge droite                                          */
 INT16     NblPage;          /* Nombre de lignes d'une page                           */
 INT16     BckCol;           /* Couleur du fond                                       */
 INT16     BckTrm;           /* trame du fond                                         */
 INT16     ExpTAB;           /* nombre d'espaces pour expandre une tabulation         */
 char      CharTAB;          /* caractere  utiliser pour visualiser TAB              */
 INT16     CurFqce;          /* frequence de clignotement                             */
 CAR_ATTR  ATT_Def[3];       /* attributs affichage de chague type de mots            */
 long      SizeLgn;          /* longueur max d'une ligne de texte                     */
 /*................... 4 octets a votre libre disposition ..........................*/
 union
    {long    L;             /* 1 long                                                */
     INT16   W[2];          /* tableau de deux entiers                               */
     char    C[4];          /* tableau de 4 caractres                               */
     char*   PtS;           /* pointeur sur une chaine                               */
     INT16*  PtI;           /* pointeur sur un INT16                                   */
     long*   PtL;           /* pointeur sur un long                                  */
     void*   PtV;           /* pointeur sur un void                                  */
     char**  TabS;          /* tableau de pointeurs de chaine                        */
     INT16** TabI;          /* tableau de pointeurs de INT16                           */
     long**  TabL;          /* tableau de pointeurs de long                          */
     void**  TabV;          /* tableau de pointeurs de void                          */
    }UsrPrm;
 /*.................. ci dessous donnes prives ...................................*/
 INT16     OfsX;           /* decalage horizontal en pixels                         */
 INT16     IntCo;          /* interligne pixels entre deux colonnes.                */
 INT16     Lcar;           /* largeur caractere                                     */
 INT16     Hcar;           /* Hauteur caractere                                     */
 long      NbLgn;          /* nombre de ligne du texte                              */
 long      NbLgnMax;       /* nombre de ligne maxi que peut stocker le texte        */
 char     *ptTxt;          /* adresse du texte                                      */
 char     *EndTxt;         /* fin du texte adresse du (zero de fin)                 */
 char     *EndBuff;        /* fin du buffer de chargement (fin memoire alouee)      */
 char     *BuffEdit;       /* buffer ou sera saisie la ligne en edition             */
 LGN_CTX  *TabLgnCtx;      /* pointeur sur le tableau de contexte de ligne          */
 INT16     TabLgnCtxSize;  /* taille d'un contexte de ligne (peut etre change)      */
 char     *SupLgnCtxtMem;  /* adresse de la memoire supplementaire de contexte ligne*/
 CAR_ATTR *ATT_Cur;        /* attributs d'affichage par defaut (sans 0 de fin)      */
 INT16     State;          /* etat de l'editeur: EDIT_ACTIV, MO_TRACK_ON, EDIT_CHG  */
 GRECT     TxtGrect;       /* rectangle dans lequel le texte doit etre contenu      */
 long      PremLigVisible; /* premiere ligne visible dans le cadre                  */
 long      NbreLigVisible; /* nombre de ligne visibles dans le cadre                */
 long      LigPt;          /* ligne pointe dans le texte                            */
 long      CarPt;          /* caractere pointe dans le texte                        */
 INT16     CurX;           /* position x du curseur en val absolue                  */
 INT16     CurY;           /* position Y du curseur en val absolue                  */
 INT16     CurH;           /* hauteur H du curseur en val absolue                   */
 INT16     CurState;       /* etat du curseur 1/allume 0/etteint                    */
 long      BlkDebLig;      /* ligne ou est le debut du bloc                         */
 long      BlkDebCar;      /* car du debut de bloc dans ligne de debut de bloc      */
 INT16     BlkDebX;        /* position x du debut de bloc                           */
 INT16     BlkDebY;        /* position Y du debut de bloc                           */
 long      BlkEndLig;      /* ligne ou est la fin du bloc                           */
 long      BlkEndCar;      /* car de la fin de bloc dans ligne de fin de bloc       */
 INT16     BlkEndX;        /* position x de la fin de bloc                          */
 INT16     BlkEndY;        /* position Y de la fin de bloc                          */
 INT16     LastXPt;        /* position x en pixels lorsque le curseur change ligne  */
 long      LastCarPt;      /* dernier caractere pointe par le curseur               */
 long      LastLigPt;      /* derniere ligne pointee par le curseur                 */
 UNDO_STACK *U_Stack;      /* adresse de la pile UNDO (si elle existe zero sinon)   */
 /*...................... Buffer de 1024 octets dont se sert le composant ..........*/
 /*                       pour buffer de travail interne pour recopie ou autre      */
 /*                       ce buffer peut etre utilise par vous comme tampon         */
 /*                       temporaire. Son contenu n'est pas critique.               */
 /*                       Il est a considr si vous l'utilisez pour vos propres    */
 /*                       besoins, comme une variable locale, dont le contenu       */
 /*                       n'est garanti que dans le corps de votre fonction.        */
 char    *AffiBuff;
 /*.................. Un composant peut etre rattache  un objet: SCROLL_EDIT ......*/
 /*                   alors les coordonnes de cet objet sont places dans les      */
 /*                   deux variables ci_dessous. Si ce n'est pas le cas utilisez    */
 /*                   cette place pour vos propres besoins.                         */
 OBJECT  *Object;          /* adresse de l'arbre auquel appartient l'objet          */
 INT16    ObjectAttach;    /* indice de l'objet SCROLL_EDIT                         */
 /*................. fonction Evenementielle .......................................*/
 /*                c'est cette fonction qui recoit tout le flux evenementiel        */
 /*                c'est le moteur de l'editeur. Il vous est bien sur possible      */
 /*                de deriver cette fonction pour vos propres besoins.              */
 INT16      (*EvntFunc)(INT16 w_ind, EVNT_O *Evnt);
 /*................. fonction de notification directe ..............................*/
 /*                  qu'appelle l'editeur pour avertir                              */
 /*               des changements que la saisie entraine                            */
 INT16      (*NotifyFunc)(INT16 w_ind, EVNT_O *Evnt);
 /*................ fonction de redessin d'une ligne de texte ......................*/
 INT16      (*DrawTxtLine)(long i, INT16 tx, INT16 ty, struct TXT_VAR *TXT_A);
 /*................ fonction  appeler lors d'un changement ........................*/
 /*                 de coordonnes du cadre texte afin que                          */
 /*                 l'editeur mette a jour son curseur et son bloc                  */
 void     (*EditTxtPosChg)(struct TXT_VAR *TXT_A);
 /*............... Fonction appelle lors du formattage de lignes ..................*/
 /*                initialise le tableau d'adresse de lignes                        */
 long     (*InitTabLgnCtx)(struct TXT_VAR *TXT_A, char *txt, long iTab, long nb_l);
 /*........ Fonction appelle lors affichage d'une partie de ligne de texte ........*/
 /* ACTION: affiche le contenu d'un buffer avec les attributs courants.             */
 /* ENTREE: INT16 tx, INT16 ty: position d'affichage en pixels.                     */
 /*         char *buft: chaine  afficher.                                          */
 /*         TXTED_OB *TXT_A: structure du composant d'edition de texte              */
 /* NOTE: l'affichage se fait selon les attributs graphiques courants pointes       */
 /*       par la structure: TXT_A->ATT_Cur                                          */
 /* RETOUR: largeur de ce qui vient d'etre affiche.                                 */
 INT16      (*DrawTxt)(INT16 tx, INT16 ty, char *PtTexteLigne, struct TXT_VAR *TXT_A);
} TXTED_OB;
#endif

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                                                                            */
/*        VARIABLES GLOBALES PUBLIQUES (liees au fichier EAZY_GEM.LIB)        */
/*         ces variables peuvent etre utilises par tous les fichiers         */
/*                                                                            */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*.......... les deux variables suivantes doivent etre modifiees .............*/
/*           avant l'appel  la fonction: InitEazyGem() pour                  */
/*               que la modification soit prise en compte                     */
extern INT16 MS_NB;     /* nbr d'evenements que peut stocker la pile.         */
                        /* si zero: elle ne sera pas activee.                 */
                        /*          (zero est la valeur par defaut)           */
                        /* Cette valeur est a modifier avant appel  la       */
                        /* fonction InitEazyGem():                            */
                        /* Si la pile d'evenements est active, la fonction:   */
                        /*     INT16 DumpEventStack(char *path_in, char *nom);*/
                        /*     permet de la Dumper dans un fichier afin de    */
                        /*     pouvoir l'analyser  des fins de Debugging.    */
extern INT16 MAX_TTIPS;   /* nbr maxi de structures TOOL_TIPS permises        */
extern INT16 MAX_WIND;    /* nbr maxi de fenetres de notre application        */
extern INT16 MIN_SLIDE_W; /* largeur minimum d'un ascenseur                   */
extern char NomAppli[MAX_PATH]; /* contient apres initialisation nom du programme  */
extern char CheminAppli[MAX_PATH];
extern char *EZ_message[]; /* table des adresses des messages, d'EAZY_GEM     */
extern INT16 Appl_id;    /* variable globale publique identifiant l'appli.    */
                       /* que le gem nous attribue lorsque nous lui demandons */
                       /* l'autorisation de demarrer. Cette variable est      */
                       /* retournee par la fonction InitEazyGem()             */
extern OBJECT *ApplIcn;          /* objet icone application.                  */
extern MACHINE_INFO MachineInfo; /* structure pour les info sur la machine    */
extern INT16 AESversion;  /* version AES utilise          (ne pas modifier)   */
extern INT16 VDIhandle;   /* handle que le systeme m'attribuera apres         */
                          /* ouverture de la station de travail graphique     */
extern INT16 Ecran_l;     /* largeur en pixel de l'ecran (ne pas modifier)    */
extern INT16 Ecran_h;     /* hauteur en pixel de l'ecran (ne pas modifier)    */
extern INT16 Nb_plan;     /* nbr de plans de l'ecran     (ne pas modifier)    */
extern long Nb_color;     /* nbr de couleurs de l'ecran  (ne pas modifier)    */
extern INT16 EZGemRun; /* variable globale publique si zero le programme sort */
                /* de la boucle evenementielle                                */
                /* pour mettre fin au programme il faut la mettre a 0         */
                /* de n'importe quel endroit du programme                     */

extern WINDTAB   *Windtab;     /* declaration de la table de structures       */
                               /* de fenetre.                                 */
extern INT16 TTswitch;         /* si 0/pas de bulle si 1/bulle actives        */
extern INT16 TT_Time_ON;       /* delai avant apparition bulle                */
extern INT16 TT_Time_OFF;      /* delai pour disparition bulle                */

extern INT16 *MenTTBack;       /* pointe sur sauvegarde fond bulle d'aide     */
                               /* definition de la forme souris "I"           */
                               /* mise au debut des bulles d'aides            */
extern INT16   NbFont;         /* nombre de fontes                            */
extern char *FontTab;     /* pointera sur tableau global des fontes           */
extern char *FontName;    /* pointera sur tableau des nom de fontes           */
extern long *FontID;      /* pointera sur tableau des ID de fontes            */
extern long  Gdos;        /* contient: l'identificateur Gdos si ok            */
                          /*          -2 si Gdos pas charg                   */
                          /*          '_FSM' si vectoriel possible            */
extern INT16 ModalFSEL;
extern INT16 ModalWind;
extern MFDB Screen_MFDB;  /* Raster initialise sur ecran                      */
extern MO_STACK *MoStack; /* pile stockant les derniers evenements souris     */

/*.................. tableaux VDI elargis pour permettre .....................*/
/*               le stockage de plus de valeurs et vecteurs(1024)             */
/*               definis dans le fichier EAZY_ASM.S                           */

extern VDIPB  EZ_VDIPB;

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                                                                            */
/*        FONCTIONS REDEFINIE (liees au fichier EAZY_GEM.LIB)                 */
/*                                                                            */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
INT16 EZ_vst_font(INT16 vh, INT16 fnt);
INT16 EZ_vst_point( INT16 vh, INT16 point, INT16 *c, INT16 *d, INT16 *e, INT16 *f);
INT16 EZ_vst_rotation(INT16 vh, INT16 angle);
INT16 EZ_vst_effect(INT16 vh, INT16 effect);
INT16 EZ_vst_color(INT16 vh, INT16 color);
INT16 EZwind_update(INT16 mode);
INT16 EZ_alert( INT16 default_button, char *form_string );
INT16 EZ_menu_bar( OBJECT *tree, INT16 show );

#ifndef _GEMLIB_H_
    
    #define vst_font(a,b)            EZ_vst_font((a),(b))

    #define vst_point(a,b,c,d,e,f)   EZ_vst_point((a),(b),(c),(d),(e),(f))

    #define vst_rotation(a,b)        EZ_vst_rotation((a),(b))

    #define vst_effects(a,b)         EZ_vst_effect((a),(b))

    #define vst_color(a,b)           EZ_vst_color((a),(b))

    #define wind_update(a)           EZwind_update((a))

    #define form_alert(a,b)          EZ_alert((a),(b))

    #define menu_bar(a,b)            EZ_menu_bar((a),(b))
#else
    #define form_alert(a,b)          EZ_alert((a),(b))
#endif


/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                                                                            */
/*        FONCTIONS PUBLIQUES (liees au fichier EAZY_GEM.LIB)                 */
/*   ces fonctions peuvent etre utilises par tous les fichiers               */
/*                                                                            */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*************************************************************************/
/*           F O N T I O N S   D 'I N I T I A L I S A T I O N  ( G E M ) */
/*************************************************************************/
void EvntEZ_GEM(INT16 evnt_mask, EVNT_I *evnt_i, EVNT_O *evnt_o);



/*--------------------------- InitEazyGem -----------------------------*/
/* ACTION: initialise sur des valeurs par defaut la structure WINDTAB  */
/*         et dclare l'application au gem                             */
/* elle declare notre programme  EAZY_GEM,                            */
/* Initialise l'application et son identificateur GEM: Appl_id,        */
/* Ouvre une station de travail VDI dont le handle est: VDIhandle,     */
/* Initialise le GDOS (si il existe), charge les polices de caracteres */
/*     Reserve et initialise la zone des donnees de fontes: FontTab,   */
/*     itialise la variable de nombre de fontes: NbFont,               */
/*     initialise le tableau d'identificateur de fontes: FontID[],     */
/*     initialise le tableau de nom des fontes: FontName,              */
/* Initialisation desvariables globales suivantes:                     */
/*                Appl_id  (identificateur GEM de l'application)       */
/*                VDIhandle (handle VDI de l'application)              */
/*                FontTab  (pointe sur zone memoire reservee pour les  */
/*                          variables lies aux fontes)                */
/*                FontID[] (tableau des identificateurs de fontes)     */
/*                FontName (zone des noms de fontes. Chaque nom de     */
/*                         fonte fait 36 caracteres y compris zero de  */
/*                         fin de chaine. EXP: Pour accder au nom de  */
/*                         la 12me fonte il faut faire, (le premier   */
/*                         lment commenant  zro):                 */
/*                         FontName + 11 * 36. L'adresse ainsi         */
/*                         calcule pointe sur le nom de la 12me      */
/*                         fonte charge.Ce nom est identique  celui  */
/*                         retourn par la fonction VDI: vqt_name      */
/*                         ouf !!)                                     */
/*                NbFont  (Nombre de fontes disponibles y compris la   */
/*                         fonte systme)                              */
/*                Ecran_l (largeur de l'ecran en pixels)               */
/*                Ecran_h (hauteur de l'ecran en pixels)               */
/*                Nb_color(nombre de couleurs)                         */
/*                Nb_plan (nombre de plan de l'ecran)                  */
/*                NomAppli (pointe sur le nom du programme)            */
/*                AESversion (utile  tester pour certaines fonctions) */
/*                Screen_MFDB  (structure raster cran)                */
/*                MachineInfo  (structure renseignant sur la machine   */
/*                               et systme sur lequel l'on est)       */
/*                Gdos   contient: l'identificateur Gdos si ok         */
/*                                -2 si Gdos pas charg                */
/*                                '_FSM' si vectoriel possible         */
/* Initialisation de la structure WINDTAB sur zero et valeurs de defaut*/
/*                                                                     */
/* ENTREE:      char *nomappli   doit pointer sur le nom du programme  */
/* RETOUR:      un INT16  positif si reussite de l'operation, qui est  */
/*                         alors l'identificteur GEM de l'application  */
/*                      NEGATIF -2 alors station de travail VDI non    */
/*                                 ouverte il faut abandonner.         */
/*                      NEGATIF -1 alors tout est foutu il faut quitter*/
/* PROTOTYPE:                                                          */
              INT16 InitEazyGem(char *nomappli);


/*----------------------------- ExitEasyGem ---------------------------*/
/* ACTION: Libre la mmoire reserve par EAZY_GEM pour ses besoins    */
/*         internes, dcharge les polices de caractres, ferme la      */
/*         station VDI, libre l'application du GEM, et quitte.        */
/* ENTREE:    nant                                                    */
/* RETOUR:    sans INT16rt                                           */
/* PROTOTYPE:                                                          */
              INT16 ExitEasyGem(void);

/*------------------------- BouclePrincipale  -------------------------*/
/* ACTION: Noyau d'EAZY_GEM cette fonction est celle qui gre          */
/*         l'vnementiel GEM le filtre, le redistribue aux diffrentes*/
/*         fonctions CALLBACK en les appelant                          */
/*         Pour mettre fin  cette boucle il faut mettre la variable   */
/*         globale: EZGemRun                                           */
/*                   0 (demande de confirmation avant sortie)         */
/*                   1 (sortie sans demande de confirmation)          */
/* ENTREE: CALLBACK (*MyEventProc)(INT16 w_ind, void *adr) adresse de  */
/*                   fonction qui sera charge de grer l'vnmentiel  */
/*                   GEM par dfaut. Si cette valeur est NULL, alors   */
/*                   l'vnmentiel GEM ne pourra etre gr que par les */
/*                   fonctions CALLBACK  de fenetre                    */
/* RETOUR: nant                                                       */
/* PROTOTYPE:                                                          */

void BouclePrincipale(CALLBACK(*MyEventProc)(INT16 w_ind,EVNT_O *Evnt));

/*************************************************************************/
/*           F O N T I O N S   D E   R E S S O U R C E S   ( G E M )     */
/*************************************************************************/

/* --------------------------- RscFicLoad -------------------------------*/
/* ACTION: charge un fichier ressource en memoire et l'adapte aux        */
/*         nouvelles specification d'EAZY_GEM.                           */
/*         La memoire est automatiquement reservee et la ressource est   */
/*         relogee et convertie prete  l'emploi.                        */
/* ENTREE: char *path, char *name chemin et nom de la ressource          */
/*         INT16 scale_flag = 1 SCALE affichage au standard GEM (normal) */
/*                        = 0 NO_SCALE affichage au standard EAZY_GEM    */
/*                            (police moyenne taille 9)                  */
/*         pour le menu GEM classique utilizez  SCALE ou 1               */
/*         pour un menu en fenetre ou une ressource en fenetre           */
/*              choisissez ce qui vous plait le plus.                    */
/* RETOUR: adresse memoire o la ressource a t charge                 */
/*         SI = 0 pas assez de memoire                                   */
/*            = 1 ce n'est pas un fichier de ressource                   */
/*            = 2 ouverture fichier impossible (fichier non trouv       */
/*                                              mauvais chemin ou nom)   */
/*         il est fortement conseille de stocker cette adresse de        */
/*         chargement quelque part !!!                                   */
/* PROTOTYPE:                                                            */
          void *RscFicLoad(char *path, char *name, INT16 scale_flag);

/* ------------------------- RscFicUnLoad ----------------------------------*/
/* ACTION: decharge la ressource et la memoire occupe par celle ci.        */
/*         il est obligatoire d'appeler cette fonction avant la fin du      */
/*         programme ou si l'on veut liberer et ejecter cette ressource     */
/*         car l'on n'en a plus besoin. Il est evident que si l'on veut de  */
/*         nouveau utiliser cette ressource il faudra la recharger avec     */
/*         la fonction: RscFicLoad                                          */
/* ENTREE: void *adr_rsc adresse memoire o a t charge la ressource      */
/* SORTIE: void *adr_rsc est mise  zero                                    */
/* PROTOTYPE:                                                               */
           void RscFicUnLoad(void *adr_rsc);

/*------------------------ LoadAppliRsc ----------------------------------*/
/* ACTION: charge la ressource dont le nom est donn en entree, dans les  */
/*         diffrents repertoires possibles de l'application.             */
/*         Soit celui de la chaine d'environnement lie  l'application,  */
/*         Soit dans un dossier portant le nom de l'application avec      */
/*              l'extension .RSC, situe dans meme repertoire que l'appli- */
/*              cation.                                                   */
/*         Soit dans un dossier portant le nom de l'application avec      */
/*              l'extension .SYS, situe dans meme repertoire que l'appli- */
/*              cation.                                                   */
/*         Soit dans un dossier portant le nom de l'application avec      */
/*              l'extension .EZB, situe dans meme repertoire que l'appli- */
/*              cation.                                                   */
/*         Soit au niveau du repertoire de l'application.                 */
/* ENTREE: char *nom_rsc: pointe sur nom du fichier ressource  charger   */
/*         INT16 scale: NO_SCALE/0 echelle reduite.                       */
/*                       SCALE/1 echelle normale du GEM.                  */
/* SORTIE: adresse de chargement de la ressource.                         */

void *LoadAppliRsc(char *nom_rsc, INT16 scale);

/*----------------------------- GetPathRsc -------------------------------*/
/* ACTION: retourne le path de chargement de la ressource dont l'adresse  */
/*         est specifiee en entree.                                       */
/* ENTREE: void *adr_rsc: pointeur sur l'adresse de la ressource.         */
/*         char *path: chaine qui recevra la copie du path de ressource.  */
/* SORTIE: char *: adresse de la chaine d'entree                          */
/*                 SI zero pas de ressource en memoire.                   */

char *GetPathRsc(void *adr_rsc, char *path);

/*------------------------ xrsrc_gaddr ---------------------------------------*/
/* ACTION: permet d'obtenir l'adresse des differents elements de la           */
/*         ressource. Cette fonction fonctionne comme  rsrc_gaddr du GEM      */
/*         avec comme parametre suplementaire l'adresse de la ressource       */
/* ENTREE: INT16 type:     type d'element dont on veut l'adresse              */
/*                       (comme ceux du  rsrc_gaddr classique du GEM)         */
/*         INT16 index:    index de l'element dont on veut l'adresse          */
/*         INT16 *adr_rsc: adresse de chargement de la ressource. C'est celle */
/*                       que l'on a obtenu avec la fonction: RscFicLoad       */
/* SORTIE: void *adr_ret: adresse de l'element recherch                      */
/* EXEMPLE: cet exemple indique comment obtenir l'adresse d'un arbre de       */
/*          ressource (dialogue, menu, etc..) Ici je desire avoir l'adresse   */
/*          du premier objet du troisieme arbre (indexe  partie de zero)     */
/*          de la ressource chargee par: RscFicLoad  l'adresse: AdrRsc       */
/*          OBJECT *tree;   je declare un pointeur sur un objet               */
/*          xrsrc_gaddr (R_TREE, 2, &tree, AdrRsc);  j'appelle la fonction    */
/*          et apres cet appel, tree pointe sur le premier objet de la        */
/*                              ressource que je peux donc utiliser pour      */
/*                              affichage et autres  manipulations comme      */
/*                              dans le GEM traditionnel.                     */
/* PROTOTYPE:                                                                 */

INT16 xrsrc_gaddr (INT16 type, INT16 index, void *adr_ret, INT16 *adr_rsc);

/*---------------------- GetXobtypeFirstObDial --------------------------*/
/* ACTION: analyse la ressource, et si trouve un arbre type etendu egal  */
/*         a celui specifie, retourne l'adresse de cet arbre.            */
/* ENTREE: void *adr_rsc: adresse de chargement de la ressource          */
/*         INT16 type:      type etendu recherche                        */
/* SORTIE: OBJECT *:      adresse de l'objet racine de l'arbre de cette  */
/*                        ressource si trouve. sinon zero.               */
OBJECT *GetXobtypeFirstObDial(void *adr_rsc, INT16 type);

/*----------------------- SetBulleState ---------------------------------*/
/* ACTION: cherche un indicateur d'tat de la bulle d'aide dans          */
/*         l'arbre de ressource point par OBJECT *object et le place    */
/*         dans le bon etat d'activite et le redessine.                  */
/* ENTREE: INT16 w_h, handle GEM de la fenetre ou se trouve la ressource */
/*         OBJECT *object, pointe sur l'arbre de ressource.              */

void SetBulleState(INT16 w_h, OBJECT *object);

/*--------------------- GetKeyboardFocus -------------------------------*/
/* ACTION: retourne l'objet possedant le focus clavier.                 */
/* ENTREE: INT16 w_ind:  indice EAZY_GEM de la fenetre ou se trouve     */
/*                     l'arbre de ressource dont on cherche a connaitre */
/*                     l'objet qui possede le focus clavier.            */
/* RETOUR: indice de l'objet ayant le focus.                            */

INT16 GetKeyboardFocus(INT16 w_ind);

/*------------------- FindFirstEditable -----------------------------*/
/* ACTION: trouve le premier editable dans les fils d'un objet       */
/* ENTREE: OBJECT *object, pointe sur l'arbre dont on cherche le     */
/*                premier editable.                                  */
/*         INT16 ind indice de l'objet pere dont il faut explorer la */
/*                descendance.                                       */
/* RETOUR: indice du premier editable si trouv.                     */
/*         -1 si non trouv.                                         */

INT16 FindFirstEditable(OBJECT *object, INT16 ind);

/*------------------- FindNextEditable ------------------------------*/
/* ACTION: trouve l'editable suivant un objet dans la descendance    */
/*         d'un objet.                                               */
/* ENTREE: OBJECT *object, pointe sur l'arbre dont on cherche        */
/*                l'editable.                                        */
/*         INT16 ind, indice de l'objet pere dont il faut explorer   */
/*                la descendance.                                    */
/*         INT16 ob_edit, indice de l'objet actuellement edit.      */
/* RETOUR: indice de  l'editable suivant si trouv.                  */
/*         -1 si non trouv.                                         */

INT16 FindNextEditable(OBJECT *object, INT16 ind, INT16 ob_edit);

/*------------------- FindFirstDefaultOb ----------------------------*/
/* ACTION: trouve le premier objet DEFAULT dans les fils d'un objet  */
/* ENTREE: OBJECT *object, pointe sur l'arbre dont on cherche le     */
/*                premier DEFAULT.                                   */
/*         INT16 ind indice de l'objet pere dont il faut explorer la */
/*                descendance.                                       */
/* RETOUR: indice du premier DEFAULT si trouv.                      */
/*         -1 si non trouv.                                         */

INT16 FindFirstDefaultOb(OBJECT *object, INT16 ind);

/*------------------- FindPreviousEditable --------------------------*/
/* ACTION: trouve l'editable prcdant un objet dans la descendance  */
/*         d'un objet.                                               */
/* ENTREE: OBJECT *object, pointe sur l'arbre dont on cherche        */
/*                l'editable.                                        */
/*         INT16 ind, indice de l'objet pere dont il faut explorer   */
/*                la descendance.                                    */
/*         INT16 ob_edit, indice de l'objet actuellement edit.      */
/* RETOUR: indice de  l'editable precedent si trouv.                */
/*         -1 si non trouv.                                         */

INT16 FindPreviousEditable(OBJECT *object, INT16 ind, INT16 ob_edit);

/*------------------- FindFirstObject -------------------------------*/
/* ACTION: donne l'indice du premier objet d'un arbre ressource      */
/*         par rapport  un objet quelconque passe en entree         */
/* ENTREE: OBJECT* object, pointe sur un objet quelconque            */
/* RETOUR: indice de l'objet pere (forcement negatif)                */

INT16 FindFirstObject(OBJECT *object);

/*------------------------------ IsThisObInvisible -------------------------*/
/* ACTION: teste si l'ascendance de l'objet est invisible (HIDETREE).       */
/* ENTREE:  OBJECT *object: adresse objet racine de l'arbre auquel          */
/*                          appartientl'objet dont on teste la visibilite.  */
/*          INT16 ind_ob: indice de l'objet dans cet arbre.                 */
/* RETOUR: un INT16: SI -1 l'objet est visible.                             */
/*                 SINON indice de l'objet ascendant HIDETREE.              */

INT16 IsThisObInvisible(OBJECT *object, INT16 ind_ob);

/*--------------------------- ObjcGetTxt -----------------------------------*/
/* ACTION: permet d'obtenir l'adresse de la chaine texte d'un objet.        */
/*         Il est impratif de n'utiliser que cette fonction dans EAZY_GEM  */
/*         pour obtenir l'adresse de la chaine texte des objets.            */
/* ENTREE: OBJECT *adr, pointe sur l'arbre de l'objet.                      */
/*         INT16 object, indice de l'objet.                                 */
/* RETOUR: un char* pointant sur la chaine de texte de cet objet.           */

char *ObjcGetTxt (OBJECT *adr, INT16 object);

/*--------------------------- ObjcGetLenTxt --------------------------------*/
/* ACTION: permet d'obtenir l'adresse de la chaine texte d'un objet.        */
/*         Il est impratif de n'utiliser que cette fonction dans EAZY_GEM  */
/*         pour obtenir l'adresse de la chaine texte des objets.            */
/*         retourne la longueur max de la chaine y compris 0 de fin         */
/* ENTREE: OBJECT *adr, pointe sur l'arbre de l'objet.                      */
/*         INT16 object, indice de l'objet.                                 */
/*         char **txt,  pointe  sur pointeur de chaine qui est placee sur   */
/*                      l'adresse de la chaine de l'objet. Cette valeur     */
/*                      ne pas etre fournie (mise  zero) et alors elle ne  */
/*                      sera pas remplie avec l'adresse de la chaine de     */
/*                      l'objet.                                            */
/* RETOUR: un long indiquant la taille de la chaine y compris le 0 de fin   */

long ObjcGetLenTxt (OBJECT *adr, INT16 object, char **txt);

/*---------------------------- ObjcSetTxt ----------------------------------*/
/* ACTION : place la chaine string place en entr dans la zone texte       */
/*          de l'objet donn en entre. La chaine d'entree est tronque si  */
/*          elle depasse celle que l'objet peut admettre.                   */
/*          Il est impratif de n'utiliser que cette fonction dans EAZY_GEM */
/*          pour placer une chaine texte dans un objet .                    */
/* ENTREE: OBJECT *adr, pointe sur l'arbre de l'objet.                      */
/*         INT16 object, indice de l'objet.                                 */
/*         char *string, pointe sur la chaine de caracteres  placer.       */

void ObjcSetTxt (OBJECT *adr, INT16 object, char *string);

/*-----------------------  Wobjc_draw ------------------------------*/
/* ACTION: redessine l'objet place en entree, en tenant compte de   */
/*         la liste des rectangles.                                 */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de LA fenetre.              */
/*         OBJECT *object, adresse arbre auquel appartient l'objet. */
/*         INT16 num_ob, numro de l'objet dans cet arbre.          */
/*         INT16 niveau, profondeur de redessin dans la descendance */
/*         GRECT *clipgrect, rectangle de clipping.                 */
/*                si il est non defini (==0), c'est le rectangle de */
/*                de l'objet qui est utilis.                       */

INT16 Wobjc_draw(INT16 w_ind, OBJECT *object, INT16 num_ob, INT16 niveau, GRECT *clip_grect);

/*-----------------------  Xobjc_draw ------------------------------*/
/* ACTION: redessine l'objet place en entree avec le rectangle de   */
/*         clipping                                                 */
/* ENTREE: OBJECT *object, adresse arbre auquel appartient l'objet. */
/*         INT16 num_ob, numro de l'objet dans cet arbre.          */
/*         INT16 niveau, profondeur de redessin dans la descendance */
/*         GRECT *clipgrect, rectangle de clipping.                 */

void Xobjc_draw(OBJECT *object, INT16 num_ob, INT16 niveau, GRECT *clipgrect);

/*------------------------- DoPopMenuFromFile --------------------------------*/
/* ACTION: cette fonction permet de creer en memoire un menu GEM  partir     */
/*         de deux descripteurs de menu. L'un fourni par un fichier,          */
/*                                       L'autre par une chaine de caracteres */
/*         Il faut au minimum que l'un de ces deux descripteurs soit valide.  */
/*         Ce Popup est cree, initialise, affiche, et la main n'est rendue    */
/*         qu'apres selection ou non (click en dehors) d'un item du menu.     */
/*         Il est alors detruit et la memoire liberee.                        */
/*                                                                            */
/* ENTREE: OBJECT *object: adresse d'un arbre d'objet dont l'objet avec l'in- */
/*                         dice ob_ind, sert uniquement pour specifier        */
/*                         l'aspect graphique.  Si l'on ne veut pas specifier */
/*                         d'aspect graphique particulier, placez zero.       */
/*         INT16 ob_ind: indice de l'objet appartenant  l'arbre: object, qui */
/*                     va servir de reference graphique pour l'affichage du   */
/*                     menu popup. Si OBJECT *object est egal  zero, il ne   */
/*                     sera pas tenu compte de ce paramtre, et un aspect     */
/*                     graphique par defaut sera mis en place.                */
/*         char *path_in: chemin (sans le fichier type: E:\CHEMIN\) o se     */
/*                        trouve le fichier decrivant le menu.                */
/*         char *name:        chaine pointant sur le nom du FICHIER decrivant */
/*                            le Popup. Ce fichier doit se trouver dans le    */
/*                            dossier systme du programme (celui ou se       */
/*                            trouvent les ressources). Ce fichier est un     */
/*                            texte dont chaque ligne (termine par \n\r)     */
/*                            represente une entree, ou ligne de menu.  Il ne */
/*                            peut y avoir plus simple !!!.                   */
/*         char *dest_string: sert  deux moments dans la fonction:           */
/*                                                                            */
/*                            AVANT CREATION DU MENU:                         */
/*                            ......................                          */
/*                            Pointe sur une chaine de caractres du meme     */
/*                            format que le fichier. les lignes de menu de    */
/*                            cette chaine sont rajoutes apres celles du     */
/*                            fichier. Si le premier caractre de la chaine   */
/*                            un zero de fin (chaine vide), Alors elle ne     */
/*                            sera pas utilisee pour construire le menu.      */
/*                                                                            */
/*                            APRES SELECTION D'UN ITEM DU MENU:              */
/*                            .................................               */
/*                            Et seulement si le pointeur de chaine est       */
/*                            valide ,non egal a 0 et pointant sur une chaine */
/*                            il est recopie dans cette chaine la ligne de    */
/*                            menu selectionne (chaine vide si pas de selec- */
/*                            tion). Cela permet par exemple de recuperer le  */
/*                            texte de la ligne de menu selectionnee afin     */
/*                            de l'analyser pour par exemple interpreter un   */
/*                            raccourci clavier.                              */
/*                            Prevoyer une chaine d'au moins la taille d'une  */
/*                            ligne de menu pour que la recopie ne deborde pas*/
/*                            Si vous n'avez que faire de cette recopie, et   */
/*                            que votre menu ne se compose que d'un fichier,  */
/*                            alors placez zero comme parametre.              */
/*                                                                            */
/* RETOUR: un INT16: qui est l'indice de l'objet selectionne (commence  1    */
/*                 pour premire ligne de menu). Si<=0 alors c'est soit erreur*/
/*                 soit aucune selection (click en dehors du menu).           */
/*                                                                            */
/* NOTE: l'aspect graphique indique par l'objet: object[ob_ind] est facultatif*/
/*       placez zero si vous ne disposez pas d'objet permettant de preciser   */
/*       un aspect graphique. Sinon placez par exemple, les references d'un   */
/*       objet WINDMENU tels que ceux qui servent  recevoir un menu en       */
/*       fenetre, ou de tout autre objet type G_BOXTEXT.                      */

INT16 DoPopMenuFromFile(OBJECT *object, INT16 ob_ind, char *path_in, char *name, char *dest_string);

/*-------------------------------- DynFilePopupCreate ------------------------*/
/* ACTION: cette fonction permet de creer en memoire un menu GEM  partir     */
/*         de deux descripteurs de menu. L'un fourni par un fichier,          */
/*                                       L'autre par une chaine de caracteres */
/*         Il faut au minimum que l'un de ces deux descripteurs soit valide.  */
/*         Ce Popup est cree, initialise en memoire, mais non affiche.        */
/*                                                                            */
/* ENTREE: char *path_in: chemin (sans le fichier type: E:\CHEMIN\) o se     */
/*                        trouve le fichier decrivant le menu.                */
/*         char *name:        chaine pointant sur le nom du FICHIER decrivant */
/*                            le Popup. Ce fichier doit se trouver dans le    */
/*                            dossier systme du programme (celui ou se       */
/*                            trouvent les ressources). Ce fichier est un     */
/*                            texte dont chaque ligne (termine par \n\r)     */
/*                            represente une entree, ou ligne de menu.  Il ne */
/*                            peut y avoir plus simple !!!.                   */
/*         char *descr_str:   Pointe sur une chaine de caractres du meme     */
/*                            format que le fichier. les lignes de menu de    */
/*                            cette chaine sont rajoutes apres celles du     */
/*                            fichier. Si le premier caractre de la chaine   */
/*                            un zero de fin (chaine vide), Alors elle ne     */
/*                            sera pas utilisee pour construire le menu.      */
/*                            Si vous placez zero dans ce parametre il n'en   */
/*                            sera pas tenu compte.                           */
/* RETOUR: OBJECT*: qui est l'adrresse de l'arbre de menu cree en memoire     */
/*                 si zero erreur lors de la creation                         */
/* NOTE: le popup ainsi cree est a detruire apres usage en faisant appel  la */
/*       fonction: DestroyDynamicPopup();                                     */

OBJECT *DynFilePopupCreate(char *path_in, char *name, char *descr_str);

/*--------------------------------- DynFilePopupDo -------------------------- */
/* ACTION: cette fonction affiche et gere l'action de la souris, sur un menu  */
/*         popup dont l'adresse de l'arbre en memoire est donnee  par la      */
/*         variable d'entree: OBJECT *popup , et la main n'est rendue         */
/*         qu'apres selection ou non (click en dehors) d'un item du menu.     */
/*                                                                            */
/* ENTREE: OBJECT *graf_object: adresse d'un arbre d'objet dont l'objet avec  */
/*                         indice graf_obind, sert uniquement pour specifier  */
/*                         l'aspect graphique.  Si l'on ne veut pas specifier */
/*                         d'aspect graphique particulier, placez zero.       */
/*         INT16 graf_obind: indice de l'objet de l'arbre: graf_object, qui   */
/*                     va servir de reference graphique pour l'affichage du   */
/*                     menu popup. Si OBJECT *graf_object est egal  zero, il */
/*                     ne sera pas tenu compte de ce paramtre, et un aspect  */
/*                     graphique par defaut sera mis en place.                */
/*         OBJECT *popup: adresse de l'arbre de menu  activer.               */
/*                                                                            */
/*         char *dest_string: Et seulement si le pointeur de chaine est       */
/*                            valide ,non egal a 0 et pointant sur une chaine */
/*                            il est recopie dans cette chaine la ligne de    */
/*                            menu selectionne (chaine vide si pas de selec- */
/*                            tion). Cela permet par exemple de recuperer le  */
/*                            texte de la ligne de menu selectionnee afin     */
/*                            de l'analyser pour par exemple interpreter un   */
/*                            raccourci clavier.                              */
/*                            Prevoyer une chaine d'au moins la taille d'une  */
/*                            ligne de menu pour que la recopie ne deborde pas*/
/*                            Si vous n'avez que faire de cette recopie, et   */
/*                            que votre menu ne se compose que d'un fichier,  */
/*                            alors placez zero comme parametre.              */
/*                                                                            */
/* RETOUR: un INT16: qui est l'indice de l'objet selectionne (commence  1    */
/*                 premire ligne de menu). Si<=0 alors c'est soit erreur     */
/*                 pour soit aucune selection (click en dehors du menu).      */
/*                                                                            */
/* NOTE: l'aspect graphique indique par l'objet: graf_object[graf_obind] est  */
/*       facultatif.                                                          */
/*       placez zero si vous ne disposez pas d'objet permettant de preciser   */
/*       un aspect graphique. Sinon placez par exemple, les references d'un   */
/*       objet WINDMENU tels que ceux qui servent  recevoir un menu en       */
/*       fenetre, ou de tout autre objet type G_BOXTEXT.                      */

INT16 DynFilePopupDo(OBJECT *graf_object, INT16 graf_obind, OBJECT *popup, char *dest_string);

/*------------------------- StringToDynPopup ------------------------*/
/* ACTION: Cette fonction cree un menu GEM  partir d'une chaine de  */
/*         caractere decrivant le menu: Cette chaine est un texte    */
/*         dont chaque ligne (termine par \n\r), represente une     */
/*         entree de menu, dit aussi une ligne de menu. Il ne peut y */
/*         avoir plus simple !!!. Exemple de menu  2 lignes:        */
/*             " Copier    CTRL C \n\r  Coller    CTRL V \n\r"       */
/* ENTREE: const char *str: cahine decrivant le menu.                */
/*         short w_car: largeur d'un caractere du menu (defaut = 16) */
/*         short h_car: hauteur d'un caractere du menu (defaut = 8)  */
/* SORTIE: OBJECT *  pointe sur l'objet racine du menu GEM cree.     */
/*                   si zero alors erreur.                           */
/* NOTE: cette creation est dynamique, il convient et est laisse    */
/*       votre charge le soin de detruire ce menu, en utilisant la   */
/*       fonction: void DestroyDynamicPopup(OBJECT *pop_up);         */

OBJECT *StringToDynPopup(const char *str, short w_car, short h_car);

/*------------------------- CreateDynamicPopup -----------------------*/
/* ACTION: Cette fonction cree un menu GEM en memoire.                */
/* ENTREE: short nb_item: nombre de lignes de menu devant etre creees */
/*         short nb_cara: largeur en nombre de caracteres de chaque   */
/*                        ligne de menu.                              */
/*         short w_car: largeur d'un caractere du menu (defaut = 16)  */
/*         short h_car: hauteur d'un caractere du menu (defaut = 8)   */
/* SORTIE: OBJECT *  pointe sur l'objet racine du menu GEM cree.      */
/*                   si zero alors erreur.                            */
/* NOTE: cette creation est dynamique, il convient et est laisse     */
/*       votre charge le soin de detruire ce menu, en utilisant la    */
/*       fonction: void DestroyDynamicPopup(OBJECT *pop_up);          */

OBJECT *CreateDynamicPopup(short nb_item, short nb_cara, short w_car, short h_car);

/*-------------------- DestroyDynamicPopup --------------------------*/
/* ACTION: libere la memoire reservee par un popup dynamique.        */
/* ENTREE: OBJECT *pop_up: pointe sur le popup  detruire.           */
/* RETOUR: neant.                                                    */
void DestroyDynamicPopup(OBJECT *pop_up);

/*-------------------------------- PopupDo -------------------------------------*/
/* ACTION: affiche et controle un popup fait d'un objet quelconque contenant    */
/*         d'autres objets consideres comme des options.                        */
/* ENTREE: OBJECT *object:                                                      */
/*               adresse de l'arbre auquel appartient l'objet pere des options. */
/*         INT16 ind:                                                           */
/*               indice dans cet arbre de l'objet pere des options .            */
/*         INT16 ob_sel:                                                        */
/*               indice dans cet arbre de l'objet option preselectionnee.       */
/*         INT16 x,y:                                                           */
/*               coordonnes d'affichage du centre popup. ce centre se recentre */
/*               sur l'option preselectionne                                   */
/*         GRECT *scrgrect:                                                     */
/*                pointe sur le rectangle que le popup ne peut pas depasser     */
/*                par exemple la fenetre d'une ressource.                       */
/*                Si egal a zero alors le popup est ajuste de facon a ne pas    */
/*                depasser l'ecran.                                             */
/* RETOUR: INT16: option selectionne si >0    click non valide sinon           */

INT16 PopupDo(OBJECT *object, INT16 ind, INT16 ob_sel, INT16 x, INT16 y ,GRECT *scrgrect);

/*---------------------------- PopupListDo --------------------------------*/
/* ACTION: affiche un popup menu avec surveillance des rectangles de titre */
/*         -->> Si ces rectangles sont definis,                            */
/*                          (grecttitle_out !=0 et grecttitle_in != 0),    */
/*         lorsque la souris penetre dans la zone  grecttitle_out le popup */
/*         se referme et retourne le message POPUP_CHANGE (32000)          */
/*         -->> Si ces rectangles ne sont pas definis,                     */
/*                          (grecttitle_out ==0 et grecttitle_in == 0),    */
/*         le popup se referme soit si click en dehors, soit si click sur  */
/*         option valide (non disabled)                                    */
/*         Cette fonction est une sous fonction de la fonction de menu en  */
/*         fenetre, et peut etre utilise pour afficher un popup simple.   */
/*         c'est pourquoi son fonctionnement est particulier.              */
/* ENTREE: ............... 1) objet de reference graphique .............   */
/*         OBJECT *object: adresse arbre auquel appartient l'objet.        */
/*         INT16 ob_ind: numro de l'objet dans cet arbre.                 */
/*               NOTE: l'objet designe par object[ob_ind] ne sert que pour */
/*                     indiquer les caractristiques graphiques du fond et */
/*                     du texte du popup. C'est en fait son TEDINFO qui    */
/*                     utilis pour dessiner le reste du menu.             */
/*                     Pour un popup simple, c'est l'objet pere des        */
/*                     options du menu. (par exemple).                     */
/*                     Cet objet pere peut etre: SOIT -> un type G_BOXTEXT */
/*                     (type BoxText sous Interface) type tendu doit      */
/*                     etre: 102.                                          */
/*                                               SOIT -> un type G_BOXTEXT */
/*                     (type BoxText sous Interface) type tendu doit      */
/*                     etre: 107. Pere d'un menu GEM en fenetre.           */
/*         ............... 2) objet de reference options ...............   */
/*         OBJECT *menu_tree: adresse arbre auquel appartient l'objet.     */
/*         INT16 ind_list: numro de l'objet dans cet arbre.               */
/*               NOTE: l'objet designe par menu_tree[ind_list] doit        */
/*                     contenir comme objets fils les options de menu sous */
/*                     forme de string.                                    */
/*         INT16 x,y;  coordonnees d'affichage du popup.                   */
/*         GRECT *grecttitle_out: rectangle de surveillance.               */
/*         GRECT *grecttitle_in: rectangle de surveillance.                */

INT16 PopupListDo(OBJECT *object,     INT16 ob_ind,
                OBJECT *menu_tree,  INT16 ind_list,
                INT16 x, INT16 y,
                GRECT *grecttitle_out,
                GRECT *grecttitle_in);

/*--------------------------- MakeEvntClicOnObjet ------------------------*/
/* ACTION: Modifie le flux evenementiel, represente par EVNT_O *Evnt, de  */
/*         maniere a silmuler le click sur un objet dont les coordonnees  */
/*         sont donnees en entree.                                        */
/* ENTREE: OBJECT *object, pointe sur le prem. objet de l'arbre d'objets  */
/*                         ou se trouve l'objet.                          */
/*         INT16 ob_ind, indice de l'objet clique dans cet arbre.         */
/*         EVNT_O *Evnt, pointe sur la variable de flux evenementiel a    */
/*                       modifier.                                        */
/* SORTIE: EVNT_O *, pointe sur la variable de flux evenementiel modifiee */

EVNT_O *MakeEvntClicOnObjet(OBJECT *object, INT16 ob_ind, EVNT_O *Evnt);

/*--------------------- GetFreeString ------------------------------------*/
/* ACTION: Retourne l'adresse du tableau de pointeurs de freestring, d'une*/
/*         ressource.                                                     */
/*         Il est ensuite possible d'acceder a chaque chaine de cette     */
/*         table par son indice. (utiliser pour les indices la table      */
/*                                symbolique .H que genere Interface.)    */
/* ENTREE: void *adr_rsc, adresse ou a ete chargee la ressource dont on   */
/*                        cherche la table de FreeString.                 */
/* SORTIE: char **, pointe sur la table de pointeur de chaine.            */

char **GetFreeStringTab(void *adr_rsc);


/*--------------------- GetObjectInterior ------------------------------*/
/* ACTION: retourne le type VDI de motif avec lequel un objet est trace */
/* ENTREE: OBJECT *object: pointe sur le premier objet de l'arbre       */
/*                         d'objets dans lequel se trouve notre objet.  */
/*         INT16 ind: indice de notre objet dans l'arbre d'objets.      */
/*         INT16 *type: pointe sur la variable dans laquelle sera retour*/
/*                    nee le type VDI de motif. A utiliser avec la      */
/*                    fonction: vsf_interior();                         */
/*         INT16 *motif:pointe sur la variable dans laquelle sera retour*/
/*                    nee le motif VDI. A utiliser avec la              */
/*                    fonction: vsf_style();                            */
/*         INT16 *color:pointe sur la variable dans laquelle sera retour*/
/*                    nee la couleur VDI. A utiliser avec la            */
/*                    fonction: vsf_color();                            */
/* RETOUR: INT16 indice EAZY_GEM de la trame. A utiliser avec les       */
/*                   fonctions:        TrameToNumSel();                 */
/*                                     NumSelToTrame();                 */
/* NOTE: on peut passer zero pour les parametres: type, motif, color    */
/*       la fonction ne retournera bien sur, rien sur ceux mis a zero   */

INT16 GetObjectInterior(OBJECT *object, INT16 ind, INT16 *type, INT16 *motif, INT16 *color);

/*-------------------------- FindParentOfObject  -------------------------*/
/* ACTION: rcherche le pere d'un objet.                                   */
/*         si l'objet est un objet racine, alors il est retourne -1       */
/* ENTREE: OBJECT *object: adresse premier objet de l'arbre ou doit se    */
/*                         faire la recherche                             */
/*         INT16 ob:  indice de l'objet dont on recherche le pere         */
/* RETOUR: INT16:  pere de l'objet ou -1 si pas de pere (objet racine)    */

INT16 FindParentOfObject(OBJECT *object, INT16 ob);

/*************************************************************************/
/*           F O N T I O N S   D E   S O U R I S   ( G E M )             */
/*************************************************************************/

/* ----------------------------- Mouse_on ------------------------------*/
/* ACTION: cette fonction sert  afficher la souris. EAZY_GEM tient    */
/*         jour un flag de visibilit permettant d'utiliser cette       */
/*         fonction sans se procuper de l'tat anterieur de la souris. */
/*         Il est conseill de toujours utiliser cette fonction.        */

void Mouse_on( void );

/* ----------------------------- Mouse_off -----------------------------*/
/* ACTION: cette fonction sert  effacer la souris. EAZY_GEM tient     */
/*         jour un flag de visibilit permettant d'utiliser cette       */
/*         fonction sans se procuper de l'tat anterieur de la souris. */
/*         Il est conseill de toujours utiliser cette fonction.        */

void Mouse_off( void );

/*-------------------------- Mousek ------------------------------------*/
/* ACTION: cette fonction retourne l'etat du bouton de la souris.       */

INT16 Mousek(void);

/*-------------------------- Mousex ------------------------------------*/
/* ACTION: cette fonction retourne la position X de la souris.          */

INT16 Mousex(void);

/*----------------------- Mousey ---------------------------------------*/
/* ACTION: cette fonction retourne la position Y de la souris.          */

INT16 Mousey(void);

/*--------------------------- SetMouseForm -----------------------------*/
/* ACTION: determine la forme de la souris.                             */
/*         Il est recommand d'utiliser cette fonction pour modifier la */
/*         forme de la souris avec EAZY_GEM                             */
/* ENTREE: long cursor, forme de la souris.                             */
/*                 Les formes 0  7 sont les formes GEM Classiques.     */
/*                 8   100 sont les formes EAZY_GEM                    */
/* RETOUR: mode effectivement mis en place                              */

INT16 SetMouseForm(long cursor);

/*--------------------------- GetMouseForm -----------------------------*/
/* ACTION: retourne la forme actuelle de la souris.                     */
/* RETOUR: forme souris effectivement en place                          */

long GetMouseForm(void);

/*------------------------- SetCaptureMouse -------------------------------*/
/* ACTION: permet a une procedure de fenetre de capturer la souris afin    */
/*         de garder pour elle les actions liees a la souris.              */
/*         Lorsqu'une fenetre capture la souris, tous les evenements       */
/*         MU_MOVE et MU_BUTTON seront diriges dessus et les actions sur   */
/*         les bordures de la fenetre ne seront pas evaluees.              */
/* ENTREE: INT16 w_ind: handle de la fenetre voulant capturer la souris.   */
/* RETOUR: INT16: 1 si tout est OK                                         */
/*              0 si erreur                                                */

INT16 SetCaptureMouse (INT16 w_ind);

/*------------------------- ClearCaptureMouse -----------------------------*/
/* ACTION: annule la capture de fenetre precedement installee. cet appel   */
/*         est indispensable si l'on veut que le comportement de la souris */
/*         redevienne normal apres une capture.                            */
/* ENTREE: neant                                                           */
/* RETOUR: INT16: l'ancien masque d'evenements precedemment install.      */

INT16 ClearCaptureMouse (void);

/*************************************************************************/
/* F O N T I O N S   D E   T E S T   I N T E R R O G A T I O N ( V D I ) */
/*************************************************************************/

/*-------------------------- IsMouseXYInGrect -----------------------------*/
/* ACTION: Teste si la souris est dans le rectangle GRECT *grect.          */
/* ENTREE: INT16 x, INT16 y, coordonnes x & y  de la souris               */
/*         GRECT *grect pointe sur le rectangle  tester                   */
/* SORTIE: 1 si la souris est dans le rectangle 0/si en dehors.            */

INT16 IsMouseXYInGrect(INT16 x, INT16 y, GRECT *grect);


/*-------------------------- IsMouseXYInVrect -----------------------------*/
/* ACTION: Teste si la souris est dans le rectangle VRECT *vrect.          */
/* ENTREE: INT16 x, INT16 y, coordonnes x & y  de la souris               */
/*         VRECT *vrect pointe sur le rectangle  tester                   */
/* SORTIE: 1 si la souris est dans le rectangle 0/si en dehors.            */

INT16 IsMouseXYInVrect(INT16 x, INT16 y, VRECT *vrect);

/*------------------------------ FontNameToFontID -----------------------------*/
/* ACTION: retourne l'indice dans le tableau de fonte EZ_GEM de la fonte      */
/*         partir du nom indique dans: char *testname                          */
/* ENTREE: char *testname:  nom de la fonte. Ce nom peut etre incomplet et     */
/*                          alors c'est le plus approchant qui sera retourne   */
/*         void *fonttab: pointeur sur le tableau de fonte. Dans EAZY_GEM      */
/*                        placez:  FontTab et tout ira bien.                   */
/* RETOUR: indice de la fonte dans le Tableau de fontes d'EASY_GEM.            */
/*                                                                             */
/* EXEMPLE: pour retrouver l'indice VDI de la fonte "Ad Lib" faites:           */
/*         long i          =   FontNameToFontID("Ad Lib", FontTab);            */
/*         INT16 IndiceVDI =  (INT16) FontID[i]                                */
/*         char *font_name =   FontName + (i*36);                              */

long FontNameToFontID(char *testname, void *fonttab);

/*------------------------------ FontNameToVdiID ------------------------------*/
/* ACTION: retourne l'indice VDI de la fonte                                  */
/*         partir du nom indique dans: char *testname                          */
/* ENTREE: char *testname:  nom de la fonte. Ce nom peut etre incomplet et     */
/*                          alors c'est le plus approchant qui sera retourne   */
/*         char *font_name: il y sera retourne le nom complet de la fonte      */
/*                          trouve. Peut etre egal  zero si l'on ne veut pas */
/*                          de cette info. Si non egal  zero, prevoyez        */
/*                          une place de 36 caracteres.                        */
/* RETOUR: indice VDI de la fonte                                              */
/*                                                                             */

int FontNameToVdiID(char *testname, char *font_name);


/*------------------------------ FntID_VDI_to_TabInd --------------------------*/
/* ACTION: retourne l'indice permettant de pointer sur le tableau de fontes   */
/*         partir de l'identificateur VDI de la fonte                          */
/* ENTREE: long Id_Vdi:  identificateur VDI de la fonte                        */
/* RETOUR: indice permettant de pointer sur le tableau de fonte                */

INT16  FntID_VDI_to_TabInd(long Id_Vdi);

/*************************************************************************/
/*           F O N T I O N S   D E   F L Y I N G                         */
/*************************************************************************/
/*------------------------ FlyGrect ------------------------------------*/
/* ACTION: Deplace un rectangle Bit map, d'ecran ou son fantome (selon  */
/*         valeur du flag: flag),  l'aide de la souris. La main est    */
/*         rendue apres relachage de la souris, ou appui d'une touche   */
/*         clavier.                                                     */
/* ENTREE: GRECT *grect: pointe sur le rectangle  deplacer sur l'ecran */
/*         INT16 x, INT16 y: position x et y de la souris lors de       */
/*                       l'appel  la fonction.                         */
/*         INT16 flag: BIT0 1/mode bit map-> il est deplace  l'ecran   */
/*                                 le bout d'ecran represente par le    */
/*                                 rectangle: grect.                    */
/*                          0/mode fantome il est deplace  l'ecran un  */
/*                                 cadre fantome represente par grect   */
/*                                                                      */
/*                     BIT1 0/  deplacement en X evalue                 */
/*                          1/  deplacement en X non evalue             */
/*                     BIT2 0/  deplacement en Y evalue                 */
/*                          1/  deplacement en Y non evalue             */
/*                                                                      */
/* RETOUR: zro:           le retour s'est fait par relachage de la     */
/*                         souris.                                      */
/*         different de 0: le retour se fait apres appui d'une touche   */
/*                         clavier qui est retournee:                   */
/*                         (meme format que evnt_multi() CAD:           */
/*                                   poids fort   = scan code           */
/*                                   poids faible = code ASCII          */
/*         -1              erreur (generalement memoire insuffisante)   */

INT16 FlyGrect(GRECT *grect, INT16 x, INT16 y, INT16 mode);

/*------------------------ Intersect -----------------------------------*/
/* ACTION: retourne le rectangle intersectant de deux rectangles        */
/* ENTREE: INT16  x1,INT16  y1,INT16  w1,INT16  h1: premier rectangle   */
/*         INT16  x2,INT16  y2,INT16  w2,INT16  h2: deuxime rectangle  */
/*         INT16 *x3,INT16 *y3,INT16 *w3,INT16 *h3: rectangle resultant */
/* RETOUR: 1/si intersection, 0/si pas d'intersection,                  */

INT16  Intersect(INT16  x1,INT16  y1,INT16  w1,INT16  h1,
               INT16  x2,INT16  y2,INT16  w2,INT16  h2,
               INT16 *x3,INT16 *y3,INT16 *w3,INT16 *h3);

/*---------------------- Flysave ----------------------------------------*/
/* ACTION: cree et sauve dans un buffer le fond du rectangle  deplacer  */
/*         tout en initialisant les donnes pour deplacement.            */
/* ENTREE: INT16 vdihandle: handle VDI de la station de trvail graphique.*/
/*         INT16 x,INT16 y,INT16 w,INT16 h: coordonnes du rectangle.    */
/* SORTIE: void *: un pointeur sur une structure de type: FLYBUFF        */
/*                  zero si erreur.                                      */

void    *Flysave(INT16 vdihandle,INT16 x,INT16 y,INT16 w,INT16 h);

/*---------------------- Flyrestore --------------------------------*/
/* ACTION: restitue le fond apres dernier deplacement et libere la  */
/*         memoire alouee pendant l'operation.                      */
/* ENTREE: void *fly_buff: pointeur sur structure de type: FLYBUFF  */
/* SORTIE: Neant                                                    */

void    Flyrestore(void *fly_buff);

/*------------------------ Scrmove ---------------------------------*/
/* ACTION: deplace un rectngle  l'ecran tout en restituant le fond */
/* ENTREE: void *fly_buff: pointeur sur structure de type: FLYBUFF  */
/*         INT16 nx,INT16 ny: quantit en X et Y du deplacement    */
/* SORTIE: void *: pointeur sur structure FLYBUFF (peut changer)    */

void     *Scrmove(void *fly_buff, INT16 nx,INT16 ny);

/*---------------------------- FlyFly ---------------------------------------*/
/* ACTION: Deplace un rectangle defini par la structure: FLYBUFF tant que la */
/*         souris reste appuyee.                                             */
/* ENTREE: void **fly_buff: pointeur sur un pointeur de structure: FLYBUFF,  */
/*                        cette structure devra auparavant avoir ete         */
/*                        initialisee par la fonction: Flysave().            */
/*         INT16* dx, INT16* dy: pointeur sur les positions initiales de la  */
/*                           souris.                                         */
/*         INT16 flag: BIT0  0/seul un cadre fantome est deplace.            */
/*                           1/le bitmap situe sous le rectangle est deplace */
/*                     BIT1  0/  deplacement en X evalue                     */
/*                           1/  deplacement en X non evalue                 */
/*                     BIT2  0/  deplacement en Y evalue                     */
/*                           1/  deplacement en Y non evalue                 */
/* RETOUR: 0/sortie par relachement  si != 0 touche clavier appuye          */

INT16 FlyFly(void **buffer, INT16* dx, INT16* dy, INT16 opaque);

/*************************************************************************/
/*           F O N T I O N S   D E   T R A C E   ( V D I )               */
/*************************************************************************/

/*----------------------- Clip ------------------------------------*/
/* ACTION: clipe un rectangle aux dimensions fournies              */
/*         par: x0, y0, x1, y1                                     */
/*                                                                 */
/* ENTREE: INT16 x0,INT16 y0, INT16 x1,INT16  y1: rectangle       */
/*                                                cliper           */
/* RETOUR: neant                                                   */

void Clip(INT16 x0,INT16 y0, INT16 x1,INT16 y1);

/*----------------------- Graphmode ---------------------------------*/
/* ACTION: Met en place un mode graphique VDI.                       */
/* ENTREE: INT16 mode: mode graphique VDI qui peut prendre les       */
/*            valeurs suivantes: MD_REPLACE  1  Replace              */
/*                               MD_TRANS    2  Transparent          */
/*                               MD_XOR      3  Xor                  */
/*                               MD_ERASE    4  Reverse Transparent  */

void Graphmode(INT16 mode);

/*----------------------- Defline -----------------------------------*/
/* ACTION: Definie et positionne tous les attributs VDI de ligne     */
/* ENTREE: INT16 type, type VDI de ligne                             */
/*         INT16 width, epaisseur de la ligne.                       */
/*         INT16 deb, type VDI du debut de ligne.                    */
/*         INT16 fin, type VDI de fin de ligne.                      */
/*         INT16 color, couleur de la ligne.                         */

void Defline(INT16 type,INT16 width,INT16 deb,INT16 fin,INT16 color);

/*------------------------ Deffill ----------------------------------*/
/* ACTION: Positionne tous les attributs VDI de remplissage          */
/* ENTREE: INT16 color, couleur de la ligne.                         */
/*         INT16 interior, type VDI de remplissage.                  */
/*         INT16 motif, type VDI de motif.                           */

void Deffill(INT16 color,INT16 interior,INT16 motif);

/*------------------------ Deftext ----------------------------------*/
/* ACTION: Positionne tous les attributs VDI d'affichage de texte.   */
/*         si speedo est detecte alors les fonctions speedo seront   */
/*         utilisees.                                                */
/* ENTREE: INT16 color, couleur du texte.                            */
/*         INT16 effect, effet VDI du texte.                         */
/*         INT16 angle, angle VDI (en 10me Degres) affichage texte. */
/*         INT16 point, taille en points du texte.                   */
/*         INT16 font, indice VDI de la police de caracteres.        */

void Deftext(INT16 color,INT16 effect,INT16 angle,INT16 point,INT16 font);

/*----------------------- EZ_v_ftext ------------------------------------*/
/* ACTION: implementation de EZ_OutText() pour tableaux de caracteres de */
/*         1024 caractres comme le permet NVDI                          */
/*         Retourne aussi les dimmensions de la chaine affiche          */
/* NOTE:   Le mode de justification verticale doit etre baseline.        */
/* ENTREE: INT16 vdi_handle:   VDIhandle                                 */
/*         INT16 x:   position x d'affichage                             */
/*         INT16 y:   position y d'affichage du sommet de la chaine      */
/*         char *str:     adresse de la chaine de caracteres             */
/* SORTIE: INT16: largeur de la chaine affiche                          */

INT16  EZ_OutText(INT16 vdi_handle, INT16 x, INT16 y, char *str);

/*----------------------- VdiText --------------------------------------*/
/* ACTION: affiche un texte sur le peripherique de sortie  represente   */
/*         par VDIhandle. Si Speedo est detect alors les fonctions     */
/*         d'affichage speedo seront utilisees.                         */
/* ENTREE: INT16 x, INT16 y: coordonnes en pixels d'affichage de la    */
/*         chaine texte.                                                */
/*         char *string: pointeur sur la chaine de texte.               */

void VdiText(INT16 x, INT16 y, char *string);

/*------------------------ Box --------------------------------------*/
/* ACTION: dessine un rectangle non rempli (mode trait).             */
/* ENTREE: INT16 *xyxy tableau de coordonnes VDI.                   */

void Box(INT16 *xyxy);

/*------------------------ Box_p -------------------------------------*/
/* ACTION: dessine un rectangle non rempli (mode trait).              */
/*         Idem que Box mais coordonnes donnes spares, sous forme */
/*         de paramtres individuels et non de tableau de parametres. */
/* ENTREE: INT16 x0,INT16 y0,INT16 x1,INT16 y1, Coordonnees VDI.      */

void Box_p(INT16 x0,INT16 y0,INT16 x1,INT16 y1);

/*------------------------ Pbox ---------------------------------------*/
/* ACTION: dessine un rectangle rempli avec le motif en vigueur.       */
/* ENTREE: INT16 *xyxy tableau de coordonnes VDI.                     */

void Pbox(INT16 *xyxy);

/*------------------------ Pbox_p -------------------------------------*/
/* ACTION: dessine un rectangle rempli avec le motif en vigueur.       */
/*         Idem que Pbox mais coordonnes donnes spares,sous forme  */
/*         de paramtres individuels et non de tableau de parametres.  */
/* ENTREE: INT16 x0,INT16 y0,INT16 x1,INT16 y1, Coordonnees VDI.       */

void Pbox_p(INT16 x0,INT16 y0,INT16 x1,INT16 y1);

/*--------------------------- GrectBox ------------------------------*/
/* ACTION: dessine un rectangle non rempli (mode trait).             */
/* ENTREE: GRECT *grect, adresse du rectangle de Coordonnees GEM.    */

void GrectBox(GRECT *grect);

/*-------------------------- GrectPbox ------------------------------*/
/* ACTION: dessine un rectangle rempli avec le motif en vigueur.     */
/* ENTREE: GRECT *grect, adresse du rectangle de Coordonnees GEM.    */

void GrectPbox(GRECT *grect);

/*----------------------------- DrawCustomCadre ----------------------------*/
/* ACTION: dessine un cadre rectangulaire epais en relief ou fin grav.     */
/* ENTREE: VRECT *vrect, coordonnes VDI du rectangle.                      */
/*         INT16 type, si 0/epais relief,   si 1/fin grav                  */

void DrawCustomCadre(VRECT *vrect, INT16 type);

/*------------------------ DrawReliefCadre ---------------------------------*/
/* ACTION: dessine un cadre rectangulaire avec effet relief.                */
/* ENTREE: GRECT *grect: pointe sur le rectangle d'entree.                  */
/*         INT16 flag_relief: Si zero le cadre sera dessine sans relief.    */
/*                          Si >0 le carde est en relief sortant.           */
/*                          Si <0 le cadre est en relief rentrant.          */
/*         INT16 thickness: epaisseur du cadre.                             */
/* SORTIE: neant:                                                           */
/* PROTOTYPE:                                                               */

void DrawReliefCadre(GRECT *grect, INT16 flag_relief, INT16 cadreColor,INT16 thick);

/*--------------------------- DrawEnjolivedBox ---------------------------*/
/* ACTION: Dessine une boite avec cadre semi_circulaire, ombre, et fond   */
/*         Jaune comme celle des bulles d'aide.                           */
/* ENTREE: GRECT *grect_in: coordonnes du rectangle de la boite.         */
/*         GRECT *grect_cli: adresse du rectangle dans lequel il sera     */
/*                          retourne la surface interne utile de la boite */
/* SORTIE: GRECT *grect_cli: contient le rectangle client. (rectangle     */
/*                           interieur au cadre semi-circulaire)          */
/* RETOUR: GRECT * pointe sur le rectangle: grect_cli                     */

GRECT *DrawEnjolivedGrectBox(GRECT *grect_in, GRECT *grect_cli, INT16 ofs_ombre);


/*------------------------ Line_p -----------------------------------*/
/* ACTION: dessine une ligne avec les attributs de ligne en vigueur. */
/* ENTREE: INT16 x0,INT16 y0,INT16 x1,INT16 y1, Coordonnees VDI.     */

void Line_p(INT16 x0,INT16 y0, INT16 x1, INT16 y1);

/*-------------------------- ClipGrect -----------------------------------*/
/* ACTION: clippe le rectangle GEM, GRECT *grect donn en entre          */
/* ENTREE: GRECT *grect, pointe sur le rectangle GEM  clipper.           */

void ClipGrect(GRECT *grect);


/*------------------------- Blk_size -----------------------------------*/
/* ACTION : calcule la taille memoire necessaire pour stocker le bloc   */
/*          ecran dont la hauteur et la largeur sont donnes en entree  */
/* ENTREE : l et h largeur et hauteur du bloc en nbr de pixels -1       */
/*          INT16 nb_plan, nombre de plans de l'image.                  */
/* SORTIE : Long longueur calcule                                      */

unsigned long Blk_size(INT16 l, INT16 h, INT16 nb_plan);

/*----------------------------- GetGRECT ---------------------------------*/
/* ACTION: sauve dans un buffer le fond de l'ecran du rectangle grect     */
/* ENTREE: GRECT *grect, pointe sur le rectangle GEM  sauver.            */
/* RETOUR: adresse de la zone memoire ou est sauve ce fond                */
/*         zero ou NULL si plus de memoire disponible                     */

INT16 *GetGRECT(GRECT* grect);

/*----------------------------- Get --------------------------------------*/
/* ACTION: sauve dans un buffer, un bloc d'ecran rectangulaire (VDI)      */
/* ENTREE: INT16 *xyxy, pointe sur les dimensions du rectangle  sauver.  */
/* RETOUR: adresse de la zone memoire ou est sauve le bloc graphique ou:  */
/*            Le 1er  INT16 est la largeur du bloc en nbr de pixels-1     */
/*            le 2eme INT16 est la hauteur du bloc en nbr de pixels-1     */
/*            le 3eme est le nbr de plans de l'image.                     */
/*            suivent les datas d'image.                                  */
/*         zero ou NULL si plus de memoire disponible                     */

INT16 *Get(INT16 *xyxy);

/*-------------------------- Put ------------------------------------------*/
/* ACTION: Place en x et y un bloc d'ecran precedemment sauv par Get.     */
/*         ce graphique doit obligatoirement etre avec les memes           */
/*         caracteristiques RASTER quel'ecran (meme nbr couleurs, plans    */
/*         et organisation memoire).                                       */
/* ENTREE: INT16 x,INT16 y:                                                */
/*              coordonnes x et y (angle sup gauche) ou l'on              */
/*              desire placer le bloc graphique.                           */
/*         INT16 *xyxy_buff:                                               */
/*              pointeur sur la zone memoire ou se trouve le bloc          */
/*              graphique. Le 1er  INT16 est la largeur en nbr de pixels-1 */
/*                         le 2eme INT16 est la hauteur en nbr de pixels-1 */
/*                         le 3eme est le nbr de plans de l'image.         */
/*                         suivent les datas d'image.                      */
/*         INT16 mode:                                                     */
/*              mode de copie du bloc (voir doc VDI)                       */

void Put( INT16 x,INT16 y,INT16 *blk_buff,INT16 mode);

/*------------------------- Put_mono --------------------------------------*/
/* ACTION: Place en x et y un bloc d'ecran precedemment sauv par Get.     */
/*         ce graphique doit obligatoirement etre monochrome 1 plan.       */
/* ENTREE: INT16 x,INT16 y:                                                */
/*              coordonnes x et y (angle sup gauche) ou l'on              */
/*              desire placer le bloc graphique.                           */
/*         INT16 *xyxy_buff:                                               */
/*              pointeur sur la zone memoire ou se trouve le bloc          */
/*              graphique. Le 1er  INT16 est la largeur en nbr de pixels-1 */
/*                         le 2eme INT16 est la hauteur en nbr de pixels-1 */
/*                         le 3eme est le nbr de plans de l'image.         */
/*                         suivent les datas d'image.                      */
/*         INT16 mode:                                                     */
/*              mode de copie du bloc (voir doc VDI)                       */

void Put_mono(INT16 x,INT16 y,INT16 *xyxy_buff,INT16 mode);

/*------------------------- Put_mono_color --------------------------------*/
/* ACTION: Place en x et y un bloc d'ecran precedemment sauv par Get.     */
/*         ce graphique doit obligatoirement etre monochrome 1 plan.       */
/* ENTREE: INT16 x,INT16 y:                                                */
/*              coordonnes x et y (angle sup gauche) ou l'on              */
/*              desire placer le bloc graphique.                           */
/*         INT16 *xyxy_buff:                                               */
/*              pointeur sur la zone memoire ou se trouve le bloc          */
/*              graphique. Le 1er  INT16 est la largeur en nbr de pixels-1 */
/*                         le 2eme INT16 est la hauteur en nbr de pixels-1 */
/*                         le 3eme est le nbr de plans de l'image.         */
/*                         suivent les datas d'image.                      */
/*         INT16 mode:                                                     */
/*              mode de copie du bloc (voir doc VDI)                       */
/*         INT16 *color:                                                   */
/*             pointe sur deux INT16, le 1er est la couleur avec laquelle  */
/*                                  les pixels  1 (mis) du bloc, seront   */
/*                                  recopis sur l'ecran.                  */
/*                                  le 2eme est la couleur avec laquelle   */
/*                                  les pixels  0 (non mis) du bloc,      */
/*                                  seront recopis sur l'ecran.           */

void Put_mono_color(INT16 x,INT16 y,INT16 *xyxy_buff,INT16 mode, INT16 *color);


/*-------------------------- Scroll_p-----------------------------------------*/
/* ACTION: Cette fonction permet de faire scroller en vertical un rectangle   */
/*         d'une certaine quantit.                                           */
/* ENTREE: INT16 x0,INT16 y0,INT16 x1,INT16 y1, coordonnes VDI du rectangle. */
/*         INT16  delty, est la valeur dont doit scroller le rectangle xyxy   */
/*                   en entree: SI negative la partie haute xyxy descend.     */
/*                              SI positive la partie basse xyxy monte.       */

void Scroll_p(INT16 x0,INT16 y0,INT16 x1,INT16 y1,INT16 delty);

/*--------------------------- CiconToMFDB ------------------------------*/
/* ACTION: retourne un MFDB pret  l'emploi pour affichage  partir     */
/*         d'une icone couleur. Archi utile pour creer des fonds de     */
/*         fenetre cette fonction peut etre utilisee dans les USERDEF   */
/*         et autres fonctions type LISTBOX et SCROLBOX.                */
/* NOTE:   les icones doivent etre des CICON prealablement Chargees par */
/*         les fonctions EAZY_GEM qui adaptent les couleurs aux         */
/*         resolutions ecran en cours.                                  */
/* ENTREE: OBJECT *object: adresse de l'objet racine de l'arbre ou se   */
/*                         trouve l'icone a dessiner.                   */
/*         INT16 ob: indice dans l'arbre, de l'objet CICON a dessiner   */
/*         MFDB *mfdb: adresse du MFDB a initialiser avec l'icone.      */
/*         INT16 state:  etat de l'icone que l'on souhaite recuperer.   */
/*                    BIT 0 Icone Selectionne       /1   (place)        */
/*                          Icone Normale           /0   (non place)    */
/*                    BIT 1 le Masque est retourne  /1   (place)        */
/*                          l'image est retournee   /0   (non place)    */
/* RETOUR: MFDB *: pointe sur le MFDB initialise.                       */

MFDB *CiconToMFDB (OBJECT *object, INT16 ob, MFDB *mfdb, INT16 state);

/*--------------------------- DrawCicon --------------------------------*/
/* ACTION: dessine une icone couleur,  l'emplacement ob_x & ob_y de    */
/*         votre choix, en utilisant que des fonctions VDI. Cette       */
/*         fonction peut etre utilisee dans les USERDEF et autres       */
/*         fonctions type LISTBOX et SCROLBOX.                          */
/* NOTE:   les icones doivent etre des CICON prealablement Chargees par */
/*         les fonctions EAZY_GEM qui adaptent les couleurs aux         */
/*         resolutions ecran en cours.                                  */
/* ENTREE: INT16 handle: handle VDI de la station de travail.           */
/*         OBJECT *object: adresse de l'objet racine de l'arbre ou se   */
/*                         trouve l'icone a dessiner.                   */
/*         INT16 ob: indice dans l'arbre, de l'objet CICON a dessiner   */
/*         INT16 ob_x, INT16 ob_y: coordonnees d'affichage desirees de  */
/*                            l'angle superieur gauche de l'icone.      */
/* RETOUR: l'etat de l'icone dessine (selectionne ou pas)               */

INT16 DrawCicon (INT16 handle, OBJECT *object, INT16 ob, INT16 ob_x, INT16 ob_y);

/*--------------------------- WindMoveRedraw ----------------------------------*/
/* ACTION:      sert a optimiser les redraws lors de deplacements dans une     */
/*              fenetre. Deplace les zones qui peuvent l'etre et demande un    */
/*              redraw pour les autres.                                        */
/*                  initialement ecrite par Gerome GINESTET pour SI_WORK,     */
/*                  modifiee par SEVIN Roland pour EAZY_GEM.                  */
/* ENTREE:  INT16 w_ind : handle EazyGem de la fenetre concerne               */
/*          INT16 xo, yo : deplacements horizontaux et verticaux. Peuvent etre */
/*                       positifs ou negatifs                                  */
/*          GRECT *scrol_grect : rectangle  faire scroller dans la fenetre.   */
/*          void  *redraw_f() : pointeur sur la fonction effectuant les        */
/*                             redraws pour la fenetre concernee  cette        */
/*                             fonction doit pouvoir gerer trois parametres:   */
/*                         INT16 w_ind :  handle EazyGem fenetre concerne.    */
/*                         GRECT *scrol_grect : rectangle dans lequel le       */
/*                                              scrolling se fait. Ce rectan-  */
/*                                              gle vous est donn pour info.  */
/*                                              et est le meme que celui       */
/*                                              fourni en entree.              */
/*                         GRECT *update_grect : rectangle  redessiner,       */
/*                                              (deja clip)                   */
/*                         void  *user_param: un parametre quelconque laisse   */
/*                                            libre  l'utilisateur pour ses   */
/*                                            propres besoins. (peut passer    */
/*                                            un pointeur sur un contexte ou   */
/*                                            tout autre information dont il   */
/*                                            aura besoin dans la fonction)    */
/*                                            ce parametre est le meme que     */
/*                                            celui transmis  la fonction     */
/*                                            WindMoveRedraw().                */
/*                                                                             */
/*          void  *user_param: un parametre quelconque laisse libre           */
/*                             l'utilisateur pour ses propres besoins.         */
/*                             (peut passer  un pointeur sur un contexte ou    */
/*                              tout autre information dont il aura besoin     */
/*                              dans la fonction)                              */
/*                             Ce parametre sera aussi transmis  la           */
/*                             fonction redraw_f() lors de son appel, dans     */
/*                             son parametre:  user_param.                     */
/*                                                                             */
/* NOTE: Si vous appelez WindMoveRedraw() avec redraw_f  zero, la fonction    */
/*       associee a la fenetre w_ind, sera directement appele avec le         */
/*       message WM_PAINT, afin de mettre a jour le rectangle a redesiner      */
/* REMARQUE : la fonction redraw_f ne doit pas gerer la rectangle list de la   */
/*            fenetre sous peine de plantage car wind_move_redraw la gere      */
/*            Cette fonction passant par la liste des rectangle permet le      */
/*            scrolling en arrire plan.                                       */

void WindMoveRedraw( INT16 w_ind,
                     INT16 xo, INT16 yo,
                     GRECT *scrol_grect,
                     void (*redraw_f)( INT16 w_ind,
                                       GRECT *scrol_grect,
                                       GRECT *update_grect,
                                       void  *user_param
                                     ),
                     void  *user_param
                   );
                   
/*----------------------- FillRectWithBmp -----------------------------*/
/* ACTION: rempli un rectangle donn par un BitMap donn.              */
/* ENTREE: INT16 vdi_h: Handle VDI.                                    */
/*         MFDB *Srce_MFDB: MFDB d'origine avec lequel il faut remplir */
/*                          le MFDB de destination.                    */
/*         MFDB *Dest_MFDB: MFDB de destination dans lequel la recopie */
/*                          doit se faire. Si zero alors un MFDB est   */
/*                          cr, il sera alors a votre charge de      */
/*                          liberer la memoire ocupe par celui-ci     */
/*         INT16 x0, y0, X1, y1: rectangle  remplir dans le MFDB.     */
/* SORTIE: MFDB *  pointe sur un MFDB soit cree (il vous faudra le     */
/*                                                detruire)            */
/*                                    soit d'entree si il a ete donn  */

MFDB *FillRectWithBmp(INT16 vdi_h, INT16 x0, INT16 y0, INT16 x1, INT16 y1,
                      MFDB *Srce_MFDB, MFDB *Dest_MFDB);
                      
/*----------------------- XFillRectWithBmp ----------------------------*/
/* ACTION: rempli un rectangle donn par un BitMap donn.              */
/* ENTREE: INT16 vdi_h: Handle VDI.                                    */
/*         MFDB *Srce_MFDB: MFDB d'origine avec lequel il faut remplir */
/*                          le MFDB de destination.                    */
/*         MFDB *Dest_MFDB: MFDB de destination dans lequel la recopie */
/*                          doit se faire. Si zero alors un MFDB est   */
/*                          cr, il sera alors a votre charge de      */
/*                          liberer la memoire ocupe par celui-ci     */
/*         INT16 ox, INT16 oy, oh, INT16 ow:  rectangle source.        */
/*         INT16 x0, y0, X1, y1: rectangle  remplir dans le MFDB.     */
/* SORTIE: MFDB *  pointe sur un MFDB soit cree (il vous faudra le     */
/*                                                detruire)            */
/*                                    soit d'entree si il a ete donn  */
MFDB *XFillRectWithBmp(INT16 vdi_h, INT16 ox, INT16 oy, INT16 ow, INT16 oh, MFDB *Srce_MFDB,
                                  INT16 x0, INT16 y0, INT16 x1, INT16 y1, MFDB *Dest_MFDB);
                                  
/*----------------------- PutMFDB -------------------------------------*/
/* ACTION: place un MFDM dans un autre                                 */
/* ENTREE: INT16 vdi_h: Handle VDI.                                    */
/*         MFDB *Srce_MFDB: MFDB d'origine avec lequel il faut remplir */
/*                          le MFDB de destination.                    */
/*         MFDB *Dest_MFDB: MFDB de destination dans lequel la recopie */
/*                          doit se faire. Si zero alors un MFDB est   */
/*                          cr, il sera alors a votre charge de      */
/*                          liberer la memoire ocupe par celui-ci     */
/*         INT16 x0, y0: endroit de la destination ou placer           */
/*                     le MFDB source.                                 */
/* SORTIE: MFDB *  pointe sur un MFDB soit cree (il vous faudra le     */
/*                                                detruire)            */
/*                                    soit d'entree si il a ete donn  */

MFDB * PutMFDB(INT16 vdi_h, INT16 x, INT16 y, MFDB *Srce_MFDB, MFDB *Dest_MFDB);

/* todo */
/*************************************************************************/
/*         F O N T I O N S   D E    F E N E T R E S   ( G E M )          */
/*************************************************************************/

/* --------------------------- CreateWindow -----------------------------*/
/* DESCRIPTION:                                                          */
/*                                                                       */
/*      il est impratif de n'utiliser que cette fonction dans EAZY_GEM  */
/*       pour creer une fenetre.                                         */
/*  long w_attr: attributs GEM classique d'une fenetre                   */
/*               trois attributs de plus:                                */
/*                         XBORDER permet d'avoir un cadre epais en      */
/*                                  relief autour de la fenetre.         */
/*                         XMOVER permet d'avoir une poigne de deplace- */
/*                                ment sur le bord sup du cadre epais    */
/*                         XSIZER permet l'agrandissement de la fenetre  */
/*                                en cliquant sur le cadre epais         */
/*  INT16 Ident:  nbr arbitraire(jamais nul) que vous devez donner. Cela   */
/*              peut servir  reperer tel ou tel type de fenetre dans    */
/*              votre programme. Exemple votre application comporte      */
/*              plusieurs fenetres dont une de menu  laquelle vous      */
/*              donnez INT16 ident=2 lors de sa cration. Il est           */
/*              alors facile pour le programme de savoir si la fenetre   */
/*              menu est ouverte en faisant appel  la fonction          */
/*              INT16 IdentToIndice(2); qui vous retourne l'indice de la   */
/*              fenetre (si elle n'existe pas l'indice est >= MAX_WIND ) */
/*              pensez  utiliser des type symboliques declars avec:    */
/*              #define FENETRE_TRUC 2  plutot qu'un nombre sans sens.   */
/*                                                                       */
/*  void *adr:  adresse pointant sur diverses choses dependant du type   */
/*              gestion que l'on prevoit pour la fenetre. Cette adresse  */
/*              permet par exemple de passer un pointeur sur une struct- */
/*              ture, avec laquelle elle doit travailler. Ce parametre   */
/*              est donc facultatif. La fonction: CreateWindow() place   */
/*              ce parametre dans Wintab[w_ind].UserPtr de la fenetre.   */
/*                                                                       */
/*  CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt): L vous donnez le nom   */
/*              fonction qui sera charge de gerer tous les evenements   */
/*              de cette fenetre. Cette fonction sera appelee par la     */
/*              sur couche EAZY_GEM.                                     */
/* INT16 x, INT16 y, INT16 w, INT16 h,: coordonnees en pixels de la fenetre      */
/*              ces coordonnees doivent etre celles du contour exterieur */
/*              de la fenetre et non de la surface de travail            */
/*              si zero en entree alors les dimensions maxi possibles    */
/*              seront choisies.                                         */
/*              Ces dimensions peuvent etre modifiees avant ouverture de */
/*              la fenetre lors du traitement du message WM_CONSTRUCT    */
/*              au sein de la procedure de fenetre.                      */
/* char *nom:   titre de la fenetre                                      */
/*              de meme le titre de la fenetre peut etre modifie au sein */
/*              de la procedure de fenetre lors du traitement du message */
/*              WM_CONTRUCT.                                             */
/* RETOURNE: Le handle GEM de la fenetre si tout est OK.                 */
/*           -1 si Echec du constructeur de la fenetre                   */
/*           -2 si nbr fenetre superieur  MAX_WIND (maximum EAZY_GEM)   */
/*           -3 si l'AES n'a plus de fenetre  nous donner               */
/* PROTOTYPE:                                                            */
/*                                                                       */
  INT16  CreateWindow ( long w_attr,
                      INT16 ident,
                      void *adr,
                      CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt),
                      INT16 x, INT16 y, INT16 w, INT16 h,
                      char *nom
                    );

/*---------------------- CreateModalWindow -----------------------------*/
/* ACTION: cet appel est le meme que create window, a la difference     */
/*         qu'apres cet appel la main n'est rendue qu'apres fermeture   */
/*         de la fenetre. Lors de cet appel les autres fenetres, et le  */
/*         menu ne sont plus accessibles. Cette fenetre est dite MODALE */
/*         Cette fenetre est blocante pour l'application, mais pas pour */
/*         les autres applications. Pour distinguer, une fenetre modale */
/*         des autres fenetres, EAZY_GEM rajoute un lisere rouge autour */
/*         de la fenetre. Il est possible de changer la couleur de ce   */
/*         cadre ou d'empecher son dessin par la fonction:              */
/*                                                   SetModalFrmCol().  */

INT16  CreateModalWindow ( long w_attr,
                    INT16 ident,
                    void *adr,
                    CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt),
                    INT16 x, INT16 y, INT16 w, INT16 h,
                    char *nom
                  );

/*----------------------------- SetModalFrmCol -----------------------------*/
/* ACTION: change la couleur du cadre modal qu'EAZY_GEM dessine a           */
/*         l'exterieur d'une fenetre modale pour la distinguer des autres   */
/*         fenetres.                                                        */
/* ENTREE: INT16 col: SI      -1 le cadre n'est pas dessine.                  */
/*                  SINON   couleur souhaitee du cadre.                     */
/* RETOUR: neant.                                                           */

void SetModalFrmCol(INT16 col);

/*-------------------------- DestroyWindow ---------------------------------*/
/* ACTION: dtruit une fenetre. Cette fonction gnre le message WM_DESTUCT */
/*         permettant  la fonction de fenetre de dsinitialiser ce qu'elle */
/*         avait ventuellement reserv (memoire, station de travail...)    */
/*         avant la destruction definitive de la fenetre GEM.               */
/*         Il est impratif de n'utiliser que cette fonction dans EAZY_GEM  */
/*         pour detruire une fenetre.                                       */
/* ENTREE: INT16 w_h, handle GEM de la fenetre  detruire.                    */

void DestroyWindow(INT16 w_h);

/*---------------------------- DestroyAllWindow ----------------------------*/
/* ACTION: dtruit toutes les fenetres de l'application. Cette fonction     */
/*         gnre pour chaque fenetre, le message WM_DESTUCT permettant     */
/*          la fonction de fenetre  de dsinitialiser ce qu'elle           */
/*         avait ventuellement reserv (memoire, station de travail...)    */
/*         avant la destruction definitive de la fenetre GEM.               */
/*         Il est impratif de n'utiliser que cette fonction dans EAZY_GEM  */
/*         pour detruire les fenetres.                                      */
/* ENTREE: neant                                                            */

void DestroyAllWindow(void);

/*-------------------------------- OpenWindow ------------------------------------*/
/* ACTION: ouvre une fenetre et note si elle est pas en FULL les coord.           */
/*         return 1 si FULL_SIZE return 0 si pas FULL_SIZE                        */
/*         Il est impratif de n'utiliser que cette fonction dans EAZY_GEM        */
/*         pour ouvrir une fenetre.                                               */
/* ENTREE: INT16 w_ind:                                                             */
/*             indice EAZY_GEM de la fenetre (pointe sur tableau Windtab[w_ind]   */
/*             correspondant  cette fenetre.                                     */
/*         GRECT* grectb: coordonnees externes d'ouverture de la fenetre.         */
/*                si ZERO le rectangle: Windtab[w_ind].ExtGrectUse de la fenetre  */
/*                                      sera utilise                              */
/* RETOUR: INT16: si 1/ouverture en full size  car coordonnes trop grandes.        */
/*                 0/ouverture selon coordonnes d'entre.                        */

INT16  OpenWindow(INT16 w_ind, GRECT* grectb);

/*---------------------- OpenModalWindow -----------------------------------------*/
/* ACTION: cet appel est le meme que OpenWindow, a la difference                  */
/*         qu'apres cet appel la main n'est rendue qu'apres fermeture             */
/*         de la fenetre. Lors de cet appel les autres fenetres, et le            */
/*         menu ne sont plus accessibles.                                         */
/* ENTREE: INT16 w_ind:                                                             */
/*             indice EAZY_GEM de la fenetre (pointe sur tableau Windtab[w_ind]   */
/*             correspondant  cette fenetre.                                     */
/*         GRECT* grectb: coordonnees externes d'ouverture de la fenetre.         */
/*                si ZERO le rectangle: Windtab[w_ind].ExtGrectUse de la fenetre  */
/*                                      sera utilise                              */
/* RETOUR: INT16: si 1/ouverture en full size  car coordonnes trop grandes.        */
/*                 0/ouverture selon coordonnes d'entre.                        */

INT16  OpenModalWindow (INT16 w_ind, GRECT* grectb);

/*--------------------------- CloseWindow ---------------------------------*/
/* ACTION: ferme une fenetre EAZY_GEM. Il est absolument imperatif et      */
/*         indispensable d'utiliser cette fonction dans EAZY_GEM pour      */
/*         fermer une fenetre.                                             */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de cette fenetre.                    */
/* RETOUR: 0/si deja fermee    1/ si non deja fermee                       */

INT16  CloseWindow(INT16 w_ind);

/*------------------------ GetTopWind ----------------------------------*/
/* ACTION: retourne le handle de la fenetre en avant plan.              */
/* ENTREE: Neant.                                                       */
/* RETOUR: handle de la fenetre en avant plan.                          */

INT16 GetTopWind(void);


/*--------------------------- SetWindowSize ------------------------------*/
/* ACTION: redimensionne une fenetre EAZY_GEM et note si elle est pas en  */
/*         FULL les coord.                                                */
/*         Il est impratif d'utiliser cette fonction dans EAZY_GEM pour  */
/*         modifier les dimensions d'une fenetre.                         */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de cette fenetre.                   */
/*         GRECT* grectb dimensions exterieures souhaites de la fenetre. */
/*         return 1 si FULL_SIZE return 0 si pas FULL_SIZE                */

INT16  SetWindowSize(INT16 w_ind, GRECT* grectb);

/*-------------------------- IsWindOpen ----------------------------------*/
/* ACTION: teste si la fenetre EAZY_GEM est ouverte                       */
/* ENTREE: INT16 ind, indice EAZY_GEM de cette fenetre.                     */
/* RETOUR: 0/si pas ouverte  1/si ouverte                                 */

INT16 IsWindOpen(INT16 ind);

/*--------------------------- IsWindFullSize -----------------------------*/
/* ACTION: teste si la fenetre EAZY_GEM est en plein ecran.               */
/* ENTREE: GRECT *grectb, dimensions exterieures de la fenetre.           */
/* RETOUR: 0/si pas plein ecran  1/si plein ecran                         */

INT16 IsWindFullSize(GRECT *grectb);

/*--------------------------- IsWindExist --------------------------------*/
/* ACTION: teste si la fenetre EAZY_GEM existe.                           */
/* ENTREE: INT16 ident, typage EAZY_GEM de cette fenetre (valeur donnee en  */
/*                    deuxime paramtre lors de CreateWindow() ).        */
/* RETOUR: -1/si existe pas  indice EAZY_GEM/si existe                    */

INT16 IsWindExist(INT16 ident);

/*--------------------------- IdentToIndice --------------------------------*/
/* ACTION: permet de retrouver l'indice EAZY_GEM d'une fenetre, dont le     */
/*         type: INT16 ident, est donn en entre (celui que l'on met en      */
/*         deuxime paramtre de la fonction: CreateWindow() )              */
/* RETOUR: indice EAZY_GEM, permettant de pointer sur le tableau Windtab de */
/*         la fenetre correspondante. Cet indice doit etre < MAX_WIND sinon */
/*         la fenetre correspondant au type donn en entre n'existe pas.   */

INT16 IdentToIndice(INT16 ident);

/*--------------------------- WindHandToIndice -----------------------------*/
/* ACTION: permet de retrouver l'indice EAZY_GEM d'une fenetre, dont le     */
/*         handle GEM: INT16 w_h, est donn en entre (celui retourn par  la */
/*         fonction: CreateWindow()  )                                      */
/* RETOUR: indice EAZY_GEM, permettant de pointer sur le tableau Windtab de */
/*         la fenetre correspondante. Cet indice doit etre < MAX_WIND sinon */
/*         la fenetre correspondant au type donn en entre n'existe pas.   */

INT16 WindHandToIndice( INT16 w_h);

/*-------------------------- WindCycle ---------------------------------*/
/* ACTION: change la fenetre de premier plan de notre application,      */
/*         en mettant en avant plan la prochaine fenetre de notre       */
/*         l'application. Si c'est la derniere fenetre, alors c'est la  */
/*         premiere qui est mise en avant plan (a cycle).              */
/* ENTREE: INT16 *old_wind: si ce pointeur est different de 0 (valide)    */
/*         il est retourne dans la variable pointee par ce pointeur, la */
/*         fenetre en avant plan avant appel a la fonction.             */
/* RETOUR: INT16  qui est -1 si erreur.                                   */
/*                      L'indice EASY_GEM de la fenetre mise 1er plan   */

INT16 WindCycle(INT16 *old_wind);

/*----------------------- GetGemWindWorkGRECT ----------------------------*/
/* ACTION: Retourne l'espace de travail GEM (interieur aux gadgets GEM de */
/*         la fenetre: Barre de titre, ascenseurs, cases etc ...          */
/* ENTREE: INT16 hwnd, handle GEM de la fenetre.                            */
/* SORTIE: GRECT *grect, est initialis sur les valeurs de ce rectangle.  */

void GetGemWindWorkGRECT(INT16 hwnd, GRECT *grect);

/*----------------------- GetGemWindFullGRECT ----------------------------*/
/* ACTION: Retourne les coordonnes maxi exterieurs de la fenetre GEM     */
/* ENTREE: INT16 hwnd, handle GEM de la fenetre.                            */
/* SORTIE: GRECT *grect, est initialis sur les valeurs de ce rectangle.  */

void GetGemWindFullGRECT(INT16 hwnd,GRECT *grect);

/*----------------------- GetGemWindExtGRECT ------------------------------*/
/* ACTION: Retourne les coordonnes exterieurs actuelles de la fenetre GEM */
/* ENTREE: INT16 hwnd, handle GEM de la fenetre.                             */
/* SORTIE: GRECT *grect, est initialis sur les valeurs de ce rectangle.   */

void GetGemWindExtGRECT(INT16 hwnd,GRECT *grect);

/*------------------------------ GetClientGrect ----------------------------*/
/* ACTION: calcule l'espace de travail utilisateur laiss libre dans la     */
/*         fenetre, interieur au cadre epais et aux ressources de bords     */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de la fenetre dont on recherche       */
/*                    l'espace client.                                      */
/*         GRECT *grect, adresse d'un rectangle devant recevoir les         */
/*                     coordonnes de l'espace client.                      */
/* SORTIE: GRECT *grect, est initialis sur l'espace de travail.            */
/* RETOUR: adresse du rectangle d'entree GRECT *grect initialise sur        */
/*               l'espace client, si il existe                              */
/*         zero sinon                                                       */

GRECT *GetClientGrect(INT16 w_ind, GRECT *grect);

/*--------------------------- GemWindWorkToClientGrect ---------------------*/
/* ACTION: calcule l'espace de travail utilisateur laiss libre dans la     */
/*         fenetre, interieur au cadre epais et aux ressources de bords     */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de la fenetre dont on recherche       */
/*                    l'espace client.                                      */
/*         GRECT *grect, rectangle de l'espace de travail GEM, qui sera     */
/*                     converti en coordonnes de l'espace client.          */
/* SORTIE: GRECT *grect, est initialis sur l'espace de travail client.     */
/* RETOUR: adresse du rectangle d'entree GRECT *grect initialise sur        */
/*               l'espace client, si il existe                              */
/*         zero sinon                                                       */

GRECT *GemWindWorkToClientGrect(INT16 w_ind, GRECT *grect);

/*------------------------ WindEZWorkToGemBorder -----------------------*/
/* ACTION: calcule  partir de l'espace de travail interieur au cadre   */
/*         epais (si il existe) d'une fenetre EAZY_GEM, l'espace        */
/*         exterieur de la fenetre GEM.                                 */
/* ENTREE: long attr, attributs EAZY_GEM de la fenetre.                 */
/*         GRECT* grectw espace de travail interieur de la fenetre      */
/*                EAZY_GEM.                                             */
/* SORTIE: GRECT *grectb, est rempli avec les coordonnes externes GEM  */
/*                de la fenetre.                                        */

void WindEZWorkToGemBorder(long attr, GRECT* grectw, GRECT* grectb);


/*------------------------ WindGemBorderToEZWork -----------------------*/
/* ACTION: calcule  partir de l'espace de travail exterieur d'une      */
/*         fenetre GEM, l'espace interieur du fenetre EAZY_GEM          */
/*         (espace interieur au cadre epais si il existe)               */
/* ENTREE: long attr, attributs EAZY_GEM de la fenetre.                 */
/*         GRECT* grectb espace de travail exterieur de la fenetre      */
/*                GEM.                                                  */
/* SORTIE: GRECT *grectw, est rempli avec les coordonnes interieures   */
/*                de la fenetre EAZY_GEM.                               */

void WindGemBorderToEZWork(long attr,GRECT* grectb, GRECT* grectw);

/*------------------------- AdjustWindCoordToSrceen ------------------------------*/
/* ACTION: ajuste les coordonnes de la fenetre sous la souris, de faon  ce     */
/*         qu'elles ne dpassent pas de l'ecran et reajuste position ressource.   */
/* ENTREE: INT16 w_ind:                                                             */
/*             indice EAZY_GEM de la fenetre (pointe sur tableau Windtab[w_ind]   */
/*             correspondant  cette fenetre.                                     */
/*         EVNT_O *Evnt: pointeur sur structure de flux evenementiel, d'ou l'on   */
/*             recupere les coordonnes de la souris.                             */
/*         GRECT *grect: pointeur sur un rectangle representant les coordonnes   */
/*             exterieures de la fenetre.                                         */
/* RETOUR: GRECT *: pointeur sur le rectangle d'entree modifie.                   */

GRECT *AdjustWindCoordToScreen (INT16 w_ind, EVNT_O *Evnt, GRECT *grect);

/*----------------------------- UnconifyWindow -------------------------------*/
/* ACTION: desiconifie la fenetre iconifiee, si c'est une fenetre representant*/
/*         toute l'application, alors toutes les fenetres seront deployes.   */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de la fenetre devant etre desiconifiee. */
/* RETOUR: toujours 1                                                         */

INT16 UnconifyWindow(INT16 w_ind);

/*------------------------------- IconifyWindow ------------------------------*/
/* ACTION: iconifie une fenetre ou l'application si touche CONTROL appuye.   */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de la fenetre devant etre iconifiee.    */
/*         GRECT *grect, si pas egal  zero, alors les coordonnees fenetre    */
/*         icone seront celles donnes par ce rectangle et non celles         */
/*         automatiques que le GEM calcule.                                   */
/* RETOUR: toujours 1                                                         */

INT16 IconifyWindow(INT16 w_ind, GRECT *grect);

/*------------------------------- AllIconify ---------------------------------*/
/* ACTION: iconifie toute l'application.                                      */
/* ENTREE: GRECT *grect, si pas egal  zero, alors les coordonnees fenetre    */
/*         icone seront celles donnes par ce rectangle et non celles         */
/*         automatiques que le GEM calcule.                                   */
/* RETOUR: toujours 1                                                         */

INT16 AllIconify(GRECT *grect);

/*------------------------------ Xform_keybd ---------------------------------*/
/* ACTION: gestion des actions clavier sur une ressource en fenetre           */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */
/* SORTIE: modification des divers champs editables                           */
/*         modification des elements de la structure DLG_VAR *dlg             */
/*         retourne -1 ou le Numero d'un objet default exit active RETURN     */

INT16 Xform_keybd(INT16 w_ind, EVNT_O *Evnt);

/*------------------------------ OnWm_moved ----------------------------------*/
/* ACTION: fonction executant tout ce qu'il est classique de faire pour       */
/*         le message WM_MOVED pour une fenetre avec ressource                */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */

INT16 OnWm_moved( INT16 w_ind, EVNT_O *Evnt);

/*------------------------------ OnWm_fulled ---------------------------------*/
/* ACTION: fonction executant tout ce qu'il est classique de faire pour       */
/*         le message WM_FULLED pour une fenetre avec ressource               */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */

INT16 OnWm_fulled( INT16 w_ind, EVNT_O *Evnt);

/*------------------------------ OnWm_sized ----------------------------------*/
/* ACTION: fonction executant tout ce qu'il est classique de faire pour       */
/*         le message WM_SIZED pour une fenetre avec ressource                */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */

INT16 OnWm_sized( INT16 w_ind, EVNT_O *Evnt);

/*------------------------------ OnButtonBorder ------------------------------*/
/* ACTION: gestion des actions souris sur la bordure d'une fenetre            */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */
/* SORTIE: messages d'agrandissement et deplacements envoys                  */
/*         retourne 0 si pas souris sur bord                                  */
/*                  1 si souris sur bord                                      */

INT16 OnButtonBorder( INT16 w_ind, EVNT_O *Evnt);

/*------------------------------ Xform_button  -------------------------------*/
/* ACTION: gestion des actions souris sur une ressource en fenetre            */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */
/* SORTIE: modification des divers champs editables                           */
/*         modification des elements de la structure DLG_VAR *dlg             */
/*         retourne -1 ou le Numero d'un objet selectable cliqu              */

INT16 Xform_button( INT16 w_ind, EVNT_O *Evnt);


/*------------------------------ Xform_WheelButton ----------------------------*/
/* ACTION: gestion des actions roue de souris sur une ressource en fenetre     */
/*         Si vous faites appel  cette fonction lors de la reception du       */
/*         message: WM_MOUSEWHEEL, alors tous les objets succeptibles de       */
/*         scroller: SCROLL_BOX, SCROL_EDIT eLIST_BOX etc..., scrollerons de   */
/*         la quantit indique dans: INT16 qscrol.                            */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre contenant la ressource.        */
/*         EVNT_O *Evnt structure de flux evenementiel                         */
/*         INT16 qscrol: >0/ non evaluee si fenetre pas au premier plan        */
/*                       <0/ evaluee si fenetre en arriere plan                */
/*                    et la valeur absolue est le nombre de lignes de Scroll   */
/*                    pour chaque cran de la roue dente.                      */
/* SORTIE: objet sur lequel la roue a agit                                     */
/*         retourne -1 si pas d'objet trouv                                   */

INT16 Xform_WheelButton( INT16 w_ind, EVNT_O *Evnt, INT16 qscrol);

/*------------------------------ XformButtonBack  -----------------------------*/
/* ACTION: gestion des actions souris sur une ressource en fenetre             */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.       */
/*         EVNT_O *Evnt structure de flux evenementiel                         */
/*         INT16 flag: 0/non click non evaluee si fenetre pas au premier plan  */
/*                   1/non click evaluee si fenetre en arriere plan            */
/* SORTIE: modification des divers champs editables                            */
/*         modification des elements de la structure DLG_VAR *dlg              */
/*         retourne -1 ou le Numero d'un objet selectable cliqu               */

INT16 XformButtonBack( INT16 w_ind, EVNT_O *Evnt, INT16 flag);

/*------------------------ Xform_moved -------------------------------*/
/* ACTION: reajuste les parametres de la ressource en fenetre apres   */
/*         un mouvement de fenetre                                    */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */
/*         GRECT *grect coordonnees interieures GEM de la fenetre contenant la*/
/*               ressource.                                                   */

void Xform_moved(INT16 w_ind, EVNT_O *Evnt);

/*------------------------------ Xform_timer ---------------------------------*/
/* ACTION: gestion des actions timersur une ressource en fenetre              */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */
/* SORTIE: etat du curseur clignotant                                         */

INT16 Xform_timer(INT16 w_ind, EVNT_O *Evnt);

/*------------------------------ Xform_mu_move -------------------------------*/
/* ACTION: gestion des actions des mouvements souris sur une ressource en     */
/*         fenetre.                                                           */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */
/*         EVNT_O *Evnt structure de flux evenementiel                        */
/* SORTIE: forme EAZY_GEM de la souris                                        */

INT16 Xform_mu_move(INT16 w_ind, EVNT_O *Evnt);

/*---------------------- WindDialogConstruct ---------------------------*/
/* ACTION: integre un dialogue en fenetre.                              */
/* ENTREE: INT16 w_ind: indice de notre fenetre pointe sur bonne        */
/*                    structure Windtab[wind]                           */
/*         void *adr_rsc: adresse de chargement de la ressource.        */
/*         INT16 tree:      numero de l'arbre a integrer.               */
/*         INT16 type:      type d'arbre a integrer RSC_DIAL ou TOOL_BAR*/
/*         EVNT_O *Evnt: pointe sur structure de flux evenementiel      */
/* SORTIE: Evnt->evnt = WM_ABORT; si echec / inchang si tout est ok    */
/*         Evnt->pipe[X_B]  Evnt->pipe[H_B] initialise sur dimenssions */
/*                                         d'ouverture de la ressource  */

INT16 WindDialogConstruct(INT16 w_ind, void *adr_rsc, INT16 tree, INT16 type,
                        EVNT_O *Evnt );

/*--------------------------- Xform_construct --------------------------*/
/* ACTION: installe un arbre de ressource dans une fenetre et l'adapte  */
/* ENTREE: INT16 w_ind indice de notre fenetre pointe sur bonne         */
/*                   structure Windtab[wind]                            */
/*         EVNT_O *Evnt pointe sur structure de flux evenementiel       */
/* IMPORTANT:                                                           */
/*         Windtab[wind].DlgVar.AdrRsc doit deja etre initialise sur    */
/*         l'adresse de chargement de la ressource avant l'appel.       */
/*         Windtab[wind].DlgVar.type doit deja etre initialise sur      */
/*         le type de ressource avant l'appel.                          */
/*         Windtab[wind].DlgVar.NumTree doit deja etre initialise sur   */
/*         l'arbre  installer (une ressource peut comporter plusieurs  */
/*         arbres)                                                      */
/* SORTIE: les elements de DLG_VAR *dlg sont initialises sur la ressour.*/
/*         Evnt->evnt = WM_ABORT; si echec / inchang si tout est ok    */
/*         Evnt->pipe[X_B]  Evnt->pipe[H_B] initialise sur dimenssions */
/*                                         d'ouverture de la ressource  */

INT16 Xform_construct(INT16 w_ind, EVNT_O *Evnt);

/*--------------------------- Xform_Destruct ---------------------------*/
/* ACTION: efface tous les blocs memoires reserve par la ressource lors */
/*         de sa mise en fenetre                                        */
/* ENTREE: INT16 w_ind indice de notre fenetre pointe sur bonne         */
/*                   structure Windtab[wind]                            */
/*         EVNT_O *Evnt pointe sur structure de flux evenementiel       */

INT16 Xform_Destruct(INT16 w_ind, EVNT_O *Evnt);

/*------------------------- ToolTipAddGrect ----------------------------*/
/* ACTION: rajoute un rectangle declenchant  la liste des rectangles   */
/*         declenchant de bulle d'aide. Lorsque la souris restera un    */
/*         certain temps au dessus de ce rectangle, un message de       */
/*         bulles d'aides: WM_TT_GET_TXT sera gnr, avec:             */
/*         Evnt->pipe[X_G]==TT_GRECT (cela permet de le distinguer      */
/*                                    des autres messages de bulles     */
/*                                    d'aides.)                         */
/*         Evnt->pipe[Y_G] = ident (cela permet de savoir quel rectan-  */
/*                                 gle est responsable du message)      */
/*         *(long*)&Evnt.pipe[X_B] = adresse du rectangle declenchant   */
/*                                   en coordonnees absolues ecran.     */
/*         *(long*)&Evnt.pipe[W_G] adresse de l'endroit  ou le texte    */
/*                                 de la bulle doit etre place          */
/* ENTREE: INT16 w_ind: indice EZ_GEM de la fenetre pour laquelle un      */
/*                    rectangle de bulle d'aide doit etre installe.     */
/*         INT16 ident: Identificateur libre qui permet de distinguer     */
/*                    les diffrents rectangles dclenchants entre eux. */
/*                    C'est  l'application (donc au programmeur soit   */
/*                     vous) de grer l'unicit de cet identificateur  */
/*                    Pour une meme fenetre il ne peut y avoir deux     */
/*                    rectangles ayant le meme identificateur, auquel   */
/*                    cas ces deux rectangles diffrents entraineront   */
/*                    le dclenchement du meme message: WM_TT_GET_TXT.  */
/*                    Remarquons que cela peut etre utilis  dessein.  */
/*         GRECT *grect: pointe sur l'adresse du rectangle declenchant  */
/*                       il n'y a recopie de ce rectangle par EZ_GEM.   */
/*                       il vous faut donc spcifier une adresse        */
/*                       statique ou globale.                           */
/*                       IMPORTANT: les coordones de ce rectangle      */
/*                                  doivent etre en relatif par rapport */
/*                                  aux dimensions externes de la       */
/*                                  fenetre.                            */
/* RETOUR: -1 si erreur (plus de place dans la liste des rectangles).   */
/*                                                                      */
/* IMPORTANT: il faut liberer ce rectangle par la fonction:             */
/*                           ToolTipDelGrect()                          */
/*                                            lorsqu'on en a plus       */
/*            besoin, car sinon risque de saturation de la liste. Par   */
/*            exemple lors du traitement du message WM_DESTRUCT.        */

INT16 ToolTipAddGrect(INT16 w_ind, INT16 ident, GRECT *grect);

/*------------------------- ToolTipDelGrect ----------------------------*/
/* ACTION: supprime un rectangle declenchant de la liste des rectangles */
/*         declenchant de bulles d'aides.                               */
/* ENTREE: INT16 w_ind: indice EZ_GEM de la fenetre pour laquelle un      */
/*                    rectangle de bulle d'aide doit etre supprime.     */
/*         INT16 ident: Identificateur libre qui permet de distinguer     */
/*                    les diffrents rectangles dclenchants entre eux. */
/*                    C'est  l'application (donc au programmeur soit   */
/*                     vous) de grer l'unicit de cet identificateur  */
/*                    Pour une meme fenetre il ne peut y avoir deux     */
/*                    rectangles ayant le meme identificateur, auquel   */
/*                    cas ces deux rectangles diffrents entraineront   */
/*                    le dclenchement du meme message: WM_TT_GET_TXT.  */
/*                    Remarquons que cela peut etre utilis  dessein.  */
/*         GRECT *grect: pointe sur l'adresse du rectangle declenchant  */
/*                       il n'y a recopie de ce rectangle par EZ_GEM.   */
/*                       il vous faut donc spcifier une adresse        */
/*                       statique ou globale.                           */
/*                       IMPORTANT: les coordones de ce rectangle      */
/*                                  doivent etre en relatif par rapport */
/*                                  aux dimensions externes de la       */
/*                                  fenetre.                            */

void ToolTipDelGrect(INT16 w_ind, INT16 ident, GRECT *grect);

/*----------------------------- CloseListBox ---------------------------------*/
/* ACTION: Verifie si une LISTBOX est ouverte dans la fenetre                 */
/*         et si oui la ferme.                                                */
/* ENTREE: w_ind, indice EAZY_GEM de la fenetre conteneant le ressource.      */

void CloseListBox (INT16 w_ind);

/*----------------------------- SetCursObEditOff------------------------------*/
/* ACTION: eteint le curseur texte des champs editables                       */
/*         Il est recommand d'utiliser cette fonction avan le redessin d'un  */
/*         editable par la fonction Xobjc_draw().                             */
/* ENTREE: DLG_VAR *dlg structure dialogue rattache  la fenetre contenant   */
/*         l'arbre de ressource dont on souhaite eteindre le curseur.         */

void SetCursObEditOff(DLG_VAR *dlg);

/*---------------------------- WSetCursObEditOff-------------------------------*/
/* ACTION: eteint le curseur texte des champs editables en tenant compte de    */
/*         la liste des rectangles.                                            */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre.                           */
/*         GRECT *clipgrect, rectangle de clipping.                            */
/*                si il est non defini (==0), c'est le rectangle de            */
/*                de l'objet qui est utilis.                                  */

void WSetCursObEditOff(INT16 w_ind, GRECT *clip_grect);

/*---------------------------- WSetCursObEditOn -------------------------------*/
/* ACTION: Allume le curseur texte des champs editables en tenant compte de    */
/*         la liste des rectangles.                                            */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre.                           */
/*         GRECT *clipgrect, rectangle de clipping.                            */
/*                si il est non defini (==0), c'est le rectangle de            */
/*                de l'objet qui est utilis.                                  */

void WSetCursObEditOn(INT16 w_ind, GRECT *clip_grect);

/* --------------------------- Lister_rectangles ---------------------------*/
/* ACTION: Gestion de la liste des rectangles GEM. Cette fonction est      */
/*         utiliser en reponse au message GEM WM_REDRAW.                    */
/*         Tout le redessin d'une ressource en fenetre est pris en          */
/*         charge par cette fonction, qui gnre le message WM_PAINT si     */
/*         il est  votre charge de redessiner quelque chose.               */
/* Ce nouveau message est envoy a notre procedure de fenetre               */
/* lorsqu'il faut retracer quelque chose  l'ecran: la surface client.      */
/* La surface client est le rectangle interieur  la fenetre, au cadre      */
/* epais, et aux eventuelles ressources de bord. Cette surface peut tres    */
/* bien ne pas exister par exemple dans le cas d'une ressource occupant     */
/* toute la fenetre, et alors le message WM_PAINT n'est pas genere.         */
/*                                                                          */
/* En: Evnt->pipe[X_G], Evnt->pipe[Y_G], Evnt->pipe[W_G], et                */
/*     Evnt->pipe[W_G], se trouve le rectangle de clipping                  */
/*                      qui est dej clipp par EAZY_GEM,                   */
/* En: Evnt->pipe[X_B], Evnt->pipe[Y_B], Evnt->pipe[W_B], et                */
/*     Evnt->pipe[W_B], se trouve le rectangle de la surface                */
/*                      client qu'il est   votre charge de                 */
/*                      redessiner                                          */
/* ENTRE : w_h handle  de la fenetre  redessiner                           */
/*         xyly pointeur sur la zone a redessiner                           */

void Lister_rectangles(INT16 w_h, GRECT *xylh);

/*-------------------------- SetSlideMinimum -------------------------------*/
/* ACTION: defini la largeur minimum possible des ascenseurs des SCROLL_BAR */
/*         par defaut cette valeur est de 5. Cette fonction ne concerne     */
/*         evidemment que les SCROLL_BOX, SCROLL_EDIT, SCROLL_TEXTE ayant   */
/*         un dispositif de SCROLL_BAR automatique. Tous les appels explic- */
/*         ites, aux fonctions de reglage des ascenseurs comportent en      */
/*         paramtre, cette longuer minimum, a vous de la placer lors de    */
/*         l'appel !. Une variable globale dans EASY_GEM stocke cette       */
/*         valeur: MIN_SLIDE_W: vous pouvez la modifier directement.        */
/*         Cette valeur concerne SCROLL_BOX, SCROLL_EDIT, SCROLL_TEXTE du   */
/*         programme.                                                       */
/* ENTREE: INT16 width: valeur minimum souhaite pour les ascenseurs. Cette   */
/*                    valeur sera limite a 3 en minimum et 50 en maximum.   */
/* SORTIE: INT16:   valeur effectivement mise en place.                       */

INT16 SetSlideMinimum(INT16 width);
/***************************************************************************/
/*           F O N T I O N S   D E  M E S S A G E S   ( G E M )            */
/***************************************************************************/
/*------------------------- GSInit ----------------------------------------*/
/* ACTION: initialise le systeme GEMSCRIPT.                                */
/*         L'application qui veut utiliser GEMSCRIPT doit commencer par    */
/*         appeler cette fonction.                                         */
/* ENTREE: void *func: pointeur sur la fonction charge de traiter la      */
/*                     reception des messages de commande GEMSCRIPT.       */
/*                     cette fonction doit avoir un prototype de la forme  */
/*                      void (*func)(void* gsc, INT16 argc, INT16 *argv[]);    */
/*         long mode: 0/mode normal (un fichier de debug n'est pas genere) */
/*                    1/mode debug  (un fichier de debug est genere)       */
/* SORTIE: 0                                                               */

 INT16 GSInit( void *func, long mode );
 
/*-------------------------- GSExit ---------------------------------------*/
/* ACTION: fonction de desinitialisation d GEMSCRIPT. cette fonction est   */
/*         utiliser en fin de programme pour liberer toutes les ressources */
/*         (memoire etc...) ayant pu etre reservees par GEMSCRIPT.         */
/* ENTREE: neant.                                                          */
/* SORTIE: 0                                                               */
 
 INT16 GSExit( void );

/*-------------------------- GSSetReplyDelay ----------------------*/
/* ACTION: modifie le delay de reponse de GEMSCRIPT lors ouverture */
/*         ou demande.                                             */
/* ENTREE: int delay: delays en s/200: 800 * 1/200 -> 4 Secondes   */

void GSSetReplyDelay (int delay);

/*----------------------- GSOpen ------------------------------------------*/
/* ACTION: ouvre et initialise un dialogue GEMSCRIPT avec une autre        */
/*         application.                                                    */
/* ENTREE: INT16 ap_id: identificateur GEM de l'application avec laquelle    */
/*                    l'on desire etablir un canal de communication.       */
/* SORTIE: void *: pointeur sur le canal de communication. Ce handle sera  */
/*                  utiliser ensuite pour appel des autres fonctions.     */
/*                 si zero erreur, la communication n'a pu s'etablir ou    */
/*                         l'application cible ne comprend pas GEMSCRIPT   */

 void* GSOpen (INT16 ap_id);

/*----------------------- GSClose ------------------------------------------*/
/* ACTION: ferme un canal de communication GEMSCRIPT. cette fonction est   */
/*         appeler quand on a plus besoin de communiquer avec l'application */
/*         cible, afin qu'elle libere ce qu'elle avait mis en place pour    */
/*         accepter notre dialogue.                                         */
/* ENTREE: void* gsc: handle sur le canal de communication precedement      */
/*                    ouvert.                                               */
/* SORTIE: 0/si ok  -1/si erreur.                                           */

 INT16 GSClose (void* gsc );

/*----------------------- GSShare ------------------------------------------*/
/* ACTION: Quand une autre application a ouvert un canal de communication   */
/*         chez nous, on doit utiliser ce canal pour lui envoyer des        */
/*         commandes, et non en ouvrir un autre.                            */
/*         On utilise donc cette fonction pour partager ce canal.           */
/* ENTREE: void* gsc: handle du canal ouvert.                               */
/* SORTIE: 0                                                                */

 INT16 GSShare(void* gsc);

/*----------------------- GSUnShare ----------------------------------------*/
/* ACTION: libere le partage d'un handle de canal de communication          */
/*         GEMSCRIPT                                                        */
/* ENTREE: void* gsc: handle du canal de communication  ne plus partager   */
/* SORTIE: 0                                                                */

 INT16 GSUnShare(void* gsc);

/*----------------------- GSSendCommand ------------------------------------*/
/* ACTION: fonction servant  envoyer des commandes  une applications avec */
/*         laquelle un canal de communication a ete ouvert.                 */
/* ENTREE: void* gsc: handle sur le canal de communication precedement      */
/*                    ouvert.                                               */
/*         char * command: pointe sur une chaine de caracteres decrivant la */
/*                         commande exple: "open"                           */
/*         INT16 nb_arg: nombre d'arguments de la commande.                   */
/*         ...  liste des arguments separes par des virgules.(autant que    */
/*              nb_arg) ces arguments sont des pointeurs sur des chaines de */
/*              caracteres. exple: "E:\DOCUMENT.TXT"                        */
/* SORTIE: <0 si erreur  >=0 si ok.                                         */

 INT16 GSSendCommand (void* gsc, char * command, INT16 nb_arg, ...);

/*----------------------- GSGetCommandResult -------------------------------*/
/* ACTION: apres avoir envoy une commande il est possible de recuperer une */
/*         chaine de caractere etant la reponse  notre commande.           */
/* ENTREE: void* gsc: handle sur le canal de communication precedement      */
/*                    ouvert auquel l'on vient d'envoyer une commande       */
/* SORTIE: char *: chaine de caracteres retournee en reponse.               */
/*                 0 si pas de reponse disponible.                          */

 char * GSGetCommandResult (void* gsc);

/*----------------------- GSGetCommandResult -------------------------------*/
/* ACTION: sert  envoyer une chaine de caractere en reponse  une commande */
/*         que l'on vient de nous envoyer.                                  */
/* ENTREE: void* gsc: handle sur le canal de communication precedement      */
/*                    ouvert qui vient de recevoir une commande             */
/*         char *ptr_result: pointeur sur la chaine de caracteres que l'on  */
/*                           sesire renvoyer comme reponse.                 */
/* SORTIE: <0 si erreur  >=0 si ok.                                         */

INT16 GSSetCommandResult (void* gsc, char *ptr_result);

/*------------------------- SetCaptureEvntProc ----------------------------*/
/* ACTION: permet a une procedure de fenetre de capturer les evenements    */
/*         afin d'etre prioritairement appelee lors de tout evenement.     */
/*         A elle d'annuler ou pas l'evenement en sortie de procedure pour */
/*         bloquer la propagation de l'evenement aux autres procedures de  */
/*         fenetre.                                                        */
/* ENTREE: INT16 w_ind:  fenetre capturant l'evenement.                      */
/*         CALLBACK (*evnt_wind_proc)(INT16 w_ind, EVNT_O *Evnt): fonction   */
/*                 devant capturer les evenements.                         */
/*         INT16 evnt_type: type d'evenement  capturer. Ce doit etre un     */
/*                        masque du type: MU_MOVE|MU_MESAG etc...          */
/*                        specifiant les evenements  capturer.            */
/* RETOUR: void *: pointeur sur l'ancienne fonction capturante.            */


void *SetCaptureEvntProc (INT16 w_ind,
                          CALLBACK (*evnt_wind_proc)(INT16 w_ind,
                                                     EVNT_O *Evnt
                                                    ),
                          INT16 evnt_type
                         );

/*------------------------- AddCaptureEvnt --------------------------------*/
/* ACTION: rajoute un evenement a capturer par la fonction de capture en   */
/*         en cours.                                                       */
/* ENTREE: INT16 evnt_type: type d'evenement  ajouter. Ce doit etre un      */
/*                        masque du type: MU_MOVE|MU_MESAG etc...          */
/*                        specifiant les evenements  capturer.            */
/* SORTIE: INT16: ancien masque d'evenement mis precedemment en place.       */

INT16 AddCaptureEvnt(INT16 evnt_type);

/*------------------------- ClearCaptureEvnt ------------------------------*/
/* ACTION: annule la capture d'evenements precedements installes.          */
/*         apres cet appel la fonction de capture en cours ne sera plus    */
/*         appelee prioritairement pour cet evenement (defini dans le      */
/*         masque d'entree: evnt_type)                                     */
/* ENTREE: INT16 evnt_type: masque des evenements dont il faut annuler       */
/*                        la capture SI zero tous les evenements sont      */
/*                        annuls et mise fin de toute capture.            */
/* RETOUR: INT16: l'ancien masque d'evenements precedemment install.        */

INT16 ClearCaptureEvnt (INT16 evnt_type);

/*------------------------- IsThisEvntCaptured ----------------------------*/
/* ACTION: retourne l'adresse de la fonction de capture si l'evenement     */
/*         donne en entree est captur.  zero sinon.                       */
/* ENTREE: INT16 evnt_type: masque des evenements dont il faut savoir si ils */
/*                        sont captures. SI zero Il est retourne la        */
/*                        fonction de capture directement.                 */
/* RETOUR: void *: pointeur sur la fonction capturante en cours.           */
/*                 Zero si pas de fonction capturante pour cet evenement.  */

void *IsThisEvntCaptured(INT16 evnt_type);

/*------------------------- GetWindCaptured -------------------------------*/
/* ACTION: retourne l'indice EAZY_GEM de la fenetre capturant un evenement */
/*         si elle existe. Si elle existe pas il est retourne -1           */
/* ENTREE: neant                                                           */
/* RETOUR: INT16: qui est l'indice EAZY_GEM de la fenetre capturante.        */
/*              si -1 c'est qu'il n'y a pas de fenetre capturante.         */

INT16 GetWindCaptured(void);

/*-------------------------- ExeWindMessage ----------------------------*/
/* ACTION: permet d'envoyer  une fenetre un message quelconque.        */
/*         SI le parametre n_param: est positif: l'execution du message */
/*                         est immediate cette fonction  ne passe pas   */
/*                         par la messagerie GEM, mais execute          */
/*                         directement la fonction de fenetre associee  */
/*                          w_ind. C'est utile lorsque l'on desire     */
/*                         effectuer quelque chose (par exemple une     */
/*                         mise a jour avant un redraw) avant la        */
/*                         messagerie GEM.                              */
/*         SI le parametre n_param: est negatif: sa valeur absolue      */
/*                         indique le nombre de paramtres, et la pile  */
/*                         des messages GEM sera utilise normalement.  */
/* ENTREE: INT16 w_ind: handle EAZY_GEM de la fenetre cible.              */
/*         INT16 messg: message  envoyer                                 */
/*         INT16 *param: parametres sous forme d'un tableau d'INT16         */
/*                SI *param est egal  zero le tableau de parametres    */
/*                    est ignor                                        */
/*                SINON le premier parametre sera copie en:             */
/*                         Evnt.pipe[X_G] et les autres suivent apres.  */
/*                         pour memoire: X_G = 4                        */
/*         INT16 n_param: nombre de parametres  copier, la facon dont le */
/*                      message est envoy  la procedure de fenetre    */
/*                      depend du caractere positif ou negatif de ce    */
/*                      parametre (voir un peu plus haut)               */
/*                                                                      */

INT16 ExeWindMessage(INT16 w_ind, INT16 messg, INT16 *param, INT16 n_param);

/*----------------------------- Pause_EZ ----------------------------------*/
/* ACTION: permet d'introduire un delai de x dixiemes de secondes          */
/*         Cette fonction est une fonction GEM et ne doit pas etre utilisee*/
/*         dans les fonctions cdecl.                                       */
/* ENTREE: long t, delai en dixiemes de secondes.                          */

void Pause_EZ(long t);

/*----------------------------- ApplWrite -------------------------------------*/
/* ACTION: fonction tire de la LIB WINNDOM de Dominique Brziat pour pouvoir */
/*         implementer les fonction GEMSCRIPT. Cette fonction  parametres     */
/*         variables permet d'envoyer un message  une application.            */
/* ENTREE: INT16 to: identificateur GEM de l'application destinataire.           */
/*         INT16 msg: Message  envoyer.                                         */
/*         ... liste d'arguments dont l'ensemble des tailles cumules ne doit  */
/*                               pas depasser 5 shorts.                        */
/*                               exemple: deux pointeurs et un short.          */
/*                                        un pointeur, et trois short          */
/* RETOUR:  0/si erreur   un nombre positif sinon.                             */

INT16 ApplWrite( INT16 to, INT16 msg, ...);

/*--------------------------- Send_VA_START ---------------------------*/
/* ACTION envoie  l'application dont l'ID est appl_id, un message     */
/*        VA_START afin qu'elle charge le fichier ou se mette au       */
/*                 premier plan ou fasse un peu ce qu'elle veut        */
/* ENTREE: appl_id iddentificateur de l'application destinataire       */
/*         path chemin complet envoy  l'application                  */

void  Send_VA_START(INT16 appl_id, char *path);

/*--------------------------- SendMessage --------------------------*/
/* ACTION: Envoie un message simple sans paramtres                 */
/* ENTREE: INT16 messg, message  envoyer                             */

void SendMessage(INT16 messg);

/*--------------------------- SendGrectRedrawMessage ---------------*/
/* ACTION: ordonne  une fenetre de redessiner une portion de sa    */
/*         surface.                                                 */
/* ENTREE: INT16 w_h, handle GEM de la fenetre cible.                 */
/*         GRECT *grect coordonnes du rectangle  redessiner.      */

void SendGrectRedrawMessage(INT16 w_h, GRECT *grect);

/*--------------------------- SendWindRedraw -----------------------*/
/* ACTION: ordonne  une fenetre de se redessiner sur toute sa      */
/*         surface.                                                 */
/* ENTREE: INT16 w_h, handle GEM de la fenetre  redessiner           */

void SendWindRedraw(INT16 w_h);

/*--------------------------- SendExeFunc ---------------------------*/
/* ACTION: envoie a l'application de destination app_id, un message  */
/*         d'execution de fonction.                                  */
/* ENTREE: INT16 app_id: identificateur GEM de l'application a qui le  */
/*                     message est destin.                          */
/*         INT16 num_func: numero de fonction que l'on desire executer */
/*                       dans cette application .                    */
/*          long user: parametre que l'on peut passer a la fonction  */
/*                     ce parametre se retrouvera en:                */
/*                     msgbuf[W_G] et msgbuf[H_G].                   */

void SendExeFunc(INT16 app_id, INT16 num_func, long user);

/*----------------------- SendObjectRedraw -------------------------*/
/* ACTION: envoie un message de redessin sur la surface occupee par */
/*         un objet  a une fenetre                                  */
/* ENTREE: INT16 w_h, handle GEM de la fenetre cible.                 */
/*         OBJECT *object, adresse arbre auquel appartient l'objet. */
/*         INT16 num_ob, numro de l'objet dans cet arbre.            */

void SendObjectRedraw(INT16 w_h, OBJECT *object, INT16 num_ob);

/*-------------------------- SendWindMessage --------------------------*/
/* ACTION: permet d'envoyer  une fenetre un message quelconque avec   */
/*         4 parametres de dimensions (ou autre chose)                 */
/* ENTREE: INT16 w_h, handle GEM de la fenetre cible.                    */
/*         INT16 messg, message  envoyer                                */
/*         GRECT *grect 4 parametres sous forme de rectangle.          */
/*                SI grect est egal  zero le rectangle est ignor     */

void SendWindMessage(INT16 w_h, INT16 messg, GRECT *grect);

/*---------------------------- ExeAllMessage -------------------------------*/
/* ACTION: permet d'executer tous les messages empils                      */
/*         afin d'etre sur que notre action puisse se faire apres tous les  */
/*         autres messages                                                  */

INT16 ExeAllMessage( void );

/*---------------------------- ClearKeybdMessage ---------------------------*/
/* ACTION: permet de vider le tampon GEM clavier sans executer les touches  */
/*         clavier mais d'executer tous les autres messages empils         */
/*         cela permet d'eviter la repetition d'une touche clavier lorsque  */
/*         son traitement a pris du temps et que le tampon GEM s'est rempli */
/*         d'evenements claviers. Appeler donc cette fonction apres celle   */
/*         traitant le clavier, afin de vider le buffer GEM.                */
/* ENTREE: CALLBACK (*Men_proc)(INT16 wind, EVNT_O *Evnt):  pointeur sur la   */
/*                 fonction de traitement  par defaut des messages (si elle */
/*                 existe) peut tres bien etre zero, et alors la fonction   */
/*                 par defaut ne sera pas appele.                          */
/* SORTIE: INT16 nbr de messages executes.                                    */

INT16 ClearKeybdMessage( CALLBACK (*Men_proc)(INT16 wind, EVNT_O *Evnt) );

/*--------------------------- WindAlertClose ------------------------*/
/* ACTION: ferme une alert non modale. Une alert non modale est la   */
/*         fenetre de message mise en place apres appel de la        */
/*         fonction form_alert(); avec comme premier parametre: 1000 */
/*         Cette fenetre est utile pour annoncer un message, avant   */
/*         action longue (exemple long calcul, conversion ou autre)  */
/*         bloquant l'application.                                   */
/*         Cette alert doit a la fin de l'action etre fermee.        */
/* ENTREE: neant                                                     */
/* RETOUR: neant                                                     */
void WindAlertClose(void);

/*************************************************************************/
/*           F O N T I O N S   D E   F I C H I E R S   ( G E M  )        */
/*************************************************************************/

/*------------------------- EZB_CreateStruct -----------------------------*/
/* ACTION: verifie si il existe un script de base de donnees associees au */
/*         formulaire de cette fenetre, si c'est le cas cree toutes les   */
/*         les structures necessaires a la gestion des bases de donnees   */
/*         ratachees a ce formulaire, ouvre les fichiers necessaires.     */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le      */
/*         formulaire.                                                    */
/* SORTIE: void*: pointeur sur la structure de gestion de base            */
/*                de donnee cree et mise en place.                        */
/*                Si zero ou -1 .... -20 erreur.                          */
/* IMPORTANT: il est imperatif de detruire les structures de base de      */
/*            donnees, avant la fin du programme, en utilisant la         */
/*            fonction: EZB_DestroyStruct();                              */

void *EZB_CreateStruct(INT16 w_ind);

/*---------------------------- EZB_DestroyStruct -------------------------*/
/* ACTION: fonction servant a detruire proprement toutes les structures   */
/*         de base de donnee mise en place avec la fonction:              */
/*         EZB_CreateStruct();                                            */
/*         Cette fonction ferme aussi tous les fichiers ouverts.          */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le      */
/*         formulaire.                                                    */

INT16 EZB_DestroyStruct(INT16 w_ind);

/*--------------------------- EZB_RecToForm -------------------------------*/
/* ACTION: Place les donnees d'une fiche, dans le formulaire               */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/*         long rec: numero de l'enregistrement (fiche) devant etre placee */
/*                   dans le formulaire.                                   */
/*                   -> SI rec est plus grand que le nombre de fiches que  */
/*                         contient le fichier, c'est la deniere fiche qui */
/*                         est placee dans le formulaire.                  */
/*                   -> SI le fichier ne contient aucun enregistrement,    */
/*                         les champs du formulaire sont effaces.          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON pointe sur le numero de fiche placee dans le formulaire.  */

long EZB_RecToForm(INT16 w_ind, long rec);

/*-------------------------- EZB_FormToRec --------------------------------*/
/* ACTION: Enregistre les donnees du formulaire ds les fichiers concernes  */
/*         par ce formulaire.                                              */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/*         long rec: numero de l'enregistrement (fiche) devant recevoir    */
/*                   les donnees du formulaire.                            */
/*                   -> SI -1 la fiche est rajoutee a la fin du fichier.   */
/*                   -> SINON elle remplace celle pointee par 'rec'        */
/*                   -> SI rec est plus grand que le nombre de fiches que  */
/*                         contient le fichier, la fiche est rajoutee au   */
/*                         fichier.                                        */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON pointe sur le numero de fiche enregistre.                 */

long EZB_FormToRec(INT16 w_ind, long rec);

/*------------------------- EZB_SetCurRec ---------------------------------*/
/* ACTION: positionne la fiche courante sur un numro de notre choix, et   */
/*         raffiche le formulaire associ.(le numero de la premiere fiche */
/*         commence a zero). Le numero est reajuste si trop grand.         */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/*         long rec: numero de l'enregistrement (fiche) devant etre place */
/*                   comme fiche courante.                                 */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON le numero de fiche mis en place.                          */

long EZB_SetCurRec(INT16 w_ind, long cur_rec);

/*------------------------- EZB_GetNbRec ----------------------------------*/
/* ACTION: retourne le nombre d'enregistrements d'une structure de fichiers*/
/*         lie au formulaire de la fenetre EAZY_GEM: w_ind.               */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON le nombre d'enregistrements (ou fiches).                  */

long EZB_GetNbRec(INT16 w_ind);

/*------------------------- EZB_FicNextRec --------------------------------*/
/* ACTION: affiche la fiche suivante, dans le formulaire.                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche affichee.                   */

long EZB_FicNextRec(INT16 w_ind);

/*------------------------- EZB_FicPrevRec --------------------------------*/
/* ACTION: affiche la fiche precedente, dans le formulaire.                */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche affichee.                   */

long EZB_FicPrevRec(INT16 w_ind);

/*-------------------------- EZB_FicDelRec --------------------------------*/
/* ACTION: efface la fiche courante, dans le formulaire, et le reaffiche.  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche affichee.                   */

long EZB_FicDelRec(INT16 w_ind);

/*--------------------------- EZB_FicModRec -------------------------------*/
/* ACTION: Enregistre les donnees du formulaire dans la fiche courante     */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche enregistree.                */

long EZB_FicModRec(INT16 w_ind);

/*--------------------------- EZB_FicChpDraw ------------------------------*/
/* ACTION: Affiche les champs du formulaire lies a une base de donnee      */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon nombre de champs affiches.                                */

long EZB_FicChpDraw(INT16 w_ind);

/*-------------------------- XFilesSelect -------------------------------*/
/* ACTION: gestion des selecteurs de fichiers modernes type FREEDOM .    */
/*         si plusieurs fichiers sont selectionnes, la liste est         */
/*         retournee par la fonction. Il convient de liberer cette liste */
/*         apres usage. Chaque nom de fichier est separe du precedent    */
/*         un espace.                                                    */
/*         appelle le selecteur d'objet et met  jour le chemin d'entree */
/*         et le nom de fichier, si confirmer est appuye.                */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\             */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT         */
/*         char *ext, extension                                          */
/*         char *mess message d'information  afficher.                  */
/*         INT16 mode: 0/mode modal     : la sortie se fait apres confirma-*/
/*                                      tion ou choix de fichier ou      */
/*                                      anuulation.                      */
/*                   1/ mode VA_START : la main est rendue  EZ_GEM et   */
/*                                      il est envoy un message VA_START*/
/*                                      avec fichiers apres confirmation */
/*                                      si annuler il n'est rien envoy  */

/*SORTIE:  char* pointeur sur la liste de fichiers, separes par des      */
/*               espaces. Apres avoir recupere les donnees il est a      */
/*               votre charge de liberer ce pointeur en faisant free();  */
/*               Si la sortie s'est faite par le bouton ANNULEZ ce       */
/*               pointeur est NULL et il n'est pas a liberer.            */

char *XFilesSelect(char *path_in, char *nom_in, char *ext, char *mess, INT16 mode);

/*--------------------------- Fic_select --------------------------------*/
/* ACTION: appelle le selecteur d'objet et met  jour le chemin d'entree */
/*         et le nom de fichier, si le fichier est valide et confirmer.  */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\             */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT         */
/*         char *ext, extension                                          */
/*         char *mess message d'information  afficher.                  */
/* RETOUR:                                                               */
/* <- longueur du fichier si zero fichier vide                           */
/*                        si -1L     mauvaise extension                  */
/*                        si -2L;    option annuler cliquee              */
/*                        si -3L;    ce Fichier n'existe pas             */
/* <- path eventuellement modifie (si Len_fic>0 ou existe pas)           */
/* <- nom eventuellement modifie  (si Len_fic>0 ou existe pas)           */

long Fic_select (char *path_in, char *nom_in, char *ext, char *mess);

/*--------------------------- FileSelect --------------------------------*/
/* ACTION: appelle le selecteur d'objet et met  jour le chemin d'entree */
/*         et le nom de fichier, si bouton CONFIRMEZ est appuy.         */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\             */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT         */
/*         char *ext, extension                                          */
/*         char *mess message d'information  afficher.                  */
/* RETOUR:                                                               */
/* <- longueur du fichier si zero fichier vide                           */
/*                        si -1L     mauvaise extension                  */
/*                        si -2L;    option annuler cliquee              */
/*                        si -3L;    ce Fichier n'existe pas             */
/* <- char *path_in: contient le chemin inscrit si OK appuy             */
/*                   inchang si                   ANNULER appuy        */
/* <- char *nom_in:  contient le nom    inscrit si OK      appuy        */
/*                   inchang si                   ANNULER appuy        */

long FileSelect (char *path_in, char *nom_in, char *ext, char *mess);

/*--------------------------- ListOfPathNomToPathNom --------------------------*/
/* ACTION: fonction d'extraction d'un path et nom d'une liste de path et       */
/*         nom telle que fournie lors des messages DRAG & DROP ou VA_START     */
/*         tenant compte des eventuels nom et path de fichiers entre quote     */
/*         permettant de tenir compte des nom de fichier avec espaces          */
/* ENTREE: char *path: pointe sur une zone texte dans laquelle sera place     */
/*                     la chaine du path recherch.                            */
/*         char *nom:  pointe sur une zone texte dans laquelle sera place     */
/*                     la chaine du nom recherch. SI zero alors path          */
/*                     sera rempli avec la chemin complet y compris le nom     */
/*                     du fichier: exple E:\PATH\FILE.EXT                      */
/*                                                 SINON path sera rempli      */
/*                     avec le  path: exple: E:\PATH\  et nom dera rempli      */
/*                     avec le nom:   exple: FILE.EXT                          */
/*         char *list: pointe sur la zone memoire contenant la liste des       */
/*                     chemins(ou path) complets CAD avec le nom des fichiers  */
/*                     cette liste peut etre de la forme entre quote: exple:   */
/*                     'E:\MY PATH\FILE.EXT' 'E:\MY PATH\FILE.EXT'/0           */
/*                     permettant les espaces dans les noms de fichiers, ou du */
/*                     type classique separes par des espaces(si pas d'espaces */
/*                     dans les noms de fichiers): exple:                      */
/*                     E:\MY_PATH\FILE.EXT E:\MY_PATH\FILE.EXT/0               */
/*         INT16 num:    numero du chemin desire dans la liste. Si au-delas    */
/*                     du nombre permis, alors le dernier sera retourn        */
/*                     ce nombre est en base zero CAR le premier desire de la  */
/*                     liste est zero.                                         */
/* RETOUR: INT16: numero (base zero) du path retourn.                         */

INT16 ListOfPathNomToPathNom(char *path, char *nom, char *list, INT16 num);


/*---------------------- GetPathAppli ----------------------------------*/
/*  ACTION: cherche le path de demarrage de l'application  partir de   */
/*          son nom, eventuellement retourne le nom du fichier avec     */
/*          lequel le programme est demarr                             */
/* ENTREE:  nom_appli = NOM_PRG.PRG nom du programme cherch            */
/* SORTIE:  path  chemin A:\UPSIS\ dans lequel se trouve le programme   */
/*          fic_auto si non NUL il sera retourne le nom du fichier      */
/*                   eventuellement depose sur le programme au depart   */
/* RETOUR: 0 si pas de fichier associe au lancement du programme        */
/*         1 si fichier associe au demarrage                            */

INT16 GetPathAppli(char *path, char *nom_appli, char *fic_auto);

/*--------------------------- FindFicSys ---------------------------------*/
/* ACTION: cherche le fichier nom dans differents chemins:                */
/*         Soit celui de la chaine d'environnement lie  l'application,  */
/*         Soit dans un dossier portant le nom de l'application avec      */
/*              l'extension .RSC, situe dans meme repertoire que l'appli- */
/*              cation.                                                   */
/*         Soit dans un dossier portant le nom de l'application avec      */
/*              l'extension .SYS, situe dans meme repertoire que l'appli- */
/*              cation.                                                   */
/*         Soit dans un dossier portant le nom de l'application avec      */
/*              l'extension .EZB, situe dans meme repertoire que l'appli- */
/*              cation.                                                   */
/*         Soit au niveau du repertoire de l'application.                 */
/* ENTREE: path = "A:\PATH\" chemin ou doit commencer la recherche        */
/*         si ce path est vide, la recherche commence au niveau du path   */
/*         de l'application. (pour cela faire: *path=0)                   */
/*         nom_appli = "NOMPRG.PRG" nom de l'application                  */
/*         nom       = "NOMFIC.FIC" nom du fichier  chercher             */
/* RETOUR: <0 si pas trouve  >=0 (longueur fichier) si trouve             */
/*         path contient le chemin "A:\PATH\" de dcouverte               */

long FindFicSys(char *path, char *nom_appli, char *nom);

/*************************************************************************/
/*           F O N T I O N S   D E   F I C H I E R S   ( G E M D O S  )  */
/*************************************************************************/

/*--------------------------- PlaceQuote --------------------------------*/
/* ACTION: Pace entre quote une chaine de caractre.                     */
/* ENTREE: char *path, char *nom: pointe sur le chemin et le nom         */
/*                                du fichier d'erreurs. Si nom = 0       */
/*                                alors path doit etre complet           */
/*                                sinon nom est concatene  path         */
/*SORTIE: char * pointe sur le chemin modifi.                           */

char *PlaceQuote(char *path, char *nom);

/*---------------------- PathNomToNomFic -------------------------------*/
/* ACTION: extrait le nom du fichier  partir du nom complet du path    */
/*         et coupe le path sans le nom.                                */
/* ENTREE: char *path: path complet type "A:\DOSSIER\NOM.FIC"           */
/*         char *nom: adresse ou doit etre recopie le nom de fichier    */
/*                    separe de son path.                               */
/*                    Si cette adresse est nulle, le nom ne sera pas    */
/*                    recopie, et juste le path sera coupe au nom.      */
/* SORTIE: nom  = NOM.FIC        (si char *nom != 0)                    */
/*         path = A:\DOSSIER\                                           */
/* RETOUR: adresse de nom                                               */

char *PathNomToNomFic(char *path, char *nom);

/*--------------------------- GetExtension -----------------------------*/
/* ACTION: retourne un pointeur sur l'extension d'un fichier si elle    */
/*         existe. Ce pointeur pointe sur le point. exemple ".DOC"      */
/* ENTREE: char *nom: pointe sur le nom du fichier dont on cherche      */
/*                    l'extension. (peut etre aussi le path complet)    */
/*         char *dst: pointe sur une chaine dans laquelle sera recopiee */
/*                    l'extension (prevoir la place). Si cette valeur   */
/*                    est  zero, il ne sera pas opere de recopie.      */
/* RETOUR: char*: un pointeur sur sur l'extension dans la chaine        */
/*                d'origine. Si zero pas d'extension retrouvee.         */

char *GetExtension(char *nom, char *dst);

/*--------------------------- Enleve_ext -------------------------------*/
/* ACTION: enleve l'extension  nom de fichier passe en entree.          */
/* ENTREE: char *nom, pointe sur le nom du fichier.                     */
/* RETOUR: un char* pointant sur le nom modifie                         */

char *Enleve_ext(char *nom);

/*--------------------- Epure_path -------------------------------------*/
/* ACTION:  enleve au path l'eventuel "*.EXT"                           */
/* ENTREE: char *path, chaine  traiter           A:\PATH\*.EXT         */
/* RETOUR: un char* pointant sur chaine traite   A:\PATH\              */

char *Epure_path(char *path);

/*--------------------- Verifie_ext ------------------------------------*/
/* ACTION: compare l'extension du nom de fichier passe en entree avec   */
/*         celle passe comme parametre.                                 */
/* ENTREE:  char *nom: nom du fichier du type "nomfic.ext" (peut etre   */
/*                     un path complet).                                */
/*          char *ext: extension de fichier du type ".ext"              */
/* SORTIE: char *: retourne l'adresse de la chaine nom si les           */
/*                 extensions sont les memes.                           */
/*                 Retourne zero si differentes.                        */

char *Verifie_ext( char *nom, char *ext);

/*---------------------- Fic_exist --------------------------------------*/
/* ACTION: retourne la longueur d'un fichier, ou -1L si n'existe pas     */
/*         avec message Alert si il n'existe pas                         */
/*         les paths d'entree ne sont pas modifis                       */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\             */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT         */
/*                       si zero c'est que le path comporte tout         */
/* RETOUR: longueur du fichier si il existe                              */
/*        -1 si il n'existe pas                                          */

long Fic_exist(char *path, char *nom);

/*----------------------------- FileLen ----------------------------------*/
/* ACTION: donne la longueur d'un fichier type FILE.                      */
/* ENTREE: FILE *stream: pointeur sur la structure FILE alouee par le     */
/*         systeme lors creation ou ouverture du fichier.                 */
/* SORTIE: longueur du fichier.                                           */

long FileLen(FILE *stream);

/*--------------------------- FicLen ------------------------------------*/
/* ACTION: retourne la longueur d'un fichier, ou -1L si n'existe pas     */
/*         avec message Alert si il n'existe pas                         */
/*         les paths d'entree ne sont pas modifis                       */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\             */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT         */
/*                       si zero c'est que le path comporte tout         */
/* RETOUR: longueur du fichier si il existe                              */
/*        -1 si il n'existe pas                                          */

long FicLen(char *path, char *nom);

/*--------------------------- Bload ------------------------------------*/
/* ACTION: Charge un fichier a l'adresse specifiee en entree.           */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\            */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT        */
/* SORTIE: adresse memoire situee apres le dernier octet charge.        */
/*         (si egale a l'adresse de chargement c'est qu'il il n'y a     */
/*          rien de charge donc erreur.)                                */

void  *Bload( char *path, char *name, void *adr_load);

/*------------------------- Bsave --------------------------------------*/
/* ACTION: Sauve dans un fichier dont le nom et le path sont specifies  */
/*         un bloc memoire situe  l'adresse adr_src et de longueur len */
/*         si le fichier existait auparavant, il est detruit.           */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\            */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT        */
/*         void *adr_src, adresse de la zone memoire a sauver.          */
/*         size_t len, longueur de memoire a sauver.                    */
/* SORTIE: long positif, tout est OK. (nbr d'octets lus)                */
/*         Negatif: -300 ce fichier existait deja et n'a pu etre efface */
/*                  -301 impossible d'ouvrir le fichier.                */
/*                  autres nbr. negatifs = GEMDOS ERROR                 */

long Bsave(char *path_in, char *nom_in, void *adr_src, size_t len);

/*************************************************************************/
/*           F O N T I O N S   D E   T R A N S F O R M A T I O N         */
/*************************************************************************/
/*---------------------- NormaliseGraphCoordLongToInt ---------------------*/
/* ACTION: permet de limiter un coordonne d'affichage long au maxi ou     */
/*         mini possible par un INT16.                                       */
/* ENTREE: long val: coordonne affichage long  normaliser.               */
/* RETOUR: INT16: coordonne normalise pour affichage.                      */

INT16 NormaliseGraphCoordLongToInt(long val);

/*-------------------- VRECT_to_GRECT ------------------------------------*/
/* ACTION: transforme un rectangle VDI en rectangle GEM                   */
/* ENTREE: VRECT *vrect, pointe sur le rectangle VDI.                     */
/*         GRECT *grect, pointe sur le rectangle GEM.                     */
/* SORTIE: GRECT *grect, est initialis sur les valeurs transformes.     */
/* RETOUR: un pointeur sur le rectangle GRECT *grect, de l'entree.        */

GRECT *VRECT_to_GRECT(VRECT *vrect, GRECT *grect);

/*-------------------- GRECT_to_VRECT ------------------------------------*/
/* ACTION: transforme un rectangle GEM en rectangle VDI                   */
/* ENTREE: GRECT *grect, pointe sur le rectangle GEM.                     */
/*         VRECT *vrect, pointe sur le rectangle VDI.                     */
/* SORTIE: VRECT *vrect, est initialis sur les valeurs transformes.     */
/* RETOUR: un pointeur sur le rectangle VRECT *vrect, de l'entree.        */

VRECT *GRECT_to_VRECT(GRECT *grect,VRECT *vrect);

/*----------------------- AdjustXYGrectToScreen --------------------------*/
/* ACTION: rajuste les coordones du rectangle GRECT de faon  ce qu'il */
/*         soit centr sur x et y et qu'il tienne dans l'ecran            */
/* ENTREE: INT16 x,INT16 y, coordonnes du centre souhait du rectangle.      */
/*         GRECT *grect, pointe sur le rectangle GEM recentrer.           */
/* SORTIE: GRECT *grect, est initialis sur les valeurs transformes.     */

void AdjustXYGrectToScreen (INT16 x, INT16 y, GRECT *grect);

/*---------------------------- AdjustGrectToGrect ------------------------*/
/* ACTION: ajuste les coordonnes du rectangle grect, de faon  ce qu'il */
/*         tienne dans le rectangle limit_grect.                          */
/* ENTREE: GRECT *limit_grect: rectangle dans lequel il faut faire tenir  */
/*                             le rectangle grect.                        */
/*         GRECT *grect: rectangle dont il faut eventuellement reajuster  */
/*                       la position.                                     */
/* RETOUR: GRECT * pointe sur le rectangle reajust.                      */

GRECT *AdjustGrectToGrect(GRECT *limit_grect, GRECT *grect);

/*----------------------- Rc_intersect ------------------------------------*/
/* ACTION: calcule l'intersection de deux rectangles entre eux et retourne */
/*         TRUE si il ya intersection et FALSE si pas d'intersection       */
/* ENTREE: r1 pointe sur premier rectangle.                                */
/*         r2 pointe sur deuxieme rectangle.                               */
/* RETOUR: retourne TRUE si intersection et FALSE si pas d'intersection    */
/*         r2 est modifie en rectangle intersectant resultant.             */

INT16 Rc_intersect(GRECT *r1,GRECT *r2);

/*---------------------------- NumSelToTrame --------------------------------*/
/* ENTREE:un nombre compris entre 0 et 39                                    */
/*        representant tous les types possibles de trames systemes atari     */
/*        selon la valeur passee dans le parametre sel le remplissage des    */
/*        objets sera le suivant:                                            */
/*        si zero pas de remplissage les objets sont de type ligne           */
/*        si 1  c'est la couleur du fond d'indice zero (blanc) (trame unie)  */
/*        si 2  c'est la couleur en cours qui remplit l'objet  (trame unie)  */
/*        si 3   26  c'est le premier groupe de trame GEM                   */
/*        si 27  38  c'est le deuxieme groupe de trame GEM                  */
/* SORTIE: INT16 *type et INT16 *trame sont positionnes sur les bonnes valeurs  */
/*         pour faire vsf_style (VDIhandle, type);    suivi de               */
/*                    vsf_interior(VDIhandle, trame); afin de positionner    */
/*                    les atributs de traage sur les bonnes valeurs         */

void NumSelToTrame(INT16 sel, INT16 *type, INT16 *trame);

/*---------------------------- TrameToNumSel --------------------------------*/
/* ACTION: transforme deux nombres diffrents reprsentant, le type VDI de   */
/*         remplissage correspondant aux fonctions: vsf_interior  () et      */
/*                                                  vsf_style()              */
/*         en un indice de liste, permettant de pointer sur une LISTBOX de   */
/*         trames.                                                           */
/* ENTREE: INT16 type correspond  la fonction  vsf_interior() et peut prendre */
/*                  les valeurs suivantes FIS_HOLLOW/0  FIS_SOLID/1          */
/*                  FIS_PATERN/2 FIS_HATCH/3 FIS_USER/4                      */
/*         INT16 trame correspond  la fonction  vsf_style()                   */
/* SORTIE: un nombre compris entre 0 et 40                                   */

INT16 TrameToNumSel(INT16 type, INT16 trame);

/*------------------------------ ScanToAscii --------------------------*/
/* ACTION: retourne  partir du scan code et de l'tat des touches     */
/*         ALTERNATE, CONTROL, SHIFT le caractre ASCII.               */
/* ENTREE: INT16 scan, scan code de la touche clavier.                   */
/*         INT16 state, etat des touches ALTERNATE, CONTROL, SHIFT       */
/* RETOUR: un INT16, qui est le code ASCII de la touche clavier.         */

INT16 ScanToAscii(INT16 scan, INT16 state);

/*------------------------- StrTrimEnd ---------------------------------*/
/* ACTION: enleve les espaces de fin de chaine.                         */
/* ENTREE: char *str:                                                   */
/*             pointe sur la chaine de caracteres  traiter.            */
/* RETOUR: char*: un pointeur sur cette chaine traitee.                 */

char *StrTrimEnd(char *str);

/*---------------------------- StrTrimDeb ------------------------------*/
/* ACTION: recherche le premier caractere non espace d'une chaine       */
/*         en partant de son debut.                                     */
/* ENTREE: char *str:                                                   */
/*             pointe sur la chaine de caracteres  traiter.            */
/* RETOUR: char*: un pointeur sur le premier caractere non espace de la */
/*             chaine.                                                  */

char *StrTrimDeb(char *pt);

/*---------------------- AsciiNumberToLedNumber ------------------------*/
/* ACTION: la chaine ASCII: 0123456789 est transformee en     */
/* ENTREE: char *str: pointe sur la chaine a traiter.                   */
/* SORTIE: char *:    pointe sur la chaine traitee (meme que entree)    */

char *AsciiNumberToLedNumber(char *str);

/*---------------------- LedNumbertoAsciiNumber ------------------------*/
/* ACTION: la chaine ASCII:  est transformee en  0123456789   */
/* ENTREE: char *str: pointe sur la chaine a traiter.                   */
/* SORTIE: char *:    pointe sur la chaine traitee (meme que entree)    */

char *LedNumbertoAsciiNumber(char *str);

/*************************************************************************/
/*           F O N T I O N S   D ' O B J E T S    E T E N D U S          */
/*************************************************************************/

/*------------------------ GetEZWindOfTree ------------------------------*/
/* ACTION retourne l'indice EAZY_GEM de la fenetre intedrant l'arbre de  */
/*        ressource passe en entree.                                     */
/* ENTREE: OBJECT *tree: pointeur sur le premier objet de l'arbre dont   */
/*                       on cherche a connaitre la fenetre.              */
/* SORTIE: INT16 qui est l'indice EAZY_GEM de la fenetre contenant l'arbre */
/*                 Si -1 c'est que pas trouvee.                          */

INT16 GetEZWindOfTree(OBJECT *tree);

/*------------------------------ SetFocus --------------------------------*/
/* ACTION: Place l'objet designe par OBJECT *object et INT16 ind en mode    */
/*         edition, le curseur s'enlve de l'ancien objet en edition et   */
/*         se place sur le nouveau et le clavier est dirig dessus.       */
/*         Cette fonction fonctionne meme sur les editables compexes tel  */
/*         que les SCROLL_EDIT.                                           */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre contenant le dialogue */
/*         OBJECT *object: objet racine de l'arbre dans lequel se trouve  */
/*                         l'objet sur lequel l'on doit placer le focus.  */
/*         INT16 ind:  indice de l'objet sur lequel l'on doit placer le     */
/*                   focus dans l'arbre.                                  */
/*         EVNT_O *Evnt: structure evenementielle d'entree dont les       */
/*                       coordonnees Evnt->x et Evnt->y servent a placer  */
/*                       le curseur dans l'objet recevant le focus.       */
/*                     Si vous placez 3L comme pointeur sur EVNT_O *Evnt  */
/*                       (faire un cast type (EVNT_O*) 3L pour cela),     */
/*                       alors il sera utilise les anciennes positions    */
/*                       du curseur. Utilisez cette methode si vous devez */
/*                       appeler cette fonction sans avoir de variable    */
/*                       evenementielle sous la main.                     */
/* RETOUR: INT16: Si zero l'objet recevant le focus est un SCROLL_EDIT.     */
/*              Si 1    l'objet recevant le focus est une editable GEM.   */

INT16 SetFocus(INT16 w_ind, EVNT_O *Evnt, OBJECT *object, INT16 ind);

/*------------------ GetSCROLBOX_GrectUtil -------------------------*/
/* ACTION: calcule la surface utile d'une SROLLBOX, ajuste aux     */
/*         reliquats lis au fait qu'il n'y a pas toujours un       */
/*         nombre entier de lignes contenus dans le rectangle       */
/*         client.                                                  */
/* ENTREE: OBJECT *object: adresse arbre auquel appartient l'objet  */
/*                         SCROLLBOX dont on cherche le rectangle   */
/*                         utile.                                   */
/*         INT16 ind: numro de l'objet dans cet arbre.               */
/*         GRECT *util_grect: pointe sur le rectangle dans lequel   */
/*                            sera retourne le rectangle utile      */
/*                            de la SCROLLBOX                       */
/* RETOUR: INT16: nbr de lignes affichables.                          */

INT16 GetSCROLBOX_GrectUtil(OBJECT* object, INT16 ind, GRECT *util_grect);

/*------------------------------ ActiveOnglet --------------------------------*/
/* ACTION: active un des dialogues d'une boite  onglet                       */
/* ENTREE: INT16 w_ind,  indice EAZY_GEM de la fenetre contenant le dialogue    */
/*         INT16 ob_onglet, numero d'objet de la boite  onglets                */
/*         INT16 next_dial, numero du dialogue d'onglet  activer               */
/* SORTIE: neant                                                              */
void ActiveOnglet(INT16 w_ind, INT16 ob_onglet, INT16 next_dial);

/*-------------------------- SetOngletUserDraw -------------------------------*/
/* ACTION: permet de donner a la boite d'onglet sa propre fonction            */
/*         d'affichage des cases d'onglet.                                    */
/* ENTREE: OBJECT *object: objet racine de l'arbre dans lequel se             */
/*                         trouve la boite d'onglet pour laquelle l'on        */
/*                         souhaite associer une fonction de redessin des     */
/*                         cases d'onglet.                                    */
/*         INT16 ind_ob:  indice de la boite a onglets dans l'arbre.            */
/*         INT16 (*OnggletDrawFunc)(void *ptOngletParam):  fonction qui         */
/*                    sera chargee de redessiner les cases d'onglet.          */
/* RETOUR: 0/si pas boite a onglet.  ongletblk sinon.                         */
/*                                                                            */
/* La fonction de redessin que vous fournissez recevra l'adresse d'une        */
/* structure vous donnant des renseignement sur l'onglet a dessiner:          */
/*                                                                            */
/* typedef struct                                                             */
/*       {OBJECT *object;     objet racine de l'arbre ou se trouve l'onglet.  */
/*        INT16     ind_ob;     indice de l'onglet en cours dans cet arbre.     */
/*        char   *txt;        texte de l'onglet en cours.                     */
/*        GRECT  *grect;      rectangle de l'onglet.                          */
/*        GRECT  *clip_rect;  rectangle de cliping.                           */
/*       } ONG_DRAW_PARAM;                                                    */
/* cette adresse se trouve dans: void *ptOngletParam (a caster evidement)     */

ONGLETUSERBLK* SetOngletUserDraw(OBJECT *object, INT16 ind_ob,
                                 INT16 (*OngletDrawFunc)(void *ptOngletParam));

/*--------------------------- SetListCallBackFunc ----------------------------*/
/* ACTION: Cette  fonction  permet de modifier la fonction d'affichage  d'une */
/*         la LIST_BOX, ou d'une SCROLLBOX ou SCROLL_EDIT.                    */
/* ENTREE: Dans le parametre:  OBJECT *tree l'on  place l'adresse de l'arbre  */
/*                             ou se situe la LISTBOX,                        */
/*         Dans le paramtre: INT16   ind_ob l'on  place l'indice  de l'objet   */
/*                            correspondant  la LIST_BOX.                    */
/*         Dans le paramtre: void *func l'on  place l'adresse de la fonction */
/*                            devant afficher les cases de la LISTBOX. Cette  */
/*                            fonction doit bien sur etre ecrite par vous.    */
/* RETOUR: l'adresse de l'ancienne fonction de gestion.                       */

void *SetListCallBackFunc ( OBJECT *tree, INT16   ind_ob, void *func );

/*--------------------------- SetScrollBoxParam ------------------------------*/
/* ACTION: Cette fonction permet de modifier les parametres de fonctionnement */
/*         la SCROLBOX.                                                       */
/*         Si vous fournissez la valeur -2, pour une valeur de parametre, le  */
/*         parametre correspondant ne sera pas modifi.                       */
/* ENTREE: Dans le parametre: OBJECT *tree l'on  place l'adresse de l'arbre   */
/*                           ou se situe la SCROLBOX,                         */
/*        Dans le paramtre: INT16   ind_ob l'on  place l'indice  de l'objet    */
/*                           correspondant  la SCROLBOX.                     */
/*        Dans le paramtre: INT16  LgnH  hauteur en pixels d'une ligne de      */
/*                            scrolling c'est de cette distance dont scrolle  */
/*                            en vertical la boite.                           */
/*        Dans le paramtre: INT16  ClnW  largeur en pixels d'une colonne       */
/*                           scrolling  c'est de cette distance dont scrolle  */
/*                           en horizontal la boite.                          */
/*        Dans le paramtre: long NbLgn nombre de lignes total (hauteur       */
/*                           totale du document / LgnH ).                     */
/*        Dans le paramtre: long NbCln nombre de colonnes total (largeur     */
/*                           totale du document / ClnW ).                     */
/*        Dans le paramtre: long FstLgn indice de la ligne de scrolling     */
/*                           placer en haut e la boite  (offset d'affichage   */
/*                           vertical).                                       */
/*        Dans le paramtre: long FstCln indice de la colonne de scrolling   */
/*                           placer  droite de la boite  (offset d'affichage */
/*                           horizontal).                                     */
/*        Dans le paramtre: long LgnSlct indice de la ligne document         */
/*                           slectionne.                                    */
/*        Dans le paramtre: long ClnSlct indice de la colonne document       */
/*                           slectionne.                                    */
/*        Dans le paramtre: void *SclBoxParam  l'on  peut  placer  ce  que   */
/*                           l'on veut, une adresse de donnes, ou tout autre */
/*                           chose. Ce  paramtre est transmis  la fonction  */
/*                           d'affichage de la SCROLBOX.                      */
/*        Dans le paramtre: INT16 Do, l'on  peut  placer une valeur qui        */
/*                           modifiera le comportement de la sroll_box lors   */
/*                           d'un affichages: si LST_DRAW elle sera dessinee  */
/*                                            normalement.                    */
/*                                            si LST_NODRAW elle ne sera pas  */
/*                                            redessinee.                     */
/* RETOUR: 0 erreur (ce n'est pas une SCROLBOX)                               */
/*         1 tout est Ok                                                      */

INT16 SetScrollBoxParam
      (
        OBJECT *tree,      /* adresse de l'arbre ou se trouve la SCROLBOX     */
        INT16 ind_ob,        /* indice de l'objet dans l'arbre                  */
        INT16 LgnH,          /* hauteur en pixels d'une ligne de scrolling      */
        INT16 ClnW,          /* largeur en pixels d'une colonne scrolling       */
        long NbLgn,        /* Nombre total de lignes document                 */
        long NbCln,        /* nombre total de colonnes document               */
        long FstLgn,       /* indice ligne document  afficher en 1er         */
        long FstCln,       /* indice colonne document  afficher  gauche     */
        long LgnSlct,      /* ligne selectionne ( mettre en surbrillance)   */
        long ClnSlct,      /* colonne selectionne ( mettre en surbrillance) */
        void *SclBoxParam, /* paramtre optionnel  type de pointeur          */
        INT16 Do             /* parametre d'action                              */
      );

/*--------------------------- GetScrollBoxParam ------------------------------*/
/* ACTION: Cette fonction permet de modifier les parametres de fonctionnement */
/*         la SCROLBOX.                                                       */
/*         Si vous fournissez la valeur 0, pour une adresse de parametre, le  */
/*         parametre correspondant ne sera pas retourn.                      */
/* ENTREE: Dans le parametre: OBJECT *tree l'on  place l'adresse de l'arbre   */
/*                            ou se situe la SCROLBOX,                        */
/*         Dans le paramtre: INT16 ind_ob l'on doit placer l'indice de l'objet */
/*                            correspondant  la SCROLBOX.                    */
/* SORTIE:                                                                    */
/*         Dans le paramtre: INT16 *LgnH on reoit la hauteur en pixels d'une  */
/*                            ligne de scrolling c'est de cette distance dont */
/*                            scrolle en vertical la boite.                   */
/*         Dans le paramtre: INT16 *ClnW  on reoit la largeur en pixels d'une */
/*                            colonne scrolling  c'est de cette distance dont */
/*                            scrolle en horizontal la boite.                 */
/*         Dans le paramtre: INT16 *NbLgn l'on reoit le nombre de lignes total*/
/*                            (hauteur totale du document / LgnH ).           */
/*         Dans le paramtre: INT16 *NbCln on reoit le nombre de colonnes total*/
/*                            (largeur totale du document / ClnW ).           */
/*         Dans le paramtre: INT16 *FstLgn l'on reoit l'indice de la ligne de */
/*                            scrolling  placer en haut e la boite  (offset  */
/*                            d'affichage vertical).                          */
/*         Dans le paramtre: INT16 *FstCln on reoit l'indice de la colonne de */
/*                            scrolling  placer  droite de la boite  (offset*/
/*                            d'affichage horizontal).                        */
/*         Dans le paramtre: INT16 *LgnSlct l'on reoit l'indice de la ligne   */
/*                            document slectionne.                          */
/*         Dans le paramtre: INT16 *ClnSlct l'on reoit indice de la colonne   */
/*                            document slectionne.                          */
/*         Dans le paramtre: long *SclBoxParam l'on reoit le parametre      */
/*                            optionnel.                                      */
/*         Dans le paramtre: INT16 *NbCase l'on reoit le nombre de lignes     */
/*                            affichables dans la scrollbox                   */
/* RETOUR: 0 erreur (ce n'est pas une SCROLBOX)                               */
/*         adresse de la structure TEDINFO de cet objet                       */

TEDINFO *GetScrollBoxParam
      (
        OBJECT *tree,       /* adresse de l'arbre ou se trouve la SCROLBOX     */
        INT16 ind_ob,         /* indice de l'objet dans l'arbre                  */
        INT16 *LgnH,          /* hauteur en pixels d'une ligne de scrolling      */
        INT16 *ClnW,          /* largeur en pixels d'une colonne scrolling       */
        INT16 *NbLgn,         /* Nombre total de lignes document                 */
        INT16 *NbCln,         /* nombre total de colonnes document               */
        INT16 *FstLgn,        /* indice ligne document  afficher en 1er         */
        INT16 *FstCln,        /* indice colonne document  afficher  gauche     */
        INT16 *LgnSlct,       /* ligne selectionne ( mettre en surbrillance)   */
        INT16 *ClnSlct,       /* colonne selectionne ( mettre en surbrillance) */
        long *SclBoxParam,  /* paramtre optionnel  type de pointeur          */
        INT16 *NbCase         /* nbr de cases afichables                         */
      );

/*--------------------------- GetScrollBoxLParam -------------------------------*/
/* ACTION: Cette  fonction permet de recuperer les parametres de fonctionnement */
/*         la SCROLBOX.                                                         */
/*         Si vous fournissez la valeur 0, pour une adresse de parametre, le    */
/*         parametre correspondant ne sera pas retourn.                        */
/* ENTREE: Dans le parametre: OBJECT *tree l'on  place l'adresse de l'arbre     */
/*                            ou se situe la SCROLBOX,                          */
/*         Dans le paramtre: INT16   ind_ob l'on doit placer l'indice de l'objet */
/*                            correspondant  la SCROLBOX.                      */
/* SORTIE:                                                                      */
/*       Dans le paramtre: INT16 *LgnH  l'on reoit la hauteur en pixels d'une   */
/*                          ligne de scrolling c'est de cette distance dont     */
/*                          scrolle en vertical la boite.                       */
/*       Dans le paramtre: INT16 *ClnW  l'on reoit la largeur en pixels d'une   */
/*                          colonne scrolling  c'est de cette distance dont     */
/*                          scrolle en horizontal la boite.                     */
/*       Dans le paramtre: long *NbLgn l'on reoit le nombre de lignes total   */
/*                          (hauteur totale du document / LgnH ).               */
/*       Dans le paramtre: long *NbCln l'on reoit le nombre de colonnestotal  */
/*                          (largeur totale du document / ClnW ).               */
/*       Dans le paramtre: long *FstLgn l'on reoit l'indice de la ligne de    */
/*                          scrolling  placer en haut e la boite  (offset      */
/*                          d'affichage vertical).                              */
/*       Dans le paramtre: long *FstCln l'on reoit l'indice de la colonne de  */
/*                          scrolling  placer  droite de la boite  (offset    */
/*                          d'affichage horizontal).                            */
/*       Dans le paramtre: long *LgnSlct l'on reoit l'indice de la ligne      */
/*                          document slectionne.                              */
/*       Dans le paramtre: long *ClnSlct l'on reoit indice de la colonne      */
/*                          document slectionne.                              */
/*       Dans le paramtre: long *SclBoxParam l'on reoit le parametre          */
/*                          optionnel.                                          */
/*       Dans le paramtre: INT16 *NbCase l'on reoit le nombre de lignes         */
/*                          affichables dans la scrollbox                       */
/* RETOUR 0 erreur (ce n'est pas une SCROLBOX)                                  */
/*         adresse de la structure TEDINFO de cet objet                         */

TEDINFO *GetScrollBoxLParam
      (
        OBJECT *tree,       /* adresse de l'arbre ou se trouve la SCROLBOX     */
        INT16 ind_ob,         /* indice de l'objet dans l'arbre                  */
        INT16 *LgnH,          /* hauteur en pixels d'une ligne de scrolling      */
        INT16 *ClnW,          /* largeur en pixels d'une colonne scrolling       */
        long *NbLgn,        /* Nombre total de lignes document                 */
        long *NbCln,        /* nombre total de colonnes document               */
        long *FstLgn,       /* indice ligne document  afficher en 1er         */
        long *FstCln,       /* indice colonne document  afficher  gauche     */
        long *LgnSlct,      /* ligne selectionne ( mettre en surbrillance)   */
        long *ClnSlct,      /* colonne selectionne ( mettre en surbrillance) */
        long *SclBoxParam,  /* paramtre optionnel  type de pointeur          */
        INT16 *NbCase         /* nbr de cases afichables                         */
      );

/*---------------------------- DoScrollBoxSlide ------------------------------*/
/* ACTION: Cette fonction permet de modifier faire scroller la SCROLBOX, d'une*/
/*         certaine quantit de lignes en horizontal ou vertical.             */
/*         Si vous fournissez une valeur ngative le sens est vers le haut et */
/*         et la droite.                                                      */
/* ENTREE: Dans le parametre: OBJECT *tree l'on  place l'adresse de l'arbre   */
/*                            ou se situe la SCROLBOX,                        */
/*         Dans le paramtre: INT16 ind_ob l'on doit placer l'indice de l'objet */
/*                            correspondant  la SCROLBOX.                    */
/*         Dans le paramtre: INT16 n_vert nbr de lignes verticales  scroller. */
/*         Dans le paramtre: INT16 n_hori nbr de lignes horizontales  scroller*/
/*                            colonne scrolling  c'est de cette distance dont */
/*         Dans le paramtre: GRECT *clip_grect il doit etre donn            */
/*                            rectangle de clipping. Si egal a zero alors     */
/*                            c'est le rectangle de l'objet qui est utilise   */
/* RETOUR: 0 erreur (ce n'est pas une SCROLBOX)                               */
/*         1 tout est Ok                                                      */

INT16 DoScrollBoxSlide
     (
      OBJECT *tree,      /* adresse de l'arbre ou se trouve la SCROLBOX     */
      INT16 ind_ob,        /* indice de l'objet dans l'arbre                  */
      INT16 n_vert,        /* nombre de lignes  scroller                     */
      INT16 n_hori,        /* nombre de colonnes  scroller                   */
      GRECT *clip_grect  /* rectangle de clipping                           */
     );

/*---------------------------- XYToScrollBoxItem -------------------------*/
/* ACTION: Retourne la ligne cliquee dans la SCROLLBOX.                   */
/* ENTREE: OBJECT *object, pointe sur le prem. objet de l'arbre d'objets  */
/*                         ou se trouve l'objet.                          */
/*         INT16 ob_ind, indice de l'objet SCROLLBOX clique dans cet arbre. */
/*         INT16 x, INT16 y, coordonnees X & Y de la souris                   */
/* SORTIE: long, ligne cliquee (option base 0) de la SCROLLBOX.           */

long XYToScrollBoxItem(OBJECT *object, INT16 ob_ind, INT16 x, INT16 y);

/*---------------------- GetScrollBoxGRECT -------------------------------------------------*/
/* ACTION: retourne les dimensions des zones d'affichage des items d'une SROLLBOX           */
/*                                                                                          */
/* ENTREE: OBJECT *object: pointe sur le premier objet (objet racine) du dialogue contenant */
/*                         la SCROLLBOX.                                                    */
/*         INT16 ind_ob: indice de l'objet SCROLLBOX dans ce dialogue.                        */
/*         GRECT *grect: pointe sur le rectangle dans lequel seront retournees les          */
/*                       dimensions demandees.                                              */
/*         INT16 item: SI != -1 alors les dimensions du rectangle d'affichage de l'item       */
/*                              pointe par la variable item seront retournees.              */
/*                              si non visible il est retourne 0.                           */
/*                   SI = -1  alors les dimensions du rectangle d'affichage contenant tous  */
/*                              les items visibles est retourne (rectangle de la surface    */
/*                              d'affichage de l'objet, sans le cadre et autres fioritures) */
/* SORTIE: GRECT *: pointe sur le rectangle donne en entree.                                */
/*                  si zero c'est que l'item est non visible.                               */

GRECT *GetScrollBoxGRECT(OBJECT *object, INT16 ind_ob, GRECT *grect, INT16 item);

/*------------------------------ VascPosAdjust ---------------------------------------------*/
/* ACTION: calcule la position de l'ascenseur vertical d'une SCROLLBAR  partir des donnes */
/*         d'un objet de type SCROLLBOX.                                                    */
/* ENTREE: OBJECT *object:                                                                  */
/*            pointe sur le premier objet (objet racine) de l'arbre ou sont contenus les    */
/*            autres objets.                                                                */
/*         INT16 ob_scroll: numero ou indice de l'objet SCROLLBOX dans cet arbre.             */
/*         INT16 ob_Vbar:   numero ou indice de l'objet SCROLLBAR dans cet arbre.             */
/*                        une SCROLLBAR est un objet contenant un objet fils ascenseur.     */
/*         INT16 ob_Vasc:   numero ou indice de l'objet Ascenseur dans cet arbre.             */
/*                        une SCROLLBAR est un objet contenant un objet fils ascenseur.     */
/* RETOUR: INT16: position y de l'ascenseur. (en relatif  la SCROLLBAR ob_Vbar).             */

INT16 VascPosAdjust(OBJECT *object, INT16 ob_scroll, INT16 ob_Vbar, INT16 ob_Vasc);

/*------------------------------ VascHeightAdjust ------------------------------------------*/
/* ACTION: calcule la taille de l'ascenseur vertical d'une SCROLLBAR  partir des donnes   */
/*         d'un objet de type SCROLLBOX. La donne: scrollboxblk->FstLgn est si besoin      */
/*         ajuste de facon  etre coherente, ainsi que la position verticale ascenseur.    */
/* ENTREE: OBJECT *object:                                                                  */
/*            pointe sur le premier objet (objet racine) de l'arbre ou sont contenus les    */
/*            autres objets.                                                                */
/*         INT16 ob_scroll: numero ou indice de l'objet SCROLLBOX dans cet arbre.             */
/*         INT16 ob_Vbar:   numero ou indice de l'objet SCROLLBAR dans cet arbre.             */
/*                        une SCROLLBAR est un objet contenant un objet fils ascenseur.     */
/*         INT16 ob_Vasc:   numero ou indice de l'objet Ascenseur dans cet arbre.             */
/*                        une SCROLLBAR est un objet contenant un objet fils ascenseur.     */
/* RETOUR: INT16: position y de l'ascenseur. (en relatif  la SCROLLBAR ob_Vbar).             */

INT16 VascHeightAdjust(OBJECT *object, INT16 ob_scroll, INT16 ob_Vbar, INT16 ob_Vasc);

/*------------------------ Scroll_window -------------------------------*/
/* ACTION: fait scroller le rectangle de fenetre specifie, et redessine */
/*         en faisant appel  la fonction de fenetre, la partie         */
/*         decouverte.                                                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre dont il faut faire  */
/*                    sroller une partie.                               */
/*         GRECT *scrol_grect: coordonnes de la zone rectangulaire a   */
/*                             faire scroller.                          */
/*         INT16 dir: egal  HORIZONTAL, VERTICAL (sens de scrolling).    */
/*         long delta: quantite  faire scroller si  <0 dans un sens,   */
/*                     si >0 dans l'autre.                              */

void Scroll_window (INT16 w_ind, GRECT *scrol_grect, INT16 dir, long delta);


/*---------------------------- SlidePosToDocPos ------------------------*/
/* ACTION: calcul de la nouvelle position document  partir de la       */
/*         position souris sur l'assenceur.                             */
/* ENTREE: OBJECT *object, INT16 ob_Vbar objet de type SLIDEBAR c.a.d.    */
/*         barre de scroll avec en fils un assenceur (slide)            */
/*         unsigned long doc_total, taille totale du document.          */
/*         unsigned long doc_view, taille representable du document dans*/
/*                                 la fenetre de visualisation.         */
/*         unsigned long doc_pos, ofset d'affichage du document par     */
/*                                rapport a son debut.(en fait c'est le */
/*                                premier element affich).             */
/*         INT16 pos_mouse,         position de la souris.                */
/*         INT16 scrolcoef,  coefficient de scrolling minimum.            */
/*         INT16 mode, HORIZONTAL ou VERTICAL indique le type de barre de */
/*                   SLIDEBAR a laquelle l'on a affaire.                */
/* RETOUR: un long qui la nouvelle position document.                   */

long SlidePosToDocPos(OBJECT *object, INT16 ob_Vbar,
                      unsigned long doc_total,
                      unsigned long doc_view,
                      unsigned long doc_pos,
                      INT16 pos_mouse,
                      INT16 scrolcoef,
                      INT16 mode);

/*---------------------------- SetSlideWidth ---------------------------*/
/* ACTION: calcul de la largeur d'un assenceur  partir des donnes du   */
/*         document.                                                    */
/* ENTREE: OBJECT *object, INT16 ob_Vbar objet de type SLIDEBAR c.a.d.    */
/*         barre de scroll avec en fils un assenceur (slide)            */
/*         unsigned long doc_total, taille totale du document.          */
/*         unsigned long doc_view, taille representable du document dans*/
/*                                 la fenetre de visualisation.         */
/*         unsigned long doc_pos, ofset d'affichage du document par     */
/*                                rapport a son debut.(en fait c'est le */
/*                                premier element affich).             */
/*         INT16 min_slide,  taille minimum de l'assenceur.               */
/*         INT16 mode, HORIZONTAL ou VERTICAL indique le type de barre de */
/*                   SLIDEBAR a laquelle l'on a affaire.                */
/* RETOUR: un long qui la nouvelle position document.                   */

long SetSlideWidth(OBJECT *object, INT16 ob_Vbar,
                  unsigned long doc_total,
                  unsigned long doc_view,
                  unsigned long doc_pos,
                  INT16 min_slide,
                  INT16 mode);

/*---------------------------- DocPosToSlidePos ------------------------*/
/* ACTION: calcul de la position d'un assenceur  partir des donnes du  */
/*         document.                                                    */
/* ENTREE: OBJECT *object, INT16 ob_Vbar objet de type SLIDEBAR c.a.d.    */
/*         barre de scroll avec en fils un assenceur (slide)            */
/*         unsigned long doc_total, taille totale du document.          */
/*         unsigned long doc_view, taille representable du document dans*/
/*                                 la fenetre de visualisation.         */
/*         unsigned long doc_pos, ofset d'affichage du document par     */
/*                                rapport a son debut.(en fait c'est le */
/*                                premier element affich).             */
/*         INT16 mode, HORIZONTAL ou VERTICAL indique le type de barre de */
/*                   SLIDEBAR a laquelle l'on a affaire.                */
/* RETOUR: un INT16 qui le nombre de pixels dont s'est deplace            */
/*         l'ascenseur                                                  */

INT16 DocPosToSlidePos(OBJECT *object, INT16 ob_Vbar,
                     unsigned long doc_total,
                     unsigned long doc_view,
                     unsigned long doc_pos,
                     INT16 mode);

/*--------------------------- SetScrollTxtParam ------------------------------*/
/* ACTION: Cette fonction permet de modifier les parametres de fonctionnement */
/*         la SCROLTEXT.                                                      */
/*         Si vous fournissez la valeur -2, pour une valeur de parametre, le  */
/*         parametre correspondant ne sera pas modifi.                       */
/* ENTREE: Dans le parametre: OBJECT *tree l'on  place l'adresse de l'arbre   */
/*                            ou se situe la SCROLTEXT,                       */
/*         Dans le paramtre: INT16   ind_ob l'on  place l'indice  de l'objet   */
/*                            correspondant  la SCROLTEXT.                   */
/*         Dans le paramtre: INT16  Clr  l'on  place la couleur du texte.      */
/*         Dans le paramtre: INT16 Pts   l'on  place la taille du texte.       */
/*         Dans le paramtre: INT16 Fnt   l'on  place l ID de la fonte.         */
/* RETOUR: 0 erreur (ce n'est pas une SCROLTEXT)                              */
/*         1 tout est Ok                                                      */

INT16 SetScrollTxtParam
      (
        OBJECT *tree,      /* adresse de l'arbre ou se trouve la SCROLBOX     */
        INT16 ind_ob,        /* indice de l'objet dans l'arbre                  */
        INT16 Clr,           /* couleur du texte                                */
        INT16 Pts,           /* taille en point du texte                        */
        INT16 Fnt            /* Police de caractere                             */
      );

/*--------------------------- GetScrollTxtParam ------------------------------*/
/* ACTION: Cette fonction permet de recuperer les parametres de fonctionnement*/
/*         la SCROLTEXT.                                                      */
/* ENTREE: Dans le parametre: OBJECT *tree l'on  place l'adresse de l'arbre   */
/*                            ou se situe la SCROLTEXT,                       */
/*         Dans le paramtre: INT16   ind_ob l'on  place l'indice  de l'objet   */
/*                            correspondant  la SCROLTEXT.                   */
/* SORTIE:                                                                    */
/*         Dans le paramtre: INT16 *Clr   l'on  reoit la couleur du texte.    */
/*         Dans le paramtre: INT16 *Pts   l'on  reoit la taille du texte.     */
/*         Dans le paramtre: INT16 *Fnt   l'on  reoit l'ID VDI de la fonte.   */
/* RETOUR: 0 erreur (ce n'est pas une SCROLTEXT)                              */
/*         adresse de la structure SCROLL_TXT_PRM                             */
/* RAPPEL:                                                                    */
/*     typedef struct                                                         */
/*        { INT16 Type;          type de donnes  afficher                     */
/*          char *txt;         adresse du texte                               */
/*          char **PtLgnTab;   adr. du tableau de pointeurs de lignes texte   */
/*          INT16 Pts;           taille en points des caractres                */
/*          INT16 Color;         couleur des caractres                         */
/*          long FontId;       ID VDI de la police a employer pour l'affichage*/
/*        } SCROLL_TXT_PRM;                                                   */

SCROLL_TXT_PRM *GetScrollTxtParam
      (
        OBJECT *tree,      /* adresse de l'arbre ou se trouve la SCROLBOX     */
        INT16 ind_ob,        /* indice de l'objet dans l'arbre                  */
        INT16 *Clr,           /* couleur du texte                               */
        INT16 *Pts,           /* taille en point du texte                       */
        INT16 *Fnt            /* Police de caractere                            */
      );

/*--------------------------- SetListBoxParam --------------------------------*/
/* ACTION: Cette fonction permet de modifier les parametres de fonctionnement */
/*         la LIST_BOX.                                                       */
/*         Si vous fournissez la valeur -2, pour une valeur de parametre, le  */
/*         parametre correspondant ne sera pas modifi.                       */
/* ENTREE: Dans le parametre: OBJECT *tree l'on  place l'adresse de l'arbre   */
/*                            ou se situe la LISTBOX,                         */
/*         Dans le paramtre: INT16   ind_ob l'on  place l'indice  de l'objet   */
/*                            correspondant  la LIST_BOX.                    */
/*         Dans le paramtre: INT16   select l'on  place le numero de l'lment */
/*                            de la  liste    reprsenter devant etre affich*/
/*                            dans la case de slection (premier lment de la*/
/*                            LISTBOX).                                       */
/*         Dans le paramtre: INT16 first, l'on place le numero de l'lment de */
/*                            la liste  reprsenter,devant etre affich dans */
/*                            la premire  case de liste (celle situe sousla */
/*                            case de slection, soit le deuxime  lment de */
/*                            la LISTBOX).                                    */
/*         Dans le paramtre: INT16 nbcases l'on  place le nombre d'lments que*/
/*                            doit comporter la  LISTBOX, y compris la case de*/
/*                            slection.                                      */
/*         Dans le paramtre: INT16 nb_item l'on place le nombre d'lments     */
/*                            de la liste  reprsenter.                      */
/*         Dans le paramtre: INT16 h_lign l'on  place la hauteur d'une case de */
/*                            la  LISTBOX.                                    */
/*         Dans le paramtre: void *LstBoxParam l'on peut placer ce que l'on  */
/*                            veut, une adresse de donnes, ou tout autre     */
/*                            chose. Ce  paramtre est transmis  la fonction */
/*                            d'affichage de la LISTBOX.                      */
/* RETOUR: 0 erreur (ce n'est pas une LISTBOX)                                */
/*         1 tout est Ok                                                      */

INT16 SetListBoxParam
     ( OBJECT *tree,
       INT16   ind_ob,
       INT16 select,
       INT16 first,
       INT16 nbcases,
       INT16 nb_item,
       INT16 h_lign,
       void *LstBoxParam
     );

/*------------------------ GetSelectedListBoxItem ----------------------------*/
/* ACTION: cette fonction permet d'obtenir l'indice (base 0) de l'element     */
/*         selectionne dans une LISTBOX, cet indice pointe donc sur une       */
/*         donnee de la liste.                                                */
/* ENTREE: Dans le parametre:  OBJECT *tree l'on  place l'adresse de l'arbre  */
/*                             ou se situe la LISTBOX,                        */
/*         Dans le paramtre: INT16   ind_ob l'on  place l'indice  de l'objet   */
/*                            correspondant  la LIST_BOX.                    */
/* RETOUR: indice (base 0) de l'element selectionne dans une LISTBOX, cet     */
/*         indice pointe donc sur une donnee de la liste. C'est cette donne  */
/*         qui doit etre affichee dans la boite de selection.                 */

INT16 GetSelectedListBoxItem(OBJECT *object, INT16 ind);

/*--------------------------- GetListBoxParam --------------------------------*/
/* ACTION: Cette  fonction  permet d'obtenir les parametres de fonctionnement */
/*         la LIST_BOX.                                                       */
/*         Si vous fournissez la valeur 0, pour une adresse de parametre, le  */
/*         parametre correspondant ne sera pas retourn.                      */
/* ENTREE: Dans le parametre:  OBJECT *tree l'on  place l'adresse de l'arbre  */
/*                             ou se situe la LISTBOX,                        */
/*         Dans le paramtre: INT16   ind_ob l'on  place l'indice  de l'objet   */
/*                            correspondant  la LIST_BOX.                    */
/* SORTIE:                                                                    */
/*         Dans le paramtre: INT16 *select, l'on reoit le numero de l'lment */
/*                            de la  liste    reprsenter devant etre affich*/
/*                            dans la case de slection (premier lment de la*/
/*                            LISTBOX).                                       */
/*         Dans le paramtre: INT16 *first, l'on  reoit le numero de l'lment */
/*                            de la liste  reprsenter,devant etre affich   */
/*                            dans la premire  case  de  liste (celle situe */
/*                            sous la case de slection, soit le deuxime     */
/*                            lment  de la LISTBOX).                        */
/*         Dans le paramtre: INT16 *nbcases, l'on reoit le nombre d'lments  */
/*                            que doit comporter la  LISTBOX, y compris la    */
/*                            case de slection.                              */
/*         Dans le paramtre: INT16 *nb_item, l'on reoit le nombre d'lments  */
/*                            de la liste  reprsenter.                      */
/*         Dans le paramtre: INT16 *h_lign, l'on reoit la hauteur d'une case  */
/*                            la  LISTBOX.                                    */
/*         Dans le paramtre: long *LstBoxParam, l'on reoit le parametre     */
/*                            optionnel.                                      */
/* RETOUR: 0 erreur (ce n'est pas une LISTBOX)                                */
/*         1 tout est Ok                                                      */

INT16 GetListBoxParam
     ( OBJECT *tree,
       INT16   ind_ob,
       INT16 *select,
       INT16 *first,
       INT16 *nbcases,
       INT16 *nb_item,
       INT16 *h_lign,
       long *LstBoxParam
     );

/*------------------------------ XYToListBoxItem -------------------------------*/
/* ACTION: si une listbox est ouverte dans la fenetre, il est recherche l'item  */
/*         pointe par la souris.                                                */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre contenant la LISTBOX        */
/*         INT16 x, INT16 y: position de la souris.                                 */
/* RETOUR: INT16: si -1 pas d'item pointe, si >=0 item point dans liste.         */

INT16 XYToListBoxItem( INT16 w_ind, INT16 x, INT16 y);


/*---------------------- AdaptListBoxToWindHeight -----------------------*/
/* ACTION: adapte une LISTBOX de maniere a ce qu'elle occupe toute la    */
/*         la hauteur d'une fenetre dont les dimenssions exterieures     */
/*         donnees (ou pas) dans les limites fixees par maxcases.        */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de la fenetre ou se trouve la      */
/*                    LISTBOX.                                           */
/*         INT16 ob_list, indice de l'objet LISTBOX dans l'arbre de        */
/*                      ressource de la fenetre.                         */
/*         INT16 maxcases, Maximum de cases que l'on autorise.             */
/*         GRECT *ext_grect, rectangle exterieur de la fenetre.          */
/*                           Si 0 la fonction utilise le dernier que la  */
/*                                la fenetre a stocke dans sa structure  */
/*                                de fenetre: Windtab[w_ind].GemWorkGrect*/
/*                           Sinon c'est celui passe en entree qui est   */
/*                                 utilise.                              */

void AdaptListBoxToWindHeight(INT16 w_ind, INT16 ob_list, INT16 maxcases, GRECT *ext_grect);

/*************************************************************************/
/*           F O N T I O N S   D ' E D I T I O N  D E   T E X T E        */
/*************************************************************************/
/*------------------------ EZ_ED_SetTxtGraphAttr ------------------------------*/
/* ACTION: fonction pour initialiser les attributs graphiques d'un tableau de  */
/*         de structures d'attributs graphiques:  CAR_ATTR *CAR_A              */
/* ENTREE: INT16 col: couleur des caracteres. Si -1 il n'est pas tenu compte de  */
/*                  ce parametre.                                              */
/*         INT16 eff: effet a appliquer aux caracteres. Si -1 il n'est pas tenu  */
/*                  compte de ce parametre.                                    */
/*         INT16 pts: taille en points a appliquer aux caracteres. Si -1         */
/*                  il n'est pas tenu compte de ce parametre.                  */
/*         INT16 fid: Indice VDI de la fonte a appliquer aux caracteres. Si -1   */
/*                  il n'est pas tenu compte de ce parametre.                  */
/*                  Si la fonte est donnee en clair dans: fntName c'est cette  */
/*                  derniere qui sera prioritaire meme si fid est un indice VDI*/
/*                  valide.                                                    */
/*         char *fntName: fonte en clair a appliquer aux caracteres. Si zero   */
/*                        la fonte sera celle indique par fid. Si lui meme -1 */
/*                        il ne sera pas tenu compte de ce parametre.          */
/*         CAR_ATTR *CAR_A: adresse du tableau d'attributs  initialiser avec  */
/*                          les parametres d'entree precedents.                */
/*         INT16 nbr: nombre d'elements du tableau  initialiser avec les        */
/*                  attributs precedents.                                      */
/*                                                                             */
/* NOTE: le parametre: CAR_A.FntName contient le nom de la fonte en clair      */
/*                                   apres appel de la fonction, meme si le    */
/*                                   nom de la fonte est donne en partie dans  */
/*                                   le parametre: char *fntName, il sera      */
/*                                   cherche la fonte avec le nom le plus      */
/*                                   approchant.                               */
/*       de meme:      CAR_A.FntID   contient l'indice VDI de la fonte apres   */
/*                                   appel de la fonction.                     */
/* RETOUR: neant.                                                              */

void EZ_ED_SetTxtGraphAttr(INT16 col, INT16 eff, INT16 pts, INT16 fid, char *fntName, CAR_ATTR *CAR_A, INT16 nbr);

/*------------------------ EZ_ED_GetTxtEditStruct -----------------------------*/
/* ACTION: retourne la stucture d'edition de texte attachee a un SCROLL_EDIT   */
/* ENTREE: OBJECT *object: adresse arbre auquel appartient l'objet             */
/*                         SCROLL_EDIT dont on cherche a connaitre l'adresse   */
/*                         de la structure edition de texte.                   */
/*         INT16 ind: numro de l'objet dans cet arbre.                          */
/* RETOUR: TXTED_OB* un pointeur sur l'editeur de texte.                       */

TXTED_OB *EZ_ED_GetTxtEditStruct(OBJECT *object, INT16 ind);

/*----------------------- EZ_ED_LoadTxt ------------------------------------------*/
/* ACTION: charge un nouveau texte et initialise la variable de fonctionnement    */
/*         general qui lui est associ.                                           */
/* ENTREE:  INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*          char *PathTxt: path ou se trouve le fichier: expl: C:\MES_TEXTES\     */
/*          char *NomTxt: nom du fichier: exple: TEXTE.TXT                        */
/*          TXTED_OB *TXT_A: variable de fonctionnement general, dont il est      */
/*                           initialis:                                          */
/*                           TXTED_OB.ptTxt sur l'adresse du texte                */
/*                                          (0 si erreur ou texte invalide)       */
/*                           TXTED_OB.NbLgn sur le nombre de lignes du texte      */
/*                                          (0 si erreur ou texte invalide)       */
/* SORTIE: INT16: TRUE si tout est OK, FALSE sinon                                  */

INT16       EZ_ED_LoadTxt(INT16 w_ind, char *PathTxt, char *NomTxt, TXTED_OB *TXT_A);

/*----------------------- EZ_ED_SaveTxt ------------------------------------------*/
/* ACTION:  sauve le texte, en edition sous le nom donne en entree dans           */
/*          PathTxt    et    NomTxt                                               */
/* ENTREE:  char *PathTxt: path ou l'on sauve le fichier: expl: C:\MES_TEXTES\    */
/*          char *NomTxt: nom du fichier: exple: TEXTE.TXT                        */
/*          INT16 flag = BLK_SAVE uniquement le texte selectionne est sauve.        */
/*                     TXT_SAVE tout le texte est sauve.                          */
/*          TXTED_OB *TXT_A: variable de fonctionnement general, liee  l'editeur */
/*                           de texte concerne, dont on veut sauver le texte.     */
/* SORTIE: long: nbr d'octets sauves.                                             */

long EZ_ED_SaveTxt( char *PathTxt, char *NomTxt, INT16 flag, TXTED_OB *TXT_A);

/*------------------------ EZ_ED_DrawCurs -----------------------------------------*/
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte   */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant     */
/*                          d'edition de texte. (peut y en avoir plusieurs dans    */
/*                          une fenetre) pour lequel on doit activer l'edition.    */
/*         INT16 mode = CURS_DRAW le curseur est dessine si il ne l'etait pas.       */
/*                  = CURS_ERASE le curseur est efface si il etait trace.          */
/*                  = CURS_FLASH le curseur est efface si trac et dessine sinon   */
/* NOTE: le curseur n'est pas dessine et reste efface si un bloc est en cours de   */
/*       definition  la souris.                                                   */
/*       Le redessin du curseur se fait en tenant compte de la liste               */
/*       des rectangles.                                                           */
/* RETOUR: INT16 = 1 si trace, 0 si efface                                           */

INT16 EZ_ED_DrawCurs(INT16 w_ind,  TXTED_OB* TXT_A, INT16 mode);

/*-------------------------- EZ_ED_PaintCurs ------------------------------------*/
/* ACTION: trace le curseur sans passer par la liste des rectangles. cette       */
/*         fonction est utile lorsque vous faites votre propre affichage custom  */
/*         en effet lorsque vous affichez la ligne ou se trouve le curseur, il   */
/*         necessaire d'y afficher aussi le curseur (si bien sur il est visible) */
/*         Testez si la ligne en cours d'affichage est celle du curseur, et si   */
/*         c'est le cas affichez le en appelant cette fonction. Exemple:         */
/*                       .                                                       */
/*                       .                                                       */
/*                       .                                                       */
/*    if ( TXT_A->CurState &&      si etat curseur est: VISIBLE et que la ligne  */
/*         i==TXT_A->LigPt         en cours d'affichage est celle du curseur     */
/*       )                                     et bien ...                       */
/*       {EZ_ED_PaintCurs(TXT_A);  affichons le curseur, logique ? non ?         */
/*       }                                                                       */
/*                       .                                                       */
/*                       .                                                       */
/*                       .                                                       */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre) pour lequel on doit afficher le curseur */

void EZ_ED_PaintCurs(TXTED_OB* TXT_A);

/*----------------------- EZ_ED_CarPtToWord -------------------------------------*/
/* ACTION: slectionne le mot sur lequel le curseur se situe.                    */
/* ENTREE: char *c: pointe sur la position du curseur dans le texte.             */
/*         char *debtxt: pointe sur le premier caractere du texte.               */
/*         char ** end_word: pointe sur le pointeur dans lequel sera place la    */
/*                           fin du mot selectionne.                             */
/*         INT16 limit_type: flag determinant les limites recherches pour un mot  */
/* RETOUR: char * pointeur sur le debur du mot selectionne.                      */

char  *EZ_ED_CarPtToWord(char *c, char *debtxt, char ** end_word, INT16 limit_type);

/*------------------------ EZ_ED_RedrawFromLineToLine ---------------------------*/
/* ACTION: dessine le texte compris entre la ligne: ligDeb et la ligne: ligEnd   */
/* ENTREE: long ligDeb: ligne de debut (incluse)  partir de laquelle le dessin  */
/*                      doit se faire. La numerotation des lignes commence       */
/*                      toujours  0                                             */
/*         long ligEnd: derniere ligne a dessiner (incluse). La numerotation des */
/*                      lignes commence toujours  0                             */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre) pour lequel on doit dessiner les lignes */
/* RETOUR: long qui est le nombre de lignes effectivements dessinees. En effet   */
/*         la fonction ne dessine que les lignes visibles et utiles.             */

long EZ_ED_RedrawFromLineToLine(INT16 w_ind,long ligDeb, long ligEnd, TXTED_OB* TXT_A);

/*------------------------ EZ_ED_DeleteTxtEdit -----------------------------------*/
/* ACTION: detruit un composant editeur de texte et libere toutes les ressources  */
/*         memoire et autres ayant pu etre reserves au cours de sa vie.          */
/*         si vous avez cree un composant edition de texte il est indispensable   */
/*         d'utiliser cette fonction pour le detruire a la fin de votre programme */
/*         sinon la memoire reservee ne sera par liberee.                         */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant    */
/*                          d'edition de texte, (peut y en avoir plusieurs dans   */
/*                          une fenetre) que l'on veut supprimer.                 */
/* RETOUR: toujours zero.                                                         */

TXTED_OB *EZ_ED_DeleteTxtEdit(TXTED_OB *TXT_A);


/*----------------------------- EZ_ED_GraphUpdate -------------------------------*/
/* ACTION: permet de mettre  jour les coordonnes graphiques du CURSEUR, et du  */
/*         BLOC TEXTE apres par exemple un changement de la premiere ligne       */
/*         affiche en haut de l'editeur, avant par exemple un redraw afin que   */
/*         bloc et le curseur texte soient correctement affichs. Cette fonction */
/*         replace aussi le contenu du buffer d'edition dans le texte. Il est    */
/*         utile et conseill d'appeler cette fonction avant une sauvegarde.     */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre) pour lequel on doit activer l'edition.  */
/* RETOUR: neant.                                                                */

void      EZ_ED_GraphUpdate(TXTED_OB *TXT_A);


/*------------------------ EZ_ED_GetLastEditActiv -------------------------------*/
/* ACTION: permet de connaitre l"editeur de texte en activite (Si il y en a un)  */
/* ENTREE:  neant.                                                               */
/* SORTIE:  TXTED_OB *: un pointeur sur une structure definissant l'editeur en   */
/*                      activite. Si zero c'est qu'il n'y a pas d'editeur actif. */

TXTED_OB *EZ_ED_GetLastEditActiv(void);


/*------------------------ EZ_ED_NewTxtEdit -------------------------------------*/
/* ACTION: cree ou initialise une instance d'editeur de texte pret  l'emploi.   */
/*         cette fonction sert surtout  placer la fonction de tracage d'une     */
/*         ligne de texte, sans laquelle l'editeur planterait.                   */
/*         Donc il est indispensable de faire appel a cette fonction de creation */
/*         avant toute utilisation de l'editeur.                                 */
/*         les autres parametres de la structure sont placs sur des valeurs     */
/*         par defaut, sauf si une structure est donne en entree.               */
/* ENTREE: TXTED_OB *TXT_A: SI non egal  zero on initialise la fonction de      */
/*                            de tracage d'une ligne texte, de la structure      */
/*                            passee en entree.                                  */
/*                          SINON on reserve la memoire d'une instance de        */
/*                             structure: TXTED_OB et on l'initialisera.         */
/*         INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, void *TXT_A): pointe sur la */
/*                fonction de redessin d'une ligne de texte. si ce parametre est */
/*                egal a zero, une fonction de redessin par defaut est placee.   */
/*         GRECT *grect: rectangle dans lequel l'editeur de texte existe.        */
/*               si ce rectangle, n'est pas donne (egal zero)  et que            */
/*               la structure est une creee dans notre fonction, il ne vous      */
/*               faudra ne pas oublier d'initialiser: TXTED_OB.TxtGrect juste    */
/*               apres.                                                          */
/* RETOUR: TXTED_OB *retourne un pointeur sur la structure d'edition.            */
/*                  si zero echec de la creation.                                */

TXTED_OB *EZ_ED_NewTxtEdit (TXTED_OB *TXT_A,
                            INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A),
                            GRECT *grect
                           );

/*------------------------ EZ_ED_ExNewTxtEdit --------------------------------------*/
/* ACTION: cree ou initialise une instance d'editeur de texte pret  l'emploi.      */
/*         cette fonction sert surtout  placer la fonction de tracage d'une        */
/*         ligne de texte, sans laquelle l'editeur planterait.                      */
/*         Donc il est indispensable de faire appel a cette fonction de creation    */
/*         avant toute utilisation de l'editeur.                                    */
/*         les autres parametres de la structure sont placs sur des valeurs        */
/*         par defaut, sauf si une structure est donne en entree.                  */
/* ENTREE: TXTED_OB *TXT_A: SI non egal  zero on initialise la fonction de         */
/*                            de tracage d'une ligne texte, de la structure         */
/*                            passee en entree.                                     */
/*                          SINON on reserve la memoire d'une instance de           */
/*                             structure: TXTED_OB et on l'initialisera.            */
/*         INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, void *TXT_A): pointe sur la    */
/*                fonction de redessin d'une ligne de texte. si ce parametre est    */
/*                egal a zero, une fonction de redessin par defaut est placee.      */
/*         GRECT *grect: rectangle dans lequel l'editeur de texte existe.           */
/*               si ce rectangle, n'est pas donne (egal zero)  et que               */
/*               la structure est une creee dans notre fonction, il ne vous         */
/*               faudra ne pas oublier d'initialiser: TXTED_OB.TxtGrect juste       */
/*               apres.                                                             */
/*         INT16 ctx_supl: nombre d'octets supplementaire alloues pour chaque         */
/*                       contexte de ligne pour stocker infos personnelles.         */
/*                       suppose que vous creerez votre routine perso, de mise     */
/*                       jour des contextes de lignes:  InitTabLgnCtxfunc           */
/*                       afin d'exploiter cette fonctionnalit.                     */
/*         long (*InitTabLgnCtxfunc)(TXTED_OB *TXT_A,char *txt,long iTab,long nb_l) */
/*                       fonction de mise  jour des pointeurs de lignes, cette     */
/*                       fonction peut etre reecrite par vous affin de stocker      */
/*                       diverse informations supplementaire sur chaque ligne.      */
/*                       si zero la fonction par defaut sera place.                */
/* RETOUR: TXTED_OB *retourne un pointeur sur la structure d'edition.               */
/*                  si zero echec de la creation.                                   */

TXTED_OB *EZ_ED_ExNewTxtEdit (TXTED_OB *TXT_A,
                            INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A),
                            GRECT *grect,
                            INT16 ctx_supl,
                            long (*InitTabLgnCtxfunc)(TXTED_OB *TXT_A, char *txt, long iTab, long nb_l)
                           );

/*------------------------ EZ_ED_SetFocus ---------------------------------------------*/
/* ACTION: donne le focus clavier, souris, timer, a un editeur de texte. C'est a dire  */
/*         que cet editeur de texte est actif, et recoit en priorite les evenements    */
/*         le clavier est dirige sur lui, afin que les caractees puissent etre saisis. */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte       */
/*         EVNT_O *Evnt: variable de flux evenementiel comme celle utilisee            */
/*                       partout dans EAZY_GEM                                         */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant         */
/*                          d'edition de texte. (peut y en avoir plusieurs dans        */
/*                          une fenetre) pour lequel on doit activer l'edition.        */
/* RETOUR: neant.                                                                      */

void      EZ_ED_SetFocus( INT16 w_ind, EVNT_O *Evnt, TXTED_OB *TXT_A);


/*------------------------ EZ_ED_KillFocus --------------------------------------------*/
/* ACTION: Enleve le focus d'un editeur de texte. Apres appel de cette fonction,       */
/*         l'editeur de texte n'a plus le clavier, ni la souris, et ne sera plus       */
/*         prioritaire pour la boucle evenementielle.                                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte en    */
/*                    activite. Il ne peut y avoir qu'un seul editeur de texte ayant   */
/*                    le focus.                                                        */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant         */
/*                          d'edition de texte. (peut y en avoir plusieurs dans        */
/*                          une fenetre) qui possedait le focus.                       */
/* SORTIE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant         */
/*                          d'edition de texte. (peut y en avoir plusieurs dans        */
/*                          une fenetre) qui possedait le focus.                       */

TXTED_OB *EZ_ED_KillFocus(INT16 w_ind, TXTED_OB *TXT_A);


/*------------------------ EZ_ED_EvntDo -----------------------------------------*/
/* ACTION: envoie un evenement  un editeur, qu'il soit ou non en edition. Cela  */
/*         permet de simuler un evenement quelconque sur un editeur.             */
/*         C'est la fonction a utiliser lors par exemple reception de caracteres */
/*         par RS 232 ou autre.                                                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*         EVNT_O *Evnt: variable de flux evenementiel comme celle utilisee      */
/*                       partout dans EAZY_GEM                                   */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre).                                        */
/* RETOUR: un INT16 qui est l'evenement d'entree (modifie ou pas)                  */

INT16       EZ_ED_EvntDo( INT16 w_ind, EVNT_O *Evnt, TXTED_OB *TXT_A);


/*------------------------ EZ_ED_SetDrawLineFunc ---------------------------------*/
/* ACTION: permet de modifier la fonction de redessin d'une ligne texte afin d'en */
/*         placer une personnelle.                                                */
/* ENTREE: INT16(*drawTxtFunc)(..): adresse de la nouvelle fonction de redessin.    */
/*                                si zero, la fonction par defaut d'origine est   */
/*                                installee.                                      */
/*         TXTED_OB *TXT_A: pointeur sur la variable generale definisssant le     */
/*                          composant d'edition dont on veut modifier la fonction */
/*                          de redessin.                                          */
/* SORTIE: void * pointeur sur l'ancienne fonction de redessin.                   */
/*                on peut tres bien imaginer une fonction appelant l'ancienne et  */
/*                rajoutant le dessin des marges et fin de page par exemple. Cela */
/*                s'appelle deriver une fonction.                                 */

void     *EZ_ED_SetDrawLineFunc(INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A),
                                TXTED_OB *TXT_A);


/*------------------------- EZ_ED_DrawBlkFrame -----------------------------------*/
/* ACTION: dessine le cadre video inverse du bloc de selection                    */
/* IMPORTANT:cette fonction ne peut etre appelee en USERDEF qu'avec               */
/*           redrawFlag = BLK_LINE_DRAW. Avec les autres valeurs de flag il n'est */
/*           pas possible d'appeler cette en USERDEF car un appel  Mouse_on()    */
/*           Mouse_off()  est fait par la fonction.                               */
/* ENTREE: long w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*                    sauf si redrawFlag = BLK_LINE_DRAW  et alors w_ind est le   */
/*                    numero de la ligne pour laquelle il faut dessiner le        */
/*                    rectangle de selection.                                     */
/*                                                                                */
/*         INT16 redrawFlag: flag modifiant le comportement de la fonction. Il peut */
/*                         prendre les valeurs suivantes:                         */
/*                                                                                */
/*                         BLK_ALL_DRAW et alors  W_ind est l'indice EAZY_GEM de  */
/*                                      la fenetre possedant l'editeur de texte.  */
/*                                      l'integralite du cadre de selection est   */
/*                                      dessine losque la fonction est appelee    */
/*                                      avec ce flag.                             */
/*                         BLK_LINE_DRAW et alors w_ind est le numero de la ligne */
/*                                       pour laquelle il faut dessiner rectangle */
/*                                       de selection. seulement le cadre de la   */
/*                                       ligne indiquee par w_ind est dessine.    */
/*                                                                                */
/*                         BLK_UPDATE   et alors w_ind est l'indice EAZY_GEM de   */
/*                                      la fenetre possedant l'editeur de texte.  */
/*                                      Lorsque le flag possede cette valeur il   */
/*                                      seulement dessine la partie situee entre  */
/*                                      l'ancienne position curseur et la         */
/*                                      nouvelle. Cette fonction est appelee avec */
/*                                      ce flag par l'editeur lui meme. Vous ne   */
/*                                      devriez normalement pas avoir a appeler   */
/*                                      la fonction avec ce flag.                 */
/*                                                                                */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant    */
/*                          d'edition de texte. (peut y en avoir plusieurs dans   */
/*                          une fenetre).                                         */

void      EZ_ED_DrawBlkFrame(long w_ind, INT16 redrawFlag, TXTED_OB* TXT_A);


/*------------------------ EZ_ED_GetLigCol ---------------------------------------*/
/* ACTION: cette fonction permet d'obtenir divers renseignements possibles sur    */
/*         les caracteres pointes par les marques de bloc, et le curseur, leurs   */
/*         positions X et Y , etc ...                                             */
/*         cette fonction est assez polymorphe et les retours dans les variables  */
/*         dependent du parametre d'entree: size_t param.                         */
/*                                                                                */
/* ENTREE: size_t param: Ce parametre d'entree determine ce qui va etre retourne  */
/*                       dans les variables long *lig, long *col et la valeur de  */
/*                       retour char*                                             */
/*        SI = BLK_DEB      soit  1 : il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne de debut de bloc,   */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_END      soit  2 : il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne de fin de bloc,     */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = CURS_POS     soit  4 : il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne du curseur,         */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_DEBXY    soit  8 : il est retourne dans: long *lig, long *col  */
/*                                    la position x et y du debut de bloc,        */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_ENDXY    soit 16 : il est retourne dans: long *lig, long *col  */
/*                                    la position x et y de fin de bloc,          */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = CURS_POSXY   soit 32 : il est retourne dans: long *lig, long *col  */
/*                                    la position x et y du curseur,              */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_TXT_MARK soit 64:  il est retourne dans: long *lig, l'adresse  */
/*                                    du texte pointe par le debut du bloc.       */
/*                                                          long *col, l'adresse  */
/*                                    du texte pointe par la fin du bloc.         */
/*                                    la valeur de retour est le texte pointe par */
/*                                    le curseur                                  */
/*        SI = XY_TO_LIGPT  soit 128: il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne pointee par,        */
/*                                    x et y donns en entree dans *lig et *col.  */
/*                                    la valeur de retour pointe le texte du      */
/*                                    debut de ligne.                             */
/*        SI = pointeur sur un caractere du texte: il est retourne en:            */
/*                                    long *lig la ligne de ce caractere.         */
/*                                    long *col la colonne de caractere           */
/*                                    la valeur de retour est le texte pointe par */
/*                                    le curseur                                  */
char     *EZ_ED_GetLigCol(size_t param, long *lig, long *col, TXTED_OB* TXT_A);

/*---------------------- EZ_ED_DirectExeEvntKey ----------------------------------*/
/* ACTION: permet de simuler l'appui d'une touche clavier, par envoi direct d'un  */
/*         evenement clavier, sans passer par l'evenementiel GEM.                 */
/* ENTREE:  INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*          INT16 key: touche clavier comme le GEM la desire: (HIBYTE=scan  code).  */
/*                                                          (LOBYTE=ascii code).  */
/*          INT16 ksp: etat des touches clavier Shift Control Alternate.            */
/*          TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte, (peut y en avoir plusieurs dans   */
/*                          une fenetre)  qui l'on veut faire effectuer ce       */
/*                          message.                                              */
/* SORTIE: INT16 dependant de la reponse de l'editeur.                              */

INT16 EZ_ED_DirectExeEvntKey(INT16 w_ind, INT16 key, INT16 ksp, TXTED_OB *TXT_A);

/*---------------------- EZ_ED_DirectExeEditMessage ------------------------------*/
/* ACTION: execute directement un message de l'editeur par appel direct de sa     */
/*         fonction evenementielle, sans passer par l'evenementiel GEM.           */
/* ENTREE:  INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*          INT16 mess: message a effectuer.                                        */
/*          INT16 *param: pointe sur un tableau de parametres dependant du message  */
/*          INT16 nb_param: comme son nom l'indique, nombre de parametres.          */
/*          TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte, (peut y en avoir plusieurs dans   */
/*                          une fenetre)  qui l'on veut faire effectuer ce       */
/*                          message.                                              */
/* SORTIE: INT16 dependant de la reponse de chaque message.                         */

INT16 EZ_ED_DirectExeEditMessage(INT16 w_ind, INT16 mess, INT16 *param, INT16 nb_param,
                               TXTED_OB *TXT_A);

/*************************************************************************/
/*           F O N T I O N S   D E  GESTION  DE  LA  PILE UNDO           */
/*************************************************************************/

/*------------------ UNDO_CreateStack ----------------------------------*/
/* ACTION: reserve et initialise une zone de memoire permettant de      */
/*         de faire fonctionner une pile de UNDO                        */
/* ENTREE: long Nb_UNDO: nombre de UNDO possibles dans cette pile.      */
/*                       au delas de ce nombre le premier UNDO entr    */
/*                       sera perdu.                                    */
/* RETOUR: UNDO_STACK *: un pointeur sur la pile UNDO. Ce pointeur est  */
/*                       a conserver, car a dtruire en fin de          */
/*                       programme, par la fonction: UNDO_DestroyStack()*/
/*                       Ce pointeur vous sera tout le temps demand    */
/*                       pour l'utilisation des autre fonctions UNDO    */
/*                       SI zero c'est que la memoire pour creer cette  */
/*                       pile UNDO n'a pu etre reservee.                */

UNDO_STACK *UNDO_CreateStack(long Nb_UNDO);

/*-------------------- UNDO_DestroyStack -----------------------------*/
/* ACTION: fonction de  destruction d'une pile UNDO. Cette fonction   */
/*         est  utiliser en fin de programme (ou avant si vous       */
/*         n'avez plus besoin de cette pile) pour detruire une pile   */
/*         UNDO et liberer la memoire reservee par sa creation.       */
/* ENTREE: UNDO_STACK *U_Stack: adresse de la pile UNDO a detruire.   */
/* RETOUR: toujours zero.                                             */

UNDO_STACK *UNDO_DestroyStack(UNDO_STACK *U_Stack);

/*--------------------- UNDO_Push -------------------------------------*/
/* ACTION: empile une action UNDO dans la pile de UNDO.                */
/* ENTREE: char *token: pointeur sur la chaine de caractere du nom de  */
/*                      l'action UNDO a empiler(32 caracteres maxi)    */
/*         long data1; premier parametre de cette action undo          */
/*         long data2; deuxieme parametre de cette action undo         */
/*         long data3; troisieme parametre de cette action undo        */
/*         UNDO_STACK *U_Stack: adresse de la pile UNDO concernee.     */
/* RETOUR: indice de l'enregistrement de cette action UNDO.            */

long UNDO_Push(char *token, INT16 type,
               long data1, long data2, long data3, UNDO_STACK *U_Stack);

/*---------------------  UNDO_Pop -------------------------------------*/
/* ACTION: depile une Action UNDO,                                     */
/* ENTREE: UNDO_STACK *U_Stack: adresse de la pile UNDO concernee.     */
/* SORTIE: UNDO_REC*: pointeur sur l'action UNDO depilee.              */

UNDO_REC* UNDO_Pop(UNDO_STACK *U_Stack);

/*************************************************************************/
/*                   F O N T I O N S   D I V E R S E S                   */
/*************************************************************************/

/*-------------------------- Timer ------------------------------------*/
/* ACTION: retourne le temps ecoul depuis l'allumage de l'ordinateur  */
/* RETOUR: long: temps coul en milisecondes                          */
/* ENTREE: Neant.                                                      */
/* NOTE: cette fonction est en assembleur dans le fichier EAZY_GEM.S   */

extern long Timer(void);

/*-------------------------- IdToAdrElement ---------------------------*/
/* ACTION: retourne l'adresse du Neme element d'une suite d'elements   */
/*         dont le premier long est sa longueur.                       */
/*         La fin de la liste doit etre marquee par une longueur zero. */
/* ENTREE: void *adr: adresse du premier element.                      */
/*         long elmt: indice de l'element dont on recherche l'adresse  */
/*                    option base zero.                                */
/* SORTIE: adresse de l'element. si elmt est trop grand alors c'est    */
/*                                  l'adresse suivant le dernier.      */
/*                               si elmt est trop petit, il est        */
/*                                  zero.                              */

void *IdToAdrElement(void *adr,long elmt);

/*-------------------------- AdrElementToID ---------------------------*/
/* ACTION: retourne l'indice (option base zero) d'un element a partir  */
/*         de son adresse. (le premier long situe a cette adresse doit */
/*         etre la longueur de l'element).                             */
/*         La fin de la liste doit etre marquee par une longueur zero. */
/* ENTREE: void *adr_first: adresse du premier element de la liste.    */
/*         void *adr_elemt: adresse de l'element dont on recherche,    */
/*                          l'indice.                                  */
/* SORTIE: indice de l'element.si adr_elemt est trop grand alors c'est */
/*                                  l'indice suivant le dernier possi- */
/*                                  ble (en fait le nbr d'elements).   */
/*                             si adr_elemt est trop petit, alors      */
/*                                  l'indice du premier element.       */
/*         long elmt: indice de l'element dont on recherche l'adresse  */
/*                    option base zero.                                */

long AdrElementToID(void *adr_first, void *adr_elemt);

/*--------------------------- XGetArgument -------------------------------*/
/* ACTION: copie dans dest, tous les caracteres  partir de pt_arg,       */
/*         jusqu' un des caracteres de separation de la chaine: str_sep  */
/*         ou jusqu'a la fin de la chaine.                                */
/* ENTREE: char *pt_arg   pointe sur la chaine d'arguments.               */
/*         char *dest     buffer ou sera recopie l'argument (si trouve,   */
/*                        sinon il est place un 0 de fin dans le buffer). */
/*         char *str_sep: pointe sur une chaine contenant le caractres  */
/*                        considerer comme separateurs.                   */
/* RETOUR: un char * qui pointe apres le caractere de separation si il a  */
/*                   ete trouve et qu'apres il y a encore du texte valide */
/*                   =  zero si pas de caractere de separation trouv et */
/*                   ou pas de texte valide apres.                        */

char *XGetArgument(char *pt_arg, char *dest, char *str_sep);

/*--------------------------- GetArgument --------------------------------*/
/* ACTION: copie dans dest, tous les caracteres  partir de pt_arg,       */
/*         jusqu' un des caracteres de separation "|" ou "," ou jusqu'a  */
/*         la fin de la chaine.                                           */
/* ENTREE: char *pt_arg   pointe sur la chaine d'arguments.               */
/*         char *dest     buffer ou sera recopie l'argument (si trouve,   */
/*                        sinon il est place un 0 de fin dans le buffer). */
/*         INT16 ind        numero (zero etant le 1er) de l'argument       */
/*                        extraire de la chaine.                          */
/* RETOUR: un char * qui pointe apres le caractere de separation si il a  */
/*                   ete trouve et qu'apres il y a encore du texte valide */
/*                   =  zero si pas de caractere de separation trouv et */
/*                   ou pas de texte valide apres.                        */

char *GetArgument(char *pt_arg, char *dest);

/*--------------------------- GetSpecifiedArgument -----------------------*/
/* ACTION: copie dans dest, tous les caracteres  partir de pt_arg,       */
/*         jusqu' un des caracteres de separation "|" ou "," ou jusqu'a  */
/*         la fin de la chaine.                                           */
/* ENTREE: char *pt_arg   pointe sur la chaine d'arguments.               */
/*         char *dest     buffer ou sera recopie l'argument (si trouve,   */
/*                        sinon il est place un 0 de fin dans le buffer). */
/*         INT16 ind        numero (zero etant le 1er) de l'argument       */
/*                        extraire de la chaine.                          */
/* RETOUR: un char * qui pointe apres le caractere de separation si il a  */
/*                   ete trouve et qu'apres il y a encore du texte valide */
/*                   =  zero si pas de caractere de separation trouv et */
/*                   ou pas de texte valide apres.                        */

char *GetSpecifiedArgument(char *pt_arg, char *dest, INT16 ind);

/*--------------------------- XGetSpecifiedArgument -----------------------*/
/* ACTION: copie dans dest, tous les caracteres  partir de pt_arg,       */
/*         jusqu' un des caracteres de separation "|" ou "," ou jusqu'a  */
/*         la fin de la chaine.                                           */
/* ENTREE: char *pt_arg   pointe sur la chaine d'arguments.               */
/*         char *dest     buffer ou sera recopie l'argument (si trouve,   */
/*                        sinon il est place un 0 de fin dans le buffer). */
/*         INT16 ind        numero (zero etant le 1er) de l'argument       */
/*                        extraire de la chaine.                          */
/*         char *str_sep: pointe sur une chaine contenant le caractres  */
/*                        considerer comme separateurs.                   */
/* RETOUR: un char * qui pointe apres le caractere de separation si il a  */
/*                   ete trouve et qu'apres il y a encore du texte valide */
/*                   =  zero si pas de caractere de separation trouv et */
/*                   ou pas de texte valide apres.                        */

char *XGetSpecifiedArgument(char *pt_arg, char *dest, INT16 ind, char *str_sep);

/*--------------------------- Extrait_mot ---------------------------------------*/
/* ACTION:  prend tous les caracteres de str_srce et tant qu'ils n'appartiennent */
/*          pas  la chaine d'invalidite ils sont recopis dans  str_dest        */
/*          la chaine de break l'emporte sur la chaine de validit               */
/*                                                                               */
/* ENTREE: *strdest    pointe sur chaine ou sont places les caracteres extraits  */
/*         *strsrc     pointe sur chaine dont il faut extraire le mot            */
/*         *str_valid  pointe sur chaine specifiant les caracteres valides       */
/*                     si vide alors tous les caracteres sont acceptes           */
/*                     si zero alors tous les caracteres sont acceptes           */
/*         *str_break   pointe sur chaine specifiant les caracteres qui doivent  */
/*                      marquer la fin du mot                                    */
/* SORTIE: *str pointe sur le premier car n'appartenant pas  la chaine extraite */

char *Extrait_mot(char *str_dest, char *str_srce, char *str_valid,
                                                                        char *str_break);

/*--------------------------- NextBreakChar ------------------------------------*/
/* ACTION: fait avancer le pointeur de chaine jusqu'u premier caractre        */
/*         invalide trouve.                                                     */
/* ENTREE: *str         pointe sur chaine  analyser                            */
/*         *str_break   pointe sur chaine specifiant les caracteres invalides   */
/* SORTIE: *str         pointe sur le caractere invalide                        */

char *NextBreakChar(char *str, char *str_break);

/*---------------------- DiderotHelpReply -------------------------------*/
/* ACTION: repond au message AID_REQUEST envoy par DIDEROT lorsqu'il    */
/*         doit afficher une aide. Cette fonction rempli automatiquement */
/*         les membres de la structure DID_HELP *VIEWHLP: dont on fourni */
/*         en entree l'adresse. Le fichier d'aide est cherche dans les   */
/*         repertoires systemes de l'application.                        */
/*         Au premier affichage de la fenetre d'aide ses dimensions sont */
/*         automatiquement ajustees pour qu'elle s'affiche de facon a ne */
/*         pas recouvrir la fenetre demandeuse d'aide.                   */
/*                                                                       */
/* ENTREE: w_ind: indice EAZY_GEM de la fenetre correspondant au fichier */
/*                d'aide, specifie par la variable: char *fic_aide       */
/*                Si ce n'est pas la fenetre pour laquelle DIDEROT deman-*/
/*                de une aide, il ne se passera rien et la fonction      */
/*                retourne avec 0;                                       */
/*         EVNT_O *Evnt: variable de flux evenementiel.                  */
/*         DID_HELP *VIEWHLP: pointeur sur la structure de retour, que   */
/*                            l'on va renvoyer a DIDEROT afin qu'il      */
/*                            afficher l'aide demandee.                  */
/*         char *fic_aide: nom du fichier d'aide. il sera cherch dans   */
/*                         les repertoires systemes de l'application.    */
/*         INT16 ref: numero de la reference a afficher de ce fichier      */
/*                  d'aide.                                              */
/*         INT16 w, h: largeur et hauteur que l'on veut pour l'affichage   */
/*                   de la fenetre d'aide.                               */
/* RETOUR:  1 tout est OK                                                */
/*          0 l'indice de fenetre fourni en entre n'est pas le bon.      */
/*         -1 l'application DIDEROT non presente.                        */
/*         -2 le fichier d'aide fourni en entre n'est pas trouve.        */

INT16 DiderotHelpReply(INT16 w_ind, EVNT_O *Evnt,
                     DID_HELP *VIEWHLP, char *fic_aide, INT16 ref,
                     INT16 w, INT16 h);
/*------------------------------ Vq_cookie -----------------------------*/
/* ACTION :retourne l'adresse d'un Cookie dont l'identificateur est     */
/*        passe en entree sinon Zero                                    */

COOKIE *Vq_cookie (long id);

/*---------------------------- DumpEventStack --------------------------*/
/* ACTION: liste sur le disque les derniers evenements enregistres dans */
/*         la pile evenementielle d'EZ_GEM.                             */
/*         Cette fonction est ecrite  des fins de debuggage.           */
/* ENTREE: char *path: chemin du fichier  ecrire                       */
/*         char *nom: nom du fichier (peut etre egal  zero, auquel cas */
/*                    path, doit etre coplet avec nom de fichier        */
/* RETOUR: INT16: 0/si erreur       1/si tout est OK                      */
/* NOTE: Pour que la pile d'evenements soit fonctionnelle il convient   */
/*      de placer avant appel  la fonction: InitEazyGem(), la variable */
/*      MS_NB sur le nombre d'evenements que l'on souhaite empiler.     */
/*            Si   zero, la pile ne sera pas fonctionnelle.             */
/*                ( zero est la valeur par defaut)                      */

INT16 DumpEventStack(char *path_in, char *nom);

/*--------------------------- StrNcat ----------------------------------*/
/* ACTION: ajoute size_t n caracteres de src a la fin de dst et si trop */
/*         long coupe  size_t n car, si trop court rajoute des espaces */
/* ENTREE: char *dst: pointe sur la chaine ou doit se faire l'ajout.    */
/*         char *src: pointe sur la chaine  rajouter.                  */
/*         size_t n: longueur du rajout.                                */
/* SORTIE: char *pointe sur dst.                                        */

char *StrNcat(char *dst, char *src, size_t n);

/*----------------------- GetTxtNbLigne -------------------------*/
/*ACTION: compte le nombre de lignes d'un texte, afin de prevoir */
/*        la taille  du tableau de pointeurs                     */
/* ENTREE: char *txt: adresse du texte dont il faut compter les  */
/*                    lignes.                                    */
/* RETOUR: INT16: nombre de lignes du texte.                       */

INT16 GetTxtNbLigne(char *txt);

/*------------------- GetTexteNbLigne -------------------------------*/
/* ACTION: Fonction tres versatile, selon si is_C_end = 0 ou         */
/*                                           is_C_end = 1            */
/*      SI is_C_end  = 0 Elle passe en revue le texte et compte le   */
/*                     nombre de lignes (-1  base 0)                 */
/*                     il est retourne alors le nombre de lignes -1  */
/*      SI is_C_end  = 1 Elle passe en revue le texte et met un zero */
/*                     de fin  la fin de chaque ligne               */
/*                     il est retourne alors la longueur maxi renc-  */
/*                     contre d'une ligne.                          */
/*      Si PtLgnTab !=0 donc pointe sur un tableau de pointeurs de   */
/*                      chaine, il est rempli avec les des lignes    */
/* NOTE: est considre comme ligne toute chaine de caractre        */
/*       termine par: \n ou \r ou \r\n ou \n\r. (cela vous va ?)    */
/*                                                                   */
/* ENTREE: char *txt: pointe sur le texte  traiter.                 */
/*         char **PtLgnTab: pointe sur un tableau de pointeurs de    */
/*                          chaines, initialise sur chaque debut de  */
/*                          lignes (si il est  valide CAD  != 0)     */
/*         char is_C_end: voir plus haut.                            */
/* RETOUR: un long: dont la signification de la valeur depend de la  */
/*                  valeur de is_C_end: (voir plus haut)             */

long GetTexteNbLigne(char *txt, char **PtLgnTab, char is_C_end);

/*----------------------- InitTxtLgnPtr -------------------------*/
/* ACTION:initialise un tableau de pointeurs de lignes sur les   */
/*        adresse de debut de lignes d'un texte                  */
/* ENTREE: char *txt: adresse du texte dont il faut initialiser  */
/*                    les pointeurs de lignes.                   */
/*         char **PtLgnTab: pointeur sur un tableau de pointeurs */
/*                    qui sera rempli par les adresses correctes */
/* RETOUR: toujours 1                                            */

INT16 InitTxtLgnPtr(char *txt, char **PtLgnTab);

/**************************************************************************/
/*           F O N T I O N S   D E  GESTION  DU DRAG & DROP               */
/**************************************************************************/

/*------------------------ PutDragDropData -----------------------------*/
/* ACTION: place des donnees sur le pipe Drag & Drop. Cette fonction    */
/*         est  appeler apres relachage du bouton de la  souris au     */
/*         dessus d'une fenetre cliente, pour luis fournir des donnes  */
/*         (  la condition qu'elle accepte ces donnes)                */
/*         elle recherche la fenetre cliente, et essaie de transmettre  */
/*         par le protocole DRAG & DROP les donnes.                    */
/* ENTREE: char *data: pointe sur la zone des donnes.                  */
/*         long len_data: longueur des donnes a transmettre            */
/*         long must_accept_type: type de donnee: 'ARGS'  '.TXT'        */
/*                                '.IMG' etc....                        */
/*         INT16 x, INT16 y: position de la souris lors du lacher bouton    */
/*         INT16 ksp: etat des touches SHIFTn, CTRL, ALT, CAPS lors du    */
/*                  lacher de bouton de souris.                         */
/* RETOUR: 0/si echec    longueur des donnees transmises/si OK          */

long PutDragDropData(char *data, long len_data, long must_accept_type, INT16 x, INT16 y, INT16 ksp);

/*--------------------------- GetDragDropData -----------------------------*/
/* ACTION: recupere les donnes presentes sur le pipe du drag & drop       */
/*         lors du message AP_DRAGDROP.                                    */
/* NOTE:   cette fonction est polymorphe, Si le dst d'entree (dst) ou      */
/*         la longueur de recopie (len_dst) sont egals a zero, il est      */
/*         retourne en ret l'adresse d'un buffer dans lequel se trouve les */
/*         donnes (termine par zero de fin)                              */
/*         Il sera a votre charge de liberer ce buffer avec la fonction:   */
/*         free();                                                         */
/* ENTREE: dd_ext: extension du fichier Drag & Drop tel qu'il est fourni   */
/*                 dans le mot N7 lors reception du message  APP_DRAGDROP */
/*                 Exemple: Evnt->pipe[7]                                  */
/*         char *dst: pointeur sur la chaine dans laquelle le texte sera   */
/*               recopie. (Si zero alors le retour est l'adresse d'un     */
/*                          BUFFER dans lequel les donnees seront placees  */
/*                          Apres usage il vous faudra liberer ce buffer   */
/*                          par free() ).                                  */
/*         long len_dst: longueur de la chaine d'entree, afin que la       */
/*               recopie ne deborde pas.                                   */
/*         long *recept_type: reoit en sortie le type de donnes que le   */
/*                            drag & drop nous envoie. Si zero alors echec */
/*                            de la recuperation.                          */
/*         char *acceptDataTyp: pointeur sur une zone memoire de n fois    */
/*                              4 octets representant le type de           */
/*                              donnes que l'on accepte. Exemple:         */
/*                              "ARGS.EXT.ASC"                             */
/*                              maximum 8 arguments soit 32 octets.        */
/* RETOUR: long: longueur de la chaine pouvant etre recupre. Si cette    */
/*              longueur est plus longue que len_dst, c'est qu'il y a eu   */
/*              non recopie d'une partie de la chaine.                     */
/*              Si dst ou len_dst sont egals  zero, ret est l'adresse     */
/*              du buffer reserve par la fonction pour stocker les donnees */
/*              recuperees dans le DRAG & DROP. Dans ce cas il vous faudra */
/*              liberer ce buffer apres usage avec la fonction free().     */
/*              les 4 premiers octets de ce buffer sont alors la longueur  */
/*              des donnes qui suivent. les donnes sont toujours fermes */
/*              par un zero de fin                                         */

long GetDragDropData(INT16 dd_ext, char *dst, long len_dst, long *recept_type, char *acceptDataTyp);

/*--------------------------- DragDropCreate -----------------------------*/
/* ACTION: Routine pour l'envoyeur qui cree un pipe D&D                   */
/* ENTREE: WORD app_id: Iddentificateur d'application de l'expediteur     */
/*         WORD rcvr_id: Iddentificateur d'application du destinataire    */
/*         WORD window: handle GEM de la fenetre destinataire             */
/*         WORD mx, WORD my: coordonnes souris (lors lacher du D&D).     */
/*         WORD kbstate: etat touches controles du clavier(lors lacher    */
/*                       du D&D)                                          */
/*         ULONG format[8]; pointe sur un tableau de 8 longs qui recevra  */
/*                          les formats acceptes par le destinataire.     */
/*         void **oldpipesig: pointeur sur pointeur de void.              */
/* RETOUR: un nombre negatif ou = 0 si echec -1 echec -2 appl_write:      */
/*         le handle du pipe si tout est OK avec l'identificateur         */
/*                   ou extension dans le mot pointe par WORD *pipe       */

WORD   DragDropCreate( WORD   app_id, WORD rcvr_id, WORD window, WORD mx, WORD my,
                WORD kbstate, ULONG format[8], void **oldpipesig );

/*--------------------- DragDropOpen ----------------------------------*/
/* ACTION: ouvre un pipe deja cree par un expediteur, en reponse au    */
/*         au message AP_DRAGDROP.                                     */
/* ENTREE: WORD ext_name: contient en poids fort et poids faible les   */
/*                        deux caracteres d'extension du pipe          */
/*                    reu par le destinataire lors reception du       */
/*                    du message: AP_DRAGDROP, dans le mot N7:        */
/*         ULONG format[8]: pointeur sur les formats supportes         */
/*         void **oldpipesig: pointeur sur pointeur de void.           */
/* RETOUR:  >0 handle du pipe.                                         */
/*         <=0 erreur                                                  */

WORD DragDropOpen( WORD ext_name, ULONG format[8], void **oldpipesig );

/*--------------------------- ddcreate -----------------------------*/
/* ACTION: Routine pour l'envoyeur qui cree un pipe D&D             */
/* ENTREE: WORD *pipe: pointe sur un INT16 qui recevra: dans le poids */
/*                     fort et le faible l'extension du pipe cree.  */
/*                     Cette extention valide est automatiquement   */
/*                     recherche par la routine.                   */
/*         void **oldpipesig: pointeur sur pointeur de void.        */
/* RETOUR: un nombre negatif ou = 0 si echec:                       */
/*         le handle du pipe si tout est OK avec l'identificateur   */
/*                   ou extension dans le mot pointe par WORD *pipe */

WORD ddcreate(WORD *pipe, void **oldpipesig);

/*--------------------- ddmessage -------------------------------*/
/* ACTION: envoie un message D&D: AP_DRAGDROP  une application  */
/* ENTREE: WORD apid: ID application destinataire du message     */
/*         WORD fd :  handle du Pipe c'est pas l'extension gaffe */
/*                    mais celui retourne par ddcreate           */
/*         WORD winid: handle GEM de la fenetre cible.           */
/*                     obtenu en faisant un wind_find()          */
/*         WORD mx, WORD my, WORD kstate: etat souris et touches */
/*                  de controles clavier.                        */
/*         WORD Pipename: extension du pipe (deux dernier octets */
/*                        de Pipename[]:  Pipename[17] & [18]    */
/*                        ou le mot: WORD *pipe initialise par   */
/*                        la fonction: ddcreate()                */
/*         void *oldpipesig: pointeur sur void.                  */
/* RETOUR: >0 pas d'erreur                                       */
/*        -1 DD_NAK: (non accept)  alors le pipe est ferme.     */
/*        -2 Timeout pas de reponse  alors le pipe est ferme.    */
/*        -3: erreur par appl_write()  alors le pipe est ferme.  */

WORD ddmessage(WORD apid, WORD fd, WORD winid, WORD mx, WORD my, WORD kstate,
               WORD Pipename, void *oldpipesig);

/*------------------- ddrexts -----------------------------------*/
/* ACTION: Demande au destinataire la liste des types de donnees */
/*         qu'il peut accepter. liste de 32 long ou byte[4]      */
/* ENTREE: WORD fd :  handle du Pipe c'est pas l'extension gaffe */
/*                    mais celui retourne par ddcreate           */
/*         BYTE *exts: pointe sur zone de 32 octets ou sera      */
/*                     retourne les extensions admises.         */
/*         void *oldpipesig: pointeur  de void.                  */
/* RETOUR: WORD :  >0 pas d'erreur.                              */
/*                <=0 0 alors le pipe est ferme.                 */

WORD ddrexts(WORD fd, BYTE *exts,  void *oldpipesig);

/*------------------------- ddsexts --------------------------------------*/
/* ACTION: envoie a l'expediteur la liste des types de donnes acceptes  */
/*         cette liste est donc de 32 octets, chaque type etant 4 octets  */
/*         du type "ARGS" ".IMG" etc..  elle peut accepter 8 types de     */
/*         donnes. Si elle n'est pas complete (exemple seulement deux    */
/*         types de donnes) le reste doit etre rempli de zeros.          */
/* ENTREE: BYTE *data_typ: pointe sur liste type de donnees acceptes     */
/*                         "ARGS" "PATH" ".IMG" ".TXT" etc...             */
/*         void *oldpipesig: pointeur sur  void.                          */
/* RETOUR:  >0 tout est OK                                                */
/*        <= 0 erreur d'ecriture (le pipe est alors ferme)                */

WORD ddsexts(WORD fd, BYTE *data_typ, void *oldpipesig);

/*------------------- ddstry ---------------------------------------*/
/* ACTION: demande au destinataire si il accepte un certain         */
/*         type de donnees dont il presente les caracteristiques    */
/*         data_typ, LONG size etc ....                             */
/* ENTREE: WORD fd :  handle du Pipe c'est pas l'extension gaffe    */
/*                    mais celui retourne par ddcreate              */
/*         BYTE *data_typ: pointe sur type de donnees a envoyer     */
/*                         "ARGS" "PATH" ".IMG" ".TXT" etc...       */
/*              BYTE *text: descripteur des donnes exemple:        */
/*                       "Caractere ASCII" est optionnel on peut    */
/*                        passer une chaine vide.                   */
/*              BYTE *name: non de fichier associe  la donne      */
/*                        ce parametre est aussi optionnel et       */
/*                        peut etre une chaine vide.                */
/*              LONG size: longueur des donnes  transmettre       */
/* RETOUR: un INT16:                                                */
/*       DD_OK  le destinataire ou cible accepte les donnes        */
/*       DD_NAK le D&D doit etre interrompu                         */
/*       DD_EXT le cible refuse les donnes telles quelles          */
/*       DD_LEN le cible ne peut accepter la longueur               */
/*     DD_TRASH le cible repond que donnes sont sur une poubelle   */
/*   DD_PRINTER le cible repond que donnes sont sur une Imprimante */
/* DD_CLIPBOARD le cible repond que donnes sont sur le CLIPBOARD   */

WORD ddstry(WORD fd, BYTE *data_typ, BYTE *text, BYTE *name, LONG size);

/*-------------------------- ddclose --------------------------------*/
/* ACTION: ferme le pipe et met fin aux procedures d'echanges        */
/*         peut etre utilisee par l'expediteur et le destinataire.   */
/* ENTREE: WORD fd :  handle du Pipe c'est pas l'extension gaffe     */
/*                    mais celui retourne par ddcreate               */
/*         void *oldpipesig:  pointeur de void.                      */

VOID ddclose(WORD fd, void *oldpipesig );

/*--------------------- ddopen ----------------------------------------*/
/* ACTION: ouvre un pipe deja cree par un expediteur, en reponse au    */
/*         au message AP_DRAGDROP.                                     */
/* ENTREE: WORD ddnam: extension du pipe  ouvrir tel qu'il a ete recu */
/*                     par le destinataire lors reception du message:  */
/*                     AP_DRAGDROP, dans le mot N7: exemple pipe[7]   */
/*         BYTE ddmsg: DD_OK on accepte   DD_NAK on refuse             */
/*         void **oldpipesig: pointeur sur pointeur de void.           */
/* RETOUR:  >0 handle du pipe.                                         */
/*         <=0 erreur                                                  */
WORD ddopen(WORD ddnam, BYTE ddmsg, void **oldpipesig);

/*------------------------- ddrtry -----------------------------------*/
/* ACTION: demande  l'expediteur, en lui precisant le type de donnee */
/*         que l'on accepte de recevoir, des renseignements divers    */
/*         dessus notamment la longueur.                              */
/* ENTREE: WORD fd :  handle du Pipe c'est pas l'extension gaffe      */
/*                    mais celui retourne par ddcreate                */
/*         BYTE *whichext: pointe sur type de donnees que l'on        */
/*                         souhaite recevoir. zone de 5 octets.       */
/*                         "ARGS" "PATH" ".IMG" ".TXT" etc...         */
/* SORTIE:                                                            */
/*         BYTE *whichext: est rempli apre appel avec type de donnees */
/*                         reues "ARGS" "PATH" ".IMG" ".TXT" etc...  */
/*                         si different de celui en entree alors      */
/*                         erreur.                                    */
/*         BYTE *text: descripteur des donnes exemple:               */
/*                    "Caractere ASCII" initialisee par la fonction   */
/*                    la longueur de la zone pointee par text doit    */
/*                    etre au minimum de: DD_NAMEMAX 128 octets       */
/*         BYTE *name: non de fichier associe  la donne             */
/*                     ce parametre est initialise par la fonction    */
/*                     la longueur de la zone pointee par name doit   */
/*                     etre au minimum de: DD_NAMEMAX 128 octets      */
/*         LONG *size: pointe sur longueur des donnes  ecevoir      */
/*                     cette valeur est initialise en retour.        */
/* RETOUR: >0 Tout est OK                                             */
/*         -1 erreur                                                  */

WORD ddrtry(WORD fd, BYTE *name, BYTE *file, BYTE *whichext, LONG *size);

/*-------------------- ddreply ----------------------------------------*/
/* ACTION: envoie 1 octet exemple: DD_OK ou DD_NAK au pipe.            */
/* ENTREE: WORD fd :  handle du Pipe c'est pas l'extension gaffe       */
/*                    mais celui retourne par ddcreate ou ddopen       */
/*         BYTE ack: octet  envoyer                                   */
/* RETOUR: >=0 Tout est OK                                             */
/*           0 erreur                                                  */

WORD ddreply(WORD fd, BYTE ack);

/*------------------------- Parse_ARGS --------------------------------*/
/* ACTION: transforme une liste d'arguments soit separes par des       */
/*         espaces, en une suite de chaines terminees par des zeros de */
/*         fin. Si les arguments sont entre quotes: exemple            */
/*         'arguments1''argument2'  etc... cela marche aussi et les    */
/*         espaces ne seront pas transformes en zero de fin.           */
/* ENTREE: char *str: chaine d'arguments termine par un zero.         */
/* RETOUR: nombre d'arguments.                                         */

INT16 Parse_ARGS(char *str);

/*------------------ GetDragDropList --------------------------------------*/
/* ACTION: recupere une liste de chaines, separes par des zero de fin     */
/*         lors du message AP_DRAGDROP. (en general liste de fichiers)     */
/* NOTE:   cette fonction est polymorphe, Si le path d'entree (path) ou    */
/*         la longueur de recopie (len_path) sont egals a zero, il est     */
/*         retourne en ret l'adresse d'un buffer dans lequel se trouve les */
/*         donnes (termin par zero de fin et separees par des espaces)   */
/*         Il sera a votre charge de liberer ce buffer avec la fonction:   */
/*         free();                                                         */
/* ENTREE: EVNT_O *Evnt: pointeur sur le flux evenementiel. Permet  la    */
/*               fonction de se servir du pipe.                            */
/*         char *path: pointeur sur la chaine dans laquelle la liste sera  */
/*               recopie. (Si zero alors le retour est l'adresse d'un     */
/*                          BUFFER dans lequel les donnees seront placees  */
/*                          NON SEPAREES par des zeros MAIS par des        */
/*                          espaces. Apres usage il vous faudra liberer ce */
/*                          buffer par free() ).                           */
/*         long len_path: longueur de la chaine d'entree, afin que la      */
/*               recopie ne deborde pas.                                   */
/* RETOUR: long: longueur de la chaine pouvant etre recupre. Si cette    */
/*              longueur est plus longue que len_path, c'est qu'il ya eu   */
/*              non recopie d'une partie de la chaine.                     */
/*              Si path ou len_path sont egals  zero, ret est l'adresse   */
/*              du buffer reserve par la fonction pour stocker les donnees */
/*              des chemins du DRAG & DROP. Dans ce cas il vous faudra     */
/*              liberer ce buffer apres usage avec la fonction free().     */

long GetDragDropList(EVNT_O *Evnt, char *path, long len_path);

/*------------------------- ClipboardSave -------------------------------------*/
/* ACTION: sauve le buffer passe en entree dans le clipboard (presse papier)   */
/* ENTREE: char *txt: adresse du buffer texte  sauver.                        */
/*         INT16 mode: O_WRONLY   ecriture seulement                           */
/*                   O_APPEND   ajout du texte  la suite de celui deja present*/
/*                   O_CREAT    recree et efface l'ancien texte.               */

INT16 ClipboardSave(char *txt, INT16 mode);

/*------------------------- ClipboardLoad -------------------------------------*/
/* ACTION: charge un buffer passe en entree avec le clipboard (presse papier)  */
/* ENTREE: char *strdest: adresse du buffer texte dans lequel les caracteres   */
/*                        du clipboard (presse papier) seront places.          */
/*         long MaxOctets: nombre d'octets maximum que peut recevoir le buffer */
/*              SI MaxOctets>0 alors un zero de fin est rajout apres le       */
/*                             transfert.                                      */
/*              SI MaxOctets<0 il est transfere la valeur absolue de MaxOctets */
/*                             et il n'est pas rajout de zero de fin.         */
/* RETOUR: long  qui est le nombre d'octets transferes.                        */

long ClipboardLoad(char *strdest, long MaxOctets );

/*------------------------- GetLenClipboard -----------------------------------*/
/* ACTION: retourne la longueur du clipboard (mode texte)                      */
/* ENTREE: neant                                                               */
/* RETOUR: long  qui est la longueur du clipboard.                             */

long GetLenClipboard(void);

/******************************************************************************/
/*           F O N T I O N S   D E  GESTION  MEMOIRE TEMPORAIRE               */
/******************************************************************************/
/*--------------------------- Timed_StrAdd --------------------------------*/
/* ACTION: cree une copie temporaire de la chaine: char *str place en     */
/*         entree. Cette copie se detruit automatiquement au bout de       */
/*         long time temps.                                                */
/* ENTREE: char *str: pointeur sur la chaine  copier.                     */
/*         long time: duree de vie de la copie en x 200 ms                 */
/*                   (exemple: 10 pour 2s de duree de vie)                 */
/* SORTIE: char*  pointe sur la copie temporaire cree.                     */

char*  Timed_StrAdd(char *str, long time);

/*--------------------------- Timed_MemAdd --------------------------------*/
/* ACTION: cree une zone memoire temporaire de taille:  size_t size        */
/*         Cette zone memoire automatiquement au bout delong time temps.   */
/* ENTREE: size_t size: taille de la zone memoire a creer.                 */
/*         long time: duree de vie de la copie en x 200 ms                 */
/*                   (exemple: 10 pour 2s de duree de vie)                 */
/* SORTIE: char*  pointe sur la zone memoire temporaire cree.              */

char*  Timed_MemAdd(size_t size, long time);

/*--------------------------- Timed_PtrAdd --------------------------------*/
/* ACTION: Donne  un pointeur un caractre temporaire de long time temps. */
/*         Au bout de long time temps ce pointeur sera libere              */
/* ENTREE: char* pt: pointeur auquel donner le caractre temporaire        */
/*         long time: duree de vie de la copie en x 200 ms                 */
/*                   (exemple: 10 pour 2s de duree de vie)                 */
/* SORTIE: char*  pointe sur le pointeur.                                  */

char*  Timed_PtrAdd(char* pt, long time);


#endif    /* __EAZY_GEM__ */