/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ TXT_PROC.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE C du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    De l'editeur de texte C avec                     */
/*                         syntaxe coloree                             */
/*                    Affichage et traitement des caracteres.          */

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*................ INCLUDES DES AUTRES MODULES DU PROGRAMME ...........*/
#include "EAZY_GEM.H"  /* inclure les definitions des fonctions que le */
                       /* que le module EAZY_GEM.C met  notre         */
                       /* notre disposition                            */
                       /* et inclure les definitions des variables     */
                       /* globales  EAZY_GEM                           */
/* end of include...................................................... */
#define LIGNE_SIZE 1024
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
extern INT16 EZ_font;
extern INT16 EZ_point;
/*........................ variable generale liee au texte ......................*/
/*                         contient toutes les infos lies                       */
/*                         au texte trait                                       */
static TXTED_OB TXT_DEF_ATT =
                           {14,         /* interligne en pixel                   */
                            1,          /* ajustage vertical affichage caractere */
                            2,          /* Marge gauche en pixels                */
                            600,        /* Marge droite en nombre de pixels      */
                            80,         /* Nombre de lignes par page             */
                            6,          /* couleur de fond (jaune)               */
                            3,          /* trame du fond                         */
                            1,          /* expansion de TAB en nbr de caracteres                    */
                            248,        /* caractre  utiliser pour visualiser les TAB             */
                            15,         /* frequence de clignotement                                */
                            { {1,   0,9,0,"MONACO MONO\0                       "}, /* 0  texte normal       */                                                           
                              {-1,  0,9,0,"MONACO MONO\0                       "}, /* 1 numero de ligne     */
                              {10,  0,9,0,"MONACO MONO\0                       "}  /* 2 fin de ligne        */
                            },
                            LIGNE_SIZE-1,       /* longueur d'une ligne sans le 0 de fin */
                            0L,         /* parametre optionnel de l'editeur de texte        */
                            
                            0,          /* decalage horizontal en pixels         */
                            6,          /* interligne pixels entre deux colonnes */
                            6,          /* largeur d'un caractere                */
                            6,          /* hauteur d'un caractere                */
                            0,          /* nombre de lignes                      */
                            0,          /* nombre de lignes maxi possibles       */
                            0,          /* adresse du texte NULL                 */
                            0,          /* fin du texte (adresse zero de fin)    */
                            0,          /* fin du buffer memoire alouee          */
                            0,          /* buffer edition de ligne               */
                            0L,         /* adresse du tableau contexte de ligne  */
                            0,          /* taille d'un contexte de ligne (peut etre change)       */
                            0L,         /* adresse de la memoire supplementaire de contexte ligne */
                            0L,         /* attributs d'affichage par defaut (sans 0 de fin)         */
                            0,          /* etat affichage                                           */
                            {0,0,0,0},  /* le rectangle dans lequel se situe le texte               */
                            0L,         /* premiere ligne visible dans le cadre                     */
                            0L,         /* nombre de lignes visible dans le cadre                   */
                            0L,         /* ligne pointe dans le texte (option BASE 0)              */
                            0L,         /* caractere pointe dans le texte (relatif au debut ligne)  */
                            0,          /* Curseur X    en valeur absolue ecran                     */
                            0,          /* Curseur Y    en valeur absolue ecran                     */
                            0,          /* Curseur H    en valeur absolue ecran                     */
                            0,          /* etat du curseur     allum/1  ou etteint/0               */
                           -1L,         /* ligne ou est le debut du bloc                    */
                            0,          /* car du debut de bloc dans ligne de debut de bloc */
                            0,          /* position x du debut de bloc                      */
                            0,          /* position Y du debut de bloc                      */
                           -1L,         /* ligne ou est la fin du bloc                      */
                            0,          /* car de la fin de bloc dans ligne de fin de bloc  */
                            0,          /* position x de la fin de bloc                     */
                            0,          /* position Y de la fin de bloc                     */
                            0,          /* position x en pixels lors changement de ligne    */
                            0L,         /* derniere ligne pointee.                          */
                            0L,         /* dernier caractere pointe                         */
                            0L,         /* adresse de la pile UNDO.                         */
                            0L,         /* adresse de AffiBuff (tampon interne de travail)  */
                            0L,         /* adresse de l'arbre auquel appartient l'objet     */
                            0,          /* indice de l'objet SCROLL_EDIT                    */
                            0L,         /* pointeur sur la fonction evenementielle          */
                            0L,         /* pointeur sur fonction de notification directe    */
                            0L,         /* pointeur sur fonction affichage ligne de texte   */
                            0L,         /* pointeur sur fonction changement coordeonnes     */
                            0L,         /* pointeur sur fonction scan et formatage lignes   */
                            0L          /* pointeur sur sous fonction d'affichage texte     */
                           };
                           
/*............... symbole de fin de ligne .............................*/
static INT16 IC_EOF[9] = {0X4   , 0X5   , 0X1   ,
                          0XE000, 0X2000, 0X2000, 0XF800, 0X7000, 0X2000,
                         };
/*......................... Buffer de recopie des caracteres ..........*/
static char AffiBuff[2048];
/*........ pointeur sur la structure texte en cours de traitement .....*/
TXTED_OB *TXT_ED        = 0;
/*........ compteur pour clignotement curseur .........................*/
static long CurTim      = 0;
/*..... stocke le dernier car pointe pour deplacemnt vertical .........*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*.............. FONCTIONS PUBLIQUES ..................................*/
/* elles sont toutes dans TXT_PROC.H                                   */
/*.............. FONCTIONS INTERNES ...................................*/
INT16    EZ_ED_Evnt( INT16 w_ind, EVNT_O *Evnt, TXTED_OB *TXT_A);
void   SetAttributForOne(INT16 col, INT16 eff, INT16 pts, INT16 fid, char *fntName, CAR_ATTR *CAR_A);
INT16    WhereIsCursor(TXTED_OB* TXT_A);
INT16    GotoNewPosCurs(INT16 w_ind, long ligpt, long carpt, TXTED_OB* TXT_A);
long   CouperBloc(INT16 w_ind, TXTED_OB* TXT_A);
void   UNDO_DO(INT16 w_ind, UNDO_REC *undo_rec, TXTED_OB *TXT_A);
void   PushCarInUndo(char *src, INT16 nb_car, long orig, TXTED_OB* TXT_A);
INT16    IsCursInBloc(TXTED_OB* TXT_A);
INT16    IsPosInBloc(long ligpt, long carpt, TXTED_OB* TXT_A);
INT16    SendNotification(INT16 w_ind, INT16 messg, INT16 *param, INT16 n_param, TXTED_OB* TXT_A);
INT16    NotifiePremLignChg(INT16 w_ind, INT16 flag, TXTED_OB* TXT_A);
INT16    NotifieNbrLignChg(INT16 w_ind, INT16 flag, TXTED_OB* TXT_A);
INT16    NotifiePremClnChg(INT16 w_ind, INT16 flag, TXTED_OB* TXT_A);
INT16    NotifieKeyBoardControl(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A);
INT16    NotifieKeyBoardAlternate(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A);
INT16    NotifieKeyDown(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A);
INT16    NotifieReturnDown(INT16 w_ind, INT16 *param, TXTED_OB* TXT_A);
INT16    NotifieClick(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A);
INT16    NotifieEditSetFocus(INT16 w_ind, TXTED_OB* TXT_A);
INT16    NotifieEditLoseFocus(INT16 w_ind, TXTED_OB* TXT_A);
INT16    NotifieOutTxtClick(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A);
INT16    NotifieLigneChg(INT16 w_ind, long lig_pt, long car_pt, TXTED_OB* TXT_A);
INT16    NotifieEditTxtChanged(INT16 w_ind, TXTED_OB* TXT_A);
INT16    NotifieTxtSizeChg(INT16 w_ind, long pos, long size, TXTED_OB* TXT_A);
char  *XY_to_CarPt(INT16 x, INT16 y, TXTED_OB* TXT_A);
long   CarPt_to_Curs(char *car, long *carPt, TXTED_OB* TXT_A);
INT16    GetNearBlkFromXY(INT16 x, INT16 y, TXTED_OB* TXT_A);
INT16    GetSortedBlkMark(long *deb_lig, long *deb_car, long *end_lig, long *end_car, TXTED_OB* TXT_A);
INT16    MemoryTxtEnough(long len_mem_suppl,   TXTED_OB* TXT_A);
INT16    MemoryLigneEnough(long nb_lign_suppl, TXTED_OB* TXT_A);
INT16    IsTxtBlkDefined(TXTED_OB* TXT_A);
void     Car_to_CursXYH(TXTED_OB* TXT_A);
void     FreeTxtMemory(TXTED_OB *TXT_A);
CALLBACK TxtEventProc(INT16 w_ind, EVNT_O *Evnt);
INT16    CarOfLigne_to_X(char *txt, long car_pt, TXTED_OB* TXT_A, INT16 flag);
long   DefaultInitTabLgnCtx(TXTED_OB *TXT_A, char *txt, long iTab, long nb_l);
INT16    AfficheBaliseTxt(INT16 tx, INT16 ty, char *PtTexteLigne, TXTED_OB *TXT_A);
long   GetTxt_NbLign(char *txt, long lenmax);
INT16    AfficheLigne(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A);
long   XY_to_Car(INT16 x, INT16 y, TXTED_OB* TXT_ED);
INT16    X_LigPt_to_CarOfLigne(INT16 x, long lig_pt, TXTED_OB* TXT_A, INT16 flag);
INT16    X_to_CarOfLigne(INT16 x,  char *txt, TXTED_OB* TXT_A, INT16 flag);
long   Y_to_Lig(INT16 y, TXTED_OB* TXT_A);
long   Lig_To_Y(long lig_pt, TXTED_OB* TXT_A);
void   Car_to_CursXYH(TXTED_OB* TXT_A);
void   TextToBuffEdit( long lig_pt, TXTED_OB* TXT_A );
long   InsereBloc(INT16 w_ind,
                  char *bloc_srce, 
                  size_t lig_pt, size_t car_pt, 
                  INT16 flag,
                  TXTED_OB* TXT_A);
void   BuffEditToText(INT16 w_ind, char *buft, long lig_pt, TXTED_OB* TXT_A);
size_t LenLigne(char *txt);
INT16    EffaceLigneCur(TXTED_OB* TXT_A);
size_t DeleteBloc(size_t ligDeb, size_t carPtDeb,
                  size_t ligEnd, size_t carPtEnd,
                  TXTED_OB* TXT_A);
INT16    SizeOf_EOF(char *deb_txt, char *pt_txt, INT16 flag);
INT16    CheckForScroll(INT16 w_ind, TXTED_OB* TXT_A);
void   DirectTxtRedraw(INT16 w_ind, GRECT * scrol_grect, GRECT *update_grect, void *param);
void   WPbox(INT16 w_ind, VRECT *box_vrect, GRECT *display_grect);
void   Blk_LigAndCar_to_BlkXY(TXTED_OB* TXT_A);
long   EZ_ED_RedrawFromLineToLine(INT16 w_ind, long ligDeb, long ligEnd, TXTED_OB* TXT_A);
void   DrawCurs(TXTED_OB* TXT_A);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*------------------------ EZ_ED_Evnt -------------------------------------------*/
/* ACTION: envoie un evenement  un editeur, en forant le mode edition.         */
/*         permet de simuler un evenement quelconque sur un editeur.             */
/*         C'est la fonction a utiliser lors par exemple reception de caracteres */
/*         par RS 232 ou autre.                                                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*         EVNT_O *Evnt: variable de flux evenementiel comme celle utilisee      */
/*                       partout dans EAZY_GEM                                   */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre).                                        */
/* RETOUR: un INT16 qui est l'evenement d'entree (modifie ou pas)                  */
 
INT16 EZ_ED_Evnt( INT16 w_ind, EVNT_O *Evnt, TXTED_OB *TXT_A)
{TXT_ED  = TXT_A;
 return TxtEventProc(w_ind, Evnt);
}
/*------------------------ TxtEventProc ------------------------------------------*/
/* ACTION: fonction de gestion de l'evenementiel au niveau d'un cadre texte.      */
/*         Gere: le clavier, pour la saisie des caracteres et curseur.            */
/*               la souris pour positionner le curseur et selectionner le texte   */
/*               le timer pour faire clignoter le curseur texte.                  */
/*               les messages specifiques au texte.                               */

CALLBACK TxtEventProc(INT16 w_ind, EVNT_O *Evnt)
{INT16 param[8];
 INT16 pos,d;
 /*.................... recuperer handles fenetres ......................*/
 INT16 w_h       = Windtab[w_ind].w_h;     /* celui de notre fenetre       */
 INT16 wh_top;
 wind_get( 0, WF_TOP, &wh_top, &d,&d,&d);          /* celui de fenetre avant plan  */

 /*........................>>>> CLAVIER  (MU_KEYBD) <<<<< .....................*/
 if (Evnt->evnt & MU_KEYBD && w_h==wh_top)
    {char scan;
     char car;
     INT16  Shortcut    = 0;
     char *txt        = TXT_ED->BuffEdit + TXT_ED->CarPt;
     INT16 blk_flag;
     /*...............................................>>>> KEY_DOWN  <<<<<<<< */
     if (NotifieKeyDown(w_ind, Evnt, TXT_ED)==0)
        {scan = car = 0;
        }
     else
        {scan        = (char)(Evnt->key>>8);
         car         = (char)Evnt->key;
        }
      /*..............................................>>>> ALTERNATE <<<<<<<< */
     if (Evnt->ksp & K_ALT)
        {if (NotifieKeyBoardAlternate(w_ind, Evnt, TXT_ED) == 0)
            {car  = 0; scan = 0;
            }
         else
            {scan        = (char)(Evnt->key>>8);
             car         = (char)Evnt->key;
            }
        }
      /*..............................................>>>> CONTROL <<<<<<<<<< */
     if (Evnt->ksp & K_CTRL)
        {car          = (char)ScanToAscii(Evnt->key, Evnt->ksp);
         if (NotifieKeyBoardControl(w_ind, Evnt, TXT_ED) == 0)
            {car  = 0;  scan = 0;
            }
         switch(scan)
           {case 0x53:   /* DEL    */
                 break;
            default:
                 switch (car|' ')
                   {case 'c': Shortcut = EXE_ED_COPY;                   break;
                    case 'x': Shortcut = EXE_ED_CUT;                    break;
                    case 'a':
                         /*............. si bloc defini ...............*/
                         if (IsTxtBlkDefined(TXT_ED))
                            {EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                             TXT_ED->BlkEndLig = TXT_ED->BlkDebLig = 0;
                             TXT_ED->BlkEndCar = TXT_ED->BlkDebCar = 0;
                            }
                         BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                         TXT_ED->BlkDebLig = 0;
                         TXT_ED->BlkDebCar = 0;
                         TXT_ED->BlkEndLig = TXT_ED->NbLgn - 1;
                         TXT_ED->BlkEndCar = LenLigne(TXT_ED->TabLgnCtx[TXT_ED->BlkEndLig].ptTxt); 
                         Blk_LigAndCar_to_BlkXY(TXT_ED);
                         EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                         scan = car = 0;
                         break;
                    case 'y':
                         /*............. si bloc defini ...............*/
                         if (IsTxtBlkDefined(TXT_ED))
                            {EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                             TXT_ED->BlkEndLig = TXT_ED->BlkDebLig = 0;
                             TXT_ED->BlkEndCar = TXT_ED->BlkDebCar = 0;
                            }
                         BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                         TXT_ED->BlkDebLig = TXT_ED->LigPt;
                         TXT_ED->BlkDebCar = 0;
                         if (TXT_ED->BlkDebLig <TXT_ED->NbLgn -1 )
                            {TXT_ED->BlkEndLig = TXT_ED->BlkDebLig + 1;
                             TXT_ED->BlkEndCar = 0;
                            }
                         else
                            {TXT_ED->BlkEndLig = TXT_ED->BlkDebLig;
                             TXT_ED->BlkEndCar = LenLigne(TXT_ED->TabLgnCtx[TXT_ED->BlkEndLig].ptTxt);
                            }
                         Blk_LigAndCar_to_BlkXY(TXT_ED);
                         EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                         Shortcut = EXE_ED_CUT;
                         break;
                    case 'v': 
                         Shortcut           = EXE_ED_SCRAP_PASTE;
                         *(long*) &param[0] = (long)0;          /*  X_G Y_G  adresse de la source (si besoin) */
                         break;
                   } /* end switch  car             */
           }  
         if (Shortcut)
            {*(long*) &param[2] = (long)TXT_ED;                 /*  W_G H_G  adresse de l'editeur cible       */
             SendWindMessage(Windtab[w_ind].w_h, Shortcut, (GRECT*)param);
             car  = 0;
             scan = 0;
            }
        }  /* endif  (Evnt->ksp & K_CTRL) */
      /*                                                     >>>> SANS RIEN <<<<<<<< */
     switch (scan)
       {case 0: 
             break;
        case 97:                     /*======== undo =================*/
             if (TXT_ED->U_Stack) UNDO_DO(w_ind, UNDO_Pop(TXT_ED->U_Stack), TXT_ED);
             break;
        case 82:                     /*======== insert ===============*/
             break;
        case 77:                     /*======== fleche droite ========*/
            /*.......... effacer le curseur texte ...................................*/
            EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
            pos = WhereIsCursor(TXT_ED);
            if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
               { GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
               }
            if (*txt==0 || *txt==13 || *txt== 10)
               {long old_lig   = TXT_ED->LigPt;
                TXT_ED->LigPt  = Min(TXT_ED->LigPt + 1, TXT_ED->NbLgn-1);
                if (old_lig   != TXT_ED->LigPt)
                   {BuffEditToText(w_ind, TXT_ED->BuffEdit, old_lig, TXT_ED);
                    TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
                    TXT_ED->CarPt  = 0;
                    TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                    CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                    if (CheckForScroll(w_ind, TXT_ED))
                       {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                        CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                       }      
                    NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                    TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
                   }
               }
            else if (*txt)
               {/*............ avancer d'une case vers la droite ....................*/
                if (Evnt->ksp & K_LRSHIFT)   TXT_ED->CarPt  = (long)LenLigne(TXT_ED->BuffEdit);
                else                         TXT_ED->CarPt += 1;
                CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                if (CheckForScroll(w_ind, TXT_ED))
                   {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                    CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                   }
                NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
               /*.......... afficher le curseur texte ...............................*/
               EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
              }
           break;
         case 75:                     /*======== fleche gauche =======*/
            /*.......... effacer le curseur texte ...................................*/
            EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
            pos = WhereIsCursor(TXT_ED);
            if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
               {GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
               }
            if (txt == TXT_ED->BuffEdit)
               {long old_lig   = TXT_ED->LigPt;
                TXT_ED->LigPt  = Max(TXT_ED->LigPt - 1, 0);
                if (old_lig   != TXT_ED->LigPt)
                   {BuffEditToText(w_ind, TXT_ED->BuffEdit, old_lig, TXT_ED);
                    TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
                    TXT_ED->CarPt  = LenLigne(TXT_ED->BuffEdit);
                    TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED); 
                    CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                    if (CheckForScroll(w_ind, TXT_ED))
                       {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                        CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                       }
                    NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                    TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
                   }
               }
            else if (txt > TXT_ED->BuffEdit)
               {/*............ avancer d'une case vers la gauche ....................*/
                if (Evnt->ksp & K_LRSHIFT)   TXT_ED->CarPt  = 0;
                else                         TXT_ED->CarPt -= 1;    
                CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                if (CheckForScroll(w_ind, TXT_ED))
                   {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                    CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                   }
                NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
               /*.......... afficher le curseur texte .................................*/
               EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
              }
           break;
         case 71:                     /*======== clr home ============*/
             {long old_lig   = TXT_ED->LigPt;
              long old_car   = TXT_ED->CarPt;
              /*.......... effacer le curseur texte ...................................*/
              EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
              /*.......... replacer le buffer d'edition dans le texte .................*/
              BuffEditToText(w_ind, TXT_ED->BuffEdit, old_lig, TXT_ED);
              if (Evnt->ksp & K_LRSHIFT)
                 {TXT_ED->LigPt          = TXT_ED->NbLgn-1;
                  TXT_ED->PremLigVisible = Min(TXT_ED->LigPt - TXT_ED->NbreLigVisible, TXT_ED->NbLgn - 1 - TXT_ED->NbreLigVisible);
                  TXT_ED->CarPt          = LenLigne(TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt);
                 }
              else
                 {TXT_ED->LigPt          = 0;
                  TXT_ED->PremLigVisible = 0;
                  TXT_ED->CarPt          = 0;
                 }
              TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
              /*.......... si changement de ligne mise a jour ..........................*/
              if (old_lig  != TXT_ED->LigPt || old_car != TXT_ED->CarPt )
                 {NotifiePremLignChg(w_ind, TRUE, TXT_ED);
                  TXT_ED->CurY          = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED); 
                  CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                  Mouse_off();
                  Blk_LigAndCar_to_BlkXY(TXT_ED);
                  EZ_ED_RedrawFromLineToLine(w_ind, TXT_ED->PremLigVisible, LONG_MAX, TXT_ED); 
                  if (CheckForScroll(w_ind, TXT_ED))
                     {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                     }
                  Mouse_on();
                  NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                 } /*  endif (old_lig  != TXT_ED->LigPt) */
             }
              break;
         case 72:                     /*======== fleche haute ========*/
         case 80:                     /*======== fleche basse ========*/
            { long old_lig   = TXT_ED->LigPt;
              /*.......... effacer le curseur texte ...................................*/
              EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE); 
              pos = WhereIsCursor(TXT_ED);
              if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
                 { GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                 }
              /*................................<<<< SHIFT PAGE vers Haut ou Bas.......*/
              if (Evnt->ksp & K_LRSHIFT)
                 {BuffEditToText(w_ind, TXT_ED->BuffEdit, old_lig, TXT_ED);
                  if (scan==80)         /* FLECHE BASSE */
                     {TXT_ED->LigPt          = Min(TXT_ED->LigPt + TXT_ED->NbreLigVisible, TXT_ED->NbLgn - 1);
                      TXT_ED->PremLigVisible = Max(0,Min(TXT_ED->PremLigVisible + TXT_ED->NbreLigVisible, TXT_ED->NbLgn - TXT_ED->NbreLigVisible));
                     }
                  else if (scan==72)    /* FLECHE HAUTE */
                     {TXT_ED->LigPt          = Max(TXT_ED->LigPt - TXT_ED->NbreLigVisible, 0);
                      TXT_ED->PremLigVisible = Max(TXT_ED->PremLigVisible - TXT_ED->NbreLigVisible, 0);
                     }
                  /*.......... si changement de ligne mise a jour ..........................*/
                  if (old_lig  != TXT_ED->LigPt)
                     {TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
                      NotifiePremLignChg(w_ind, FALSE, TXT_ED);
                      TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                      TXT_ED->CarPt  = X_to_CarOfLigne(TXT_ED->LastXPt + TXT_ED->TxtGrect.g_x + TXT_ED->MargLeft - TXT_ED->OfsX,
                                                       TXT_ED->BuffEdit, TXT_ED, CURS_UPDATE); 
                      Mouse_off();
                      Blk_LigAndCar_to_BlkXY(TXT_ED);
                      EZ_ED_RedrawFromLineToLine(w_ind, TXT_ED->PremLigVisible, LONG_MAX, TXT_ED); 
                      if (CheckForScroll(w_ind, TXT_ED))
                         {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                          CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                         }
                      NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                      Mouse_on();
                     } /*  endif (old_lig  != TXT_ED->LigPt) */
                 } /* if (Evnt->ksp & K_LRSHIFT)  */
              /*................................<<<< SANS RIEN LIGNE vers Haut ou Bas...... */
              else
                 {if (scan==80) TXT_ED->LigPt = Min(TXT_ED->LigPt + 1, TXT_ED->NbLgn - 1);
                  else          TXT_ED->LigPt = Max(TXT_ED->LigPt - 1, 0);
                  /*.......... si changement de ligne mise a jour ..........................*/
                  if (old_lig  != TXT_ED->LigPt)
                     {BuffEditToText(w_ind, TXT_ED->BuffEdit, old_lig, TXT_ED);
                      TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
                      TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED); 
                      TXT_ED->CarPt  = X_to_CarOfLigne(TXT_ED->LastXPt + TXT_ED->TxtGrect.g_x + TXT_ED->MargLeft - TXT_ED->OfsX, 
                                                       TXT_ED->BuffEdit, TXT_ED, CURS_UPDATE);
                      if (CheckForScroll(w_ind, TXT_ED))
                         {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                          CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                         }
                      NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);                      
                     } /*  endif (old_lig  != TXT_ED->LigPt)   */
                 } /* endelse  de if (Evnt->ksp & K_LRSHIFT)  */
              /*.......... afficher le curseur texte ...............................*/
              EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
              break;
            }  /* endcase case 72:  case 80:     */   
         default:
              {switch (car)
                 {case 0: break;
                  case 13:                     /*======== return ==============*/
                      {INT16 ret;
                       long len_str   = strlen(TXT_ED->BuffEdit);
                       blk_flag       = IsCursInBloc(TXT_ED);
                       /*.......... effacer le curseur texte .................................*/
                       EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                       pos = WhereIsCursor(TXT_ED);
                       if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
                          {GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                          }
                       /*........... effacer le bloc si curseur dedans ou coll .............*/
                       if (blk_flag & BLK_DEFINED && blk_flag & BLK_NEAR_CURS)
                          {/*.......... mettre  jour le texte ..............................*/
                           BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                           CouperBloc(w_ind, TXT_ED);
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                          }
                       /*.......... notifier au pere que la touche RETURN est appuye ........*/
                       param[0]=0;   /* position d'une eventuelle modif du buffer d'edition   */
                       param[1]=0;   /* longueur d'une eventuelle modif du buffer d'edition   */
                       ret = NotifieReturnDown(w_ind, param, TXT_ED);
                       /*............. si buffer modifi par pere, mise a jour pos bloc .........*/
                       if (ret == ED_RETURN_CHG && param[1])
                          {blk_flag       = IsPosInBloc(TXT_ED->LigPt, param[0], TXT_ED);
                           if (blk_flag & BLK_DEFINED && blk_flag & BLK_AFTER_CURS )
                              {if (TXT_ED->LigPt == TXT_ED->BlkDebLig) TXT_ED->BlkDebCar += param[1];                                       
                               if (TXT_ED->LigPt == TXT_ED->BlkEndLig) TXT_ED->BlkEndCar += param[1]; 
                               Blk_LigAndCar_to_BlkXY(TXT_ED);
                              }
                            NotifieTxtSizeChg(w_ind, EZ_ED_GETCURPOS(TXT_ED), param[1], TXT_ED);
                            UNDO_Push("INSBLK",
                                         0, 
                                         TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt + param[0] - TXT_ED->ptTxt, 
                                         param[1], 
                                         0, 
                                         TXT_ED->U_Stack);
                           len_str += param[1];
                          }
                       if (ret)
                          {/*.......... inserer le caractere CR/LF ..............................*/
                           memcpy(TXT_ED->BuffEdit + TXT_ED->CarPt + 2, TXT_ED->BuffEdit + TXT_ED->CarPt, len_str - TXT_ED->CarPt + 2);
                           if (TXT_ED->U_Stack)
                              {UNDO_Push("INSBLK",
                                         0, 
                                         TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt + TXT_ED->CarPt - TXT_ED->ptTxt, 
                                         2, 
                                         0, 
                                         TXT_ED->U_Stack);
                              }
                           TXT_ED->BuffEdit [TXT_ED->CarPt]   = 13;
                           TXT_ED->BuffEdit [TXT_ED->CarPt+1] = 10;
                           /*........... faut changer le buffer car plusieurs lignes ............*/
                           BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                           /*............. notifier au pere la modification de taille ...........*/   
                           NotifieTxtSizeChg(w_ind, EZ_ED_GETCURPOS(TXT_ED), 2L, TXT_ED);   
                           
                           /*............... mettre  jour les pointeurs du bloc ................*/
                           if (blk_flag & BLK_DEFINED && blk_flag & BLK_AFTER_CURS )
                              {if (TXT_ED->LigPt == TXT_ED->BlkDebLig) TXT_ED->BlkDebCar -= TXT_ED->CarPt;                                       
                               if (TXT_ED->LigPt == TXT_ED->BlkEndLig) TXT_ED->BlkEndCar -= TXT_ED->CarPt; 
                               TXT_ED->BlkEndLig ++;
                               TXT_ED->BlkDebLig ++;
                               Blk_LigAndCar_to_BlkXY(TXT_ED);
                              }
                           TXT_ED->LigPt++;
                           TextToBuffEdit( TXT_ED->LigPt, TXT_ED );
                           /*................ mettre a jour les pointeurs et curseur ............*/
                           TXT_ED->CarPt  = 0;         /* on se met au debut de la ligne         */
                           TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                           CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                           /*............... afficher la ligne et celles sous jacentes ..........*/
                           Mouse_off();
                           /*............ Regler le rectangle sur les lignes a afficher..........*/
                           EZ_ED_RedrawFromLineToLine(w_ind, TXT_ED->LigPt-1, LONG_MAX, TXT_ED); 
                           /*.......... notifier au parent le changement du nbr de lignes........*/
                           NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                           NotifieNbrLignChg(w_ind, FALSE, TXT_ED);
                           if (CheckForScroll(w_ind, TXT_ED))
                             {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                              CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                             }
                           TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
                           NotifieEditTxtChanged(w_ind, TXT_ED);                 
                           /*.......... afficher le curseur texte ...............................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
                           Mouse_on();
                          }
                      }
                       break;
                  case 8:             /*======== backspace ========*/
                       blk_flag = IsCursInBloc(TXT_ED);
                       if (blk_flag & BLK_DEFINED && blk_flag & BLK_NEAR_CURS)
                          {/*.......... effacer le curseur texte ................................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                           /*.......... mettre  jour le texte ..................................*/
                           BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                           CouperBloc(w_ind, TXT_ED);
                           pos      = WhereIsCursor(TXT_ED);
                           if (pos /* & SCROLL_BOTTOM || pos & SCROLL_TOP */)
                              { GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                              }
                           /*.......... remettre a jour les coordonnes du curseur ..............*/
                           CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                           TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                          }
                       else if (TXT_ED->CarPt > 0)                        /* ON EST DANS LE BUFFER       */
                          {long len_str = strlen(TXT_ED->BuffEdit);       /* nombre de lignes inchang   */
                           /*.......... effacer le curseur texte ................................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                           pos = WhereIsCursor(TXT_ED);
                           if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
                              { GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                              }
                           /*.......... pousser le caractere dans UNDO ..........................*/
                           if (TXT_ED->U_Stack) PushCarInUndo(TXT_ED->BuffEdit + TXT_ED->CarPt - 1, 
                                                              1,
                                                              TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt + TXT_ED->CarPt -1 - TXT_ED->ptTxt,
                                                              TXT_ED);
                           /*.......... effacer le caractere ....................................*/
                           memcpy(TXT_ED->BuffEdit + TXT_ED->CarPt - 1, TXT_ED->BuffEdit + TXT_ED->CarPt, len_str - TXT_ED->CarPt + 2);
                           /*............. notifier au pere la modification de taille ...........*/   
                           NotifieTxtSizeChg(w_ind, EZ_ED_GETCURPOS(TXT_ED)  - 1, -1L, TXT_ED);                    
                           /*............... mettre  jour les pointeurs du bloc ................*/
                           if (blk_flag & BLK_DEFINED && blk_flag & BLK_AFTER_CURS )
                              {TXT_ED->BlkDebCar -= 1;
                               TXT_ED->BlkEndCar -= 1;
                               Blk_LigAndCar_to_BlkXY(TXT_ED);
                              }  
                           /*................ mettre a jour les pointeurs et curseur ............*/
                           TXT_ED->CarPt--;
                           CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                           if (CheckForScroll(w_ind, TXT_ED))
                              {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                               CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                              }
                           TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
                           NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                           NotifieEditTxtChanged(w_ind, TXT_ED);
                           /*............... afficher la ligne ..................................*/
                           Mouse_off();
                           if (EffaceLigneCur(TXT_ED))
                              {Graphmode(MD_TRANS);
                               TXT_ED->DrawTxtLine(TXT_ED->LigPt, TXT_ED->TxtGrect.g_x, TXT_ED->CurY, TXT_ED);
                              }
                           /*.......... afficher le curseur texte ...............................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
                           Mouse_on();
                          } /* end if (TXT_ED->CarPt > 0)   */
                       else if (TXT_ED->LigPt>0)               /* ON EST AU DEBUT DU BUFFER      */
                          {/*................. mesurer la longueur de la ligne d'avant ..........*/
                           long len_str    = LenLigne(TXT_ED->TabLgnCtx[TXT_ED->LigPt - 1].ptTxt); 
                           long old_ligpt  = TXT_ED->LigPt;
                           long nb_car_del = 0;
                           /*.......... effacer le curseur texte ................................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                           pos = WhereIsCursor(TXT_ED);
                           if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
                              { GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                              }
                           /*.......... mettre  jour le texte ..................................*/
                           BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                           /*.......... effacer le \r\n .........................................*/
                           TXT_ED->LigPt--;   /* on se met ligne avant pour effacer \r\n         */
                           /*.......... le curseur texte passe  la fin de la ligne d'avant .....*/
                           TXT_ED->CarPt = LenLigne(TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt);
                           /*.......... on efface le bloc comme pour delete .....................*/
                           nb_car_del = DeleteBloc(TXT_ED->LigPt, TXT_ED->CarPt,  TXT_ED->LigPt + 1, 0,  TXT_ED); 
                           /*............. notifier au pere la modification de taille ...........*/   
                           NotifieTxtSizeChg(w_ind, EZ_ED_GETCURPOS(TXT_ED), -nb_car_del, TXT_ED);                                               
                           NotifieEditTxtChanged(w_ind, TXT_ED);
                           /*............... mettre  jour les pointeurs du bloc ................*/
                           if (blk_flag & BLK_DEFINED && blk_flag & BLK_AFTER_CURS )
                              {if (old_ligpt == TXT_ED->BlkDebLig) TXT_ED->BlkDebCar += len_str;                                       
                               if (old_ligpt == TXT_ED->BlkEndLig) TXT_ED->BlkEndCar += len_str; 
                               TXT_ED->BlkEndLig --;
                               TXT_ED->BlkDebLig --;
                              }
                           Blk_LigAndCar_to_BlkXY(TXT_ED);
                           /*.......... replacer la ligne en edition ............................*/                           
                           TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
                           /*.......... notifier au parent le changement du nbr de lignes........*/
                           NotifieNbrLignChg(w_ind, FALSE, TXT_ED);
                           NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);                           
                           /*.......... remettre a jour les coordonnes du curseur ..............*/
                           TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                           CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE); 
                           if (CheckForScroll(w_ind, TXT_ED))
                              {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                               CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                              }
                           /*............... afficher la ligne et celles sous jacentes ..........*/
                           Mouse_off();
                           EZ_ED_RedrawFromLineToLine(w_ind, TXT_ED->LigPt -1, LONG_MAX, TXT_ED);
                           /*.......... afficher le curseur texte ...............................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
                           Mouse_on();
                          }
                       break;
                  case 127:           /*======== delete ========*/ 
                      {long len_str    = strlen(TXT_ED->BuffEdit);
                       long nb_car_del = 0;
                       blk_flag = IsCursInBloc(TXT_ED);
                       if (blk_flag & BLK_DEFINED && blk_flag & BLK_NEAR_CURS)
                          {/*.......... effacer le curseur texte ................................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                           /*.......... mettre  jour le texte ..................................*/
                           BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                           CouperBloc(w_ind, TXT_ED);
                           pos      = WhereIsCursor(TXT_ED);
                           if (pos /* & SCROLL_BOTTOM || pos & SCROLL_TOP */)
                              { GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                              }
                           /*.......... remettre a jour les coordonnes du curseur ..............*/
                           CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                           TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                          }
                       else if (TXT_ED->BuffEdit[TXT_ED->CarPt])           /* ON EST DANS LE BUFFER      */
                          {/*.......... effacer le curseur texte ................................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                           pos = WhereIsCursor(TXT_ED);
                           if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
                              {GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                              }
                           /*.......... pousser le caractere dans UNDO ..........................*/
                           if (TXT_ED->U_Stack) PushCarInUndo(TXT_ED->BuffEdit + TXT_ED->CarPt, 
                                                              1,
                                                              TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt + TXT_ED->CarPt - TXT_ED->ptTxt,
                                                              TXT_ED);
                           /*.......... effacer le caractere ....................................*/
                           memcpy(TXT_ED->BuffEdit + TXT_ED->CarPt, TXT_ED->BuffEdit + TXT_ED->CarPt + 1, len_str - TXT_ED->CarPt + 1);
                           /*............. notifier au pere la modification de taille ...........*/   
                           NotifieTxtSizeChg(w_ind, EZ_ED_GETCURPOS(TXT_ED), -1L, TXT_ED);
                           /*............... mettre  jour les pointeurs du bloc ................*/
                           if (blk_flag & BLK_DEFINED && blk_flag & BLK_AFTER_CURS )
                              {if (TXT_ED->LigPt == TXT_ED->BlkDebLig) TXT_ED->BlkDebCar -= 1;
                               if (TXT_ED->LigPt == TXT_ED->BlkEndLig) TXT_ED->BlkEndCar -= 1; 
                               Blk_LigAndCar_to_BlkXY(TXT_ED);
                              }
                           /*............... afficher la ligne ..................................*/    
                           Mouse_off();
                           if (EffaceLigneCur(TXT_ED))
                              {Graphmode(MD_TRANS);
                               TXT_ED->DrawTxtLine(TXT_ED->LigPt, TXT_ED->TxtGrect.g_x, TXT_ED->CurY, TXT_ED);
                              }
                           /*................ mettre a jour les pointeurs et curseur ............*/
                           CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                           TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
                           NotifieEditTxtChanged(w_ind, TXT_ED);
                           NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                           /*.......... afficher le curseur texte ...............................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
                           Mouse_on();
                          } /* end if (TXT_ED->BuffEdit[TXT_ED->CarPt])   */
                       else if (TXT_ED->LigPt<TXT_ED->NbLgn - 1)    /* ON EST EN FIN DE BUFFER   */
                          {/*.......... effacer le curseur texte ................................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                           pos = WhereIsCursor(TXT_ED);
                           if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
                              {GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                              }
                           /*.......... mettre  jour le texte ..................................*/
                           BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                           /*.......... effacer le \r\n .........................................*/                           
                           nb_car_del = DeleteBloc(TXT_ED->LigPt, TXT_ED->CarPt,  TXT_ED->LigPt+1, 0,  TXT_ED);
                           /*............. notifier au pere la modification de taille ...........*/   
                           NotifieTxtSizeChg(w_ind, EZ_ED_GETCURPOS(TXT_ED), -nb_car_del, TXT_ED);   
                           NotifieEditTxtChanged(w_ind, TXT_ED);
                           /*............... mettre  jour les pointeurs du bloc ................*/
                           if (blk_flag & BLK_DEFINED && blk_flag & BLK_AFTER_CURS )
                              {TXT_ED->BlkEndLig --;
                               TXT_ED->BlkDebLig --;
                               if (TXT_ED->LigPt == TXT_ED->BlkDebLig) TXT_ED->BlkDebCar += len_str;                                       
                               if (TXT_ED->LigPt == TXT_ED->BlkEndLig) TXT_ED->BlkEndCar += len_str; 
                               Blk_LigAndCar_to_BlkXY(TXT_ED);
                              }
                           /*.......... replacer la ligne en edition ............................*/
                           TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
                           /*............... afficher la ligne et celles sous jacentes ..........*/
                           Mouse_off();
                           EZ_ED_RedrawFromLineToLine(w_ind, TXT_ED->LigPt -1, LONG_MAX, TXT_ED);                           
                           /*.......... notifier au parent le changement du nbr de lignes........*/
                           NotifieNbrLignChg(w_ind, TRUE, TXT_ED);
                           NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                           /*.......... afficher le curseur texte ...............................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
                          }
                       }
                       break;
                  case '':           /*======== escape ========*/
                       Evnt->evnt              |= MU_MESAG;
                       Evnt->pipe[MESG]         = WM_EDIT_CLOSE;
                       *(long*)&Evnt->pipe[W_G] = (long)TXT_ED;
                       break;
                  default:
                       blk_flag = IsCursInBloc(TXT_ED);
                       pos      = WhereIsCursor(TXT_ED);
                       if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP)
                          { GotoNewPosCurs(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                          }
                       if (blk_flag & BLK_DEFINED && blk_flag & BLK_NEAR_CURS)
                          {/*.......... mettre  jour le texte ..................................*/
                           BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
                           CouperBloc(w_ind, TXT_ED); 
                           blk_flag &= ~(BLK_DEFINED|BLK_NEAR_CURS);
                          }
                       if (TXT_ED->CarPt < TXT_ED->SizeLgn)
                          {long len_str = strlen(TXT_ED->BuffEdit);
                           /*.......... effacer le curseur texte ................................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE);
                           /*.......... inserer le caractere ....................................*/
                           memcpy(TXT_ED->BuffEdit + TXT_ED->CarPt + 1, TXT_ED->BuffEdit + TXT_ED->CarPt, len_str - TXT_ED->CarPt + 2);
                           if (TXT_ED->U_Stack) 
                              {UNDO_Push("INSBLK",
                                         0,
                                         TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt + TXT_ED->CarPt - TXT_ED->ptTxt, 
                                         1,
                                         0,
                                         TXT_ED->U_Stack);
                              }
                           TXT_ED->BuffEdit [TXT_ED->CarPt] = car;
                           /*............. notifier au pere la modification de taille ...........*/   
                           NotifieTxtSizeChg(w_ind, EZ_ED_GETCURPOS(TXT_ED), 1L, TXT_ED);
                           /*............... mettre  jour les pointeurs du bloc ................*/
                           if (blk_flag & BLK_DEFINED && blk_flag & BLK_AFTER_CURS )
                              {if (TXT_ED->LigPt == TXT_ED->BlkDebLig) TXT_ED->BlkDebCar += 1;
                               if (TXT_ED->LigPt == TXT_ED->BlkEndLig) TXT_ED->BlkEndCar += 1; 
                               Blk_LigAndCar_to_BlkXY(TXT_ED);
                              }
                           /*............... afficher la ligne ..................................*/                           
                           Mouse_off();
                           if (EffaceLigneCur(TXT_ED))
                              {Graphmode(MD_TRANS);
                               TXT_ED->DrawTxtLine(TXT_ED->LigPt, TXT_ED->TxtGrect.g_x, TXT_ED->CurY, TXT_ED);
                              }
                           /*................ mettre a jour les pointeurs et curseur ............*/
                           TXT_ED->CarPt++;
                           CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                           if (CheckForScroll(w_ind, TXT_ED))
                              {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
                               CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
                              }
                           TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
                           NotifieEditTxtChanged(w_ind, TXT_ED);
                           NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
                           /*.......... afficher le curseur texte ...............................*/
                           EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
                           Mouse_on();
                          } /* end if (TXT_ED->CarPt < TXT_ED->SizeLgn)   */
                 }  /*endswitch (car)     */
              } /* end default:          */
        } /*endswitch (scan)            */
     /*........ empecher la propagation du message ........*/
     Evnt->evnt &= ~MU_KEYBD;            
    } /* endif (Evnt->evnt & MU_KEYBD) */
    
 /*.........................>>>> SOURIS  (MU_MOVE) <<<< ......................*/
 if (Evnt->evnt & MU_MOVE)
    {INT16 mo_form;
     INT16 k = Mousek();  /* sous TOS simple l'appui bouton mal evalue lors MU_MOVE !! */
     if      (TXT_ED->State & EDIT_MOFORM_POINT_HAND) mo_form = POINT_HAND;
     else if (TXT_ED->State & EDIT_MOFORM_ARROW)      mo_form = ARROW;
     else                                             mo_form = TEXT_CRSR;
     if (TXT_ED->State & MO_TRACK_ON && k == 0)
        {TXT_ED->State    &= ~MO_TRACK_ON;
         if (GetMouseForm() != mo_form) SetMouseForm(mo_form);
         Evnt->evnt &= ~MU_MOVE;
        }
     if (TXT_ED->State & MO_TRACK_ON && k == 1)
        {Evnt->evnt &= ~MU_MOVE;
        }
     else
        {/*.............. si on est dans le rectangle texte ..................*/
         /*               verifier si bonne forme de souris                   */
         if (wh_top == GETGEMHAND(w_ind) && 
             IsMouseXYInGrect(Evnt->x,  Evnt->y, &TXT_ED->TxtGrect)
            )
            {if (GetMouseForm() != mo_form)  SetMouseForm(mo_form);
             Evnt->evnt &= ~MU_MOVE;
            }
         else if (GetMouseForm() == mo_form) SetMouseForm(ARROW);
        }       /*  endif (TXT_ED->State & MO_TRACK_ON)    */
    }         /*   endif (Evnt->evnt & MU_MOVE)           */
    
 /*........................>>>> SOURIS  (MU_BUTTON) <<<<< .....................*/
 if (Evnt->evnt & MU_BUTTON )
    {INT16 mo_form;
     if      (TXT_ED->State & EDIT_MOFORM_POINT_HAND) mo_form = POINT_HAND;
     else if (TXT_ED->State & EDIT_MOFORM_ARROW)      mo_form = ARROW;
     else                                             mo_form = TEXT_CRSR;
     /*................... si pas au top mettre au top ........................*/
     if (w_h != wh_top)
        {BuffEditToText(w_ind,TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
        }
     /*................... sinon interpreter le clic souris ...................*/
     else if ((IsMouseXYInGrect(Evnt->x,  Evnt->y, &TXT_ED->TxtGrect) || TXT_ED->State & MO_TRACK_ON) &&
              NotifieClick(w_ind, Evnt, TXT_ED)
             )
        {long old_lig     = TXT_ED->LigPt;
         /*.............. verifier forme souris ...............................*/
         if (TXT_ED->State & MO_TRACK_ON)
            {if (GetMouseForm() != POINT_HAND)   SetMouseForm(POINT_HAND);
            }
         else if (GetMouseForm() != mo_form)     SetMouseForm(mo_form);
         /*.......... effacer le curseur texte ................................*/
         EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_ERASE); 
         /*.......... calcul nouvelle position souris .........................*/
         TXT_ED->LigPt = Y_to_Lig(Evnt->y, TXT_ED);
         /*......... ne pas pointer plus d'une ligne apres le bas .............*/
         /*          car le scroll des blocs aime pas                          */
         TXT_ED->LigPt = Min(TXT_ED->LigPt, TXT_ED->PremLigVisible + TXT_ED->NbreLigVisible);
         TXT_ED->LigPt = Max(TXT_ED->LigPt, 0);
         /*.......... si changement de ligne mise a jour ......................*/
         if (old_lig  != TXT_ED->LigPt)
            {BuffEditToText(w_ind, TXT_ED->BuffEdit, old_lig, TXT_ED);
             TextToBuffEdit( TXT_ED->LigPt, TXT_ED);
            }
         TXT_ED->CarPt = X_LigPt_to_CarOfLigne( Evnt->x,  TXT_ED->LigPt, TXT_ED, CURS_UPDATE);
         if (CheckForScroll(w_ind, TXT_ED))
            {TXT_ED->CurY   = (INT16)Lig_To_Y(TXT_ED->LigPt, TXT_ED);
             CarOfLigne_to_X(TXT_ED->BuffEdit, TXT_ED->CarPt, TXT_ED, CURS_UPDATE);
            }
         NotifieLigneChg(w_ind, TXT_ED->LigPt, TXT_ED->CarPt, TXT_ED);
         /*....................... DOUBLE CLICK ...............................*/
         if ( Evnt->click == 2)
            {BuffEditToText(w_ind, TXT_ED->BuffEdit, TXT_ED->LigPt, TXT_ED);
             if (Evnt->ksp & K_LRSHIFT)           /* selectionner la ligne     */
                {char *word_deb, *word_end;
                 word_deb = TXT_ED->TabLgnCtx[TXT_ED->LigPt].ptTxt;
                 if (TXT_ED->LigPt < TXT_ED->NbLgn -1)
                    word_end = TXT_ED->TabLgnCtx[TXT_ED->LigPt+1].ptTxt;
                 else                                  
                    word_end = word_deb + LenLigne(word_deb);
                 if (word_end != word_deb)
                    {if (IsTxtBlkDefined(TXT_ED))
                        {EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                        }
                     TXT_ED->BlkDebLig =  CarPt_to_Curs(word_deb, &TXT_ED->BlkDebCar, TXT_ED);
                     TXT_ED->BlkEndLig =  CarPt_to_Curs(word_end, &TXT_ED->BlkEndCar, TXT_ED);
                     Blk_LigAndCar_to_BlkXY(TXT_ED);
                     EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                    }
                }
             else
                {char *car, *word_deb, *word_end;
                 INT16 i;
                 car      = XY_to_CarPt(Evnt->x, Evnt->y, TXT_ED);
                 if (Evnt->ksp & K_CTRL) i = WORD_VAR;
                 else                    i = WORD_SIMPLE;
                 word_deb = EZ_ED_CarPtToWord(car, TXT_ED->ptTxt, &word_end, i);
                 if (word_end != word_deb)
                    {if (IsTxtBlkDefined(TXT_ED))
                        {EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                        }
                     TXT_ED->BlkDebLig =  CarPt_to_Curs(word_deb, &TXT_ED->BlkDebCar, TXT_ED);
                     TXT_ED->BlkEndLig =  CarPt_to_Curs(word_end, &TXT_ED->BlkEndCar, TXT_ED);
                     Blk_LigAndCar_to_BlkXY(TXT_ED);
                     EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                    }
                }
             /*.......... afficher le curseur texte ...............................*/
             EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
            }
         /*....................... SIMPLE CLICK ...............................*/
         else
            {/*............ si on est sur le meme caractere .......................*/
             /*             et que le bloc est pas en cours de definition          */
             /*             on commence une definition de bloc                     */
             /*             ou on l'etend si SHIFT appuy                          */
             INT16 k = Mousek();  /* sous TOS simple l'appui bouton mal evalue lors MU_MOVE !! */
             if (Evnt->ksp & K_LRSHIFT  && !(TXT_ED->State & MO_TRACK_ON) && k == 1)
                {/*............ etendre le bloc vers le haut ou le bas ............*/
                 if (IsTxtBlkDefined(TXT_ED))
                    {EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                    }
                 if (GetNearBlkFromXY(Evnt->x, Evnt->y, TXT_ED))
                    {TXT_ED->BlkDebLig = TXT_ED->BlkEndLig;
                     TXT_ED->BlkDebCar = TXT_ED->BlkEndCar;
                     TXT_ED->BlkDebX   = TXT_ED->BlkEndX;
                     TXT_ED->BlkDebY   = TXT_ED->BlkEndY;
                    }
                 TXT_ED->BlkEndLig = TXT_ED->LigPt;
                 TXT_ED->BlkEndCar = TXT_ED->CarPt;
                 TXT_ED->BlkEndX   = TXT_ED->CurX;
                 TXT_ED->BlkEndY   = TXT_ED->CurY;
                 TXT_ED->State    |= MO_TRACK_ON;
                 EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                }
             else if ( ! (TXT_ED->State & MO_TRACK_ON) && k == 1)
                {/*............ si un bloc est deja defini l'effacer ..............*/
                 if (IsTxtBlkDefined(TXT_ED))
                    {EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_ED);
                    }
                 TXT_ED->BlkDebLig = TXT_ED->LigPt;
                 TXT_ED->BlkDebCar = TXT_ED->CarPt;
                 TXT_ED->BlkEndLig = TXT_ED->LigPt;
                 TXT_ED->BlkEndCar = TXT_ED->CarPt;
                 TXT_ED->BlkDebX   = TXT_ED->CurX;
                 TXT_ED->BlkDebY   = TXT_ED->CurY;
                 TXT_ED->BlkEndX   = TXT_ED->CurX;
                 TXT_ED->BlkEndY   = TXT_ED->CurY;
                 TXT_ED->State    |= MO_TRACK_ON;
                 if (GetMouseForm() != POINT_HAND) SetMouseForm(POINT_HAND);
                }
             /*........... si on est en mode definition de bloc ..................*/
             /*            updater le bloc si changement                          */
             else if (TXT_ED->State     & MO_TRACK_ON)
                {/*........... si bloc change ............*/
                 if (TXT_ED->BlkEndLig != TXT_ED->LigPt ||
                     TXT_ED->BlkEndCar != TXT_ED->CarPt
                    )
                    {EZ_ED_DrawBlkFrame(w_ind, BLK_UPDATE, TXT_ED);
                     TXT_ED->BlkEndLig = TXT_ED->LigPt;
                     TXT_ED->BlkEndCar = TXT_ED->CarPt;
                     TXT_ED->BlkEndX   = TXT_ED->CurX;
                     TXT_ED->BlkEndY   = TXT_ED->CurY;
                    }
                }
             TXT_ED->LastXPt = TXT_ED->CurX - TXT_ED->TxtGrect.g_x - TXT_ED->MargLeft + TXT_ED->OfsX;
             /*.......... afficher le curseur texte ...............................*/
             EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_DRAW);
            }  /* endelse de if ( Evnt->click == 2)   */ 
         /*................... empecher propagation evenement souris ...........*/
         /*                    afin que le reste du programme                   */
         /*                    ne reagisse pas a la souris                      */
         Evnt->evnt &= ~MU_BUTTON;
        }
     else  /* else de if (if NotifieClick() && IsMouseXYInGrect())       */
        {if (NotifieOutTxtClick(w_ind, Evnt, TXT_ED))
            {Evnt->evnt              |= MU_MESAG;
             Evnt->pipe[MESG]         = WM_EDIT_CLOSE;
             *(long*)&Evnt->pipe[W_G] = (long)TXT_ED;
            }
        }
    }
 
 /*.........................>>>> TIMER  (MU_TIMER) <<<< .......................*/
 if (Evnt->evnt & MU_TIMER)  
    {INT16 mo_form;
     INT16 k = Mousek();  /* sous TOS simple l'appui bouton mal evalue lors MU_MOVE !! */
     if      (TXT_ED->State & EDIT_MOFORM_POINT_HAND) mo_form = POINT_HAND;
     else if (TXT_ED->State & EDIT_MOFORM_ARROW)      mo_form = ARROW;
     else                                             mo_form = TEXT_CRSR;
     
     CurTim++;
     if (CurTim>TXT_ED->CurFqce)
        {CurTim=0;
         if (! (Windtab[w_ind].w_flag & (W_IS_ICON|W_IS_ALLICON)) )
            {EZ_ED_DrawCurs(w_ind,  TXT_ED, CURS_FLASH);
            }
        }

     if (TXT_ED->State & MO_TRACK_ON && k == 0)
        {TXT_ED->State    &= ~MO_TRACK_ON;
         if (GetMouseForm() != mo_form) SetMouseForm(mo_form);
        }
     else
        {/*.............. si on est dans le rectangle texte ..................*/
         /*           de la fenetre en edition (celle au top)                 */
         /*               verifier si bonne forme de souris                   */
         if (wh_top == GETGEMHAND(w_ind) && 
             IsMouseXYInGrect(Evnt->x,  Evnt->y, &TXT_ED->TxtGrect)
            )
            {if (GetMouseForm() != mo_form)  SetMouseForm(mo_form);
            }
         else if (GetMouseForm() == mo_form) SetMouseForm(ARROW);
        }
     Evnt->evnt &= ~MU_TIMER;
    }
    
 /*.........................>>>> MESSAGES  (MU_MESAG) <<<< ....................*/
 if (Evnt->evnt & MU_MESAG)
    {TXTED_OB* TXT_A;
     char *pt_txt;
     switch (Evnt->pipe[MESG])
       {case  EXE_ED_SET_CURS_POS:
             {long ligpt, carpt;
              pt_txt       = (char*)(*(long*)&Evnt->pipe[X_G]);
              TXT_A        = (TXTED_OB*)(*(long*)&Evnt->pipe[W_G]);
              /*.......... mettre  jour le texte ..................................*/
              BuffEditToText(w_ind, TXT_A->BuffEdit, TXT_A->LigPt, TXT_A);
              /*.......... effacer le curseur texte ................................*/
              /* if (TXT_A==TXT_ED) */ EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);
              ligpt        = CarPt_to_Curs(pt_txt, &carpt, TXT_A);
              TXT_A->LigPt = Min(ligpt, TXT_A->NbLgn - 1);
              TextToBuffEdit(TXT_A->LigPt , TXT_A);
              GotoNewPosCurs(w_ind, ligpt, carpt, TXT_A);
              EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_DRAW);
             }
              break;
        case  EXE_ED_CLEAR_SEL:
             {TXT_A = (TXTED_OB*)(*(long*)&Evnt->pipe[W_G]);
              if (IsTxtBlkDefined(TXT_A))
                 {/*.......... effacer le curseur texte ................................*/
                  EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);
                  EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_A);
                 }
              TXT_A->BlkDebLig = TXT_A->LigPt;
              TXT_A->BlkDebCar = TXT_A->CarPt;
              TXT_A->BlkEndLig = TXT_A->LigPt;
              TXT_A->BlkEndCar = TXT_A->CarPt;
              Blk_LigAndCar_to_BlkXY(TXT_A);
             }
              break;
        case  EXE_ED_SET_SEL_DEB:
        case  EXE_ED_SET_SEL_END:
             {long ligpt, carpt; 
              pt_txt       = (char*)(*(long*)&Evnt->pipe[X_G]);
              TXT_A = (TXTED_OB*)(*(long*)&Evnt->pipe[W_G]);
              /*.......... mettre  jour le texte ......................................*/
              BuffEditToText(w_ind, TXT_A->BuffEdit, TXT_A->LigPt, TXT_A);
              ligpt = CarPt_to_Curs(pt_txt, &carpt, TXT_A);
              /*............ si un bloc est deja defini l'effacer ......................*/
              if (IsTxtBlkDefined(TXT_A))
                 {/*.......... effacer le curseur texte ................................*/
                  EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);
                  EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_A);
                 }
              if (ligpt>=0)
                 {if (Evnt->pipe[MESG] == EXE_ED_SET_SEL_DEB)
                     {TXT_A->BlkDebLig = ligpt;
                      TXT_A->BlkDebCar = carpt;
                     }
                  else
                     {TXT_A->BlkEndLig = ligpt;
                      TXT_A->BlkEndCar = carpt;
                     }
                  Blk_LigAndCar_to_BlkXY(TXT_A);
                  if (IsTxtBlkDefined(TXT_A)) EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_A);
                  /*.......... afficher le curseur texte ..............................*/
                  EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_DRAW);
                 }
              }
              break;
              
        case  EXE_ED_DEL:
        case  EXE_ED_COPY:
        case  EXE_ED_COPY_ADD:
        case  EXE_ED_CUT:
              TXT_A = (TXTED_OB*)(*(long*)&Evnt->pipe[W_G]);
              if (IsTxtBlkDefined(TXT_A))
                 {char *deb_txt;
                  char *end_txt;
                  char  sav;
                  INT16   pos;
                  long  deb_lig ,deb_car ,end_lig ,end_car;
                  /*.............. Recuperer un bloc ordonn ...........................*/
                  GetSortedBlkMark(&deb_lig, &deb_car, &end_lig, &end_car, TXT_A);                  
                  /*.......... mettre  jour le texte ..................................*/
                  BuffEditToText(w_ind, TXT_A->BuffEdit, TXT_A->LigPt, TXT_A);
                  deb_txt  =  TXT_A->TabLgnCtx[deb_lig].ptTxt + deb_car;
                  end_txt  =  TXT_A->TabLgnCtx[end_lig].ptTxt + end_car;
                  sav      = *end_txt;
                  *end_txt = 0;
                  if (Evnt->pipe[MESG] != EXE_ED_DEL)
                     {if (Evnt->ksp & K_LRSHIFT || Evnt->pipe[MESG] == EXE_ED_COPY_ADD)
                         {ClipboardSave("\n\r",  O_WRONLY|O_APPEND|O_CREAT);  /* shift */
                          ClipboardSave(deb_txt, O_WRONLY|O_APPEND|O_CREAT);  /* shift */
                         }
                      else
                         {ClipboardSave(deb_txt, O_WRONLY|O_CREAT|O_TRUNC);                                       
                         }
                     }
                  *end_txt = sav;
                  /*.............. si couper le bloc ...................................*/
                  if (Evnt->pipe[MESG] == EXE_ED_CUT || Evnt->pipe[MESG] == EXE_ED_DEL)
                     {
                      CouperBloc(w_ind, TXT_A);
                     }  /*   endif (Evnt->pipe[MESG] == EXE_ED_CUT) */
                  EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);   
                  pos      = WhereIsCursor(TXT_A);
                  if (pos /*& SCROLL_BOTTOM || pos & SCROLL_TOP*/)
                     {GotoNewPosCurs(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
                     }
                  /*.......... remettre a jour les coordonnes du curseur ..............*/
                  CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
                  TXT_A->CurY   = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
                           
                  /*.......... afficher le curseur texte ..............................*/
                  EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_DRAW);
                  Mouse_on();
                 }
              break;
              
        case  EXE_ED_FILE_PASTE:
        case  EXE_ED_MEMORY_PASTE:
        case  EXE_ED_SCRAP_PASTE:
             {long old_ligpt;
              long old_preml;
              long old_car;
              long old_car_from_end_line ;
              long nb_l;
              INT16 pos;
              INT16 blk_flag;
              TXT_A    = (TXTED_OB*)(*(long*)&Evnt->pipe[W_G]);
              blk_flag = IsCursInBloc(TXT_A);
              /*.......... mettre  jour le texte ..................................*/
              BuffEditToText(w_ind, TXT_A->BuffEdit, TXT_A->LigPt, TXT_A);
              /*.......... effacer le bloc si besoin ...............................*/
              if (blk_flag & BLK_DEFINED && blk_flag & BLK_NEAR_CURS)
                 {CouperBloc(w_ind, TXT_A);
                 }
              /*.......... effacer le curseur texte ................................*/
              EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);
              old_ligpt = TXT_A->LigPt;
              old_preml = TXT_A->PremLigVisible;
              old_car   = TXT_A->CarPt;
              /*............ si un bloc est deja defini l'effacer ..................*/
              if (IsTxtBlkDefined(TXT_A))
                 {EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_A);
                 }
              /*.......... noter a combien de la fin de ligne ......................*/
              /*                se trouve le curseur                                */
              old_car_from_end_line  = LenLigne(TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt) -
                                                TXT_A->CarPt;
              /*.......... inserer le texte ........................................*/
              nb_l = InsereBloc(w_ind,
                                (char*)(*(long*)&Evnt->pipe[X_G]),
                                TXT_A->LigPt,
                                TXT_A->CarPt,
                                Evnt->pipe[MESG],
                                TXT_A
                                );   
              NotifieEditTxtChanged(w_ind, TXT_A);
              
              if (nb_l > 0)
                 {TXT_A->LigPt += nb_l - 1;         /* sur la der ligne inseree    */
                 }
              TXT_A->CarPt  = LenLigne(TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt) - 
                                        old_car_from_end_line;
              /*.......... replacer la ligne en edition ............................*/
              TextToBuffEdit( TXT_A->LigPt, TXT_A);
              /*.......... replacer les marques du bloc ............................*/
              /*           sur ce qui vient d'etre insere                           */
              
              /*.......... mise a jour du curseur et du pere .......................*/
              if (old_ligpt != TXT_A->LigPt)
                 {NotifieNbrLignChg(w_ind, FALSE, TXT_A);
                 }
              if (TXT_A->LigPt < TXT_A->PremLigVisible || TXT_A->LigPt > TXT_A->PremLigVisible + TXT_A->NbreLigVisible)
                 {TXT_A->PremLigVisible = Max(0, TXT_A->LigPt - TXT_A->NbreLigVisible);
                  TXT_A->PremLigVisible = Min(TXT_A->PremLigVisible, TXT_A->NbLgn - 1 - TXT_A->NbreLigVisible );
                  TXT_A->PremLigVisible = Max(TXT_A->PremLigVisible, 0);
                  NotifiePremLignChg(w_ind, FALSE, TXT_A);
                 }
              NotifieLigneChg(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
              TXT_A->CurY    = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A); 
              CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
              TXT_A->LastXPt = TXT_A->CurX - TXT_A->TxtGrect.g_x - TXT_A->MargLeft + TXT_A->OfsX;
              /*............. effacer les marques de bloc afin que les redraws......*/
              /*                      sous jacents ne l'affichent plus              */
              TXT_A->BlkDebLig   = TXT_A->BlkDebCar = TXT_A->BlkEndLig = TXT_A->BlkEndCar = 0;
              /*............... afficher la ligne et celles sous jacentes ..........*/
              Mouse_off(); 
              if (nb_l== 1)
                 {EZ_ED_RedrawFromLineToLine(w_ind, TXT_A->LigPt, TXT_A->LigPt + 1, TXT_A); 
                 }
              /*..................... si bloc visible dans fenetre .................*/
              else if (TXT_A->LigPt >= old_preml && TXT_A->LigPt <= old_preml + TXT_A->NbreLigVisible)
                 { EZ_ED_RedrawFromLineToLine(w_ind, old_ligpt , LONG_MAX, TXT_A);
                 }
              else
                 {EZ_ED_RedrawFromLineToLine(w_ind, TXT_A->PremLigVisible , LONG_MAX, TXT_A);
                 }
              /*.......... definir un bloc avec l'insertion ........................*/
              /* #define EDIT_BLK_NOT_AFTER_PASTE     64   specifie que l'ajout est non marque        */
              if (TXT_A->State & EDIT_BLK_NOT_AFTER_PASTE)
                 {TXT_A->BlkDebLig = TXT_A->BlkEndLig = TXT_A->LigPt;
                  TXT_A->BlkDebCar = TXT_A->BlkEndCar = TXT_A->CarPt;
                 }
              else
                 {TXT_A->BlkDebLig = old_ligpt;
                  TXT_A->BlkDebCar = old_car;
                  TXT_A->BlkEndLig = TXT_A->LigPt;
                  TXT_A->BlkEndCar = TXT_A->CarPt;
                  Blk_LigAndCar_to_BlkXY(TXT_A);
                  /*.............. Dessiner selection du bloc ..........................*/
                  EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_A);
                 }
              /*..................... curseur visible dans fenetre ?....................*/
              /* #define EDIT_SCRL_NOT_AFTER_PASTE   128   specifie ecran non auto centre apres paste */
              if (TXT_A->State & EDIT_SCRLH_NOT_AFTER_PASTE && 
                  TXT_A->State & EDIT_SCRLV_NOT_AFTER_PASTE)
                 {
                 }
              else if (TXT_A->State & EDIT_SCRLH_NOT_AFTER_PASTE)
                 {pos      = WhereIsCursor(TXT_A);
                  if (pos & SCROLL_BOTTOM || pos & SCROLL_TOP )
                     { GotoNewPosCurs(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
                     }
                  /*.......... remettre a jour les coordonnes du curseur ..............*/
                  CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
                  TXT_A->CurY   = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
                 }
              else if (TXT_A->State & EDIT_SCRLV_NOT_AFTER_PASTE)
                 {pos      = WhereIsCursor(TXT_A);
                  if (pos & SCROLL_LEFT || pos & SCROLL_RIGHT)
                     { GotoNewPosCurs(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
                     }
                  /*.......... remettre a jour les coordonnes du curseur ..............*/
                  CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
                  TXT_A->CurY   = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
                 }
              else
                 {pos      = WhereIsCursor(TXT_A);
                  if (pos)
                     { GotoNewPosCurs(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
                     }
                  /*.......... remettre a jour les coordonnes du curseur ..............*/
                  CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
                  TXT_A->CurY   = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
                 }
                  
              /*.......... afficher le curseur texte ...............................*/
              EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_DRAW);
              Mouse_on();
             }
              break;
              
        case WM_EDIT_OPEN:
        case WM_EDIT_ON:
             TXT_A = (TXTED_OB*)(*(long*)&Evnt->pipe[W_G]);
             if (NotifieEditSetFocus( w_ind, TXT_A)) 
                {/*.......... devier le clavier et autres vers notre routine ......*/
                 INT16 mo_form;
                 if (Evnt->pipe[MESG] == WM_EDIT_OPEN)
                    {if (TXT_A->EvntFunc) SetCaptureEvntProc (w_ind, TXT_A->EvntFunc, MU_MESAG|MU_BUTTON|MU_TIMER|MU_KEYBD|MU_MOVE);
                     else                 SetCaptureEvntProc (w_ind, TxtEventProc, MU_MESAG|MU_BUTTON|MU_TIMER|MU_KEYBD|MU_MOVE);
                    }
                 /*.......... noter les parametres du texte a traiter .............*/
                 
                 if (TXT_A->ptTxt == 0)                                    return 0;
                 TXT_ED = TXT_A;
                 if      (TXT_ED->State & EDIT_MOFORM_POINT_HAND) mo_form = POINT_HAND;
                 else if (TXT_ED->State & EDIT_MOFORM_ARROW)      mo_form = ARROW;
                 else                                             mo_form = TEXT_CRSR;
                 
                 Blk_LigAndCar_to_BlkXY(TXT_A);
                 /*.......... reperer la ligne et le caractere dans cette ligne ...*/
                 /*                   pointes par la souris                        */
                 if (Evnt->y != -1 &&  Evnt->y != -1)
                    {TXT_A->LigPt       = Y_to_Lig( Evnt->y, TXT_A);
                     TXT_A->CarPt       = X_LigPt_to_CarOfLigne( Evnt->x,  TXT_A->LigPt, TXT_A, CURS_UPDATE);
                    }
                 /*..... initialiser le buffer d'edition avec ligne pointee .......*/
                 TextToBuffEdit( TXT_A->LigPt, TXT_A);
                 TXT_A->State    |= EDIT_ACTIV;     /*>> edition en cours          */
                 TXT_A->State    &= ~MO_TRACK_ON;   /*>> pas de poursuite souris   */
                 /*.......... afficher le curseur texte ...........................*/
                 /*TXT_A->CurState = 0; */                      /*  on sait jamais     */
                 if (w_ind != -1)
                    {EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_DRAW);
                     NotifieLigneChg(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
                    }
                 TXT_A->LastXPt = TXT_A->CurX - TXT_A->TxtGrect.g_x - TXT_A->MargLeft + TXT_A->OfsX;
                 if (GetMouseForm() != mo_form && 
                     IsMouseXYInGrect(Mousex(),  Mousey(), &TXT_A->TxtGrect)
                    ) SetMouseForm(mo_form);
             
                 /*..........Empecher propagation du message ......................*/
                 Evnt->evnt &= ~MU_MESAG;
                }
             break;
             
        case WM_EDIT_CLOSE: 
             TXT_A = (TXTED_OB*)(*(long*)&Evnt->pipe[W_G]);
             BuffEditToText(w_ind, TXT_A->BuffEdit, TXT_A->LigPt, TXT_A);
             if (NotifieEditLoseFocus(w_ind, TXT_A))
                {TXT_A->State    &= ~EDIT_ACTIV;   /*>> edition plus en cours     */
                 if (w_ind != -1) EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);
                 ClearCaptureEvnt (0);
                 SetMouseForm(ARROW);
                 /*..........Empecher propagation du message ......................*/
                }
             Evnt->evnt &= ~MU_MESAG;
             break;   
       }  /* endswitch (Evnt->pipe[MESG]) */
    }   /*endif (Evnt->evnt & MU_MESAG)  */
 return Evnt->evnt;        /* retourner le flux evenementiel (modifie ou pas)    */
}

/*------------------------ EZ_ED_DrawCurs -----------------------------------------*/
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte   */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant     */
/*                          d'edition de texte. (peut y en avoir plusieurs dans    */
/*                          une fenetre) pour lequel on doit activer l'edition.    */
/*         INT16 mode = CURS_DRAW le curseur est dessine si il ne l'etait pas.       */
/*                  = CURS_ERASE le curseur est efface si il etait trace.          */
/*                  = CURS_FLASH le curseur est efface si trac et dessine sinon   */
/* NOTE: le curseur n'est pas dessine et reste efface si un bloc est en cours de   */
/*       definition  la souris.                                                   */
/* RETOUR: INT16 = 1 si trace, 0 si efface                                           */

INT16 EZ_ED_DrawCurs(INT16 w_ind,  TXTED_OB* TXT_A, INT16 mode)
{GRECT curs_grect, r1;
 INT16 w_h ;
 /*........... selon etat dessiner ou pas  ........................................*/
 if (TXT_A->State & EDIT_HIDE && !TXT_A->CurState ) return 0;
 if ( !TXT_A->CurState && mode==CURS_ERASE)         return 0;
 if (TXT_A->State & MO_TRACK_ON)                    return TXT_A->CurState;
 if (  TXT_A->CurState && mode==CURS_DRAW)          return 1;
 
 w_h            = GETGEMHAND(w_ind);
 /*............. definir le rectangle d'affichage du curseur .....................*/
 curs_grect.g_x = TXT_A->CurX -2;
 curs_grect.g_y = TXT_A->CurY -2;
 curs_grect.g_w = 4;
 curs_grect.g_h = TXT_A->CurH + 4;
 /*............ ne dessiner que si intersecte avec fenetre de texte ..............*/
 if ( Rc_intersect( &TXT_A->TxtGrect, &curs_grect))
    {Mouse_off();
     /*............. dessiner en tenant compte de la liste des rectangles.........*/
     wind_get( w_h, WF_FIRSTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
     while (r1.g_w && r1.g_h)
        {if ( Rc_intersect( &curs_grect, &r1))
            {ClipGrect(&r1);
             EZ_ED_PaintCurs(TXT_A);
            }
         wind_get(w_h, WF_NEXTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
        }   /*endwhile (r1.g_w && r1.g_h) */
     Mouse_on();
    }  /*endif ( Rc_intersect( &TXT_A->TxtGrect, &curs_grect))  */
 TXT_A->CurState ^= 1;  /* inverser etat du temoins       */
 return TXT_A->CurState;
} 

/*-------------------------- EZ_ED_PaintCurs ------------------------------------*/
/* ACTION: trace le curseur sans passer par la liste des rectangles. cette       */
/*         fonction est utile lorsque vous faites votre propre affichage custom  */
/*         en effet lorsque vous affichez la ligne ou se trouve le curseur, il   */
/*         necessaire d'y afficher aussi le curseur (si bien sur il est visible) */
/*         Testez si la ligne en cours d'affichage est celle du curseur, et si   */
/*         c'est le cas affichez le en appelant cette fonction. Exemple:         */
/*                       .                                                       */
/*                       .                                                       */
/*                       .                                                       */
/*    if ( TXT_A->CurState &&      si etat curseur est: VISIBLE et que la ligne  */
/*         i==TXT_A->LigPt         en cours d'affichage est celle du curseur     */
/*       )                                     et bien ...                       */
/*       {EZ_ED_PaintCurs(TXT_A);  affichons le curseur, logique ? non ?         */
/*       }                                                                       */
/*                       .                                                       */
/*                       .                                                       */
/*                       .                                                       */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre) pour lequel on doit afficher le curseur */

void EZ_ED_PaintCurs(TXTED_OB* TXT_A)
{INT16 vectxy[4];
 /*........... positionner les attributs graphiques ..........................*/
 vsl_ends(VDIhandle,0,0);
 vsl_width(VDIhandle,1);
 vsl_type(VDIhandle,1);
 vswr_mode(VDIhandle,3);
 vsl_color(VDIhandle,1);
 vectxy[0] = TXT_A->CurX;
 vectxy[1] = TXT_A->CurY;
 vectxy[2] = TXT_A->CurX;
 vectxy[3] = TXT_A->CurY - 1 + TXT_A->CurH;
 v_pline(VDIhandle,2,vectxy);
}

/*------------------------ EZ_ED_RedrawFromLineToLine ---------------------------*/
/* ACTION: dessine le texte compris entre la ligne: ligDeb et la ligne: ligEnd   */
/* ENTREE: long ligDeb: ligne de debut (incluse)  partir de laquelle le dessin  */
/*                      doit se faire. La numerotation des lignes commence       */
/*                      toujours  0                                             */
/*         long ligEnd: derniere ligne a dessiner (incluse). La numerotation des */
/*                      lignes commence toujours  0                             */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre) pour lequel on doit dessiner les lignes */
/* RETOUR: long qui est le nombre de lignes effectivements dessinees. En effet   */
/*         la fonction ne dessine que les lignes visibles et utiles.             */

long EZ_ED_RedrawFromLineToLine(INT16 w_ind, long ligDeb, long ligEnd, TXTED_OB* TXT_A)
{GRECT grect, r1,r2;
 INT16 w_h = GETGEMHAND(w_ind);
 INT16  y, yend, trame, type;
 long i;
 if (TXT_A->State & EDIT_HIDE)  return 0;
 ligEnd = Min(ligEnd,TXT_A->PremLigVisible + TXT_A->NbreLigVisible);
 ligDeb = Max(ligDeb,TXT_A->PremLigVisible);
 /*............ Regler le rectangle sur les lignes a afficher...........*/
 yend        = TXT_A->TxtGrect.g_y + (INT16)(ligEnd - TXT_A->PremLigVisible) * TXT_A->IntLg;
 grect.g_y   = TXT_A->TxtGrect.g_y + (INT16)(ligDeb - TXT_A->PremLigVisible) * TXT_A->IntLg;
 grect.g_h   = yend - grect.g_y;
 grect.g_w   = TXT_A->TxtGrect.g_w;
 grect.g_x   = TXT_A->TxtGrect.g_x;
 r2          = TXT_A->TxtGrect;
 /*.......... on intersecte d'abord avec le rectangle texte ...........*/
 if ( !Rc_intersect( &grect, &r2))           return 0;
 /*......... positionner remplissage rectangle du fond ................*/
 NumSelToTrame(TXT_A->BckTrm, &type, &trame);
 wind_get( w_h, WF_FIRSTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
 while (r1.g_w && r1.g_h)
   {if ( Rc_intersect( &r2, &r1))
       {ClipGrect(&r1);
        vsf_color   (VDIhandle,  TXT_A->BckCol);
        vsf_style   (VDIhandle,  trame);
        vsf_interior(VDIhandle,  type);
        Graphmode(MD_REPLACE);
        GrectPbox(&r1);
        y    = grect.g_y;
        for (i = ligDeb; i<TXT_A->NbLgn && y < yend; i++)
            {Graphmode(MD_TRANS);
             TXT_A->DrawTxtLine(i, TXT_A->TxtGrect.g_x  , y, TXT_A);
             if ( TXT_A->CurState && i==TXT_A->LigPt )
                {EZ_ED_PaintCurs(TXT_A);
                }
             y += TXT_A->IntLg;
            }
       }
    wind_get(w_h, WF_NEXTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
   }   /*endwhile (r1.g_w && r1.g_h) */
 return i - ligDeb ;
}

/*------------------------ EZ_ED_GetTxtEditStruct -----------------------------*/
/* ACTION: retourne la stucture d'edition de texte attachee a un SCROLL_EDIT   */
/* ENTREE: OBJECT *object: adresse arbre auquel appartient l'objet             */
/*                         SCROLL_EDIT dont on cherche a connaitre l'adresse   */
/*                         de la structure edition de texte.                   */
/*         INT16 ind: numro de l'objet dans cet arbre.                          */
/* RETOUR: TXTED_OB* un pointeur sur l'editeur de texte.                       */

TXTED_OB *EZ_ED_GetTxtEditStruct(OBJECT *object, INT16 ind)
{XSCROLLBLK *scrollboxblk = (XSCROLLBLK*) object[ind].ob_spec.userblk->ub_parm;
 return (TXTED_OB*) scrollboxblk->ScrollBoxParam;
}

/*------------------------ EZ_ED_SetTxtGraphAttr ------------------------------*/
/* ACTION: fonction pour initialiser les attributs graphiques d'un tableau de  */
/*         de structures d'attributs graphiques:  CAR_ATTR *CAR_A              */
/* ENTREE: INT16 col: couleur des caracteres. Si -1 il n'est pas tenu compte de  */
/*                  ce parametre.                                              */
/*         INT16 eff: effet a appliquer aux caracteres. Si -1 il n'est pas tenu  */
/*                  compte de ce parametre.                                    */
/*         INT16 pts: taille en points a appliquer aux caracteres. Si -1         */
/*                  il n'est pas tenu compte de ce parametre.                  */
/*         INT16 fid: Indice VDI de la fonte a appliquer aux caracteres. Si -1   */
/*                  il n'est pas tenu compte de ce parametre.                  */
/*                  Si la fonte est donnee en clair dans: fntName c'est cette  */
/*                  derniere qui sera prioritaire meme si fid est un indice VDI*/
/*                  valide.                                                    */
/*         char *fntName: fonte en clair a appliquer aux caracteres. Si zero   */
/*                        la fonte sera celle indique par fid. Si lui meme -1 */
/*                        il ne sera pas tenu compte de ce parametre.          */
/*         CAR_ATTR *CAR_A: adresse du tableau d'attributs  initialiser avec  */
/*                          les parametres d'entree precedents.                */
/*         INT16 nbr: nombre d'elements du tableau  initialiser avec les        */
/*                  attributs precedents.                                      */
/*                                                                             */
/* NOTE: le parametre: CAR_A.FntName contient le nom de la fonte en clair      */
/*                                   apres appel de la fonction, meme si le    */
/*                                   nom de la fonte est donne en partie dans  */
/*                                   le parametre: char *fntName, il sera      */
/*                                   cherche la fonte avec le nom le plus      */
/*                                   approchant.                               */
/*       de meme:      CAR_A.FntID   contient l'indice VDI de la fonte apres   */
/*                                   appel de la fonction.                     */
/* RETOUR: neant.                                                              */

void EZ_ED_SetTxtGraphAttr(INT16 col, INT16 eff, INT16 pts, INT16 fid, char *fntName, CAR_ATTR *CAR_A, INT16 nbr)
{INT16 i;
 for (i=0; i<nbr; i++)
     { SetAttributForOne(col, eff, pts, fid, fntName, &CAR_A[i]);
     }
}
/*------------------------ EZ_ED_SetDrawLineFunc ---------------------------------*/
/* ACTION: permet de modifier la fonction de redessin d'une ligne texte afin d'en */
/*         placer une personnelle.                                                */
/* ENTREE: INT16(*drawTxtFunc)(..): adresse de la nouvelle fonction de redessin.    */
/*                                si zero, la fonction par defaut d'origine est   */
/*                                installee.                                      */
/*         TXTED_OB *TXT_A: pointeur sur la variable generale definisssant le     */
/*                          composant d'edition dont on veut modifier la fonction */
/*                          de redessin.                                          */
/* SORTIE: void * pointeur sur l'ancienne fonction de redessin.                   */
/*                on peut tres bien imaginer une fonction appelant l'ancienne et  */
/*                rajoutant le dessin des marges et fin de page par exemple. Cela */
/*                s'appelle deriver une fonction.                                 */

void *EZ_ED_SetDrawLineFunc(INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A), TXTED_OB *TXT_A)
{void *old_func = TXT_A->DrawTxtLine;
 if    (drawTxtFunc) TXT_A->DrawTxtLine = drawTxtFunc;
 else                TXT_A->DrawTxtLine = AfficheLigne;
 return old_func;
}

/*------------------------ EZ_ED_GetLigCol ---------------------------------------*/
/* ACTION: cette fonction permet d'obtenir divers renseignements possibles sur    */
/*         les caracteres pointes par les marques de bloc, et le curseur, leurs   */
/*         positions X et Y , etc ...                                             */
/*         cette fonction est assez polymorphe et les retours dans les variables  */
/*         dependent du parametre d'entree: size_t param.                         */
/*                                                                                */
/* ENTREE: size_t param: Ce parametre d'entree determine ce qui va etre retourne  */
/*                       dans les variables long *lig, long *col et la valeur de  */
/*                       retour char*                                             */
/*        SI = BLK_DEB      soit  1 : il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne de debut de bloc,   */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_END      soit  2 : il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne de fin de bloc,     */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = CURS_POS     soit  4 : il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne du curseur,         */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_DEBXY    soit  8 : il est retourne dans: long *lig, long *col  */
/*                                    la position x et y du debut de bloc,        */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_ENDXY    soit 16 : il est retourne dans: long *lig, long *col  */
/*                                    la position x et y de fin de bloc,          */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = CURS_POSXY   soit 32 : il est retourne dans: long *lig, long *col  */
/*                                    la position x et y du curseur,              */
/*                                    la valeur de retour pointe le texte.        */
/*        SI = BLK_TXT_MARK soit 64:  il est retourne dans: long *lig, l'adresse  */
/*                                    du texte pointe par le debut du bloc.       */
/*                                                          long *col, l'adresse  */
/*                                    du texte pointe par la fin du bloc.         */
/*                                    la valeur de retour est le texte pointe par */
/*                                    le curseur                                  */
/*        SI = XY_TO_LIGPT  soit 128: il est retourne dans: long *lig, long *col  */
/*                                    la ligne  et la colonne pointee par,        */
/*                                    x et y donns en entree dans *lig et *col.  */
/*                                    la valeur de retour pointe le texte du      */
/*                                    debut de ligne.                             */
/*        SI = pointeur sur un caractere du texte: il est retourne en:            */
/*                                    long *lig la ligne de ce caractere.         */
/*                                    long *col la colonne de caractere           */
/*                                    la valeur de retour est le texte pointe par */
/*                                    le curseur                                  */

char *EZ_ED_GetLigCol(size_t param, long *lig, long *col, TXTED_OB* TXT_A)
{char *pttxt = (char*)param;
 Blk_LigAndCar_to_BlkXY(TXT_A);
 if (param == BLK_DEB)
    {if (lig) *lig = TXT_A->BlkDebLig;
     if (col) *col = TXT_A->BlkDebCar;
     return TXT_A->TabLgnCtx[TXT_A->BlkDebLig].ptTxt + TXT_A->BlkDebCar;
    }
 else if (param == BLK_END)
    {if (lig) *lig = TXT_A->BlkEndLig;
     if (col) *col = TXT_A->BlkEndCar;
     return TXT_A->TabLgnCtx[TXT_A->BlkEndLig].ptTxt + TXT_A->BlkEndCar;
    }
 else if (param == CURS_POS)
    {if (lig) *lig = TXT_A->LigPt;
     if (col) *col = TXT_A->CarPt;
     return TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt + TXT_A->CarPt;
    }
 else if (param == BLK_DEBXY)
    {if (lig) *lig = TXT_A->BlkDebY;
     if (col) *col = TXT_A->BlkDebX;
     return TXT_A->TabLgnCtx[TXT_A->BlkDebLig].ptTxt + TXT_A->BlkDebCar;
    }
 else if (param == BLK_ENDXY)
    {if (lig) *lig = TXT_A->BlkEndY;
     if (col) *col = TXT_A->BlkEndX;
     return TXT_A->TabLgnCtx[TXT_A->BlkEndLig].ptTxt + TXT_A->BlkEndCar;
    }
 else if (param == CURS_POSXY)
    {if (lig) *lig = TXT_A->CurY;
     if (col) *col = TXT_A->CurX;
     return TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt + TXT_A->CarPt;;
    }
 else if (param == BLK_TXT_MARK)
    {long deb_lig, deb_car, end_lig, end_car;
     GetSortedBlkMark(&deb_lig, &deb_car, &end_lig, &end_car, TXT_A); 
     if (lig) *lig     = (long)(TXT_A->TabLgnCtx[deb_lig].ptTxt + deb_car);
     if (col) *col     = (long)(TXT_A->TabLgnCtx[end_lig].ptTxt + end_car);
     return TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt + TXT_A->CarPt;
    }
 else if (param == XY_TO_LIGPT)
    {long ligpt, carpt;    
     ligpt = Y_to_Lig((INT16)*lig, TXT_A);
     /*......... ne pas pointer plus d'une ligne apres le bas .............*/
     /*          car le scroll des blocs aime pas                          */
     ligpt = Min(ligpt, TXT_A->PremLigVisible + TXT_A->NbreLigVisible);
     ligpt = Max(ligpt, 0);
     carpt = X_LigPt_to_CarOfLigne( (INT16)*col,  ligpt, TXT_A, 0);
     *col  = carpt;
     *lig  = ligpt;
     return TXT_A->TabLgnCtx[ligpt].ptTxt;
    }   
 else if (pttxt >= TXT_A->ptTxt && pttxt <= TXT_A->EndTxt)
    {long ligpt,colpt;
     ligpt = CarPt_to_Curs(pttxt, &colpt, TXT_A);
     if (lig) *lig     = ligpt;
     if (col) *col     = colpt;
     return  TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt + TXT_A->CarPt;
    }
 else return 0;
}

/*------------------------ EZ_ED_GetLastEditActiv -------------------------------*/
/* ACTION: permet de connaitre l"editeur de texte en activite (Si il y en a un)  */
/* ENTREE:  neant.                                                               */
/* SORTIE:  TXTED_OB *: un pointeur sur une structure definissant l'editeur en   */
/*                      activite. Si zero c'est qu'il n'y a pa d'editeur actif.  */

TXTED_OB *EZ_ED_GetLastEditActiv(void)
{return TXT_ED;
}

/*----------------------------- EZ_ED_GraphUpdate -------------------------------*/
/* ACTION: permet de mettre  jour les coordonnes graphiques du CURSEUR, et du  */
/*         BLOC TEXTE apres par exemple un changement de la premiere ligne       */
/*         affiche en haut de l'editeur, avant par exemple un redraw afin que   */
/*         bloc et le curseur texte soient correctement affichs. Cette fonction */
/*         replace aussi le contenu du buffer d'edition dans le texte. Il est    */
/*         utile et conseill d'appeler cette fonction avant une sauvegarde.     */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre) pour lequel on doit activer l'edition.  */
/* RETOUR: neant.                                                                */
void EZ_ED_GraphUpdate(TXTED_OB *TXT_A)
{BuffEditToText(0, TXT_A->BuffEdit, TXT_A->LigPt, TXT_A);
 Blk_LigAndCar_to_BlkXY(TXT_A); /* reajuster coordonnees bloc        */
 Car_to_CursXYH(TXT_A);         /* reajuster la position du curseur  */
}

/*------------------------ EZ_ED_KillFocus --------------------------------------------*/
/* ACTION: Enleve le focus d'un editeur de texte. Apres appel de cette fonction,       */
/*         l'editeur de texte n'a plus le clavier, ni la souris, et ne sera plus       */
/*         prioritaire pour la boucle evenementielle.                                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte en    */
/*                    activite. Il ne peut y avoir qu'un seul editeur de texte ayant   */
/*                    le focus.                                                        */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant         */
/*                          d'edition de texte. (peut y en avoir plusieurs dans        */
/*                          une fenetre) qui possedait le focus.                       */
/* SORTIE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant         */
/*                          d'edition de texte. (peut y en avoir plusieurs dans        */
/*                          une fenetre) qui possedait le focus.                       */

TXTED_OB *EZ_ED_KillFocus(INT16 w_ind, TXTED_OB *TXT_A)
{EVNT_O Evnt_mess;
 if (TXT_A==0)                        return 0;
 /*if (!(TXT_ED->State & EDIT_ACTIV)) return 0;   */   /*>> edition etait deja plus en cours     */
 /*.......... effacer le curseur texte ................................*/
 EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);
 Evnt_mess.evnt       = MU_MESAG;
 Evnt_mess.pipe[MESG] = WM_EDIT_CLOSE;
 Evnt_mess.pipe[APPL] = Appl_id;                   /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL] = 0;                         /*   message sans surplus                 */
 if (w_ind != -1) Evnt_mess.pipe[WHND] = Windtab[w_ind].w_h;        /*   fenetre  qui est dediee le message  */
 else             Evnt_mess.pipe[WHND] = 0;
 *(long*)(&Evnt_mess.pipe[W_G])        = (long)TXT_A;
 /*..... appeler la fonction de d'edition pour lui signifier que c'est elle ....*/
 TXT_A->EvntFunc(w_ind, &Evnt_mess);
 return TXT_ED;
}

/*------------------------ EZ_ED_SetFocus ---------------------------------------------*/
/* ACTION: donne le focus clavier, souris, timer, a un editeur de texte. C'est a dire  */
/*         que cet editeur de texte est actif, et recoit en priorite les evenements    */
/*         le clavier est dirige sur lui, afin que les caractees puissent etre saisis. */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte       */
/*         EVNT_O *Evnt: variable de flux evenementiel comme celle utilisee            */
/*                       partout dans EAZY_GEM                                         */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant         */
/*                          d'edition de texte. (peut y en avoir plusieurs dans        */
/*                          une fenetre) pour lequel on doit activer l'edition.        */
/* RETOUR: neant.                                                                      */

void EZ_ED_SetFocus( INT16 w_ind, EVNT_O *Evnt, TXTED_OB *TXT_A)
{EVNT_O Evnt_mess;
 if (TXT_A==0)                     return;
 /* if (TXT_A->State & EDIT_ACTIV)    return; */  /*>> edition etait deja  en cours         */
 Evnt_mess.evnt       = MU_MESAG;
 if (Evnt > (EVNT_O*)100L)
    {Evnt_mess.x          = Evnt->x;
     Evnt_mess.y          = Evnt->y;
     Evnt_mess.k          = Evnt->k;
     Evnt_mess.ksp        = Evnt->ksp;
     Evnt_mess.key        = Evnt->key;
     Evnt_mess.click      = Evnt->click;
    }
 else
    {Evnt_mess.x          = Mousex();
     Evnt_mess.y          = Mousey();
     Evnt_mess.k          = Mousek();
     Evnt_mess.ksp        = (INT16)Kbshift(-1);
     Evnt_mess.key        = 0;
     Evnt_mess.click      = 0;
    }
 if (Evnt>=(EVNT_O*)1L && (long)Evnt&1)           Evnt_mess.pipe[MESG] = WM_EDIT_ON;
 else if ( Evnt->pipe[MESG] ==  WM_EDIT_ON)       Evnt_mess.pipe[MESG] = WM_EDIT_ON;
 else                                             Evnt_mess.pipe[MESG] = WM_EDIT_OPEN;
 if (Evnt>=(EVNT_O*)1L && (long)Evnt&2) {Evnt_mess.x          = -1;
                                         Evnt_mess.y          = -1;
                                        }
 Evnt_mess.pipe[APPL] = Appl_id;                   /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL] = 0;                         /*   message sans surplus                 */
 if (w_ind != -1) Evnt_mess.pipe[WHND] = Windtab[w_ind].w_h;        /*   fenetre  qui est dediee le message  */
 else             Evnt_mess.pipe[WHND] = 0;
 *(long*)(&Evnt_mess.pipe[W_G]) = (long)TXT_A; 
 /*..... appeler la fonction de d'edition pour lui signifier que c'est elle ....*/
 /*      qui va capturer le clavier. Au passage on lui passe la variable        */
 /*      generale du texte sur lequel elle va travailler                        */
 TXT_A->EvntFunc(w_ind, &Evnt_mess);
}

/*------------------------ EZ_ED_EvntDo -----------------------------------------*/
/* ACTION: envoie un evenement  un editeur, qu'il soit ou non en edition. Cela  */
/*         permet de simuler un evenement quelconque sur un editeur.             */
/*         C'est la fonction a utiliser lors par exemple reception de caracteres */
/*         par RS 232 ou autre.                                                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*         EVNT_O *Evnt: variable de flux evenementiel comme celle utilisee      */
/*                       partout dans EAZY_GEM                                   */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte. (peut y en avoir plusieurs dans  */
/*                          une fenetre).                                        */
/* RETOUR: un INT16 qui est l'evenement d'entree (modifie ou pas)                  */
 
INT16 EZ_ED_EvntDo( INT16 w_ind, EVNT_O *Evnt, TXTED_OB *TXT_A)
{INT16 ret;
 TXTED_OB *OldTXT_A      = TXT_ED;
 INT16 OldActiv            = TXT_A->State;
 TXT_ED                  = TXT_A;
 TXT_ED->State          |= EDIT_ACTIV;
 ret                     = TXT_A->EvntFunc(w_ind, Evnt);
 TXT_A->State            = OldActiv;
 TXT_ED                  = OldTXT_A;
 return ret;
}
/*------------------------ EZ_ED_NewTxtEdit -------------------------------------*/
/* ACTION: cree ou initialise une instance d'editeur de texte pret  l'emploi.   */
/*         cette fonction sert surtout  placer la fonction de tracage d'une     */
/*         ligne de texte, sans laquelle l'editeur planterait.                   */
/*         Donc il est indispensable de faire appel a cette fonction de creation */
/*         avant toute utilisation de l'editeur.                                 */
/*         les autres parametres de la structure sont placs sur des valeurs     */
/*         par defaut, sauf si une structure est donne en entree.               */
/* ENTREE: TXTED_OB *TXT_A: SI non egal  zero on initialise la fonction de      */
/*                            de tracage d'une ligne texte, de la structure      */
/*                            passee en entree.                                  */
/*                          SINON on reserve la memoire d'une instance de        */
/*                             structure: TXTED_OB et on l'initialisera.         */
/*         INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, void *TXT_A): pointe sur la */
/*                fonction de redessin d'une ligne de texte. si ce parametre est */
/*                egal a zero, une fonction de redessin par defaut est placee.   */
/*         GRECT *grect: rectangle dans lequel l'editeur de texte existe.        */
/*               si ce rectangle, n'est pas donne (egal zero)  et que            */
/*               la structure est une creee dans notre fonction, il ne vous      */
/*               faudra ne pas oublier d'initialiser: TXTED_OB.TxtGrect juste    */
/*               apres.                                                          */
/* RETOUR: TXTED_OB *retourne un pointeur sur la structure d'edition.            */
/*                  si zero echec de la creation.                                */
       
TXTED_OB *EZ_ED_NewTxtEdit (TXTED_OB *TXT_A,
                            INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A),
                            GRECT *grect
                           )
 {return EZ_ED_ExNewTxtEdit(TXT_A, drawTxtFunc, grect, 0, 0);
 }
/*------------------------ EZ_ED_ExNewTxtEdit --------------------------------------*/
/* ACTION: cree ou initialise une instance d'editeur de texte pret  l'emploi.      */
/*         cette fonction sert surtout  placer la fonction de tracage d'une        */
/*         ligne de texte, sans laquelle l'editeur planterait.                      */
/*         Donc il est indispensable de faire appel a cette fonction de creation    */
/*         avant toute utilisation de l'editeur.                                    */
/*         les autres parametres de la structure sont placs sur des valeurs        */
/*         par defaut, sauf si une structure est donne en entree.                  */
/* ENTREE: TXTED_OB *TXT_A: SI non egal  zero on initialise la fonction de         */
/*                            de tracage d'une ligne texte, de la structure         */
/*                            passee en entree.                                     */
/*                          SINON on reserve la memoire d'une instance de           */
/*                             structure: TXTED_OB et on l'initialisera.            */
/*         INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, void *TXT_A): pointe sur la    */
/*                fonction de redessin d'une ligne de texte. si ce parametre est    */
/*                egal a zero, une fonction de redessin par defaut est placee.      */
/*         GRECT *grect: rectangle dans lequel l'editeur de texte existe.           */
/*               si ce rectangle, n'est pas donne (egal zero)  et que               */
/*               la structure est une creee dans notre fonction, il ne vous         */
/*               faudra ne pas oublier d'initialiser: TXTED_OB.TxtGrect juste       */
/*               apres.                                                             */
/*         INT16 ctx_supl: nombre d'octets supplementaire alloues pour chaque         */
/*                       contexte de ligne pour stocker infos personnelles.         */
/*                       suppose que vous creerez votre routine perso, de mise     */
/*                       jour des contextes de lignes:  InitTabLgnCtxfunc           */
/*                       afin d'exploiter cette fonctionnalit.                     */
/*         long (*InitTabLgnCtxfunc)(TXTED_OB *TXT_A,char *txt,long iTab,long nb_l) */
/*                       fonction de mise  jour des pointeurs de lignes, cette     */
/*                       fonction peut etre reecrite par vous affin de stocker      */
/*                       diverse informations supplementaire sur chaque ligne.      */
/*                       si zero la fonction par defaut sera place.                */
/* RETOUR: TXTED_OB *retourne un pointeur sur la structure d'edition.               */
/*                  si zero echec de la creation.                                   */
       
TXTED_OB *EZ_ED_ExNewTxtEdit (TXTED_OB *TXT_A,
                              INT16(*drawTxtFunc)(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A),
                              GRECT *grect,
                              INT16 ctx_supl,
                              long (*InitTabLgnCtxfunc)(TXTED_OB *TXT_A, char *txt, long iTab, long nb_l)
                             )
{INT16 new_s = FALSE;
 long len_mem_sup;
 INT16 nb_ligne = 10;
 if (TXT_A == 0)
    {TXT_A = (TXTED_OB*) malloc(sizeof(TXTED_OB));
     if (TXT_A) new_s = TRUE;
    }
 if (TXT_A == 0)  return 0;
 if (new_s)
    {*TXT_A = TXT_DEF_ATT; /* initialiser sur attributs par defaut */
    }
 if (TXT_A->EvntFunc==0)  TXT_A->EvntFunc    = TxtEventProc; /* fonction par defaut      */
 if (drawTxtFunc)         TXT_A->DrawTxtLine = drawTxtFunc;  /* fonction utilisateur     */
 else                     TXT_A->DrawTxtLine = AfficheLigne; /* fonction par defaut      */
 if (grect)               TXT_A->TxtGrect    = *grect;
 TXT_A->EditTxtPosChg = EZ_ED_GraphUpdate;
 TXT_A->AffiBuff      = AffiBuff;
 TXT_A->DrawTxt       = AfficheBaliseTxt;
 TXT_A->State        &= ~EDIT_CHG;            /* le texte est inchange              */
 /*................ si la memoire est deja alouee car la............................*/
 /*                 structure d'entree l'a deja fait, sortir                        */
 if (TXT_A->ptTxt && TXT_A->TabLgnCtx)                            return TXT_A;
 /*................ allouer memoire de l'editeur ...................................*/
 len_mem_sup          = nb_ligne * TXT_A->SizeLgn;
 TXT_A->ptTxt         = malloc(len_mem_sup );
 /*.............. si pas possible sortir ...........................................*/
 if (TXT_A->ptTxt == 0)                                           return 0;
 /*.................. reserver les structures de lignes ............................*/
 TXT_A->TabLgnCtxSize  = (INT16)sizeof(LGN_CTX) + ctx_supl;
 TXT_A->ptTxt[0]       = 0;
 TXT_A->NbLgn          = 1;
 TXT_A->NbLgnMax       = 0;
 TXT_A->TabLgnCtx      = malloc( (TXT_A->NbLgn + nb_ligne) * TXT_A->TabLgnCtxSize);
 /*............. calcul de la position memoire contexte de ligne suppl .............*/
 if (ctx_supl)
     TXT_A->SupLgnCtxtMem  = (char*)((long)TXT_A->TabLgnCtx + sizeof(LGN_CTX) * (TXT_A->NbLgn + nb_ligne));
 else
     TXT_A->SupLgnCtxtMem  = 0;
 /*.............. si pas possible sortir ...........................................*/
 if (TXT_A->TabLgnCtx == 0)                                       return 0;
 /*................. reserver buffer d'edition .....................................*/
 if (TXT_A->SizeLgn   == 0) TXT_A->SizeLgn = LIGNE_SIZE;
 if (TXT_A->BuffEdit  == 0)
    {TXT_A->BuffEdit  = malloc(TXT_A->SizeLgn + 16);
    }
 /*.............. si pas possible sortir ...........................................*/
 if (TXT_A->BuffEdit==0)                                          return 0;
 TXT_A->BuffEdit[0] = 0;
 /*................ placer routine d'initialisation de ligne .......................*/
 /*                 par defaut ou celle fournie et s'en servir                      */
 if (InitTabLgnCtxfunc)
     TXT_A->InitTabLgnCtx  = InitTabLgnCtxfunc;
 else
     TXT_A->InitTabLgnCtx  = DefaultInitTabLgnCtx;
 TXT_A->InitTabLgnCtx(TXT_A, TXT_A->ptTxt, 0, LONG_MAX);
 /*............... initialiser reste de la structure ...............................*/
 TXT_A->EndBuff        = TXT_A->ptTxt  + len_mem_sup;
 TXT_A->EndTxt         = TXT_A->ptTxt;
 TXT_A->BlkDebLig      = 0;
 TXT_A->BlkDebCar      = 0;
 TXT_A->BlkEndLig      = 0;
 TXT_A->BlkEndCar      = 0;
 TXT_A->NbLgnMax       = TXT_A->NbLgn + nb_ligne;
 return TXT_A;
}

/*------------------------ EZ_ED_DeleteTxtEdit -----------------------------------*/
/* ACTION: detruit un composant editeur de texte et libere toutes les ressources  */
/*         memoire et autres ayant pu etre reserves au cours de sa vie.          */
/*         si vous avez cree un composant edition de texte il est indispensable   */
/*         d'utiliser cette fonction pour le detruire a la fin de votre programme */
/*         sinon la memoire reservee ne sera par liberee.                         */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur la structure definissant un composant    */
/*                          d'edition de texte, (peut y en avoir plusieurs dans   */
/*                          une fenetre) que l'on veut supprimer.                 */
/* RETOUR: toujours zero.                                                         */
 
TXTED_OB *EZ_ED_DeleteTxtEdit(TXTED_OB *TXT_A)
{if (TXT_A==0) return 0;
 FreeTxtMemory(TXT_A);
 if (TXT_A->BuffEdit) free(TXT_A->BuffEdit);
 free (TXT_A);
 if (TXT_ED == TXT_A) TXT_ED = 0;
 return 0;
}
/*----------------------- EZ_ED_SaveTxt ------------------------------------------*/
/* ACTION:  sauve le texte, en edition sous le nom donne en entree dans           */
/*          PathTxt    et    NomTxt                                               */
/* ENTREE:  char *PathTxt: path ou l'on sauve le fichier: expl: C:\MES_TEXTES\    */
/*          char *NomTxt: nom du fichier: exple: TEXTE.TXT                        */
/*          INT16 flag = BLK_SAVE uniquement le texte selectionne est sauve.      */
/*                       TXT_SAVE tout le texte est sauve.                        */
/*          TXTED_OB *TXT_A: variable de fonctionnement general, liee  l'editeur */
/*                           de texte concerne, dont on veut sauver le texte.     */
/* SORTIE: long: nbr d'octets sauves.                                             */

long EZ_ED_SaveTxt(char *PathTxt, char *NomTxt, INT16 flag, TXTED_OB *TXT_A)
{ if (flag == TXT_SAVE)
     {EZ_ED_GraphUpdate(TXT_A);
      return Bsave(PathTxt, NomTxt, TXT_A->ptTxt, TXT_A->EndTxt - TXT_A->ptTxt);
     }
  else
     {char *deb, *end;
      EZ_ED_GraphUpdate(TXT_A);
      EZ_ED_GetLigCol(BLK_TXT_MARK, (long*) &deb, (long*)&end, TXT_A);
      if (deb != end) return Bsave(PathTxt, NomTxt, deb, end - deb);
      else            return 0;
     }
}

/*----------------------- EZ_ED_LoadTxt ------------------------------------------*/
/* ACTION: charge un nouveau texte et initialise la variable de fonctionnement    */
/*         general qui lui est associ.                                           */
/* ENTREE:  INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*          char *PathTxt: path ou se trouve le fichier: expl: C:\MES_TEXTES\     */
/*          char *NomTxt: nom du fichier: exple: TEXTE.TXT                        */
/*          TXTED_OB *TXT_A: variable de fonctionnement general, dont il est      */
/*                           initialis:                                          */
/*                           TXTED_OB.ptTxt sur l'adresse du texte                */
/*                                          (0 si erreur ou texte invalide)       */
/*                           TXTED_OB.NbLgn sur le nombre de lignes du texte      */
/*                                          (0 si erreur ou texte invalide)       */
/* SORTIE: INT16: TRUE si tout est OK, FALSE sinon                                  */

INT16 EZ_ED_LoadTxt(INT16 w_ind, char *PathTxt, char *NomTxt, TXTED_OB *TXT_A)
{INT16 f_h;
 long len_nbl_sup = 50;
 long len_fic, len_mem_sup;
 INT16 okFlag  = FALSE;
 len_fic       = Fic_exist(PathTxt, NomTxt);
 len_mem_sup   = len_nbl_sup * TXT_A->SizeLgn;

if (len_fic>0)
   {/*
    if (w_ind != -1)
       {form_alert(1000,"[0][Patientez: Chargement|et formatage du texte|en cours...][ok]");
        ExeAllMessage();
       }
    */
    /*............ effacer de la memoire l'ancien texte ...........*/
    if (TXT_A->TabLgnCtx)  free(TXT_A->TabLgnCtx);
    if (TXT_A->ptTxt)      free(TXT_A->ptTxt);
    TXT_A->ptTxt     = 0;
    TXT_A->NbLgn     = 0;
    TXT_A->EndBuff   = 0;
    TXT_A->EndTxt    = 0;
    TXT_A->NbLgn     = 0;
    /*............ charger le nouveau texte ......................*/
    TXT_A->ptTxt = malloc(len_fic  + len_mem_sup );
    if (TXT_A->ptTxt)
       {char path[512];
        strcpy(path,PathTxt);
        strcat(path,NomTxt);
        f_h = open(path ,O_RDONLY); /* ouvrir fichier  */
        if (f_h>-1)
           {read(f_h, TXT_A->ptTxt, len_fic);
            TXT_A->ptTxt[len_fic] = 0; 
            TXT_A->NbLgn          = GetTxt_NbLign(TXT_A->ptTxt, TXT_A->SizeLgn) + 1;
            TXT_A->TabLgnCtx      = malloc( (TXT_A->NbLgn + len_nbl_sup) * TXT_A->TabLgnCtxSize);
            /*............... calcul emplacement memoire du contexte de ligne suppl..........*/
            if (TXT_A->SupLgnCtxtMem)
                TXT_A->SupLgnCtxtMem  = (char*) TXT_A->TabLgnCtx                            + 
                                        ((long)sizeof(LGN_CTX) * (TXT_A->NbLgn + len_nbl_sup));
            else
                TXT_A->SupLgnCtxtMem  = 0;
                
            if (TXT_A->TabLgnCtx)
               {TXT_A->InitTabLgnCtx(TXT_A, TXT_A->ptTxt, 0, LONG_MAX);
                TXT_A->NbLgnMax        = TXT_A->NbLgn + len_nbl_sup;
                TXT_A->EndBuff         = TXT_A->ptTxt + len_fic  + len_mem_sup;
                TXT_A->EndTxt          = TXT_A->ptTxt + len_fic;
                TXT_A->BlkDebLig       = 0;
                TXT_A->BlkDebCar       = 0;
                TXT_A->BlkEndLig       = 0;
                TXT_A->BlkEndCar       = 0;
                TXT_A->PremLigVisible  = 0;
                Blk_LigAndCar_to_BlkXY(TXT_A);
                TXT_A->LigPt = 0;
                TXT_A->CarPt = 0;
                TextToBuffEdit( TXT_A->LigPt, TXT_A);
                if (w_ind != -1)
                   {NotifieNbrLignChg(  w_ind, FALSE, TXT_A);
                    NotifiePremLignChg( w_ind, FALSE, TXT_A);
                    NotifieTxtSizeChg(  w_ind, -1L, -1L, TXT_A);
                   }
                if ( w_ind != -1)
                   {/*.......... effacer le curseur texte ................................*/
                    EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE); 
                    /*.......... calcul nouvelle position souris .........................*/
                    TXT_A->LigPt  = Y_to_Lig(TXT_A->CurY, TXT_A);
                    TXT_A->CarPt  = X_LigPt_to_CarOfLigne( TXT_A->CurX,  TXT_A->LigPt, TXT_A, CURS_UPDATE);                    

                    /*.......... si changement de ligne mise a jour ......................*/
                    TextToBuffEdit( TXT_A->LigPt, TXT_A);
                    NotifieLigneChg(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
                    /* Car_to_CursXYH(TXT_A);*/
                   }
                else
                   {/*.......... calcul nouvelle position souris .........................*/
                    TXT_A->LigPt  = Min(TXT_A->NbLgnMax-1, Max(0,Y_to_Lig(TXT_A->CurY, TXT_A)));
                    TXT_A->CarPt  = X_LigPt_to_CarOfLigne( TXT_A->CurX,  TXT_A->LigPt, TXT_A, CURS_UPDATE);                    
                   }
                TXT_A->State &= ~EDIT_CHG;          /* le texte est inchange          */
                okFlag = TRUE;
               }
            else 
               {free(TXT_A->ptTxt);
                TXT_A->ptTxt     = 0;
                TXT_A->NbLgn     = 0;
                TXT_A->EndBuff   = 0;
                TXT_A->EndTxt    = 0;
                TXT_A->NbLgnMax  = 0;
               }
            close(f_h);
           } /* endif if (f_h)   */
        else
           {free(TXT_A->ptTxt);
            TXT_A->ptTxt     = 0;
            TXT_A->NbLgn     = 0;
            TXT_A->EndBuff   = 0;
            TXT_A->EndTxt    = 0;
            TXT_A->NbLgnMax  = 0;
           }
       } /* endif if (adr_txt)  */
    /* if (w_ind != -1) WindAlertClose(); */
   } /* endif if len_fic   */
 return okFlag;
}

/*------------------------- EZ_ED_DrawBlkFrame -----------------------------------*/
/* ACTION: dessine le cadre video inverse du bloc de selection                    */
/* IMPORTANT:cette fonction ne peut etre appelee en USERDEF qu'avec               */
/*           redrawFlag = BLK_LINE_DRAW. Avec les autres valeurs de flag il n'est */
/*           pas possible d'appeler cette en USERDEF car un appel  Mouse_on()    */
/*           Mouse_off()  est fait par la fonction.                               */
/* ENTREE: long w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*                    sauf si redrawFlag = BLK_LINE_DRAW  et alors w_ind est le   */
/*                    numero de la ligne pour laquelle il faut dessiner le        */
/*                    rectangle de selection.                                     */
/*                                                                                */
/*         INT16 redrawFlag: flag modifiant le comportement de la fonction. Il peut */
/*                         prendre les valeurs suivantes:                         */
/*                                                                                */
/*                         BLK_ALL_DRAW et alors  W_ind est l'indice EAZY_GEM de  */
/*                                      la fenetre possedant l'editeur de texte.  */
/*                                      l'integralite du cadre de selection est   */
/*                                      dessine losque la fonction est appelee    */
/*                                      avec ce flag.                             */
/*                         BLK_LINE_DRAW et alors w_ind est le numero de la ligne */
/*                                       pour laquelle il faut dessiner rectangle */
/*                                       de selection. seulement le cadre de la   */
/*                                       ligne indiquee par w_ind est dessine.    */
/*                                                                                */
/*                         BLK_UPDATE   et alors w_ind est l'indice EAZY_GEM de   */
/*                                      la fenetre possedant l'editeur de texte.  */
/*                                      Lorsque le flag possede cette valeur il   */
/*                                      seulement dessine la partie situee entre  */
/*                                      l'ancienne position curseur et la         */
/*                                      nouvelle. Cette fonction est appelee avec */
/*                                      ce flag par l'editeur lui meme. Vous ne   */
/*                                      devriez normalement pas avoir a appeler   */
/*                                      la fonction avec ce flag.                 */
/*                                                                                */
/*         TXTED_OB *TXT_A: pointeur sur la structure definissant un composant    */
/*                          d'edition de texte. (peut y en avoir plusieurs dans   */
/*                          une fenetre).                                         */

void EZ_ED_DrawBlkFrame(long w_ind, INT16 redrawFlag, TXTED_OB* TXT_A)
{/*..... fonction cauchemard, est il difficile de faire pire .........*/
 /*      en taille de code, mauvais que je suis !!!                   */
 VRECT blk_vrect;
 long lig_pt;
 if (TXT_A->State & EDIT_HIDE)  return;
 Deffill(1,1,1);
 Graphmode(3);
 switch(redrawFlag)
   {case BLK_ALL_DRAW:        /* dans ce cas w_ind est l'indice de fenetre */
        {POINT blk_pts[2];
         INT16 debx, deby, endx, endy;
         GRECT txtgrect = TXT_A->TxtGrect;         
         Mouse_off();
         /*.... le debut et fin de ligne de bloc peuvent etre inverses ...*/
         /*           donc les remettre en ordre pour test                */
         if (TXT_A->BlkDebLig > TXT_A->BlkEndLig)
            {debx = TXT_A->BlkEndX;
             deby = TXT_A->BlkEndY;
             endx = TXT_A->BlkDebX;
             endy = TXT_A->BlkDebY;
            }
         else 
            {debx = TXT_A->BlkDebX;
             deby = TXT_A->BlkDebY;
             endx = TXT_A->BlkEndX;
             endy = TXT_A->BlkEndY;
            }
         
         /*............ si une seule ligne cassos apres dessin ..........*/
         if (TXT_A->BlkDebLig == TXT_A->BlkEndLig)
            {blk_pts[0].x = debx+1;
             blk_pts[0].y = deby;
             blk_pts[1].x = endx;
             blk_pts[1].y = endy + TXT_A->CurH -1;
             if (TXT_A->BlkDebX > TXT_A->BlkEndX)
                {blk_pts[0].x -= 1;
                 blk_pts[1].x += 1;
                }
             WPbox((INT16)w_ind, (VRECT*)blk_pts, &txtgrect);
             break;
            }
         blk_pts[0].x = debx+1;
         blk_pts[0].y = deby;
         blk_pts[1].x = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1 ;
         blk_pts[1].y = deby + TXT_A->CurH -1 ;
         if (blk_pts[0].x<blk_pts[1].x) WPbox((INT16)w_ind, (VRECT*)blk_pts, &txtgrect);
         /*.......... si plus de deux lignes dessiner le millieu ........*/
         if ( labs( (TXT_A->BlkDebLig - TXT_A->BlkEndLig) ) >1 )
            {blk_pts[0].x = TXT_A->TxtGrect.g_x;
             blk_pts[0].y = deby + TXT_A->CurH ;
             blk_pts[1].x = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
             blk_pts[1].y = endy -1 ;
             WPbox((INT16)w_ind, (VRECT*)blk_pts, &txtgrect);             
            }
         blk_pts[0].x = TXT_A->TxtGrect.g_x;
         blk_pts[0].y = endy;
         blk_pts[1].x = endx;
         blk_pts[1].y = endy + TXT_A->CurH -1;
         if (blk_pts[0].x<blk_pts[1].x) WPbox((INT16)w_ind, (VRECT*)blk_pts, &txtgrect);
         Mouse_on();
        }
         break;
         
    case BLK_LINE_DRAW:       /* dans ce cas w_ind est le numero de ligne  */
         lig_pt = w_ind;      /* ne surtout pas faire Mouse_on()           */
         /*.... on est sur ligne de fin et debut (1 seule ligne).....*/
         if (lig_pt == TXT_A->BlkEndLig && lig_pt == TXT_A->BlkDebLig )
            {blk_vrect.left   = TXT_A->BlkEndX;
             blk_vrect.top    = TXT_A->BlkEndY;
             blk_vrect.right  = TXT_A->BlkDebX + 1;
             blk_vrect.bottom = TXT_A->BlkDebY + TXT_A->CurH - 1;
             if (blk_vrect.right>blk_vrect.left)
                {blk_vrect.left ++;
                 blk_vrect.right --;
                }
             Pbox((INT16*)&blk_vrect);
            }
          /*.............. on est sur la ligne de fin ...............*/
          else if (lig_pt == TXT_A->BlkEndLig)
            {if (TXT_A->BlkEndLig > TXT_A->BlkDebLig)
                {blk_vrect.left   = TXT_A->TxtGrect.g_x;
                 blk_vrect.top    = TXT_A->BlkEndY;
                 blk_vrect.right  = TXT_A->BlkEndX;
                 blk_vrect.bottom = TXT_A->BlkEndY + TXT_A->CurH - 1;
                 if (blk_vrect.left<blk_vrect.right) Pbox((INT16*)&blk_vrect);
                }
             else
                {blk_vrect.left   = TXT_A->BlkEndX + 1;
                 blk_vrect.top    = TXT_A->BlkEndY;
                 blk_vrect.right  = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
                 blk_vrect.bottom = TXT_A->BlkEndY + TXT_A->CurH - 1;
                 if (blk_vrect.left<blk_vrect.right) Pbox((INT16*)&blk_vrect);
                }
            }
          /*.............. on est sur la ligne de debut .............*/
          else if (lig_pt == TXT_A->BlkDebLig)
            {if (TXT_A->BlkDebLig < TXT_A->BlkEndLig)      /* |---->   */
                {blk_vrect.left   = TXT_A->BlkDebX + 1;
                 blk_vrect.top    = TXT_A->BlkDebY;
                 blk_vrect.right  = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
                 blk_vrect.bottom = TXT_A->BlkDebY + TXT_A->CurH - 1;
                 if (blk_vrect.left<blk_vrect.right) Pbox((INT16*)&blk_vrect);
                }
             else                                          /* <----|   */
                {blk_vrect.left   = TXT_A->TxtGrect.g_x;
                 blk_vrect.top    = TXT_A->BlkDebY;
                 blk_vrect.right  = TXT_A->BlkDebX;
                 blk_vrect.bottom = TXT_A->BlkDebY + TXT_A->CurH - 1;
                 if (blk_vrect.left<blk_vrect.right) Pbox((INT16*)&blk_vrect);
                }
            }
          /*.............. on est sur la ligne du milieu ...........*/
          else
            {blk_vrect.left   = TXT_A->TxtGrect.g_x;
             blk_vrect.top    = (INT16)Lig_To_Y(lig_pt, TXT_A);
             blk_vrect.right  = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
             blk_vrect.bottom = blk_vrect.top + TXT_A->CurH - 1;
             Pbox((INT16*)&blk_vrect);
            }
          break;
    case BLK_UPDATE:
         Mouse_off();
         /*.......... on est au moins une ligne plus haut ...........*/
         if (TXT_A->BlkEndLig > TXT_A->LigPt)
            {/*........ completer  gauche du l'ancien curseur ......*/
             blk_vrect.left   = TXT_A->TxtGrect.g_x -1 ;
             blk_vrect.top    = TXT_A->BlkEndY;
             blk_vrect.right  = TXT_A->BlkEndX;
             blk_vrect.bottom = TXT_A->BlkEndY + TXT_A->CurH - 1; 
             blk_vrect.left++;
             WPbox((INT16)w_ind, &blk_vrect, &TXT_A->TxtGrect);
             /*........... si plusieurs lignes ......................*/
             if (TXT_A->BlkEndLig - TXT_A->LigPt  > 1)
                {blk_vrect.left   = TXT_A->TxtGrect.g_x;
                 blk_vrect.top    = TXT_A->CurY + TXT_A->CurH; 
                 blk_vrect.right  = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
                 blk_vrect.bottom = TXT_A->BlkEndY - 1;
                 WPbox((INT16)w_ind, &blk_vrect, &TXT_A->TxtGrect);
                }
             blk_vrect.left   = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
             blk_vrect.top    = TXT_A->CurY;
             blk_vrect.right  = TXT_A->CurX;
             blk_vrect.bottom = TXT_A->CurY + TXT_A->CurH - 1;
             if (TXT_A->CurX > blk_vrect.left) blk_vrect.left++;
             else                              blk_vrect.right++;
             WPbox((INT16)w_ind, &blk_vrect, &TXT_A->TxtGrect);
            }             
         /*.......... on est au moins une ligne plus bas ............*/
         else if (TXT_A->BlkEndLig < TXT_A->LigPt)
            {/*........ completer  droite du l'ancien curseur ......*/
             blk_vrect.left   = TXT_A->BlkEndX;
             blk_vrect.top    = TXT_A->BlkEndY;
             blk_vrect.right  = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
             blk_vrect.bottom = TXT_A->BlkEndY + TXT_A->CurH - 1;
             blk_vrect.left++;
             WPbox((INT16)w_ind, &blk_vrect, &TXT_A->TxtGrect);
             /*........... si plusieurs lignes entre ................*/
             if (TXT_A->LigPt - TXT_A->BlkEndLig > 1)
                {blk_vrect.left   = TXT_A->TxtGrect.g_x;
                 blk_vrect.top    = TXT_A->BlkEndY + TXT_A->CurH;
                 blk_vrect.right  = TXT_A->TxtGrect.g_x + TXT_A->TxtGrect.g_w -1;
                 blk_vrect.bottom = TXT_A->CurY - 1; 
                 WPbox((INT16)w_ind, &blk_vrect, &TXT_A->TxtGrect);
                }
             /*.......... completer  gauche du curseur .............*/
             blk_vrect.left   = TXT_A->TxtGrect.g_x -1;
             blk_vrect.top    = TXT_A->CurY;
             blk_vrect.right  = TXT_A->CurX;
             blk_vrect.bottom = TXT_A->CurY + TXT_A->CurH - 1; 
             if (TXT_A->CurX > blk_vrect.left) blk_vrect.left++;
             else                              blk_vrect.right++;
             WPbox((INT16)w_ind, &blk_vrect, &TXT_A->TxtGrect);
            }
         /*.......... on est sur la meme ligne ......................*/
         else 
            {blk_vrect.left   = TXT_A->BlkEndX;
             blk_vrect.top    = TXT_A->BlkEndY;
             blk_vrect.right  = TXT_A->CurX;
             blk_vrect.bottom = TXT_A->CurY + TXT_A->CurH - 1; 
             if (TXT_A->CurX > blk_vrect.left) blk_vrect.left++;
             else                              blk_vrect.right++;
             WPbox((INT16)w_ind, &blk_vrect, &TXT_A->TxtGrect);
            }
         Mouse_on();
         break;
   }
}
/*---------------------- EZ_ED_DirectExeEvntKey ----------------------------------*/
/* ACTION: permet de simuler l'appui d'une touche clavier, par envoi direct d'un  */
/*         evenement clavier, sans passer par l'evenementiel GEM.                 */
/* ENTREE:  INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*          INT16 key: touche clavier comme le GEM la desire: (HIBYTE=scan  code).  */
/*                                                          (LOBYTE=ascii code).  */
/*          INT16 ksp: etat des touches clavier Shift Control Alternate.            */
/*          TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte, (peut y en avoir plusieurs dans   */
/*                          une fenetre)  qui l'on veut faire effectuer ce       */
/*                          message.                                              */
/* SORTIE: INT16 dependant de la reponse de l'editeur.                              */

INT16 EZ_ED_DirectExeEvntKey(INT16 w_ind, INT16 key, INT16 ksp, TXTED_OB *TXT_A)
{EVNT_O Evnt_mess;
 Evnt_mess.evnt                = MU_KEYBD;
 Evnt_mess.x                   = Mousex();
 Evnt_mess.y                   = Mousey();
 Evnt_mess.k                   = Mousek();
 Evnt_mess.ksp                 = ksp;
 Evnt_mess.key                 = key;
 Evnt_mess.click               = 0;
 return TXT_A->EvntFunc(w_ind, &Evnt_mess);
}

/*---------------------- EZ_ED_DirectExeEditMessage ------------------------------*/
/* ACTION: execute directement un message de l'editeur par appel direct de sa     */
/*         fonction evenementielle, sans passer par l'evenementiel GEM.           */
/* ENTREE:  INT16 w_ind: indice EAZY_GEM de la fenetre possedant l'editeur de texte */
/*          INT16 mess: message a effectuer.                                        */
/*          INT16 *param: pointe sur un tableau de parametres dependant du message  */
/*          INT16 nb_param: comme son nom l'indique, nombre de parametres.          */
/*          TXTED_OB *TXT_A: pointeur sur la structure definissant un composant   */
/*                          d'edition de texte, (peut y en avoir plusieurs dans   */
/*                          une fenetre)  qui l'on veut faire effectuer ce       */
/*                          message.                                              */
/* SORTIE: INT16 dependant de la reponse de chaque message.                         */

INT16 EZ_ED_DirectExeEditMessage(INT16 w_ind, INT16 mess, INT16 *param, INT16 nb_param, TXTED_OB *TXT_A)
{EVNT_O Evnt_mess;
 Evnt_mess.evnt                = MU_MESAG;
 Evnt_mess.x          = 0; /* Mousex(); */
 Evnt_mess.y          = 0; /* Mousey(); */
 Evnt_mess.k          = 0; /* Mousek(); */
 Evnt_mess.ksp                 = (INT16)Kbshift(-1);
 Evnt_mess.key                 = 0;
 Evnt_mess.click               = 0;
 Evnt_mess.pipe[MESG]          = mess;  
 Evnt_mess.pipe[APPL]          = Appl_id;                  /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL]          = 0;                        /*   message sans surplus                 */
 Evnt_mess.pipe[WHND]          = GETGEMHAND(w_ind);
 memcpy(&Evnt_mess.pipe[X_G], param, sizeof(INT16) * Min(nb_param,8));
 return TXT_A->EvntFunc(w_ind, &Evnt_mess);
}

/*----------------------- EZ_ED_CarPtToWord -------------------------------------*/
/* ACTION: slectionne le mot sur lequel le curseur se situe.                    */
/* ENTREE: char *c: pointe sur la position du curseur dans le texte.             */
/*         char *debtxt: pointe sur le premier caractere du texte.               */
/*         char ** end_word: pointe sur le pointeur dans lequel sera place la    */
/*                           fin du mot selectionne.                             */
/*         INT16 limit_type: flag determinant les limites recherches pour un mot  */
/* RETOUR: char * pointeur sur le debur du mot selectionne.                      */

char  *EZ_ED_CarPtToWord(char *c, char *debtxt, char ** end_word, INT16 limit_type)
{char *pt = c;
 switch(limit_type)
   {case WORD_SIMPLE:
         while (*pt && (isalnum(*pt) || *pt=='_') )           pt++;
         *end_word = pt;
         while (c>debtxt && (isalnum(c[-1]) || c[-1]=='_') )  c--;
         return c;
    case WORD_VAR:
         while (*pt && (isalnum(*pt) || strchr("_&[].->",*pt)) )           pt++;
         *end_word = pt;
         while (c>debtxt && (isalnum(c[-1]) || strchr("_&[].->",c[-1])) )  c--;
         return c;
   }
 return 0;
}

/*------------------------ UNDO_DO --------------------------------------*/
void UNDO_DO(INT16 w_ind, UNDO_REC *undo_rec, TXTED_OB *TXT_A)
{INT16 param[4];
 long token;
 UNDO_STACK *un_sav_Stack;
 
 /*........ si pointeurs invalides cassos ...............*/
 if (undo_rec==0 || TXT_A==0) return;
 
 /*........... bloquer le UNDO du UNDO ..................*/
 /*            car reempile ce que l'on                  */
 /*                vient de faire                        */
 un_sav_Stack   = TXT_A->U_Stack;
 TXT_A->U_Stack = 0;
 /*.......... analyse du UNDO et Action .................*/
 memcpy(&token, undo_rec->Token, 4);
 
 /*........... restaurer un bloc effac .................*/
 if      (token=='DELB')  /* "DELBLK" */
   {char *src = undo_rec->Data1.Dszstr;
    long  len = undo_rec->Data2.Dlong;
    char *dst = undo_rec->Data3.Dlong + TXT_A->ptTxt;
    src[len]  = 0;
    *(long*) &param[0] = (long)dst;
    *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);
    *(long*) &param[0] = (long)src;
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_MEMORY_PASTE, param, 4, TXT_A);
   }
 /*........... restaurer un caractere effac ............*/
 else if (token=='DELC')  /* "DELCAR" */
   {char str[16];
    char *dst = undo_rec->Data3.Dlong + TXT_A->ptTxt;
    memcpy(str,     &undo_rec->Data1.Dlong, 4);
    str[undo_rec->Data2.Dlong] = 0;
    *(long*) &param[0] = (long)dst;
    *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);
    *(long*) &param[0] = (long)str;
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_MEMORY_PASTE, param, 4, TXT_A);
   }
 /*.......... annuler les caracteres saisis ou pasts ....*/
 else if (token=='INSB')  /* "INSBLK" */
   {char *src = undo_rec->Data1.Dlong + TXT_A->ptTxt;
    long  len = undo_rec->Data2.Dlong;
    *(long*) &param[0] = (long)src;
    *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,  param, 4, TXT_A);
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
    *(long*) &param[0] = (long)src + len;
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END, param, 4, TXT_A);
    EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_DEL,         param, 4, TXT_A);
   }
 if (undo_rec->Type==AUTO_ALLOC) free(undo_rec->Data1.Dszstr);
 /*........... restaurer la pile undo .............................*/
 TXT_A->U_Stack = un_sav_Stack;
 
 /*........... pour memoire .......................................*/
 /*  UNDO_Push("DEL_BLK", AUTO_ALLOC, (long)deb_blk, nb_car_del, deb_blk - TXT_A->ptTxt, TXT_A->U_Stack); */
 /*  UNDO_Push("DEL_CAR", 0, data[0], data[1], orig, TXT_A->U_Stack);                                     */
 /*  UNDO_Push("INS_BLK", 0, dst - TXT_A->ptTxt, len_src, 0, TXT_A->U_Stack);                             */
}

/*----------------------- SetAttributForOne --------------------------------------*/
void SetAttributForOne(INT16 col, INT16 eff, INT16 pts, INT16 fid, char *fntName, CAR_ATTR *CAR_A)
{if (col != -1) CAR_A->CarCol = col;
 if (pts != -1) CAR_A->CarPts = pts;
 if (eff != -1) CAR_A->CarEff = eff;
 /*.......... retrouver le nom de la police  partir de l'indice VDI .............*/
 if (fid != -1) 
    {INT16 tabId     =  FntID_VDI_to_TabInd(fid);  /* indice VDI vers indice tableau EZ_GEM */
     CAR_A->FntID  = fid;
     strcpy(CAR_A->FntName, FontName+tabId*36);
    }
 /*......... retrouver l'indice VDI de la police  artir du nom ..................*/
 if (fntName)
    {INT16 tabId     =(INT16) FontNameToFontID(fntName, FontTab);
     CAR_A->FntID  =(INT16) FontID[tabId];
     strcpy(CAR_A->FntName, FontName+tabId*36);
    }
}


/*------------------------ CouperBloc --------------------------------------------*/
long CouperBloc(INT16 w_ind, TXTED_OB* TXT_A)
{long  deb_lig ,deb_car ,end_lig ,end_car;
 INT16 prem_lchg   = 0;
 long nb_car_del = 0;
 long old_preml  = TXT_A->PremLigVisible;  
 long old_nbl    = TXT_A->NbLgn;

 /*.......... effacer le curseur texte ................................*/
 EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_ERASE);
 /*.............. Enlever selection du bloc ...........................*/
 Blk_LigAndCar_to_BlkXY(TXT_A);
 EZ_ED_DrawBlkFrame(w_ind, BLK_ALL_DRAW, TXT_A);
 /*.............. Recuperer un bloc ordonn ...........................*/
 GetSortedBlkMark(&deb_lig, &deb_car, &end_lig, &end_car, TXT_A);
 /*.......... effacer les caracteres ..................................*/                           
 nb_car_del = DeleteBloc(deb_lig, deb_car,  end_lig, end_car,  TXT_A);
 NotifieEditTxtChanged(w_ind, TXT_A);
 /*............. notifier au pere la modification de taille ...........*/   
 NotifieTxtSizeChg(w_ind, EZ_ED_GETPOS(TXT_A, deb_lig, deb_car), -nb_car_del, TXT_A); 
 /*........... mise a jour des pointeurs ..............................*/
 TXT_A->BlkEndLig = deb_lig;
 TXT_A->BlkDebLig = deb_lig;
 TXT_A->CarPt     = deb_car;
 TXT_A->BlkEndCar = deb_car;
 TXT_A->BlkDebCar = deb_car;
 TXT_A->LigPt     = deb_lig;
 Blk_LigAndCar_to_BlkXY(TXT_A);
 /*.......... replacer la ligne en edition ............................*/
 TextToBuffEdit( TXT_A->LigPt, TXT_A);
 if (old_nbl != TXT_A->NbLgn)
    {NotifieNbrLignChg(w_ind, FALSE, TXT_A);
    }
 /*.......... mise a jour du curseur et du pere .......................*/
 if (TXT_A->LigPt < TXT_A->PremLigVisible                           ||
     TXT_A->LigPt > TXT_A->PremLigVisible + TXT_A->NbreLigVisible)
    {TXT_A->PremLigVisible = Max(0, TXT_A->LigPt - (TXT_A->NbreLigVisible >> 1));
     TXT_A->PremLigVisible = Min(TXT_A->PremLigVisible, TXT_A->NbLgn - 1 - (TXT_A->NbreLigVisible >> 1));
     TXT_A->PremLigVisible = Max(TXT_A->PremLigVisible, 0);
     prem_lchg = 1;
    }
 if (TXT_A->PremLigVisible + TXT_A->NbreLigVisible > TXT_A->NbLgn)
    {TXT_A->PremLigVisible = Max(0, TXT_A->NbLgn - TXT_A->NbreLigVisible);
    prem_lchg = 1;
    }
 if (prem_lchg) NotifiePremLignChg(w_ind, FALSE, TXT_A);
 
 NotifieLigneChg(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
 TXT_A->CurY       = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A); 
 CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
 TXT_A->LastXPt = TXT_A->CurX - TXT_A->TxtGrect.g_x - TXT_A->MargLeft + TXT_A->OfsX;
 /*.............. redessin des lignes sous jacentes ...................*/
 /*..................... si qu'une ligne la redessiner.................*/
 Mouse_off();
 if (deb_lig == end_lig)
    {EZ_ED_RedrawFromLineToLine(w_ind, TXT_A->LigPt , TXT_A->LigPt + 1, TXT_A);
    }
 /*..................... si visible dans fenetre ......................*/
 else if (deb_lig >= old_preml && deb_lig <= old_preml + TXT_A->NbreLigVisible && !prem_lchg)
   { EZ_ED_RedrawFromLineToLine(w_ind, TXT_A->LigPt , LONG_MAX, TXT_A);
   }
 else
   {EZ_ED_RedrawFromLineToLine(w_ind, TXT_A->PremLigVisible , LONG_MAX, TXT_A);
   }
 /*.......... afficher le curseur texte ...............................*/
 EZ_ED_DrawCurs(w_ind,  TXT_A, CURS_DRAW);
 return 1;
}  
/*----------------------------- SendNotification ---------------------------------*/
INT16 SendNotification(INT16 w_ind, INT16 messg, INT16 *param, INT16 n_param, TXTED_OB* TXT_A)
{EVNT_O Evnt_mess;
 INT16 n_par = abs(n_param);
 if (TXT_A->NotifyFunc==0) return 2;
 Evnt_mess.evnt       = MU_MESAG;
 Evnt_mess.x          = 0; /* Mousex(); */
 Evnt_mess.y          = 0; /* Mousey(); */
 Evnt_mess.k          = 0; /* Mousek(); */
 Evnt_mess.ksp        = (INT16)Kbshift(-1);
 Evnt_mess.key        = 0;
 Evnt_mess.click      = 0;
 Evnt_mess.pipe[MESG] = messg;  
 Evnt_mess.pipe[APPL] = Appl_id;                   /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL] = 0;                         /*   message sans surplus                 */
 Evnt_mess.pipe[WHND] = Windtab[w_ind].w_h;        /*   fenetre  qui est dediee le message  */
 if (param) memcpy(&Evnt_mess.pipe[X_G ], param, Min(16, n_par) * sizeof(INT16) );
 return TXT_A->NotifyFunc(w_ind, &Evnt_mess);
}

/*------------------------ NotifiePremLignChg ------------------------------------*/
INT16 NotifiePremLignChg(INT16 w_ind, INT16 flag, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 
 param[0]                = ED_FST_LIG_CHG;     /* notifier au pere clic en dehors texte */
 param[1]                = flag;               /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 *(long*) &param[4]      = TXT_A->PremLigVisible;         /* premiere ligne visible     */
 if (ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8) == 0)
    {TXT_ED              = TXT_S;
     return 0;
    }
 ret = SendNotification( w_ind,  WM_EDIT_UPDATE, param, 8, TXT_A);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifiePremClnChg ------------------------------------*/
INT16 NotifiePremClnChg(INT16 w_ind, INT16 flag, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 param[0]                = ED_FST_CLN_CHG;     /* notifier au pere clic en dehors texte */
 param[1]                = flag;               /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
           param[4]      = TXT_A->OfsX/TXT_A->IntCo;     /* premiere colonne visible     */
if (ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8) == 0)
    {TXT_ED              = TXT_S;
     return 0;
    }
 ret = SendNotification( w_ind,  WM_EDIT_UPDATE, param, 8, TXT_A);
 TXT_ED                  = TXT_S;
 return ret;
}
/*------------------------ NotifieNbrLignChg ------------------------------------*/
INT16 NotifieNbrLignChg(INT16 w_ind, INT16 flag, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                                /* dans la procedure de notification.    */
 param[0]                = ED_NBR_LIG_CHG;      /* notifier au pere clic en dehors texte */
 param[1]                = flag;                /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;         /* placer adresse des parametres texte   */
 *(long*) &param[4]      = TXT_A->NbLgn;        /* placer nbr de lignes document         */
 if (ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8) == 0)
    {TXT_ED              = TXT_S;
     return 0;
    }
 ret = SendNotification( w_ind,  WM_EDIT_UPDATE, param, 8, TXT_A);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieOutTxtClick ------------------------------------*/
INT16 NotifieOutTxtClick(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 param[0]                = ED_CLICK_OUT;       /* notifier au pere clic en dehors texte */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 *(long*) &param[4]      = (long)Evnt;         /* flus evenementiel                     */
 if (ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8) == 0)
    {TXT_ED              = TXT_S;
     return 0;
    }
 ret = SendNotification( w_ind,  WM_EDIT_UPDATE, param, 8, TXT_A);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieReturnDown -------------------------------------*/
/* ACTION: envoie de cette notification au pere du composant d'edition de texte   */
/*         pour lui signaler que la touche RETURN ENTER a ete appuye.            */
/*         Le pere retourne 0/ pour signaler qu'il prend en charge lui meme la    */
/*                             gestion de cette touche.                           */
/*          MU_MESAG(16) ou 1/ pour signaler au composant d'edition de texte      */
/*                             qu'il ne prend pas en charge la gestion.           */
/*          ED_RETURN_CHG(15)/ pour signaler au composant d'edition de texte que  */
/*                             le buffer d'edition est modifie et alors le pere   */
/*                             retourne au composant d'edition de texte:          */
/*                             en Evnt_mess.pipe[X_G ]: position modif in buffer. */
/*                                Evnt_mess.pipe[Y_G ]: nombre de caracteres      */
/*                                                       rajoutes  (si > 0)       */
/*                                                       ou enleves(si < 0)       */
INT16 NotifieReturnDown(INT16 w_ind, INT16 *param, TXTED_OB* TXT_A)
{INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 EVNT_O Evnt_mess; 
 Evnt_mess.evnt       = MU_MESAG;
 Evnt_mess.x          = 0; /* Mousex(); */
 Evnt_mess.y          = 0; /* Mousey(); */
 Evnt_mess.k          = 0; /* Mousek(); */
 Evnt_mess.ksp        = (INT16)Kbshift(-1);
 Evnt_mess.key        = 0x000D;                    /*  touche return ASCII 13                */
 Evnt_mess.click      = 0;
 Evnt_mess.pipe[MESG] = WM_EDIT_UPDATE;            /*   message de notification              */
 Evnt_mess.pipe[APPL] = Appl_id;                   /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL] = 0;                         /*   message sans surplus                 */
 Evnt_mess.pipe[WHND] = Windtab[w_ind].w_h;        /*   fenetre  qui est dediee le message  */
 Evnt_mess.pipe[X_G ]          = ED_RETURN_DWN;    /*   nature de la notification            */
 *(long*)&Evnt_mess.pipe[W_G ] = (long)TXT_A;      /*   adresse du composant d'edition       */
 ret = Windtab[w_ind].w_proc(w_ind , &Evnt_mess);
 TXT_ED                  = TXT_S;
 param[0] = Evnt_mess.pipe[X_G ];
 param[1] = Evnt_mess.pipe[Y_G ];
 return ret;
}

/*------------------------ NotifieKeyBoardControl --------------------------------*/
INT16 NotifieKeyBoardControl(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 param[0]                = ED_KEYB_CNTRL;      /* notifier au pere clic en dehors texte */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 *(long*) &param[4]      = (long)Evnt;         /* flus evenementiel                     */
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieKeyBoardAlternate ------------------------------*/
INT16 NotifieKeyBoardAlternate(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 param[0]                = ED_KEYB_ALT;        /* notifier au pere clic en dehors texte */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 *(long*) &param[4]      = (long)Evnt;         /* flus evenementiel                     */
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieKeyDown ----------------------------------------*/
INT16 NotifieKeyDown(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 param[0]                = ED_KEYB_DWN;        /* notifier au pere clic en dehors texte */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 *(long*) &param[4]      = (long)Evnt;         /* flus evenementiel                     */
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieClick ------------------------------------------*/
INT16 NotifieClick(INT16 w_ind, EVNT_O *Evnt, TXTED_OB* TXT_A)
{INT16 param[8];
 EVNT_O Evnt_mess;
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 param[0]                = ED_CLICK_IN;        /* notifier au pere clic en dehors texte */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 *(long*) &param[4]      = (long)Evnt;         /* flus evenementiel                     */
 /* ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);  */
 Evnt_mess.evnt       = MU_MESAG;
 Evnt_mess.x          = Evnt->x;
 Evnt_mess.y          = Evnt->y;
 Evnt_mess.k          = Evnt->k;
 Evnt_mess.ksp        = Evnt->ksp;
 Evnt_mess.key        = Evnt->key;
 Evnt_mess.click      = Evnt->click;
 Evnt_mess.pipe[MESG] = WM_EDIT_UPDATE;  
 Evnt_mess.pipe[APPL] = Appl_id;                   /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL] = 0;                        /*   message sans surplus                 */
 Evnt_mess.pipe[WHND] = Windtab[w_ind].w_h;        /*   fenetre  qui est dediee le message  */
 memcpy(&Evnt_mess.pipe[X_G ], param, 8 * sizeof(INT16) );
 ret = (Windtab[w_ind].w_proc)(w_ind , &Evnt_mess);
 TXT_ED               = TXT_S;
 return ret;
}

/*------------------------ NotifieEditLoseFocus ----------------------------------*/
INT16 NotifieEditLoseFocus(INT16 w_ind, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 if (w_ind==-1)          return 1;
 param[0]                = ED_LOSE_FOCUS;      /* notifier au pere la perte du focus    */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieEditSetFocus -----------------------------------*/
INT16 NotifieEditSetFocus(INT16 w_ind, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 if (w_ind==-1)           return 1;
 param[0]                = ED_SET_FOCUS;       /* notifier au pere le gain du focus     */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieEditTxtChanged ---------------------------------*/
INT16 NotifieEditTxtChanged(INT16 w_ind, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 if (TXT_A->State & EDIT_CHG)  return 1;
 TXT_A->State |= EDIT_CHG; 
 if (w_ind==-1)                return 1; 
 param[0]                = ED_TXT_CHG;        /* notifier au pere le gain du focus     */
 param[1]                = FALSE;             /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;       /* placer adresse des parametres texte   */
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieTxtSizeChg -------------------------------------*/
INT16 NotifieTxtSizeChg(INT16 w_ind, long pos, long size, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 if (w_ind==-1)           return 1;
 param[0]                = ED_SIZE_CHG;        /* notifier au pere que la taille change */
 param[1]                = FALSE;              /* pas de redessin demande au pere       */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte   */
 *(long*) &param[4]      = pos;                /* la taille est modifiee juste apres    */ 
 *(long*) &param[6]      = size;               /* nbr d'octets (negatif ou positif)     */
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ NotifieLigneChg ---------------------------------------*/
INT16 NotifieLigneChg(INT16 w_ind, long lig_pt, long car_pt, TXTED_OB* TXT_A)
{INT16 param[8];
 INT16 ret;
 TXTED_OB* TXT_S         = TXT_ED;             /* pour que la reentrance soit possible  */
                                               /* dans la procedure de notification.    */
 param[0]                = ED_POS_CURS_CHG;    /* notifier au pere changement nb ligne */
 param[1]                = FALSE;              /* pas de redessin demande au pere      */
 *(long*) &param[2]      = (long)TXT_A;        /* placer adresse des parametres texte  */
 if (lig_pt != TXT_A->LastLigPt)
     *(long*) &param[4]    = lig_pt;           /* ligne pointee                        */
 else
     *(long*) &param[4]    = -1;
 if (car_pt != TXT_A->LastCarPt)
     *(long*) &param[6]    = car_pt;           /* caractere pointee dans la ligne      */
 else
     *(long*) &param[6]    = -1;
 TXT_A->LastLigPt = lig_pt;
 TXT_A->LastCarPt = car_pt;
 ret =  ExeWindMessage(w_ind, WM_EDIT_UPDATE, param, 8);
 TXT_ED                  = TXT_S;
 return ret;
}

/*------------------------ GetNearBlkFromXY -------------------------------------*/
INT16 GetNearBlkFromXY(INT16 x, INT16 y, TXTED_OB* TXT_A)
{if (TXT_A->BlkDebLig == TXT_A->BlkEndLig)
    {if ( abs(TXT_A->BlkDebX - x) < abs(x - TXT_A->BlkEndX) ) return 1;
     else                                                     return 0;
    }
 else
    {if ( abs(TXT_A->BlkDebY - y) < abs(y - TXT_A->BlkEndY) ) return 1;
     else                                                     return 0;
    }
}

/*------------------------ IsCursInBloc ------------------------------------------*/
INT16 IsCursInBloc(TXTED_OB* TXT_A)
{long deb_lig, deb_car, end_lig, end_car;
 INT16  flag = 0;
 
 if ( !IsTxtBlkDefined(TXT_A) )           return 0;
                                          flag |= BLK_DEFINED;
 if (GetSortedBlkMark(&deb_lig, &deb_car, &end_lig, &end_car, TXT_A))
    {                                     flag |= BLK_INVERSED;
    }
 /*............ tester position curseur ..........................................*/
 
 if        (deb_lig > TXT_A->LigPt)                             flag |=  BLK_AFTER_CURS;
 else if   (deb_lig == TXT_A->LigPt && deb_car > TXT_A->CarPt)  flag |=  BLK_AFTER_CURS;
 else if   (end_lig < TXT_A->LigPt)                             flag &= ~(BLK_NEAR_CURS|BLK_NEAR_CURS);
 else if   (end_lig == TXT_A->LigPt)
           {if (end_car < TXT_A->CarPt)               flag &= ~(BLK_NEAR_CURS|BLK_NEAR_CURS);
            else                                      flag |=  BLK_NEAR_CURS;
           }
 else                                                 flag |=  BLK_NEAR_CURS; 
 return flag;
}

/*------------------------ IsPosInBloc ------------------------------------------*/
INT16 IsPosInBloc(long ligpt, long carpt, TXTED_OB* TXT_A)
{long deb_lig, deb_car, end_lig, end_car;
 INT16  flag = 0;
 
 if ( !IsTxtBlkDefined(TXT_A) )           return 0;
                                          flag |= BLK_DEFINED;
 if (GetSortedBlkMark(&deb_lig, &deb_car, &end_lig, &end_car, TXT_A))
    {                                     flag |= BLK_INVERSED;
    }
 /*............ tester position curseur ..........................................*/
 
 if        (deb_lig > ligpt)                             flag |=  BLK_AFTER_CURS;
 else if   (deb_lig == ligpt && deb_car > carpt)         flag |=  BLK_AFTER_CURS;
 else if   (end_lig < ligpt)                             flag &= ~(BLK_NEAR_CURS|BLK_NEAR_CURS);
 else if   (end_lig == ligpt)
           {if (end_car < carpt)                      flag &= ~(BLK_NEAR_CURS|BLK_NEAR_CURS);
            else                                      flag |=  BLK_NEAR_CURS;
           }
 else                                                 flag |=  BLK_NEAR_CURS; 
 return flag;
}

/*------------------------ GetSortedBlkMark -------------------------------------*/
INT16 GetSortedBlkMark(long *deb_lig, long *deb_car, long *end_lig, long *end_car, TXTED_OB* TXT_A)
{long dumy;
 long temp;
 *deb_lig = TXT_A->BlkDebLig;
 *deb_car = TXT_A->BlkDebCar;
 *end_lig = TXT_A->BlkEndLig;
 *end_car = TXT_A->BlkEndCar;
 /*................. faut swapper si inversion ..........*/
 if (*deb_lig > *end_lig)
    {dumy     = *deb_lig;
     temp     = *deb_car;
     *deb_lig = *end_lig;
     *end_lig = dumy;
     *deb_car = *end_car;
     *end_car = temp;
     return  TRUE;
    }
 else if (*deb_lig == *end_lig && *deb_car > *end_car)
    {temp     = *deb_car;
     *deb_car = *end_car;
     *end_car = temp;
     return TRUE;
    }
 return  FALSE;
}

/*------------------------ IsTxtBlkDefined --------------------------------------*/
INT16 IsTxtBlkDefined(TXTED_OB* TXT_A)
{return (TXT_A->BlkEndLig != TXT_A->BlkDebLig ||
         TXT_A->BlkEndCar != TXT_A->BlkDebCar
        );
}

/*----------------------------- Blk_LigAndCar_to_BlkXY --------------------------*/
void Blk_LigAndCar_to_BlkXY(TXTED_OB* TXT_A)
{if (TXT_A->BlkDebLig > -1 && TXT_A->BlkDebLig <TXT_A->NbLgn)
    {/*......... Pb du depasement capacite d'un INT16 .............................*/
     long y = Lig_To_Y(TXT_A->BlkDebLig, TXT_A);
     if (TXT_A->BlkDebLig < TXT_A->PremLigVisible) TXT_A->BlkDebY = (INT16) Max(INT_MIN/2, y);
     else                                          TXT_A->BlkDebY = (INT16) Min(INT_MAX/2, y);
     /*................. si debut de bloc sur ligne en edition ..................*/
     /*                  calcul de la position dans buffer d'edition             */
     
     if (TXT_A->BlkDebLig == TXT_A->LigPt)
         TXT_A->BlkDebX   = CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->BlkDebCar, TXT_A, FALSE);
     else
         TXT_A->BlkDebX   = CarOfLigne_to_X(TXT_A->TabLgnCtx[TXT_A->BlkDebLig].ptTxt, TXT_A->BlkDebCar, TXT_A, FALSE);
    }
 if (TXT_A->BlkEndLig > -1 && TXT_A->BlkEndLig <TXT_A->NbLgn)
    {/*......... Pb du depasement capacite d'un INT16 .............................*/
     long y = Lig_To_Y(TXT_A->BlkEndLig, TXT_A);
     if (TXT_A->BlkEndLig < TXT_A->PremLigVisible) TXT_A->BlkEndY = (INT16) Max(INT_MIN/2, y);
     else                                          TXT_A->BlkEndY = (INT16) Min(INT_MAX/2, y);
     /*................. si fin de bloc sur ligne en edition ....................*/
     /*                  calcul de la position dans buffer d'edition             */
     if (TXT_A->BlkEndLig == TXT_A->LigPt)
         TXT_A->BlkEndX   = CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->BlkEndCar, TXT_A, FALSE);
     else
         TXT_A->BlkEndX   = CarOfLigne_to_X(TXT_A->TabLgnCtx[TXT_A->BlkEndLig].ptTxt, TXT_A->BlkEndCar, TXT_A, FALSE);
     
    }
}

/*------------------------ WPbox -------------------------------------------------*/
void WPbox(INT16 w_ind, VRECT *box_vrect, GRECT *display_grect)
{GRECT  r1, box_grect;
 INT16 sav;
 INT16 w_h             = Windtab[w_ind].w_h;
 /*..........reorienter le rectangle sinon trouble de VRECT_to_GRECT ........*/
 if (box_vrect->right < box_vrect->left)
    {sav = box_vrect->right; box_vrect->right = box_vrect->left; box_vrect->left = sav;
    }
 if (box_vrect->bottom < box_vrect->top)
    {sav = box_vrect->bottom; box_vrect->bottom = box_vrect->top; box_vrect->top = sav;
    }
 VRECT_to_GRECT(box_vrect, &box_grect);
 /*............ ne dessiner que si intersecte avec fenetre de texte ..........*/
 if ( !Rc_intersect( display_grect, &box_grect))                        return;
 /*............. dessiner en tenant compte de la liste des rectangles.........*/
 wind_get( w_h, WF_FIRSTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
 while (r1.g_w && r1.g_h)
       {if ( Rc_intersect( &box_grect, &r1)) 
           {ClipGrect(&r1);
            Pbox( (INT16*) box_vrect);
	          } 
	       wind_get(w_h, WF_NEXTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
	      }   /*endwhile (r1.g_w && r1.g_h) */
}

/*------------------------ WhereIsCursor -----------------------------------------*/
INT16 WhereIsCursor(TXTED_OB* TXT_A)
{INT16 scroll_flag = 0; 
 VRECT txt_vrect;
 GRECT_to_VRECT( &TXT_A->TxtGrect, &txt_vrect );
 if      (TXT_A->CurX >= txt_vrect.right)                         scroll_flag |= SCROLL_LEFT;
 else if (TXT_A->CurX <= txt_vrect.left)                          scroll_flag |= SCROLL_RIGHT;
 if (TXT_A->NbreLigVisible<=1) 
    {TXT_A->CurY   = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
     return scroll_flag;
    }
 if      (TXT_A->CurY < txt_vrect.top && TXT_A->PremLigVisible>0) scroll_flag |= SCROLL_BOTTOM;
 else if (TXT_A->CurY + TXT_A->CurH > txt_vrect.bottom )          scroll_flag |= SCROLL_TOP;
 return scroll_flag;
}

/*------------------------ GotoNewPosCurs -----------------------------------------*/
INT16 GotoNewPosCurs(INT16 w_ind, long ligpt, long carpt, TXTED_OB* TXT_A)
{if (ligpt >= 0)
    {long old_preml    = TXT_A->PremLigVisible;
     TXT_A->LigPt      = ligpt;
     TXT_A->CarPt      = carpt;
     /*.......... mise a jour du curseur et du pere .......................*/
     TXT_A->LigPt = Min(TXT_A->NbLgn - 1, TXT_A->LigPt);
     if (TXT_A->LigPt < TXT_A->PremLigVisible || TXT_A->LigPt > TXT_A->PremLigVisible + TXT_A->NbreLigVisible)
        {TXT_A->PremLigVisible = Max(0, TXT_A->LigPt - (TXT_A->NbreLigVisible >> 1));
         TXT_A->PremLigVisible = Min(TXT_A->PremLigVisible, TXT_A->NbLgn - 1 - TXT_A->NbreLigVisible);
         TXT_A->PremLigVisible = Max(TXT_A->PremLigVisible, 0);
         NotifiePremLignChg(w_ind, FALSE, TXT_A);
        }
     NotifieLigneChg(w_ind, TXT_A->LigPt, TXT_A->CarPt, TXT_A);
     TXT_A->CurY       = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
     CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
     TXT_A->LastXPt = TXT_A->CurX - TXT_A->TxtGrect.g_x - TXT_A->MargLeft + TXT_A->OfsX;
     /*..................... si pas visible dans fenetre ..................*/
     Blk_LigAndCar_to_BlkXY(TXT_A);
     if ( !(TXT_A->LigPt >= old_preml && TXT_A->LigPt <= old_preml + TXT_A->NbreLigVisible) )
        { Mouse_off();
          EZ_ED_RedrawFromLineToLine(w_ind, TXT_A->PremLigVisible , LONG_MAX, TXT_A); 
        }
     if (CheckForScroll(w_ind, TXT_A))
        {TXT_A->CurY   = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
         CarOfLigne_to_X(TXT_A->BuffEdit, TXT_A->CarPt, TXT_A, CURS_UPDATE);
        }
    /* Pause_EZ(4);  */
    } /* endif (ligpt >= 0) */
 return 1;
}

/*------------------------ CheckForScroll ----------------------------------------*/
/*  #define SCROLL_LEFT    1      lorsque le curseur est trop  droite            */
/*  #define SCROLL_RIGHT   2      lorsque le curseur est trop  gauche            */
/*  #define SCROLL_TOP     4      lorsque le curseur est trop en bas              */
/*  #define SCROLL_BOTTOM  8      lorsque le curseur est trop en haut             */

INT16 CheckForScroll(INT16 w_ind, TXTED_OB* TXT_A)
{INT16 scroll_flag = 0;
 GRECT txt_grect = TXT_A->TxtGrect;
 VRECT txt_vrect;
 INT16 delta_x;
 GRECT_to_VRECT( &TXT_A->TxtGrect, &txt_vrect );
 if      ( (TXT_A->CurX >= txt_vrect.right || TXT_A->CurX <= txt_vrect.left) &&
          !(TXT_A->State & EDIT_SCRLH_NOT_AFTER_PASTE)
         )
         {INT16 old_OfsX = TXT_A->OfsX;
          scroll_flag |= SCROLL_LEFT;
          TXT_A->OfsX  = TXT_A->OfsX + TXT_A->CurX - ((txt_grect.g_w - 4)>>1) - txt_vrect.left;
          TXT_A->OfsX /= TXT_A->IntCo;
          TXT_A->OfsX *= TXT_A->IntCo;
          TXT_A->OfsX  = Max(0, TXT_A->OfsX);
          delta_x      = TXT_A->OfsX - old_OfsX;
          Blk_LigAndCar_to_BlkXY(TXT_A);
          NotifiePremClnChg(w_ind, FALSE, TXT_A);
          WindMoveRedraw( w_ind, 
                     -delta_x, 0, 
                     &txt_grect, 
                     DirectTxtRedraw,
                     (void*) TXT_A
                   );
         }
 if (TXT_A->State & EDIT_SCRLV_NOT_AFTER_PASTE) return 0;
 if (TXT_A->NbreLigVisible<=1)
    {long old_prem_lgn = TXT_A->PremLigVisible;
     TXT_A->PremLigVisible = TXT_A->LigPt;
     if (old_prem_lgn == TXT_A->PremLigVisible) return 0;
     NotifiePremLignChg(w_ind, FALSE, TXT_A);
     Blk_LigAndCar_to_BlkXY(TXT_A);
     TXT_A->CurY   = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
     Lister_rectangles(Windtab[w_ind].w_h, &txt_grect);
    }
 else if (TXT_A->CurY <= txt_vrect.top+3 && TXT_A->PremLigVisible>0)
         {scroll_flag |= SCROLL_BOTTOM;
          TXT_A->PremLigVisible = Max(0, TXT_A->PremLigVisible - 1 );
          NotifiePremLignChg(w_ind, FALSE, TXT_A);
          Blk_LigAndCar_to_BlkXY(TXT_A);          
          WindMoveRedraw( w_ind, 
                     0, + TXT_A->IntLg, 
                     &txt_grect, 
                     DirectTxtRedraw,
                     (void*) TXT_A
                   );
         }
 else if (TXT_A->CurY + TXT_A->CurH > txt_vrect.bottom )
         {long old_prem_lgn = TXT_A->PremLigVisible;
          scroll_flag |= SCROLL_TOP;
          TXT_A->PremLigVisible = Min(TXT_A->NbLgn - TXT_A->NbreLigVisible , TXT_A->PremLigVisible + 1 );
          if (old_prem_lgn == TXT_A->PremLigVisible) return 0;
          NotifiePremLignChg(w_ind, FALSE, TXT_A);
          Blk_LigAndCar_to_BlkXY(TXT_A); 
          WindMoveRedraw( w_ind, 
                     0, - TXT_A->IntLg, 
                     &txt_grect, 
                     DirectTxtRedraw,
                     (void*) TXT_A
                   );
         }
 return scroll_flag;
}

void DirectTxtRedraw(INT16 w_ind, GRECT *scrol_grect, GRECT *update_grect, void *param)
{TXTED_OB* TXT_A = (TXTED_OB*)param;
 GRECT grect;
 INT16  y, yend, trame, type;
 long i, ligEnd, ligDeb;
 if (TXT_A->State & EDIT_HIDE)  return;
 w_ind++;
 /*.......... cliper le rectangle  redessiner .........................*/
 ClipGrect(update_grect);
 /*...... calcul des lignes textes correspondant  ce rectangle ........*/
 ligDeb   =  Y_to_Lig(update_grect->g_y , TXT_A);
 ligEnd   =  Y_to_Lig(update_grect->g_y + update_grect->g_h + TXT_A->IntLg, TXT_A)+1;
 ligEnd   = Min(ligEnd,TXT_A->PremLigVisible + TXT_A->NbreLigVisible);
 ligDeb   = Max(ligDeb,TXT_A->PremLigVisible);
 /*............ Regler le rectangle sur les lignes a afficher...........*/
 yend        = scrol_grect->g_y + (INT16)(ligEnd - TXT_A->PremLigVisible) * TXT_A->IntLg;
 grect.g_y   = scrol_grect->g_y + (INT16)(ligDeb - TXT_A->PremLigVisible) * TXT_A->IntLg;
 grect.g_h   = Max(TXT_A->IntLg, yend - grect.g_y);
 grect.g_w   = scrol_grect->g_w;
 grect.g_x   = scrol_grect->g_x;
 /*......... positionner remplissage rectangle du fond ................*/
 NumSelToTrame(TXT_A->BckTrm, &type, &trame);
 
 vsf_color   (VDIhandle,  TXT_A->BckCol);
 vsf_style   (VDIhandle,  trame);
 vsf_interior(VDIhandle,  type);
 Graphmode(MD_REPLACE);
 GrectPbox(&grect);
 y    = grect.g_y;
 for (i = ligDeb; i<TXT_A->NbLgn && y < yend; i++)
     {Graphmode(MD_TRANS);
      TXT_A->DrawTxtLine(i, TXT_A->TxtGrect.g_x , y, TXT_A);
      if ( TXT_A->CurState && i==TXT_A->LigPt )
         {EZ_ED_PaintCurs(TXT_A);
         }
      y += TXT_A->IntLg;
     }
}
/*------------------------ SizeOf_EOF --------------------------------------------*/
/* ACTION: analyse le type de fin de ligne et en deduit le nombre de car.         */
/* ENTREE: char *deb_txt: pointeur sur le debut du texte a analyser pour ne pas   */
/*                        rechercher avant !!!                                    */
/*         char *pt_txt: pointeur sur les caracteres de fin de ligne.             */
/*         INT16 flag: SI egal a AFTER_EOL  (pt_txt pointe apres la fin ligne)    */
/*                   SI egal a BEFORE_EOL (pt_txt pointe apres la fin ligne)      */
/* RETOUR: nombre de caracteres marquant la fin de ligne. si zero erreur.         */

INT16 SizeOf_EOF(char *deb_txt, char *pt_txt, INT16 flag)
{char *pt = pt_txt;
 if (flag == BEFORE_EOL)
    {if (*pt==13 || *pt==10)
        {pt++;
         if (*pt && pt[-1]==13 && *pt==10) pt++;
        }
     return (INT16)(pt - deb_txt);
    }
 else if (pt>deb_txt)
    {if (pt[-1]==13 || pt[-1]==10)
     pt--;
     if (pt>deb_txt && *pt==10 && pt[-1]==13) pt--;
     return (INT16)(deb_txt - pt);
    }
 return 0;
}

/*------------------------ EffaceLigne -------------------------------------------*/
INT16 EffaceLigneCur(TXTED_OB* TXT_A)
{GRECT grect  = TXT_A->TxtGrect;
 GRECT  r1    = TXT_A->TxtGrect;
 INT16 type, trame;
 /*............ Regler le rectangle a droite du curseur ..........................*/
 grect.g_h   = TXT_A->CurH;
 grect.g_y   = TXT_A->CurY;
 /*
 grect.g_w   = grect.g_x + grect.g_w - TXT_A->CurX + 1;
 grect.g_x   = TXT_A->CurX - 1;
 */
 if ( Rc_intersect( &grect, &r1) &&  !(TXT_ED->State & EDIT_HIDE ) ) 
    {NumSelToTrame(TXT_A->BckTrm, &type, &trame);
     vsf_color(VDIhandle,TXT_A->BckCol);
     vsf_style (VDIhandle, trame);
     vsf_interior(VDIhandle, type);
     Graphmode(MD_REPLACE);
     ClipGrect(&r1);
     GrectPbox(&r1);
     return 1;
    }
 return 0;
}

/*------------------------ PushCarInUndo -----------------------------------------*/
void PushCarInUndo(char *src, INT16 nb_car, long orig, TXTED_OB* TXT_A)
{long data1;
 nb_car = Min(4, nb_car);
 memcpy(&data1, src, nb_car);
 UNDO_Push("DELCAR", 0, data1, nb_car, orig, TXT_A->U_Stack);
}

/*------------------------ DeleteBloc --------------------------------------------*/
/* ACTION: efface les caracteres definis par les marques de bloc.                 */
/* NOTE: cette fonction doit obligatoirement se faire sur un texte mis a jour.    */
/*       donc faire si ce n'est pas deja fait un: BuffEditToText() avant de       */
/*       l'appeler.                                                               */

size_t DeleteBloc(size_t ligDeb, size_t carPtDeb,
                  size_t ligEnd, size_t carPtEnd,
                  TXTED_OB* TXT_A)
{/*............. coller fin de derniere ligne dans buffer ........................*/
 char *deb_blk     = TXT_A->TabLgnCtx[ligDeb].ptTxt + carPtDeb;
 char *end_blk     = TXT_A->TabLgnCtx[ligEnd].ptTxt + carPtEnd;
 size_t nb_car_del = end_blk - deb_blk;
 size_t nb_lig_del = ligEnd - ligDeb;
 size_t i          = 0;
 
 /*............ Si tampon buffer defini, y copier les car ........................*/
 if (TXT_A->U_Stack)
    {if (nb_car_del > 4)
         UNDO_Push("DELBLK", AUTO_ALLOC, (long)deb_blk, nb_car_del, deb_blk - TXT_A->ptTxt, TXT_A->U_Stack);
     else
        {PushCarInUndo(deb_blk, (INT16)nb_car_del, deb_blk - TXT_A->ptTxt, TXT_A);
        }
    }
 /*............ effacer les caracteres ...........................................*/
 memmove(deb_blk, end_blk, TXT_A->EndTxt - deb_blk + 2); /* +2 pour zero de fin   */
 /*..... mise  jour des indicateurs de longueur texte ...........................*/
 TXT_A->EndTxt    -= nb_car_del;
 
 /*..... mise  jour des pointeurs texte des lignes sous jacentes ................*/
 for (i=ligDeb+1; i<TXT_A->NbLgn; i++)
     {TXT_A->TabLgnCtx[i].ptTxt -= nb_car_del;
     }
 /*....................mise  jour du tableau des descripteurs de ligne ..........*/
 /*                           en effacant les lignes                              */
 if (nb_lig_del>0)
    {/*...... taille du contexte de ligne supplementaire .....*/
     long sizeof_ctx_sup =  (long) TXT_A->TabLgnCtxSize - sizeof(LGN_CTX);
     /*........... deplacer contexte de ligne normal .........*/
     char *src     = (char*) &TXT_A->TabLgnCtx[ligDeb + nb_lig_del + 1];
     char *dst     = (char*) &TXT_A->TabLgnCtx[ligDeb + 1];
     memmove( dst, src, (size_t)&TXT_A->TabLgnCtx[TXT_A->NbLgn] - (size_t)src );
     /*.... deplacer contexte de ligne supplementaire ........*/
     if (sizeof_ctx_sup>0)
        {src = TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (ligDeb + nb_lig_del + 1);
         dst = TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (ligDeb + 1);
         memmove( dst, src, (size_t)TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (TXT_A->NbLgn) - (size_t)src );
        }
     TXT_A->NbLgn -= nb_lig_del;
    } 
 return  nb_car_del;
}

/*------------------------ InsereBloc --------------------------------------------*/
long InsereBloc(INT16 w_ind,
                char *bloc_srce, 
                size_t lig_pt, size_t car_pt,
                INT16 flag,
                TXTED_OB* TXT_A)
{long i;
 char sav         = 0;
 char *src        = bloc_srce;
 char *dst        = 0;
 long   nbl_src   = 0;
 size_t len_src   = 0;
 /*................ longueur selon la nature de l'objet  inserer .................*/
 if (flag == EXE_ED_FILE_PASTE)
    {INT16   f_hand;
     if ( (f_hand = (INT16) Fopen( bloc_srce, FO_READ)) >= 0)
        {len_src  = filelength(f_hand);
         /*........... eliminer les zero de fin de fichier ........................*/
         while (len_src>1 && sav == 0)
               {Fseek(len_src - 1, f_hand, 0);    /* aller en fin de fichier -1    */
                Fread(f_hand, 1, &sav);           /* lire 1 octet                  */
                len_src--;                        /* si zero on continue  reculer */
               }
         Fclose (f_hand);
        }
    } 
 else if (flag == EXE_ED_SCRAP_PASTE)
    {len_src = GetLenClipboard();
    }
 else if (flag == EXE_ED_MEMORY_PASTE)
    {len_src = strlen(bloc_srce);
    }

 if (len_src == 0)                                            return 0;
 /*................ memoire texte suffisante pour inserer ? .......................*/
 if (!MemoryTxtEnough(len_src, TXT_A))                        return 0;
 /*.................. faire la place dans la destination ..........................*/
 dst = TXT_A->TabLgnCtx[lig_pt].ptTxt + car_pt;   /* reactualiser apres MemoryTxtEnough() */
 memmove( dst +  len_src, dst , TXT_A->EndTxt - dst + 2 );
 
 /*............. notifier au pere la modification de taille ...........*/   
 NotifieTxtSizeChg(w_ind, dst - TXT_A->ptTxt , len_src, TXT_A); 
  
 /*...................... noter le undo ...........................................*/
 if (TXT_A->U_Stack) UNDO_Push("INSBLK", 0, dst - TXT_A->ptTxt, len_src, 0, TXT_A->U_Stack);
 /*................. charger la destination avec la source ........................*/
 if (flag == EXE_ED_FILE_PASTE)
    {INT16   f_hand;
     if ( (f_hand = (INT16) Fopen( bloc_srce, FO_READ)) >= 0)
        {Fread(f_hand, len_src, dst);            /* lire les octets                */
         Fclose (f_hand);
        }
    } 
 else if (flag == EXE_ED_SCRAP_PASTE)
    {ClipboardLoad(dst, -len_src); /* -len pour que le zero de fin ne soit pas mis */
    }
 else
    {memcpy(dst, bloc_srce, len_src);
    }
 /*................ MISE A JOUR ...................................................*/
 sav            = dst[len_src];
 dst[len_src]   = 0;       /* placer un faux zero de fin  la suite de l'insertion */
 nbl_src        = GetTxt_NbLign(dst,TXT_A->SizeLgn) + 1; /* plus 1 car base zero   */
 dst[len_src]   = sav;
 /*................ memoire ligne suffisante pour inserer ? .......................*/
 if (!MemoryLigneEnough(nbl_src, TXT_A))                      return 0;
 /*..... mise  jour des indicateurs de longueur...................................*/
 TXT_A->EndTxt += len_src;
 /*...mise  jour des pointeurs de lignes sous jacents........*/
 for (i=lig_pt+1; i<TXT_A->NbLgn; i++)
     {TXT_A->TabLgnCtx[i].ptTxt += len_src;
     }
 
 /*............. si plusieurs lignes inseres faire...........*/
 /*        la place dans le tableau de contexte de lignes     */
 if (nbl_src>1)
    {/*...... taille du contexte de ligne supplementaire .....*/
     long sizeof_ctx_sup =  (long) TXT_A->TabLgnCtxSize - sizeof(LGN_CTX);
     /*........... deplacer contexte de ligne normal .........*/
     src = (char*) &TXT_A->TabLgnCtx[lig_pt + 1];
     dst = (char*) &TXT_A->TabLgnCtx[lig_pt + nbl_src];
     memmove( dst, src, (size_t)&TXT_A->TabLgnCtx[TXT_A->NbLgn] - (size_t)src );
     /*.... deplacer contexte de ligne supplementaire ........*/
     if (sizeof_ctx_sup>0)
        {src = TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (lig_pt + 1);
         dst = TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (lig_pt + nbl_src);
         memmove( dst, src, (size_t)TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (TXT_A->NbLgn) - (size_t)src );
        }
     TXT_A->NbLgn += nbl_src - 1;
     /*.... mettre a jour les nouveaux pointeurs de ligne.....*/
     TXT_A->InitTabLgnCtx(TXT_A, TXT_A->TabLgnCtx[lig_pt].ptTxt, lig_pt, nbl_src);
    }
 return  nbl_src;
}

/*------------------------ BuffEditToText ----------------------------------------*/
/* ACTION: insere un buffer de texte au debut de la ligne pointee par lig_pt      */
/*         met  jour tous les pointeurs de ligne et autres.                      */
/*         Pour se servir de cette fonction pour inserer du texte  un endroit    */
/*         quelconque, il faut: COMPLETER LE DEBUT du buffer avec le debut de la  */
/*         ligne ou l'on va inserer et ce de son debut jusqu'au point d'insertion */
/*                              COMPLETER LA FIN du buffer avec la fin de la      */
/*         ligne ou l'on va inserer et ce de point d'insertion jusqu' sa fin.    */
 
void BuffEditToText(INT16 w_ind, char *buft, long lig_pt, TXTED_OB* TXT_A)
{char *src        = buft;
 char *dst        = TXT_A->TabLgnCtx[lig_pt].ptTxt;
 long   nbl_src   = 0;
 size_t len_src   = 0;
 size_t len_dst   = 0;
 size_t delta     = 0;
 w_ind++;
 /*.......... mesurer la longueur de la source ...............*/
 nbl_src   = GetTxt_NbLign(src, TXT_A->SizeLgn)+1; /* plus 1 car base zero     */
 len_src   = strlen(src);
 
 /*.......... mesurer la longueur de la destination ..........*/
 len_dst   = LenLigne(dst);
 
 /*.......... si les buffers ne font pas la meme taille ......*/
 /*           faut faire la place dans le texte               */
 /*           et mettre  jour les pointeurs de ligne         */
 delta = len_src - len_dst;
 if (delta>0   && !MemoryTxtEnough(delta,       TXT_A))        return;
 dst = TXT_A->TabLgnCtx[lig_pt].ptTxt;  /* reactualiser apres MemoryTxtEnough() */
 if (nbl_src>1 && !MemoryLigneEnough(nbl_src-1, TXT_A))        return;
 if (delta)
    {long i;
     /*............ deplacer le texte sous jacent ............*/
     /*             avec son zero de fin (+2)                 */
     memmove( dst + len_dst + delta, dst + len_dst, TXT_A->EndTxt - dst - len_dst + 2 );
     /*..... mise  jour des indicateurs de longueur..........*/
     TXT_A->EndTxt += delta;
     /*...mise  jour des pointeurs de lignes sous jacents....*/
     for (i=lig_pt+1; i<TXT_A->NbLgn; i++)
         {TXT_A->TabLgnCtx[i].ptTxt += delta;
         }   
    }
 /*.......... copier le buffer dans la ligne .................*/
 memcpy(dst, src, len_src);
 
 /*............. si plusieurs lignes inseres faire...........*/
 /*        la place dans le tableau de contexte de lignes     */
 if (nbl_src>1)
    {/*...... taille du contexte de ligne supplementaire .....*/
     long sizeof_ctx_sup =  (long) TXT_A->TabLgnCtxSize - sizeof(LGN_CTX);
     /*........... deplacer contexte de ligne normal .........*/
     src = (char*) &TXT_A->TabLgnCtx[lig_pt + 1];
     dst = (char*) &TXT_A->TabLgnCtx[lig_pt + nbl_src];
     memmove( dst, src, (size_t)&TXT_A->TabLgnCtx[TXT_A->NbLgn] - (size_t)src );
     /*.... deplacer contexte de ligne supplementaire ........*/
     if (sizeof_ctx_sup>0)
        {src = TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (lig_pt + 1);
         dst = TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (lig_pt + nbl_src);
         memmove( dst, src, (size_t)TXT_A->SupLgnCtxtMem + sizeof_ctx_sup * (TXT_A->NbLgn) - (size_t)src );
        }
     TXT_A->NbLgn += nbl_src - 1;
     /*.... mettre a jour les nouveaux pointeurs de ligne.....*/
     TXT_A->InitTabLgnCtx(TXT_A, TXT_A->TabLgnCtx[lig_pt].ptTxt, lig_pt, nbl_src);
    }
}

/*------------------------ LenLigne ----------------------------------------------*/
size_t LenLigne(char *txt)
{char *pt = txt;
 while(*pt && *pt != 13 && *pt != 10) pt++;
 return  pt - txt;
}

/*------------------------ TextToBuffEdit ----------------------------------------*/
void TextToBuffEdit( long lig_pt, TXTED_OB* TXT_A)
{char *src = TXT_A->TabLgnCtx[lig_pt].ptTxt;
 char *dst = TXT_A->BuffEdit;
 while(*src && *src != 13 && *src != 10)
    {*dst  = *src;
      dst++;  src++;
    }
 *dst=0;
}

/*------------------------ XY_to_CarPt ------------------------------------------*/
char *XY_to_CarPt(INT16 x, INT16 y, TXTED_OB* TXT_A)
{long ligPt   = Y_to_Lig(y, TXT_A);
 long car_pt  = X_LigPt_to_CarOfLigne(x, ligPt, TXT_A, NORMAL);
 return TXT_A->TabLgnCtx[ligPt].ptTxt + car_pt;
}

/*----------------------- CarPt_to_Curs ------------------------------------------*/
long CarPt_to_Curs(char *car, long *carPt, TXTED_OB* TXT_A)
{long i;
 long lig_pt = -1;
 /*.............. voir si on est dans le texte ..................................*/
 if (car<TXT_A->ptTxt && car > TXT_A->EndTxt)                            return -1;
 /*.............. chercher ligne d'appartenance du caractere ....................*/
 for (i=0; i < TXT_A->NbLgn-1; i++)
     {if (car >= TXT_A->TabLgnCtx[i].ptTxt && car < TXT_A->TabLgnCtx[i+1].ptTxt) break;
     } 
 lig_pt = i;
 *carPt = car - TXT_A->TabLgnCtx[lig_pt].ptTxt;
 return lig_pt;
}
/*------------------------ Lig_To_Y ----------------------------------------------*/
long Lig_To_Y(long lig_pt, TXTED_OB* TXT_A)
{return  TXT_A->IntLg * (lig_pt - TXT_A->PremLigVisible) + TXT_A->TxtGrect.g_y;
}

/*------------------------ XY_to_Car ---------------------------------------------*/
long XY_to_Car(INT16 x, INT16 y, TXTED_OB* TXT_A)
{long lig_pt, car_pt;
 lig_pt  = Y_to_Lig(y, TXT_A);
 car_pt  = X_LigPt_to_CarOfLigne(x, lig_pt, TXT_A, NORMAL);
 return (long)(TXT_A->TabLgnCtx[lig_pt].ptTxt - TXT_A->ptTxt) + car_pt;
}

/*------------------------ Y_to_Lig ----------------------------------------------*/
long Y_to_Lig(INT16 y, TXTED_OB* TXT_A)
{long lig_pt;
 y      -= TXT_A->TxtGrect.g_y;
 lig_pt  = Max(0, y / TXT_A->IntLg);
 lig_pt += TXT_A->PremLigVisible;
 return Min(TXT_A->NbLgn - 1, lig_pt);
}


/*------------------------ X_LigPt_to_CarOfLigne --------------------------------*/
INT16 X_LigPt_to_CarOfLigne(INT16 x, long lig_pt, TXTED_OB* TXT_A, INT16 flag)
{char   *txt     = 0;
 /*............. si ligne en edition ............................................*/
 if  (lig_pt== TXT_A->LigPt ) txt = TXT_A->BuffEdit;
 else                         txt = TXT_A->TabLgnCtx[lig_pt].ptTxt;
 if (flag & CURS_UPDATE)
    {TXT_A->CurY = (INT16) Lig_To_Y(TXT_A->LigPt, TXT_A);
    }    
 return X_to_CarOfLigne(x, txt, TXT_A, flag);
}
 
/*----------------------- X_to_CarOfLigne --------------------------------------*/
INT16 X_to_CarOfLigne(INT16 x, char *txt, TXTED_OB* TXT_A, INT16 flag)
{EXTND_DIM strdim; 
 char   *pt          = txt;
 INT16   x_ref         = 0;
 INT16  x_prev         = 0;
 char *dst           = AffiBuff;
 long   max          = TXT_A->SizeLgn - 1;
 INT16    tab          = TXT_A->ExpTAB;
 INT16    fill, pos    = 0;
 /*.......... placer les attributs par defaut ...................................*/
 EZ_font = EZ_point = -3;
 Deftext(-1, /* couleur */
         TXT_A->ATT_Cur->CarEff, /* effet   */
         0,                      /* angle   */
         TXT_A->ATT_Cur->CarPts, /* taille  */
         TXT_A->ATT_Cur->FntID   /* fonte   */
        );
 /*................ relativiser le curseur ......................................*/
 x      -= TXT_A->TxtGrect.g_x + TXT_A->MargLeft - TXT_A->OfsX;
 if (x <= 0)
    { if (flag & CURS_UPDATE)
         {TXT_A->CurX  =  TXT_A->TxtGrect.g_x + TXT_A->MargLeft - TXT_A->OfsX;
          TXT_A->CurH  =  TXT_A->IntLg;
         }
     return 0;
    }
 /*.............. avancer jusquau curseur X .....................................*/
 while (*pt       &&
        *pt != 13 &&
        *pt != 10 && max
       )
       {if (*pt == '\t')
           {fill = tab - (pos % tab);
            while (fill-- && max)
                  {*dst++ = ' ';
                   max--;
                  }
            pos += tab - (pos % tab);
           }
        else
           {*dst++ = *pt;
            max--;
            pos++;
           }
       *dst=0;
       /*........... Mesurer la largeur du caractere........................*/
       if (Gdos == '_FSM')
          {vqt_f_extent(VDIhandle, AffiBuff, (INT16*)&strdim);
          }
       else
          {vqt_extent(VDIhandle,   AffiBuff, (INT16*)&strdim);
          }
        x_ref = strdim.XinfD - strdim.XinfG;
        if (x >= x_prev && x <x_ref) break;
        pt++;
        x_prev = x_ref;
       }   
 if (flag & CURS_UPDATE)
    {TXT_A->CurX =  x_prev + TXT_A->TxtGrect.g_x + TXT_A->MargLeft - TXT_A->OfsX;
     TXT_A->CurH =  TXT_A->IntLg;
    }
 return (INT16)(pt - txt);
}

/*------------------------ Car_to_CursXYH ----------------------------------------*/
void Car_to_CursXYH( TXTED_OB* TXT_A)
{CarOfLigne_to_X(TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt, TXT_A->CarPt, TXT_A, CURS_UPDATE);
 TXT_A->CurY = (INT16)Lig_To_Y(TXT_A->LigPt, TXT_A);
}
 
/*---------------------- CarOfLigne_to_X -----------------------------------------*/
INT16 CarOfLigne_to_X(char *txt, long car_pt, TXTED_OB* TXT_A, INT16 flag)
 {EXTND_DIM strdim;
  INT16 x;
  char *pt         = txt;
  char *end        = txt + car_pt;
  char *dst        = AffiBuff;
  INT16    tab       = TXT_A->ExpTAB;
  INT16    fill, pos = 0;
  
 /*........... placer dans le buffer la chaine avec TAB expanse...................*/
 while (pt<end)
       {if (*pt == '\t')
           {fill = tab - (pos % tab);
            while (fill--)
                  {*dst++ = ' ';
                  }
            pos += tab - (pos % tab);
           }
        else
           {*dst = *pt;
             dst ++;
             pos ++;
           }
        pt++;
       }
 *dst = 0;       /* fermer la chaine */
 /*.......... placer les attributs par defaut ...................................*/
 EZ_font = EZ_point = -3;
 Deftext(-1,                     /* couleur */
         TXT_A->ATT_Cur->CarEff, /* effet   */
         0,                      /* angle   */
         TXT_A->ATT_Cur->CarPts, /* taille  */
         TXT_A->ATT_Cur->FntID   /* fonte   */
        );
 /*........... Mesurer la largeur de cette chaine................................*/
 if (Gdos == '_FSM')
    {vqt_f_extent(VDIhandle, AffiBuff, (INT16*)&strdim);
    }
 else
    { vqt_extent(VDIhandle, AffiBuff, (INT16*)&strdim);
    }
 /*........... relativiser X par rapport au debut du cadre ......................*/
 x = strdim.XinfD - strdim.XinfG + TXT_A->TxtGrect.g_x + TXT_A->MargLeft - TXT_A->OfsX;
 if (flag & CURS_UPDATE)
    {TXT_A->CurX =  x;
     TXT_A->CurH =  TXT_A->IntLg;
    }
 return x;
}

/*------------------------ FreeTxtMemory -----------------------------------------*/
void   FreeTxtMemory(TXTED_OB *TXT_A)
{if (TXT_A->TabLgnCtx)  free(TXT_A->TabLgnCtx);
 if (TXT_A->ptTxt)      free(TXT_A->ptTxt);
}

/*---------------------------  MemoryTxtEnough -----------------------------------*/
INT16 MemoryTxtEnough(long len_mem_suppl, TXTED_OB* TXT_A)
{/*............ si memoire insuffisante on tente une nouvelle allocation .........*/
 if (TXT_A->EndTxt + len_mem_suppl + 2 >  TXT_A->EndBuff)
    {char *old_alloc = TXT_A->ptTxt;
     long new_size   = TXT_A->EndBuff - TXT_A->ptTxt +  len_mem_suppl + SIZE_MEM_ALLOC;
     char *new_alloc;
     /*
     form_alert(1000,"[0][Patientez:|         Procedure de rallocation|         mmoire Texte en cours...][ok]");
     ExeAllMessage();
     */
     new_alloc = realloc(TXT_A->ptTxt, new_size);
     if (new_alloc == 0)
        {/* WindAlertClose(); */
         new_alloc = malloc(new_size);
         if (new_alloc)
            {memcpy(new_alloc, TXT_A->ptTxt, TXT_A->EndTxt - TXT_A->ptTxt + 2);
             free(TXT_A->ptTxt);
            }
         else   
            {form_alert( 1, "[0][TEXTE:|Pas assez de mmoire|pour l'opration demande.|Dsol.][Annulez]" );
             return 0;
            }
        }
     TXT_A->ptTxt   =  new_alloc;
     TXT_A->EndBuff =  new_alloc + new_size;
     /*........... si reallocation change de place ..............*/
     /*                reformater les lignes                     */
     if (new_alloc     != old_alloc)
        {long         i = 0;
         long delta     = new_alloc - old_alloc;
         TXT_A->EndTxt  = TXT_A->EndTxt + delta;
         for (i=0; i < TXT_A->NbLgn; i++)
             {TXT_A->TabLgnCtx[i].ptTxt += delta;
             }
        } /* endif (new_alloc     != old_alloc)                       */
     /* WindAlertClose(); */
    }  /* endif (TXT_A->EndTxt + len_mem_suppl + 2 >  TXT_A->EndBuff) */
 return 1;
}


/*---------------------------  MemoryLigneEnough ---------------------------------*/
INT16 MemoryLigneEnough(long nb_lign_suppl, TXTED_OB* TXT_A)
{if (TXT_A->NbLgn + nb_lign_suppl + 2> TXT_A->NbLgnMax )
    {long old_nb_ligne    = TXT_A->NbLgnMax;
     long new_nb_ligne    = (TXT_A->NbLgnMax      +
                             nb_lign_suppl        +
                             SIZE_MEM_ALLOC/TXT_A->SizeLgn
                            );    
     long new_size        = new_nb_ligne * TXT_A->TabLgnCtxSize; 
     LGN_CTX *new_alloc   = (LGN_CTX*)realloc(TXT_A->TabLgnCtx, new_size);
     
     
     /*
     form_alert(1000,"[0][Patientez:|         Procedure de rallocation|         mmoire Lignes en cours...][ok]");
     ExeAllMessage();
     */
     if (new_alloc == 0)
        {/* WindAlertClose(); */
         new_alloc = malloc(new_size);
         if (new_alloc)
            {/*..... recopier tableaux de lignes (LGN_CTX + Suplementaire) ..............*/
             /*                 dans le nouvel emplacement                               */
             memcpy(new_alloc, TXT_A->TabLgnCtx, (old_nb_ligne+1) * TXT_A->TabLgnCtxSize);
             free(TXT_A->TabLgnCtx);
            }
         else
            {form_alert( 1, "[0][LIGNES:|Pas assez de mmoire|pour l'opration demande.|Dsol.][Annulez]" );
             return 0;
            }
        }
     TXT_A->TabLgnCtx   =  new_alloc;
     TXT_A->NbLgnMax    =  new_nb_ligne;
     /*............... calcul emplacement memoire du contexte de ligne suppl..........*/
     /*                a ce stade new_alloc = TXT_A->TabLgnCtx                        */
     /*                et tout a ete recopie dans la nouvelle allocation              */
     if (TXT_A->SupLgnCtxtMem)
        {/*...... taille du contexte de ligne supplementaire .........................*/
         long sizeof_ctx_sup    =  (long) TXT_A->TabLgnCtxSize - sizeof(LGN_CTX);
         /*...... adresse du contenu de l'ancien memoire sup peut avoir ..............*/
         /*       change lors allocation mais a ete recopi                          */
         char *old_data_ctx_sup = (char*)(((size_t) new_alloc) + sizeof(LGN_CTX) * old_nb_ligne);
         TXT_A->SupLgnCtxtMem   = (char*)(((size_t) new_alloc) + sizeof(LGN_CTX) * new_nb_ligne);
         memcpy(TXT_A->SupLgnCtxtMem, old_data_ctx_sup, sizeof_ctx_sup * old_nb_ligne);
        }
     else
         TXT_A->SupLgnCtxtMem  = 0;
     /* WindAlertClose(); */
    }
 return 1;
}

/*----------------------------- DefaultInitTabLgnCtx ---------------------------*/
/* ACTION: passe en revue le texte  partir de  char *txt et initialise la      */
/*         table des pointeurs de lignes                                        */
/*                            TXT_A->TabLgnCtx[i].ptTxt   avec les adresses des */
/*         debuts de chaque lignes (cette table doit toujours etre  jour pour  */
/*         un fonctionnement correct du composant d'edition).                   */
/*                                                                              */
/* ENTREE: TXTED_OB *TXT_A: pointeur sur le composant d'edition de texte pour   */
/*                          lequel il est demande un formattage de lignes.      */
/*         char *txt:   adresse texte  partir de laquelle cette mise  jour    */
/*                      doit se faire.                                          */
/*         long iTab:   indice du premier element de la table  mettre  jour.  */
/*         long nb_l:   nombre de lignes  mettre  jour. Si plus grand que le  */
/*                      texte, tout le texte sous jacent sera remis  jour.     */
/* RETOUR: long: retourne le dernier indice+1 remis  jour (pointe apres)       */
/* NOTE:   cette fonction est celle qui est utilisee par defaut par un composant*/
/*         d'edition de texte. il vous est possible de la detourner et de la    */
/*         reecrire pour vos propres besoins (experts only)                     */
/*         par defaut cette fonction est en:  TXT_A->InitTabLgnCtx              */

long DefaultInitTabLgnCtx(TXTED_OB *TXT_A, char *txt, long iTab, long nb_l)
{char *pt, *ptdebl;
 long flag_no_erase           = nb_l;
 long len_max                 = TXT_A->SizeLgn;
 pt                           = txt;
 ptdebl                       = pt; 
 TXT_A->TabLgnCtx[iTab].ptTxt = txt;

 while(*pt && nb_l)
   {if (*pt==13 || *pt==10 ||(pt - ptdebl)>=len_max)
       {if ( (pt - ptdebl) >=len_max)
           {pt [-1] = '\r';
            pt++;
           }
        else
           {pt++;
            if (*pt && pt[-1]==13 && *pt==10) pt++;
           }
        ptdebl = pt;
        /*........... initialiser pointeur texte et N de ligne .....*/
        iTab++;        
        TXT_A->TabLgnCtx[iTab].ptTxt     = pt;
        nb_l --;
       }
    else
       {pt++;
       }
   }
  if (flag_no_erase == LONG_MAX) TXT_A->TabLgnCtx[iTab+1].ptTxt   = 0;
 return iTab;
} 

/*----------------------- GetTxt_NbLign -------------------------*/
/*ACTION: compte le nombre de lignes d'un texte, afin de prevoir */
/*        la taille  du tableau de pointeurs                     */
/* ENTREE: char *txt: adresse du texte dont il faut compter les  */
/*                    lignes.                                    */
/* RETOUR: INT16: nombre de lignes du texte.                     */

long GetTxt_NbLign(char *txt, long len_max)
{char *pt, *ptdebl;
 long nb_lgn = 0;
 pt     = txt;
 ptdebl = pt;
 while(*pt)
   {if (*pt==13|| *pt==10 || (pt - ptdebl)>=len_max)
       {if ( (pt - ptdebl) >=len_max)
           {pt++;
           }
        else
           {pt++; 
            if (*pt && pt[-1]==13 && *pt==10) pt++;
           }
        nb_lgn++;
        ptdebl = pt;
       } 
     else
       {pt++;
       }
   }
 return nb_lgn;
}

/*-------------------------- AfficheLigne ---------------------------------*/
INT16 AfficheLigne(long i, INT16 tx, INT16 ty, TXTED_OB *TXT_A)
{ 
#pragma warn -pia   /* Possible incorrect assignment. */
  INT16 d;
  char *pt_dst     = TXT_A->AffiBuff;
  char *pt_src     = TXT_A->TabLgnCtx[i].ptTxt;
  INT16    tab       = TXT_A->ExpTAB;
  long   max       = TXT_A->SizeLgn - 1;
  INT16    fill, pos = 0;
 if (TXT_A->State & EDIT_HIDE)  return 0;
 /*............ Si edition active et affi de la ligne en edition ...........*/
 if (i == TXT_A->LigPt )
    {pt_src = TXT_A->BuffEdit;            /* on affiche le buffer de saisie */
    }
 else
    {pt_src = TXT_A->TabLgnCtx[i].ptTxt;  /* on affiche le texte normal     */
    }
 /*............ positionner les attributs graphiques .......................*/
 vst_alignment (VDIhandle, ALI_LEFT, ALI_BASE, &d, &d);
 tx -= TXT_A->OfsX;
 /*.............. Si numero de ligne positionn .............................*/
 
 if (TXT_A->ATT_Def[ATT_TXT_NUM_LGN].CarCol>-1)
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NUM_LGN];
     TXT_A->DrawTxt(tx+2, ty, ltoa(i+1, "                                ", 10), TXT_A) ;
     TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NORMAL];
    }
 
 tx += TXT_A->MargLeft;
 /*............ analyser la ligne ..........................................*/
 while (*pt_src && *pt_src != 13 && *pt_src != 10 && max)
  {switch(*pt_src)
        {    /*........... si TAB il faut expandre ...................*/
         case '\t':
              fill = tab - (pos % tab);
              while (fill-- && max)
                    {*pt_dst++ = ' ';
                     max--;
                    }
              pos += tab - (pos % tab);
              if (TXT_A->State & EDIT_TAB_VISIBLE && pt_dst[-tab]==' ')
                 {pt_dst[-tab] = TXT_A->CharTAB;
                 } 
              pt_src++;
              break;
         default:
             {*pt_dst++  = *pt_src++;
               pos++;
               max--;
             }  /* enddefault */
        } /* endswitch */
  }/* endwhile */
 *pt_dst = 0; 
 tx += TXT_A->DrawTxt( tx,  ty, TXT_A->AffiBuff, TXT_A);
 /*............. si couleur fin de ligne positionne .................*/
 if (TXT_A->ATT_Def[ATT_TXT_EOL].CarCol>-1)
    {INT16 EOF_COL[2] = {2,0};
     EOF_COL[0]     = TXT_A->ATT_Def[ATT_TXT_EOL].CarCol; 
     Put_mono_color(tx, ty + TXT_A->IntLg - IC_EOF[1]-1,IC_EOF,2,EOF_COL);
    }
 /*................ si curseur positionne ...........................*/
 if ( TXT_A->CurState && i==TXT_A->LigPt )
    {EZ_ED_PaintCurs(TXT_A);
    }
 /*.............. si un bloc est positionn .........................*/
 if (TXT_A->BlkEndLig != TXT_A->BlkDebLig || TXT_A->BlkEndCar != TXT_A->BlkDebCar)
    {long blk_first = TXT_A->BlkDebLig;
     long blk_last  = TXT_A->BlkEndLig;
     /*.... le debut et fin de ligne de bloc peuvent etre inverses ...*/
     /*           donc les remettre en ordre pour test                */
     if (blk_last < blk_first)
        {blk_first = TXT_A->BlkEndLig;
         blk_last  = TXT_A->BlkDebLig;
        }
      
     /*......... tester si la ligne en cours d'affichage est .........*/
     /*                    dans le bloc                               */
     if (i>= blk_first && i<= blk_last)
        {/*............ afficher le  bloc ............................*/
         EZ_ED_DrawBlkFrame(i, BLK_LINE_DRAW, TXT_A);
        }
    }
 return 1;
#pragma warn .pia
}

/*-------------------------- AfficheBaliseTxt -------------------------------*/
/* ACTION: affiche le contenu d'un buffer avec les attributs courants.       */
/* ENTREE: INT16 tx, INT16 ty: position d'affichage en pixels.               */
/*         char *buft: chaine  afficher.                                    */
/*         TXTED_OB *TXT_A: structure de definition des parametres.          */
/* NOTE: l'affichage se fait selon les attributs graphiques courants pointes */
/*       par la structure: TXT_A->ATT_Cur                                    */
/* RETOUR: largeur de ce qui vient d'etre affiche.                           */

INT16 AfficheBaliseTxt(INT16 tx, INT16 ty, char *PtTexteLigne, TXTED_OB *TXT_A)
{EXTND_DIM strdim;
 INT16 ofs_v = 2;
 if (*PtTexteLigne==0) return 0;
 /*.............. placer les attributs courants ............................*/
 EZ_font = EZ_point = -3;
 Deftext(TXT_A->ATT_Cur->CarCol, /* couleur */
         TXT_A->ATT_Cur->CarEff, /* effet   */
         0,                      /* angle   */
         TXT_A->ATT_Cur->CarPts, /* taille  */
         TXT_A->ATT_Cur->FntID   /* fonte   */
        );
 /*............. mesurer ce qui va etre affiche ............................*/
 if (TXT_A->ATT_Cur->FntID > 1) ofs_v = TXT_A->BaseAjust;

 if (Gdos == '_FSM')
    {return EZ_OutText(VDIhandle, tx , ty - ofs_v, PtTexteLigne);
    }
 else
    {vqt_extent(VDIhandle,PtTexteLigne,(INT16*)&strdim);
     v_gtext(VDIhandle, tx , ty + ((strdim.YsupD-strdim.YinfD)- ofs_v), PtTexteLigne ); 
    }

 /*..............afficher le texte .........................................*/
 /*if (TXT_A->ATT_Cur->FntID > 1) ofs_v = TXT_A->BaseAjust;*/
 /* VdiText(tx , ty + ((strdim.YsupD-strdim.YinfD)- ofs_v), PtTexteLigne); */
 /* v_gtext(VDIhandle, tx , ty + ((strdim.YsupD-strdim.YinfD)- ofs_v), PtTexteLigne ); */
 /*.............. retourner la largeur en pixel ............................*/
 return strdim.XinfD - strdim.XinfG;
}
